User Guide

Data Dynamics Reports is a new evolution of reporting based on Microsoft® RDL specifications but with a more robust set of features, better application integration, and more developer support.

In Data Dynamics Reports Designer Documentation

Introducing Data Dynamics Reports
Find out about the components and features included in Data Dynamics Reports, as well as license information.
Installing Data Dynamics Reports
Look here to find information about system requirements and installed files.
Creating Reports
This section introduces Data Dynamics Reports concepts and architecture, and provides information on various aspects of building reports.
Rendering and Transforming Reports
Here you will find information about the various formats in which reports may be rendered.
Getting Help
Find out about product support and registration requirements.
Troubleshooting
Learn how to resolve some common issues with Data Dynamics Reports.
How-To Section
This is where you can find specific information on performing all manner of tasks with Data Dynamics Reports.
Samples and Walkthroughs
Use the Samples and Walkthroughs to guide you in the use of many of the features supported by Data Dynamics Reports.
See Also

Viewer: Viewer Guide

Reference: Smart Panel Guide

Copyright © 2006-2007 Data Dynamics, Ltd. All Rights Reserved.


Introducing Data Dynamics Reports

Data Dynamics Reports is a new product based on Microsoft® RDL specifications. Years of experience with ActiveReports as well as all-important user feedback have been incorporated into the building of a reporting product that is easy and intuitive to use, and has the flexibility to bend to a developer's needs.

This section contains information about:

Data Dynamics Reports License Agreement
Find the details of the license agreement and limited warranty.
Features
Learn about the features of Data Dynamics Reports.
Components
The components which are shipped with Data Dynamics Reports are detailed here.


License Agreement

License Agreement and Limited Warranty

Data Dynamics Reports 1.0

Please read carefully before installing this software package. Your installation of the package indicates your acceptance of the terms and conditions of this license agreement. Contact Data Dynamics if you have any questions about this license.

The Product (libraries and object code) is proprietary to Data Dynamics, Ltd. and is protected by Federal Copyright Law. Data Dynamics retains the title to and ownership of the Product. You are licensed to use this Product on the following terms and conditions:

LICENSE: The Product is licensed per software application developer (“developer”) and must be activated by said developer. Licensee is defined as the person or entity that pays consideration for the license to use the Product. Data Dynamics hereby grants the Licensee a nonexclusive License authorizing one, and only one, developer at a time to use the Product for development purposes. The Licensee is also permitted to distribute applications containing the files designated below on a royalty free basis. The use of this License does not create any kind of partnership or joint ownership interest in the Licensee’s proprietary applications. Please contact Data Dynamics if you require additional Licenses. Licensee may incorporate the sample code into Licensee’s applications. Use of this product by more than one developer at a time terminates, without notification, this License and the right to use this product.

LICENSEE MAY NOT: Distribute, rent, sub-license or otherwise make available to others the software or documentation or copies thereof, except as expressly permitted in this License without prior written consent from Data Dynamics. In the case of an authorized transfer, the transferee must agree to be bound by the terms and conditions of this License Agreement.

RESTRICTIONS: Licensee may use this Product in Licensee’s business application for sale or distribution as long as:

1. The product that Licensee produces and/or distributes is NOT a software development product; a product that is sold primarily to software developers or system integrators or a development environment of any kind. Please contact Data Dynamics, Ltd. for special commercial licensing provisions in these circumstances.

2. The software license is activated and registered through Data Dynamics.

· Activation and registration is accomplished during installation via a web service

· In the event that web access is not available, the registering developer should contact our technical support group for assistance

3. Licensee may not remove any proprietary notices, labels, trademarks on the software or documentation.

4. Licensee may not modify, de-compile, disassemble, reverse engineer or translate the software.

FILES THAT MAY BE DISTRIBUTED WITH LICENSEE’S APPLICATION:

datadynamics.reports.config, DataDynamics.Reports.dll, DataDynamics.Reports.Design.dll, DataDynamics.Reports.Diagnostics.dll, DataDynamics.Reports.Extensibility.dll, DataDynamics.Reports.Rendering.Graphics.dll, DataDynamics.Reports.Rendering.Html.dll, DataDynamics.Reports.Rendering.Pdf.dll, DataDynamics.Reports.Rendering.Word.dll, DataDynamics.Reports.Rendering.Xml.dll, DataDynamics.Reports.Web.dll, DataDynamics.Reports.Windows.Forms.dll, DataDynamics.Reports.Designer.exe, DataDynamics.Reports.Designer.chm, DataDynamics.Reports.Preview.exe, DataDynamics.Reports.Preview.chm

US GOVERNMENT RESTRICTED RIGHTS: Use, duplication or disclosure by the United States Government is subject to restrictions as set forth under DFARS 252.227-7013 or in FARS 52.227-19 Commercial Computer Software - Restricted Rights.

TERM: Licensee may terminate its License and this Agreement at any time by destroying all copies of the Product and Product Documentation. This License and this Agreement will also terminate automatically if Licensee fails to comply with any term or condition in this Agreement.

LIMITED WARRANTY: This software and documentation are sold "as is" without any warranty as to their performance, merchantability or fitness for any particular purpose. Licensee assumes the entire risk as to the quality and performance of the software. Data Dynamics warrants that the media on which the Program is furnished will be free from any defects in materials. Exclusive remedy in the event of a defect is expressly limited to the replacement of media. In no event shall Data Dynamics or anyone else who has been involved in the creation, development, production, or delivery of this software be liable for any direct, incidental or consequential damages, such as, but not limited to, loss of anticipated profits, benefits, use, or data resulting from the use of this software, or arising out of any breach of warranty.


Features

Since it is based on Microsoft® RDL specifications, Data Dynamics Reports shares many features with other RDL reporting solutions, but also adds features which ActiveReports users have come to expect plus new features responding to user requests.

Features

  • Better application integration
  • Intelligent Windows forms viewer and Web viewer
    • Configurable scroll bar jump buttons (like those found in Microsoft® Word®)
    • Document map (table of contents)
    • Drill down capability
    • Metadata query support
    • Parameters
    • Bookmark links, hyperlinks and drillthrough links
    • Interactive editing
    • Exports
      • HTML (XHTML)
      • PDF (with security, font embedding, and font subsetting)
      • Image (BMP, EMF, GIF, JPEG, TIFF, and PNG)
      • XML
  • Templates
  • Master reports
  • Themes
  • Scripting
  • Proprietary controls
    • FormattedText Report Item with HTML support
    • BarCode Report Item
    • BandedList Data Region
  • Report wizard
  • Data Sources
    • SQL
    • Dataset
    • Object (used for unbound data)
    • ODBC
    • OLEDB
    • Oracle
    • XML
    • Custom data provider extensions can also be created
  • Data Regions
    • Table
    • Matrix
    • List
    • Banded List
    • Chart
  • Report Items
    • TextBox
    • Line
    • Rectangle
    • Image
    • Subreport
  • Expressions
    • Aggregates
    • Data Visualization
      • Data bar
      • Icon set
      • Range bar
      • Color scale
  • Imports
    • Access® Reports
    • Crystal Reports
    • ActiveReports for .NET

Data Dynamics Reports allows you to integrate royalty-free reports based on Report Definition Language (RDL) into .NET Web and Windows forms applications. It provides a comprehensive object model and API, allowing you to create and modify reports in code for maximum customization and development flexibility.

The report designer can be used within Visual Studio 2005 to connect reports to data, lay out reports, add code for use in expressions, and preview reports.

Data Dynamics Reports adds new components to the RDL specification to extend your reporting capabilities.

  • The Formatted Text report item takes HTML input.
  • The Banded List report item combines the freeform layout of the list report item with the grouping and nesting capabilities of the table data region.
  • The Chart report item provides all of the standard chart types plus some of the less commonly found financial charts like Kagi and Three Line Break.

For your convenience, two applications are included with this installation which are independent of the Visual Studio environment. Both of these applications demonstrate the capabilities of the corresponding controls available for use within Visual Studio 2005.

The Report Viewer application opens RDL and RDLX files with interactive features and allows users to print or export reports. The ReportPreview control available within Visual Studio allows developers to customize the user experience.

Export formats use these rendering extensions.

  • HTML (XHTML)
  • PDF (with security, font embedding, and font subsetting)
  • Image (BMP, EMF, GIF, JPEG, TIFF, or PNG)
  • XML

Interactive features such as the following are supported.

  • Document Map (table of contents)
  • Bookmark Links, Hyperlinks, and Drill Through links
  • Parameters
  • Drill-down
  • Search and meta-data queries
  • Copy, pan, and zoom
  • Jump to previous, next, first, or last group or search result

The Report Designer application empowers users to create or modify report layouts. The UserDesignerControl available within Visual Studio allows developers to customize the user experience in their own applications. The designer has the following features:

  • Designer zoom
  • Visual Basic.NET expression based control properties
  • Added data visualization functions (DataBar, ColorScale, IconSet, and RangeBar)
  • Advanced aggregate functions
  • Multiple data regions
  • Child Datasets for XML, Object and other hierarchical data sources


Components

The four main components of Data Dynamics Reports are the Report Designer, the Windows Forms Viewer, the Web Viewer, and the End User Report Designer.

Report Designer
The report designer is integrated into the Visual Studio®.NET 2005 environment, and is the component with which the developer authors reports. The report designer has pages for Data, Layout, Code, and Preview.
ReportPreview
The ReportPreview control is customizable for use on Windows Forms and allows end users to take advantage of the interactive features in report definitions.
WebReportViewer
The WebReportViewer is a customizable control for use on Web Forms. The components of the WebReportViewer are also available separately so that you can create a custom Web viewer with only the parts that you select.
UserDesignerControl
The UserDesignerControl is customizable for use on Windows Forms and allows end users to design their own custom reports.

Stand-alone Applications

A Report Designer application and a Report Viewer application are also included for your convenience. They can be opened from the Start menu, and neither requires Visual Studio.

The Report Designer application contains all the functionality of the integrated Report Designer.

The Report Viewer application contains all the functionality of the ReportPreview control.


Report Designer

The Report Designer offers a design surface which is fully integrated into the Microsoft® Visual Studio® .NET 2005 environment. You can add a report to a project, or simply open a report designer from the Visual Studio File menu under New > File and save it to be opened in the Report Preview application.

Once you have opened a report, you will see that the designer is comprised of three tabs. The first tab is the visual designer, the second allows you to add code to the report, and the third is the preview window.

The Data smart panel allows you to connect your report to data from practically any source. You can share a data source across a project with a number of reports, or you can set up one or more new data sources for each report. On the Data smart panel, you select the fields for your report by creating datasets with the query builder or by typing in your SQL query (or use XPath expressions for XML data sources).

The Data Explorer shows you a tree view of all of your report's data sources and datasets.

The Layout tab includes a toolbox filled with data regions and report items which you can use on the design surface, which by default consists of only a Body section. The data regions are used to contain report items with data which is to repeat for each record. There is also a Data Explorer containing datasets with lists of fields which were created in the Data smart panel that you can drag onto the report.

The Code tab allows you to add custom code or unbound data sources to your report.

The Report menu offers access to report images, parameters and properties. You can also add a page header or footer in the Report menu.

The Preview tab allows you to check your work as you go without the need to run the project and provides printing and exporting functionality.

See Also

Layout

Reference: Creating Reports


Report Preview

The ReportPreview control is a component which you can add to your Visual Studio toolbox, and then drop onto a Windows Form. The control is only available in Windows Application projects, and is disabled in the toolbox in Web projects.

At run time, the viewer includes a Document Map (table of contents) and thumbnail views of the pages in the report, and allows the user to search for words or phrases. The viewer's tool bar is customizable, and enables printing as well as exporting to a number of formats. Other features include support for drilldown and hyperlinks, normal search, meta-data query, copy, pan, and zoom. The scroll bar includes jump buttons which allow the user to jump to the previous, next, first, or last group or search result.

Data Dynamics Reports also includes a compiled Report Viewer application for your convenience which you can use or distribute. You can open it from the Start menu, or find it in the installation folder under Assemblies.

See Also

Web Viewer | Components

Viewer: Viewer Guide


Web Viewer

The WebReportViewer control is a component which you can add to your Visual Studio® toolbox, and then drop onto a Web Form. (For help with this, see Adding Components to the Visual Studio Toolbox.) The control is only available in Web projects, and is disabled in Windows Application projects.

At design time, only a gray box is shown on the WebForm.

At run time, the WebReportViewer control offers the user the same features that can be found in the ReportPreview control. At design time, the control includes all of the separate sections listed below already packaged for ease of use.

Individual sections

  • CoreViewer is the section that displays the current page of the report. It may also be used to display messages, such as "Loading report," or "Waiting for parameters."
  • DocumentMapPanel is the basic Table of Contents (TOC) panel for document navigation. It displays the interactive document map as a treeview at run time.
  • FindPanel is the basic panel that offers users an interface for searching the document. At run time, it displays a list of results that the user can click to navigate.
  • ParameterPanel is the basic panel for accepting parameter input from users.
  • Toolbar is the basic toolbar that allows for interaction with the report through navigation, viewer modes, export options, et cetera. The toolbar contains the following buttons:
    1. Back to Parent Report enables the user to navigate back to the previous report after they have followed a drill through link.
    2. Hide/Show Side Bar allows the user to open or close the side bar where they can select from any of the panels that you may have added to the CoreViewer.
      • Report Parameters provides access to the ParameterPanel control in which users can change the parameters on which to base the report.
      • Find provides access to the FindPanel control which allows users to search the report for key words.
      • Document Map provides access to the DocumentMapPanel and (if a document map is provided as a part of the report) allows users to navigate the report from table of contents entries in the treeview.
    3. Page Setup opens a dialog with paper size, page margins and orientation options.
    4. Print opens a print dialog with printer, print range, and page handling options.
    5. Print Preview shows the individual pages of the report instead of a single html page.
    6. Viewer Mode allows users to select HTML or PDF from the drop-down box, and then click the Viewer Mode button to change modes.
    7. Go to First Page navigates to the first page of the report.
    8. Back navigates to the page immediately prior to the current page. (This button is disabled when the first page of the report is in view.)
    9. Forward navigates to the page immediately after the current page. (This button is disabled when the last page of the report is in view.)
    10. Go to End Page navigates to the last page of the report.
    11. Select a format allows users to select from Acrobat (PDF) File or Web Archive from the drop-down box, and then click the Export button to export the report.
    12. Export exports the report to the selected format.
    13. E-mail opens a dialog which allows users to enter e-mail addresses in the To and From fields, as well as a subject and notes.
See Also

Report Preview | Components

Viewer: Viewer Features

Tutorials: Walkthrough: Web Report Viewer

Support: Troubleshooting


User Designer Control

The UserDesignerControl is a component which you can add to your Visual Studio toolbox, and then drop onto a Windows Form. The control is only available in Windows Application projects, and is disabled in Web projects. At run time, the UserDesignerControl allows end users to create their own custom reports.

Data Dynamics Reports also includes a compiled Report Designer application for your convenience which you can use or distribute. You can open it from the Start menu, or find it in the installation folder under Assemblies.

See Also

Components


Installing Data Dynamics Reports

Here you will find the information you need about system requirements and installed files.

Requirements
Find out which hardware and software is required prior to installing Data Dynamics Reports.
Installed Files
Learn what files are installed with Data Dynamics Reports.
Non-Admin Installation
It is best to install Data Dynamics Reports as the machine administrator.
Tip: Close Visual Studio® .NET before running the installation program to allow the help files to be integrated into the common help collection in Visual Studio®.
See Also

Tutorials: Creating a Report in the Designer


Installed Files

All of the files installed with Data Dynamics Reports can be found under Program Files\Data Dynamics\Reports\build number.

Assemblies Folder

DataDynamics.Reports.Designer.exe
Stand-alone report designer with viewer tab
DataDynamics.Reports.Imports.Access.exe
Import utility for Access reports
DataDynamics.Reports.Imports.Activereports.exe
Import utility for ActiveReports
DataDynamics.Reports.Imports.Crystal.exe
Import utility for Crystal Reports
DataDynamics.Reports.Preview.exe
Stand-alone report viewer with export capability
DataDynamics.Reports.SampleGallery.exe
Stand-alone sample gallery with report designer and viewer
DataDynamics.Reports.Design.dll
Report Designer control assembly used within Visual Studio
DataDynamics.Reports.dll
Report run-time assembly
DataDynamics.Reports.Extensibility.dll
HTML Export assembly
DataDynamics.Reports.Rendering.Graphics.dll
PDF Export assembly
DataDynamics.Reports.Rendering.Html.dll
RTF Export assembly
DataDynamics.Reports.Rendering.Pdf.dll
Text Export assembly
DataDynamics.Reports.Rendering.Xml.dll
TIFF Export assembly
DataDynamics.Reports.Web.dll
WebReportViewer control assembly for use on ASP.NET WebForms
DataDynamics.Reports.Windows.Forms.dll
ReportPreview control assembly for use on Windows Forms
DataDynamics.Reports.Preview.chm
Help file for the report viewer
DataDynamics.Reports.Designer.chm
Help file for the report designer
DataDynamics.Reports.Designer.exe.manifest
Application manifest describing the stand-alone report designer
datadynamics.reports.config
Configuration file for the stand-alone applications
DataDynamics.Reports.*.xml (10 files)
XML documentation used in property descriptions and Visual Studio Intellisense

Samples

Factbook Folder
Contains a sample XML database, images, and sample reports
Reels Folder
Contains a sample Access database, images, and sample reports
SampleGallery Folder
Contains the source code for the sample gallery executable

Visual Studio Folder

datadynamics.reports.config
Configuration file for Visual Studio assemblies
DataDynamics.Reports.VisualStudio.dll
Visual Studio integration package
msvcr71.dll
Microsoft common language runtime
VSIP Interop Assembly Redist.log
Visual Studio integration log

Visual Studio\1033

DataDynamics.Reports.VisualStudioUI.dll
US English localized user interface for Visual Studio

Visual Studio\Documentation

ddDDR.hxs
Integrated help file (User Guide and Class Library)
DDRCol* (7 files)
Help integration collection
H2Reg.* (3 files)
Files used to register the help collection in the Visual Studio combined help collection

Visual Studio\Templates

DataDynamics.Reports.VisualStudio.vsdir
Contains information that allows Data Dynamics Reports to be displayed in the Add Item and New Project dialog boxes
rdlx.rdlx
Basic report template


Non-Admin Installation

Recommended

Data Dynamics Reports performs best when installed by an administrator on the machine. If restricted users on the machine need access to Reports within Visual Studio, or need access to file associations, we recommend that the administrator select the "For All Users" option during installation.

Note: Restricted users cannot create or open Web projects regardless of selected options.

Not Recommended

If a non-administrator on the machine installs Data Dynamics Reports, the following problems occur.

  • Data Dynamics Reports does not integrate into Visual Studio.
  • An error occurs when the executable tries to access C:\Program Files\

If the administrator installs Data Dynamics Reports without selecting "For All Users," the following problems occur.

  • File associations do not work.
  • Restricted users can only use the stand-alone designer and viewer applications (but not the Visual Studio components).
See Also

Installing Data Dynamics Reports


Licensing Data Dynamics Reports

Licensing a Machine for Data Dynamics Reports

To license a machine for Data Dynamics Reports during installation

  1. Near the end of the installation, a Product Registration screen requests the following information:
    • User Name: Enter your name or company name here. You can use any characters in this field except the semicolon.
    • Email: Enter your e-mail address in this field.
    • Serial: Enter the serial number exactly as you received it from Data Dynamics, including any dashes or capital letters.
  3. Click the Next button and then the Finish button to complete the installation.
  4. The machine is now licensed, and no nag screens or evaluation banners appear when you use the product or create new solutions with it.

To license a machine with the trial version of Data Dynamics Reports

  1. From the Start menu, open the Control Panel.
  2. Select Add or Remove Programs.
  3. From the list of currently installed programs, select Data Dynamics Reports.
  4. Click the Change button.
  5. Select the License radio button and click the Next button.
  6. A Product Registration screen requests the following information:
    • User Name: Enter your name or company name here. You can use any characters in this field except the semicolon.
    • Email: Enter your e-mail address in this field.
    • Serial: Enter the serial number exactly as you received it from Data Dynamics, including any dashes or capital letters.
  7. If you have already created any Visual Studio projects using Data Dynamics Reports components, see the appropriate section on licensing Windows or Web applications below.

Checking Data Dynamics Reports Windows Applications for Licensing

Caution: If the application containing Data Dynamics Reports is not an executable, licensing must be embedded in the calling application, or root level executable, to take effect.

To check an existing Data Dynamics Reports Windows application for licensing

  1. Open an existing Data Dynamics Reports Windows application project.
  2. In the Solution Explorer window, click the "Show All Files" icon.

  3. If there is a file called "licenses.licx" in your application's file list, the Data Dynamics Reports application is licensed.
  4. If the "licenses.licx" file does not appear in your application's file list, follow the instructions under "Licensing Existing Windows Forms Projects" below.

Licensing Existing Windows Forms Projects

To license Windows Forms Projects

  1. Ensure that Data Dynamics Reports is licensed on the machine by following the steps above in the "Licensing a Machine for Data Dynamics Reports" section. As per above, this can be done either during installation of Data Dynamics Reports or later if using a trial version.
  2. Open the project in Microsoft Visual Studio.
  3. Open the Build menu from the Visual Studio menu bar and select the Rebuild Solution option.
  4. The executable program is now licensed, and no nag screens or evaluation banners appear when you use the program. The program can be redistributed to un-licensed machines and no nag screens or evaluation banners will appear there either.

Licensing Web Forms Projects

To license Web Forms Projects

  1. Data Dynamics Reports must be installed and licensed on a Development machine first. Follow the above steps under "Licensing a Machine for Data Dynamics Reports" to license this machine.
  2. Once installation is complete, browse to the Program Files\Data Dynamics\Reports\build number\Licensing\Web\Server\ folder on this machine. Inside of this folder are the following files:
    • GetServerID.aspx
    • Bin\DDClientTools.dll
    • Bin\GetServerIDTool.dll
  4. These files are to be copied to the root folder of the ASP.NET application on the production server (such as C:\Inetpub\wwwroot\). Be sure to copy the GetServerID.aspx file to the application's root folder, and copy the DDClientTools.dll and GetServerIDTool.dll files to the Bin folder inside this application root folder.
  5. Using your web browser, navigate to the http path of the GetServerID.aspx page (http://localhost/GetServerID.aspx, for example). It will display a "ServerID" that you will need for a subsequent step.
  6. On the licensed Development machine, browse to the Program Files\Data Dynamics\Reports\build number\Licensing\Web\ folder. Run the ServerLicensingApp.exe executable inside of this folder.
  7. When prompted, copy and paste the "ServerID" string obtained above into this application. Because some of the characters on-screen may look like other characters, it is important that you copy and paste this ServerID string instead of typing it out, to avoid entering the wrong information.
  8. It will produce an XML file in the same directory as the executable. Rename this file to license.xml.
  9. On the production server, inside of the root folder of the ASP.NET application, create a new folder named DataDynamicsLicenses. Copy the license.xml file created above into this new folder.
  10. The ASP.NET application is now licensed on the production server and no evaluation banners will show up on reports shown through this application.

Note: Once you have generated the licence.xml file, the GetServerID.aspx, Bin\DDClientTools.dll and Bin\GetServerIDTool.dll files are no longer required, and can safely be deleted from the production server. You may also leave these files there should you need to re-generate this ServerID for future applications.


Creating Reports

Data Dynamics Reports provides a Report Designer which allows you to create reports visually and store them in RDLX format. Here are the concepts and the skills you will need to begin authoring reports with the Report Designer.

Report Concepts and Architecture
Explore this section to learn about the structure and concepts of report design.
Building Reports
Learn the basics of report authoring with the Report Designer.
See Also

Tutorials: How-To Section | Walkthroughs


Report Concepts and Architecture

This section is provided to orient you to the new concepts and architecture that have been incorporated into Data Dynamics Reports.

Data
Learn about connecting data to a report.
Layout
Learn about the arrangement of items in a report.
Rendering
Learn how Data Dynamics Reports renders reports into specified formats.
Data Regions
Learn about the report items which you can use to display repeated rows of data.
Report Items
Learn about the items you can use to display data and graphics in your reports.
Document Map
Learn about the document map, or table of contents.
Interactive Sort
Learn about interactive sorting on textboxes.
Aggregates and Scope
Learn about the aggregate functions supported by Data Dynamics Reports, and the scope to which they are applied.
DataSet and ObjectDataSource Data Providers
Learn about the DataSet and ObjectDataSource data providers and how you can use the LocateDataSource event to return data from them.
Credentials
Learn to circumvent the data source credentials prompt and how you can use the LocateCredentials event to provide credentials at run time.
See Also

Tutorials: Building Reports


Data Explorer

Data Explorer

Access the Data Explorer by clicking the Data Explorer icon to the left of the report.

Once you add a data source and dataset to the Data Explorer, you can drag a field from it onto a data region or onto the report body itself to create a text box containing an expression, the scope of which depends on the context of the drop location.

Data Sources

Add a data source by clicking the Add Data Source icon.

The Data smart panel is where you select the type of data to use, provide a connection string, and choose other options for your data source. Access it by right-clicking a data source in the Data Explorer and selecting Edit. You can also elect to use a shared data source reference, use a single transaction, and select the method for handling credentials. Once you have finished supplying the necessary information, clicking the Accept icon causes the name of the data source to appear in the Data Explorer. You can add more than one data source to a report.

Datasets

Add a dataset by clicking the Add DataSet icon.

The Dataset smart panel is where you provide a command type and query string and choose other options for your dataset. Access the Dataset smart panel by right-clicking the new dataset in the Data Explorer and selecting Edit. You can also control the timeout period and other data options, and add fields, parameters, and filters to pull exactly the data you need. With some data types, clicking the Validate icon automatically populates it with the fields pulled by your query. With the XML data type, the fields must be added manually with XPath expressions. Clicking the Accept icon causes the name of the dataset and the names of the fields to appear under the data source name in the Data Explorer. You can add multiple datasets to a data source.

See Also

Reference: Connecting to a Data Source

Tutorials: Creating a Shared Data Source


Layout

A newly created report contains one area by default: the body. In the Report menu, you have the option of adding a page header or a page footer.

The Body of the Report

This area is the freeform empty slate upon which you can place any report item and which contains the data for the report. A data bound report item such as a TextBox which is placed directly on the body of the report displays the first value found for the associated field. Data regions, which can contain other report items, may be placed anywhere in the body of the report to display all of the values for any data bound report items you add to them. For more information, see Data Regions and Report Items.

The Page Header and Page Footer

You can add a page header or a page footer, or both, in the Report menu. These areas display the same information at the top and bottom of each page in your report. You can use any report item other than a data region or a subreport in these sections. You cannot bind a report item to a field in these areas. Page headers and footers are generally used for letterheads, company logos, contact information, and global information such as print date, report name, and page numbers. For information on suppressing page headers and footers on the first and last page of a report, see Hiding Page Headers and Footers.

See Also

Data Regions | Report Items | Report Designer

Tutorials: Hiding Page Headers and Footers


Rendering

To render a report, the Report Manager reads the RDLX file which defines the report, collects parameters, reads data, evaluates any expressions, calculates aggregates, and renders the compiled report into the chosen format.

The Report Manager uses rendering extensions and transformation extensions to render the compiled reports into the selected formats. See Rendering and Transforming Reports for more information.

See Also

Reference: Rendering and Transforming Reports


Data Regions

Data regions are report items which can contain other report items to repeat for all rows of data instead of showing only the first row. Data Dynamics Reports offers five types of data regions: Table, List, BandedList, Matrix, and Chart.

Table

The table data region shows data in rows. By default, a table has three columns and three rows. Once set at design time, the columns are static, while the rows repeat for each row of data.

The default rows are the header, detail, and footer. The header and footer can be removed, and group headers and footers can be added to suit your needs. Each cell contains a TextBox report item by default, but you can replace the TextBox with any other report item, including another data region.

List

The list data region allows you to arrange your data in any way you like. You can place any report item, including another data region, in the list, and it will repeat for each row of data.

Banded List

The banded list data region offers the freeform style of the list, but with groups added in bands. (ActiveReports and Access users will probably be most familiar with this layout.) By default, the banded list contains three bands: a header, a detail band, and a footer. You can insert groups in the banded list, and choose whether to show a group header and group footer band.

You can place any data region in header, footer, group header, and group footer bands. Other report items can be placed in any band in the banded list. Report items in the detail band repeat for each row of data, and report items in the group header and footer bands repeat for each group instance. The main header and footer rows render once at the beginning and end of the banded list, respectively, and are a good place for titles and grand totals.

Matrix

The matrix data region shows data in a pivot table or cross tab fashion. In a matrix, both columns and rows can expand to accommodate the data. You can create dynamic or static columns and rows in a matrix, and you can nest other data regions within the matrix.

Chart

The chart data region shows data in a graphical format that makes the data quickly and easily understood. All of the most popular chart types are included, and you can choose to make many of them three-dimensional.

For more information on each of these types of data region, see Using Data Regions.

See Also

Report Items

Reference: Chart Types | Using Data Regions | Grouping and Sorting Data


Report Items

Data Dynamics Reports offers a variety of report items. Each may be used in the body of the report, or within data regions.

Note: Take care in the naming of report items, as these are displayed to end users in the advanced search feature of the viewer.

TextBox

The TextBox displays data, and is the default report item which appears in each cell of a table or matrix. This is also the type of report item which is created when you drag a field from the Data Explorer onto the report. You can use expressions to modify the data which appears in a TextBox.

FormattedText

The FormattedText report item also displays data, but it allows you to format selected areas of text within the control in different ways. This report item accepts RichText and HTML input.

Barcode

The Barcode report item renders scannable barcodes in any of 23 popular symbologies. You can control check sums, bar width, rotation, quiet zones, caption locations, and many other properties, so this report item obviates the need to purchase a separate component.

Image

The Image report item displays an image from a database, a URL, or one that is embedded in the document. The report definition supports the following image types: .bmp, .gif, .jpg, and .png.

Line

The Line report item is a graphical element and has no data associated with it. You can use lines of varying weights, colors, and styles to highlight regions of your reports and to add style and polish.

Rectangle

The Rectangle report item is a graphical element which may be used as a container, and has no data associated with it. As a container, the rectangle serves to keep the report items it contains together when they might otherwise grow apart due to the growth of adjacent report items.

Subreport

The Subreport item displays another report within the report. You can pass a parameter to the subreport from the main report to keep it in synch with the other data displayed. Please note that since each subreport instance is run as a separate report, this can cause a noticeable difference in performance with large reports. In such cases, you may wish to consider using a data region instead.

See Also

Data Regions | TextBox Report Item

Reference: Text Formatting | Formatted Text Report Item | Images | Lines | Rectangles | Subreports | Barcodes | Report Item and Data Region Smart Panels


Document Map

The document map is a table of contents for the report. When a user clicks an item in the document map, the viewer jumps to that item in the report. Text boxes which have a document map label are added automatically to the document map. Other report items can be added to the document map by adding a document map label on the Navigation page of the smart panel displayed when you right-click the report item and choose Properties.

See Also

Tutorials: Adding Items to a Document Map

Reference: Document Maps

Viewer: Document Map Sidebar


Aggregates and Scope

Aggregates

You can use aggregate functions within report item value expressions to accrue data. Aggregate functions have a Scope parameter which is optional unless your report contains more than one dataset and the expression is not contained in a data region. Here are the aggregate functions supported by Data Dynamics Reports:

Function | Description
Avg | Calculates the average of the non-null values returned by the expression.
Count | Calculates the number of values returned by the expression.
CountDistinct | Calculates the number of distinct values returned by the expression.
CountRows | Calculates the number of rows in the scope of the expression.
First | Shows the first value returned by the expression.
Last | Shows the last value returned by the expression.
Max | Shows the largest non-null value returned by the expression.
Min | Shows the smallest non-null value returned by the expression.
StDev | Calculates the dispersion (standard deviation) of all non-null values returned by the expression.
StDevP | Calculates the population dispersion (population standard deviation) of all non-null values returned by the expression.
Sum | Calculates the sum of the values returned by the expression.
Var | Calculates the variance (standard deviation squared) of all non-null values returned by the expression.
VarP | Calculates the population variance (population standard deviation squared) of all non-null values returned by the expression.
RowNumber (Running Aggregate) | Shows a running count of all the rows returned by the expression.
RunningValue (Running Aggregate) | Uses one of the above functions to show a running aggregate of the values returned by the expression.
Aggregate (Custom Aggregate) | Calculates a custom aggregate from the data provider of the values returned by the expression.

Scope

The default scope of an aggregate function in a data region is the innermost grouping to which the report item belongs. You can specify the name of another grouping, dataset, or data region, or you can specify Nothing to choose the outermost grouping to which the report item belongs.

The default scope of an aggregate function outside a data region is the dataset. You must specify the dataset if there is more than one to avoid ambiguity. You cannot specify Nothing for the scope of a report item outside a data region.

Note: You cannot use the scope parameter in page headers or page footers.
See Also

Expressions

Reference: Functions


DataSet and ObjectDataSource Providers

Within Visual Studio, you can use the API to provide data at run time. A DataSetDataSource sample is included with this installation that demonstrates how this may be done.

You can also create a custom data provider. See the included CustomDataProvider sample for details.

Both samples may be found in the Sample Gallery application under Features > Developers > Report API.

DataSet Provider

Use the API to set a dataset on a report at run time. The DataSet provider returns a data table. All fields in the data table are available. To use the DataSet provider as a report's data source, set up a ReportDefinition and a ReportRuntime, and attach the ReportRuntime to a LocateDataSourceEventHandler.

Show Click to show or hide the code sample

//C# (See the DataSetDataSource sample for more context.)
private void LoadReport()
{
    FileInfo rptPath = new FileInfo(@"..\..\ReportFromDataSet.rdlx");
    //Create a report definition that loads an existing report.
    ReportDefinition definition = new ReportDefinition(rptPath);
    //Load the report definition into a new report runtime.
    ReportRuntime runtime = new ReportRuntime(definition);
    //Attach the runtime to an event. This line of code creates the event shell below.
    runtime.LocateDataSource += new LocateDataSourceEventHandler(runtime_LocateDataSource);
    previewControl.OpenReport(runtime, "DataSet Data Source");
}

private bool StringsAreEqual(string str1, string str2)
{
    //Allow for language-specific variances in strings.
    return string.Compare(str1, str2, true, CultureInfo.InvariantCulture) == 0;
}

//Data Dynamics Reports raises this event when it cannot locate a report's data
//source in the usual ways.
private void runtime_LocateDataSource(object sender, LocateDataSourceEventArgs args)
{
    object data = null;
    string dataSetName = args.DataSetName;
    string dataSourceName = args.DataSourceName;
    //Select which table to return.
    if (StringsAreEqual("DataSetDataSource", dataSourceName))
    {
        if (StringsAreEqual("ProductsDataSet", dataSetName))
            data = dataLayer.Data.Tables["Products"];
        else if (StringsAreEqual("DataSet1", dataSetName))
            data = dataLayer.Data.Tables["Sales"];
    }
    args.Data = data;
}

Parent Table Fields

To request a field from a parent table, prefix the field name with the name of the relation(s) that must be traversed to navigate to the appropriate parent table. Separate field names and relations with periods.

For example, consider a main table named OrderDetails which has a parent table named Orders. A Relation named Orders_OrderDetails defines the relationship between the two tables. Use a field with the syntax below to access the OrderDate from the parent table:

Orders_OrderDetails.OrderDate

Use this same technique to traverse multiple levels of table relations. For example, consider that the Orders table used in the prior example has a parent table named Customers and a relation binding the two called Customers_Orders. If the CommandText specifies the main table as OrderDetails, use the following syntax to get the CustomerName field from the parent table:

Customers_Orders.Orders_OrderDetails.CustomerName
Note: Ambiguity can occur if a field and a relation have the same name. This is not supported.

Limitations of the DataSet Provider

  • Relationship names that have periods in them are not supported.
  • Fields in nested relationships will only traverse parent relationships (e.g. FK_Order_Details_Orders.FK_Orders_Customers.CompanyName).

ObjectDataSource Provider

Use the API to bind a report data source to a collection of objects via the IEnumerable interface. The Object provider returns an IEnumerable collection. To use the Object provider as a report's data source, set up a ReportDefinition and a ReportRuntime, and attach the ReportRuntime to a LocateDataSourceEventHandler. Create a public class which sets up a property name to which the DataField can bind.

Show Click to show or hide the code sample

' VB.NET
' This code assumes a Windows form project with a ReportPreview control
' and a report named DogReport.rdlx.
Imports DataDynamics.Reports
Imports DataDynamics.Reports.ReportsCore
Public Class Form1

    Inherits System.Windows.Forms.Form

#Region " Windows Form Designer generated code "
' Leave this code intact.
#End Region

' Create a class from which to call a property.
    Public Class dog
        Private _name As String
        Public Property name() As String
            Get
                Return _name
            End Get
            Set(ByVal Value As String)
                _name = Value
            End Set
        End Property
    End Class

' Create an array to contain the data.
    Dim dogArray As System.Collections.ArrayList

' Create a method to populate the data array.
    Private Sub LoadData()
        dogArray = New ArrayList
        Dim dog1 As New dog
        dog1.name = "border collie"
        dogArray.Add(dog1)
        dog1 = New dog
        dog1.name = "cocker spaniel"
        dogArray.Add(dog1)
        dog1 = New dog
        dog1.name = "golden retriever"
        dogArray.Add(dog1)
        dog1 = New dog
        dog1.name = "shar pei"
        dogArray.Add(dog1)
    End Sub

' Add code to the form load event to set up the report
' and to add a handler for the LocateDataSource event.
    Private Sub Form1_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.Load
        ' Create file info with a path to the report in your project.
        Dim fi As New System.IO.FileInfo("..\DogReport.rdlx")
        ' Create a report definition using the file info.
        Dim repDef As New ReportDefinition(fi)
        ' Create a report runtime using the report definition.
        Dim runt As New ReportRuntime(repDef)
        ' Create a LocateDataSource event for the runtime.
        AddHandler runt.LocateDataSource, AddressOf runt_LocateDataSource
        ' Display the report in the viewer. The title can be any text.
        Me.ReportPreview1.OpenReport(runt, "Dog Report")
    End Sub

' Use the LocateDataSource event to load the data from the object.
    Private Sub runt_LocateDataSource(ByVal sender As Object, ByVal args As LocateDataSourceEventArgs)
        If dogArray Is Nothing Then
            LoadData()
        End If
        args.Data = dogArray
    End Function

End Class

Limitations of the ObjectDataSource Provider

  • Only public properties with no parameters can be used.

  • Objects passed to the ObjectDataReader must support IEnumerable.

  • The CommandText must be set to a Property or Method with no parameters that returns an IEnumerable object.

LocateDataSource Event

The reporting engine raises this event when it cannot find the data source in the usual ways, and passes in the following arguments:

  • DataSetName (a string)

  • DataSourceName (a string)

  • Report (a report runtime)

Provide the data for the report in the Data property of the event argument.

See Also

Data Source General Page | Report Concepts and Architecture

Getting Started: Data Explorer


Credentials

In most cases, you can retrieve any credentials required for data access from the user via the data source prompt. However, in the case of automated reports where there is no user, you need a way to circumvent the data source prompt. For this reason, we provide access to the LocateCredentials event.

Within Visual Studio, you can use the API to provide credentials at run time. To use this portion of the API, you must add references to your solution to the following components:

  • Data Dynamics Reports Extensibility Library
  • Data Dynamics Reports Core

LocateCredentials Event

Use the API to provide data credentials on a report at run time. Set up a ReportDefinition and a ReportRuntime, and attach the ReportRuntime to a LocateCredentialsEventHandler as in the sample code below.

LocateCredentials Event Arguments

The reporting engine raises the LocateCredentials event when the data source prompt is disabled, and passes in the following arguments:

  • DataSourceName
  • PromptText
  • ReportPath

The developer provides values for the following arguments:

  • UserName (a string)
  • Password (a string)
See Also

DataSet and ObjectDataSource Providers


Building Reports

This section is designed to familiarize you with the tools you can use to create impressive reports painlessly using Data Dynamics Reports.

Data
Explore the various ways in which you can add data to your reports.
Report Appearance
Examine the formatting and graphical options you have with Data Dynamics Reports, as well as report sections and subreports.
Interactive Reports
Discover interactive features such as parameters, filters, drill-down reporting, and links.
Expressions
Consider the ways that you can use expressions, global collections, functions, and custom code to enrich your reports.


Data

Report definitions offer great flexibility in the type of data you can use in your reports, as well as in the ways you can use it.

Connecting to a Data Source
Learn to connect your report to a data source.
Using Data Regions
Review the types of data regions available and how they may be used.
Grouping and Sorting Data
Learn how and where to best group and sort data for your reports.
See Also

Tutorials: Building Reports


Connecting to a Data Source

Data Dynamics Reports supports nearly any data source. Here are some of the more common ones:

  • SQL
  • DataSet
  • Object
  • ODBC
  • OleDb
  • Oracle
  • XML (Supports XPath 1.0)

Shared Data Source

To save time entering connection information, and to save time when such information changes, you can set up a shared data source which can be used in all of your reports. Then you need only create a SQL query to create a dataset for each report.

A shared data source is saved as a separate RDSX (Report Data Source XML) file in the project, so you can manage it separately.

Report Data Source

Even if you have a shared data source set up for your project, this does not limit you to using only that. You can still set up a new data source for any of your individual reports. This type of data source is saved as part of the report.

Unbound Data Source

You also have the option of setting up an extra data source in code for some special item in your report. This might be a text file or an array or just another data source. Please note that this type of data source does not appear in the fields list next to the designer, so the drag and drop functionality is not available for unbound data sources.

See Also

DataSet and ObjectDataSource Providers | Credentials

Getting Started: Data Explorer

Tutorials: Creating a Shared Data Source


Using Data Regions

Data Dynamics Reports offers a number of data regions for use in your reports.

Table
The Table data region has a static number of columns, and you can add group header and footer rows.
List
The List is a freeform data region in which you can place other report items.
Banded List
The Banded List data region is the one which most closely resembles the ActiveReports design surface with bands of freeform sections.
Matrix
The Matrix is a data region with dynamic numbers of rows and columns, and is similar in functionality to a cross tab or pivot table.
Chart
The chart is a graphic data region which allows you to display data in a variety of chart styles with 3D effects and colors.


Table

A table data region initially has three columns and three rows, for a total of nine cells, each of which is filled with a text box. At design time, you can add or remove columns and rows and groupings to suit your needs. At run time, the columns are static, while the rows expand downward to fill with the data you selected.

Data

As with any data region, you can drag fields from your fields list onto cells in the table. Although the default report item within each cell of the table is a text box, you can replace it with any other report item, including any other data region. When you drag a field into a cell in the detail row, Data Dynamics Reports automatically provides a label in the table header. As with all report items, you can use expressions to further manipulate the data within the cells of the table. For more information, see Expressions.

Grouping

One of the types of rows you can add to the table is the group header/footer. This is useful when you need to create, for example, a report which is grouped by country. You just add a group, and in the Group On Expression, choose the Country field from your dataset.

You can also group the data in your detail section, and you can add multiple rows to any group in the table. (i.e. More than one row in group header 1, more than one row in details, more than one row in the table header.) You can use aggregate functions in group footer rows to provide subtotals. For more information, see Grouping a Table.

Appearance

There are many ways in which you can control the appearance of the table data region. You can merge cells, control visibility, text color, background color. You can use graphical elements within the cells and borders on the cells themselves. For more information, see Report Appearance.

See Also

Table Data Region Smart Panel

Tutorials: Filtering a Table or Matrix Group | Grouping a Table | Sorting a Table | Walkthrough: Basic Report | Walkthrough: Master Detail | Walkthrough: Sorting


List

The list data region, like other data regions, repeats any report items it contains for every record in the dataset. Unlike other data regions, the list is freeform, so you can arrange report items in any configuration you like.

Grouping in the list is done on the details group. For more complex groupings, you can nest lists or other data regions.

See Also

List Data Region Smart Panel

Tutorials: Sorting a List | Grouping a List | Filtering a List Group


Banded List

The banded list data region is a collection of freeform bands with a detail band that repeats data in any report item for every row in the dataset. By default, the banded list is composed of three bands: the header, detail, and footer. You can add group header and group footer bands, and nest groups. You can also nest other data regions within the banded list in any band other than the detail band.

Grouping in the banded list is performed in much the same way as the table data region. You can provide a grouping expression for each group, and also sort the groups. You cannot sort the detail data in a banded list, so any sorting of this type must be done at the query level.

See Also

BandedList Data Region Smart Panel

Tutorials: Filtering a List Group | Sorting a Banded List | Grouping a Banded List | Walkthrough: BandedList Data Region


Matrix

The matrix data region arranges data in columns and rows like a cross tab or pivot table. Columns and rows in a matrix can be dynamic or static. Each cell in a matrix contains a textbox report item by default, but as with the other data regions, this can be replaced with any other report item. As with other data regions, the matrix repeats each report item it contains for each row in the dataset, but unlike the others, it also repeats horizontally for dynamic columns.

Cells

When you drop a matrix data region onto your report, there are four cells.

The top left cell is the corner or label cell. You can leave this cell blank or use it to display a label for the matrix.

The top right cell is a column header and the bottom left cell is a row header. You can drag fields into these cells or use expressions to group the data.

The bottom right cell is used to aggregate the detail data. At run time, detail cells display aggregates of the intersections of columns and rows.

Data

The matrix data region is associated with a dataset. You can make this association in the DataSetName property in the property grid.

Groups

You can group the columns and rows in the matrix by right-clicking the matrix and choosing Properties and on the Row Groups or Column Groups page, editing the Group on expression, or by dragging a field into the header cell.

You can nest column and row groups by right-clicking a column or row and choosing to insert a group, or simply by dragging another field onto the column or row into which you want to insert it.

To determine where new groups are displayed, when you drag a field into an existing group you can move the mouse up or down (for columns) or left or right (for rows) to nest the new group within the existing group, or to nest the existing group within the new group.

At run time, the nested group repeats within the original group. For instance, when you drag the City field from your dataset onto a header already grouped by Country, the report displays the first country with all of its cities, then the next country with all of its cities, and so on until all of the countries in the dataset are displayed with all of their cities.

Static Rows and Columns

To insert a static row or column, right-click the detail cell and choose to add a column or row. This displays a column next to or a row above or below the existing one and adds another detail cell.

Aggregates

Groups in a matrix do not subtotal data by default. To add this functionality, right-click the group header and choose Subtotal. This adds a cell to the right of the column, or below the row. Subtotal cells have a green triangle in the upper right corner which allows you to select the subtotal and set its properties in the property grid. For more information, see Aggregates and Scope.

Placement of Data

You can control where data is placed in several ways. You can change the Direction property of the matrix to RTL to cause dynamic column headers to expand left instead of right.

You can also move row headers to the right of the detail cells by changing the GroupsBeforeRowHeaders property of the matrix. The integer value you supply for this property equals the number of instances of the outermost column group that displays to the left of the row headers (or to the left if the Direction property is set to RTL).

See Also

Matrix Data Region Smart Panel

Tutorials: Filtering a Table or Matrix Group | Sorting a Matrix | Walkthrough: Matrix Data Region | Grouping in a Matrix Using Dynamic Columns and Rows

Getting Started: Adding Static Rows and Columns to a Matrix


Chart

The chart data region shows your data in a graphical representation that often makes it easier for users to comprehend large amounts of data quickly. The three main areas of control you have over the chart are as follows:

Chart Types
You can choose from a wide variety of chart types to best represent your data.
Chart Data
You can specify values, category groups, and series groups for your chart.
See Also

Chart Data Region Smart Panel

Tutorials: Filtering a Chart Group | Walkthrough: Charts


Chart Types

The Chart data region supports the following types of charts: Column, Bar, Area, Line, Pie, Scatter, Financial, and Other. See below for a description of each type as well as any sub-types offered for each.

Column Charts

Column charts present each series as a vertical column, and group the columns by category. The y-axis values determine the heights of the columns, while the x-axis displays the category labels.

Show Sub-types

Plain
Use a column chart to compare values of items across categories.
Stacked
A stacked column chart is a column chart with two or more data series stacked one on top of the other. Use this chart to show how each value contributes to a total.
Percent Stacked
A percent stacked column chart is a column chart with two or more data series stacked one on top of the other to sum up to 100%. Use this chart to show how each value contributes to a total with the relative size of each series representing its contribution to the total.

Bar Charts

Bar charts present each series as a horizontal bar, and group the bars by category. The x-axis values determine the lengths of the bars, while the y-axis displays the category labels.

Show Sub-types

Plain
Use a bar chart to compare values of items across categories.
Stacked
A stacked bar chart is a bar chart with two or more data series stacked one on top of the other. Use this chart to show how each value contributes to a total.
Percent Stacked
A percent stacked bar chart is a bar chart with two or more data series stacked one on top of the other to sum up to 100%. Use this chart to show how each value contributes to a total with the relative size of each series representing its contribution to the total.

Area Charts

Area charts present each series as a point, connect the points with a line, and fill the area below the line. The y-axis values determine the heights of the points, while the x-axis displays the category labels.

Show Sub-types

Plain
Use an area chart to compare trends over a period of time or in specific categories.
Stacked
A stacked area chart is an area chart with two or more data series stacked one on top of the other. Use this chart to show how each value contributes to a total.
Percent Stacked
A percent stacked area chart is an area chart with two or more data series stacked one on top of the other to sum up to 100%. Use this chart to show how each value contributes to a total with the relative size of each series representing its contribution to the total.

Line Charts

Line charts present each series as a point, and connect the points with a line. The y-axis values determine the heights of the points, while the x-axis displays the category labels.

Show Sub-types

Plain
Use a line chart to compare trends over a period of time or in certain categories.
Smooth (Bezier)
A smooth line chart is a line chart that plots curves rather than angled lines through the data points in a series. Use a smooth line chart to compare trends over a period of time or in certain categories.

Pie Charts

Pie charts present each category as a slice of pie or doughnut, sized according to value. Series groups are not represented in pie charts.

Show Sub-types

Pie
Use a pie chart to show how the percentage of each data item contributes to the total.
Exploded
Use an exploded pie chart to show how the percentage of each data item contributes to the total, with the pie slices pulled out from the center to show detail.
Doughnut
A doughnut chart shows how the percentage of each data item contributes to a total percentage.
Exploded Doughnut
Use an exploded doughnut chart to show how the percentage of each data item contributes to the total, with slices pulled out from the doughnut to show detail.

Scatter Charts

Scatter charts present each series as a point or bubble. The y-axis values determine the heights of the points, while the x-axis displays the category labels.

Show Sub-types

Plain
Use a scatter chart to show the relationships between numeric values in two or more series sets of XY values.
Connected
A connected scatter chart plots points on the X and Y axes as one series and uses a line to connect points to each other.
Smoothly Connected
A smoothly connected scatter chart plots points on the X and Y axes as one series and uses a line with the angles smoothed out to connect points to each other.
Bubble
The Bubble chart is an XY chart in which bubbles represent data points. The first Y value is used to plot the bubble along the Y axis, and the second Y value is used to set the size of the bubble. The bubble shape can be changed using the series Shape property. Shape choices include points, squares, circles, triangles, inverted triangles, diamonds, pyramids, and crosses.

Financial Charts

Stock charts present each series as a line with markers showing some combination of high, low, open, and close values. The y-axis values determine the heights of the lines, while the x-axis displays the category labels.

Show Sub-types

High Low Close
A high low close chart displays stock information using High, Low, and Close values. High and low values are displayed using vertical lines, while tick marks on the right indicate closing values.
Open High Low Close
An open high low close chart displays stock information using Open, High, Low, and Close values. Opening values are displayed using lines to the left, while lines to the right indicate closing values. The high and low values determine the top and bottom points of the vertical lines.
Candlestick
A candlestick chart displays stock information using High, Low, Open and Close values. The height of the wick line is determined by the High and Low values, while the height of the bar is determined by the Open and Close values. The bar is displayed using different colors, depending on whether the price of the stock has gone up or down.
Renko

The Renko chart uses bricks of uniform size to chart price movement. When a price moves to a greater or lesser value than the preset BoxSize value required to draw a new brick, a new brick is drawn in the succeeding column. The change in box color and direction signifies a trend reversal.

Kagi
A Kagi chart displays supply and demand trends using a sequence of linked vertical lines. The thickness and direction of the lines vary depending on the price movement. If closing prices go in the direction of the previous Kagi line, then that Kagi line is extended. However, if the closing price reverses by the preset reversal amount, a new Kagi line is charted in the next column in the opposite direction. Thin lines indicate that the price breaks the previous low (supply) while thick lines indicate that the price breaks the previous high (demand).
Point and Figure
The point and figure chart uses stacked columns of Xs to indicate that demand exceeds supply and columns of Os to indicate that supply exceeds demand to define pricing trends. A new X or O is added to the chart if the price moves higher or lower than the BoxSize value you set. A new column is added when the price reverses to the level of the BoxSize value multiplied by the ReversalAmount you set. The use of these values in the point and figure chart to calculate pricing trends makes this chart best suited for long-term financial analysis.
Three Line Break

A three line break chart uses vertical boxes or lines to illustrate price changes of an asset or market. The price in a three line break graph must break the prior high or low set in the NewLineBreak property in order to reverse the direction of the graph.

Other Charts

Other chart types may be used for special functions like charting the progress of individual tasks.

Show Sub-types

Funnel
A funnel chart shows how the percentage of each data item contributes to the whole, with the largest value at the top and the smallest at the bottom. This chart type works best with relatively few data items.
Pyramid
A pyramid chart shows how the percentage of each data item contributes to the whole, with the smallest value at the top and the largest at the bottom. This chart type works best with relatively few data items.
Gantt
The Gantt chart is a project management tool used to chart the progress of individual project tasks. The chart compares project task completion to the task schedule.
See Also

Chart | Chart Data Region Smart Panel

Tutorials: Walkthrough: Charts


Chart Data

When you create a chart, you must provide values to determine the size of the chart element, and category groups to group the data and to provide category labels. You may also, for some of the chart types, use series groups to add a chart element for each series group to each category.

Values

You must provide at least one value series for your chart to appear. These are static, similar to a static matrix row group, and dictate the size of your chart elements such as the height of a column or the location and size of a bubble.

A single value series with no series groups shows a single chart element for each category group. Multiple values show a chart element for each value in each category group with the name of each value series displayed in the chart legend. (i.e. Adding a Freight value series to a Sales by Customer column chart adds a column for freight next to each sales column for each customer. It also specifies the Freight and Sales values by color or pattern in the legend.)

To use category groups or series groups, you must use an aggregate expression for the value. You do not need to use an expression for the value if you only have one value in your dataset for each category. For more information on using expressions, see Expressions.

Category Groups

Using category groups not only groups your data, similar to a matrix column group, it also provides labels for your chart elements. For a bar chart, these labels appear along the y-axis, while for a column chart, they appear along the x-axis.

Using multiple category groups nests the categories, so if you group sales by country and by city in a column chart, the x-axis shows a tick mark labeled with each city, and the country below with brackets encompassing all of that country's cities.

Series Groups (Optional)

Series groups are dynamic, similar to a matrix row group, so you can use them to create another dimension in your data. For example, by adding a Year series group to a bar chart of Sales by Product, instead of a single bar for each product, you would have a bar for each year for each product. Labels for series groups appear in the chart legend.

Connecting Data to a Chart

Data Bound Charts
To create a data bound chart, use the Chart UI or the Chart Properties smart panel.


Data Bound Charts

Data Binding with the Chart UI

Data can be bound to charts very simply using the UI. When you click on the chart in the layout tab, you will notice that areas with the following labels appear:

  • Drop data fields here
  • Drop category fields here
  • Drop series fields here

Simply drag fields from the Data Explorer and drop them onto the appropriate areas. If you need to edit the expressions in any of these fields, right-click them and select Edit.

Data Binding with the Chart Properties Smart Panel

If you want to take advantage of the many other chart options you can control, you may instead right-click the chart and choose Properties. The Chart Data Region smart panel offers a Data page in which you can set the Dataset name for the chart and add, remove, and edit expressions for Values, Category Groups, Series Groups, and Filters. The smart panel also offers other pages in which you can control a wide array of properties to create exactly the chart you need. For more information on those properties, see Chart Appearance.

See Also

Chart Data Region Smart Panel

Getting Started: Data Explorer


Grouping and Sorting Data

Grouping Data

You can group data by fields or expressions in data regions. In the Table and the Banded List, you can group details and add group header and footer rows and aggregate data.

The default scope of an aggregate function in a data region is the innermost grouping to which the report item belongs. You can specify the name of another grouping, dataset, or data region, or you can specify Nothing to choose the outermost grouping to which the report item belongs.

For more information on aggregates or subtotals, see Aggregates and Scope. In the Matrix, you can add dynamic columns and rows to group data. In the List, you can group detail data and even nest Lists for more levels of grouping. For more information on how to group data in each of the data regions, see Grouping in the How-To section.

Detail Grouping

Detail grouping is available in the List and Table data regions. It is useful when you do not want to repeat values within the details. When a detail grouping is set, the value repeats for each distinct result of the grouping expression instead of for each row of data. For example, if you use the Customers table of the NorthWind database to create a list of countries without setting the details grouping, each country is listed as many times as there are customers in that country. If you set the details grouping to =Fields!Country.Value each country is listed only once.

Note: If the detail grouping expression you use results in a value that is distinct for every row of data, a customer number for example, you will see no difference in the results.

Recursive Hierarchies

If you need to report on data in which all parent-child relationships are represented, you can create a recursive hierarchy. To do this, you need a unique ID field for the child to use as the Details Group, and an ID field for the parent to use as the Parent Group.

For example, if you have a dataset pulled from the NorthWind database with the SQL statement SELECT * FROM Employees, you can use the EmployeeID value as the group on expression, and the ReportsTo value as the parent group expression.

Please note that you can use only one group expression when you use a parent group.

To better visualize data in a recursive hierarchy, you can use the Level function:

Level Function

In a recursive hierarchy, you can use the Level function to indent text and further clarify the relationships between parents and children. To do this, you use an expression in the Left Padding property of the text box you want to indent.

For example, if you group on the EmployeeID value, and use the ReportsTo value as the parent group, you can indent the employee name text box based on the level by using the following expression in the Padding > Left property:

=Convert.ToString(2 + (Level()*10)) & "pt"

This gives left padding of 2pt to a top level employee (i.e. Vice President, Sales), 12pt for a second level employee (i.e. Sales Manager, Inside Sales Coordinator), and 22pt for a third level employee (i.e. Sales Representatives who report to a Sales Manager).

For more information, see Functions.

Sorting Data

Even after your employees in the above examples have been grouped and indented by level, you may still want to sort them by a field other than the default, which in this case is the EmployeeID. To do this, you can sort the data on an expression or a field. To alphabetize the employees on each level in the example above, you can set the Sort On expression to the value of the LastName field.

Note: The sorting behavior of Data Dynamics Reports differs slightly from that of our competitors. In other reporting solutions, the outer list, data region, or grouping directly affects the sort order of the detail records in the nested list, data regions, or groupings. In DD Reports, the sorting and grouping of the records is disconnected from one grouping level (or list or data region nesting level) to the next to honor the original order of the records coming in from the query. This offloads some of the sorting work to the server, which provides a performance benefit with very large numbers of records.

For example, if you have a parent list ("list1") with two sort fields (CustomerID, OrderData) and a child list ("list2") with no sort fields set, choose one of the following ways to get the same results as you would get with other reporting solutions:

  • Add OrderDate after CustomerID to the ORDER BY clause in the SQL query.
  • Add the sorting specification for OrderDate to the nested list ("list2") in addition to or instead of the outer list ("list1").

For more information on how to sort data in each of the data regions, see Sorting in the How-To section.

See Also

Aggregates and Scope

Tutorials: Sorting | Grouping


Report Appearance

Data Dynamics Reports offers a number of ways to customize the appearance of your reports.

Headers and Footers
Add headers and footers to each page of your report.
TextBox Report Item
Learn about the most commonly used report item in the toolbox.
Text Formatting
Use .NET and custom formatting strings for text, numbers, and dates.
Conditional Formatting
Use expressions to allow your data to dictate the formatting of report items.
FormattedText Report Item
Use XHTML to richly format text in this report item.
Graphical Elements
Add appeal to your reports with images, lines, and rectangles.
Themes
Predefined sets of colors, fonts, and images for use in expressions help to keep reports consistent in appearance.
Master Reports
Develop master reports with a common set of report items, page layouts, and data sources to be combined with content in child reports.
Subreports
Embed another report within the body of your report.


Headers and Footers

In addition to the Body section which is contained in every report definition, you can add Header and Footer sections. From the Report menu, choose Page Header or Page Footer.

You can add any of the following controls to the Page Header or Page Footer:

  • Textbox
  • FormattedText
  • Image
  • Barcode
  • Line
  • Rectangle

You cannot use expressions which refer to any of the report's fields in the Page Header or Page Footer, and you cannot use data regions or subreports in these sections.

You can, however, use expressions based on global values such as page number, date, report name, etc. in the Page Header or Page Footer. To add page numbering, use an expression like the following in the Value property of a textbox:

= "Page " & Globals!PageNumber & " of " & Globals!TotalPages

By default, the Page Header and Page Footer are rendered on the first and last pages of the report. However, if you do not want these sections to appear on every page of a report, change the PrintOnFirstPage and PrintOnLastPage properties to False. For more information, see Hiding Page Headers and Footers.

See Also

Tutorials: Hiding Page Headers and Footers

Getting Started: Layout


TextBox Report Item

The TextBox is the most basic report item that can display data in a report. It is the default report item that fills each cell of a table or matrix data region, and it is the report item that is created when you drag a field from the Data Explorer onto the report.

In the Value property of the TextBox, you can enter static text or an expression. An expression can display fields from a database, or calculate a value, or visually display data. See the Expressions topic for more information.

Tip: You can enter text directly into the TextBox on the design surface of the report by double-clicking inside it.

You will notice in the property grid an abundance of properties that you can use to control the appearance and behavior of this report item. For example, under the subheading Misc, you can set the Action property to cause the report to jump to another report, a bookmark, or a URL when the TextBox is clicked at run time. The DataElement properties under the subheading Data allow you to control how and whether the data in the report item is displayed in XML exports.

Under the subheading Layout are properties that control where, when and whether the report item displays. You can use the RepeatWith property to specify a data region with which the TextBox should repeat when that data region spans multiple pages. The HideDuplicates property allows you to specify a grouping or dataset within which to hide the TextBox when its value equals the value of the same item in the previous row.

By default, a TextBox can grow vertically to accommodate the data it displays, and cannot shrink smaller than it appears at design time. To change this behavior, set the CanShrink and CanGrow properties in the property grid.

Fields

When you drag a field from a dataset in the Data Explorer onto the report surface, a TextBox report item with an expression is automatically created. The type of expression that is created depends upon the context where you drop the field. The following table describes the various contexts and expressions created if you drag a field named SalesAmount onto the report.

Note: The expression created is different for a field with a string or unknown data type. In these cases, the First aggregate is used in place of the Sum aggregate in the expressions below. At run time, the first value found within the scope is displayed instead of a summary.
Context | Expression | Run-Time Behavior
Directly on the report surface | =Sum(Fields!SalesAmount.Value) | Displays a summary of the sales amount for the entire dataset.
List data region | =Fields!SalesAmount.Value | Displays a value for each row of data, in a list running down the page.
BandedList data region, header or footer band | =Sum(Fields!SalesAmount.Value) | Displays a summary of the sales amount for the dataset associated with the BandedList.
BandedList data region, detail band | =Fields!SalesAmount.Value | Displays a value for each row of data, in a list running down the page.
BandedList data region, group header or footer band | =Sum(Fields!SalesAmount.Value) | Displays a summary of the sales amount for the grouping.
Table data region, header or footer row | =Sum(Fields!SalesAmount.Value) | Displays a summary of the sales amount for the dataset associated with the Table.
Table data region, detail row | =Fields!SalesAmount.Value | Displays a value for each row of data, in a list running down the page.
Table data region, group header or footer row | =Sum(Fields!SalesAmount.Value) | Displays a summary of the sales amount for the grouping.
Matrix data region, corner cell | =Sum(Fields!SalesAmount.Value) | Displays a summary of the sales amount for the dataset associated with the Matrix.
Matrix data region, column header cell | =Fields!SalesAmount.Value | Displays the value at the top of a new column for each row of data running to the right.
Matrix data region, row header cell | =Fields!SalesAmount.Value | Displays the value to the left of a new row for each row of data running down the page.
Matrix data region, detail cell | =Sum(Fields!SalesAmount.Value) | Displays a summary of the sales amount for the intersection of the column and row.
See Also

TextBox Report Item Smart Panels

Reference: Report Appearance | Text Formatting


Text Formatting

The two main types of formatting concern numbers and dates. Report definitions allow you to use .NET formatting strings as well as custom formatting strings such as those you may have used in Microsoft Excel.

Common Number Formats

Visual Studio.NET provides shortcuts for some of the most commonly used number formats, or you can create your own:

Format String | Description | Results on the number 123456789 in the en-US Culture
C or c | Currency | $123,456,789.00
D or d | Decimal | 123456789
E or e | Scientific | 1.234568E+008
F or f | Fixed-point | 123456789.00
G or g | General | 123456789
N or n | Number | 123,456,789.00
P or p | Percentage | 12,345,678,900.00 %
R or r | Round-trip | 123456789
X or x | Hexadecimal | 123456789
##m##m##m##.000 | Custom m formatting | 123m45m67m89.000

Common Date Formats

Visual Studio.NET also provides shortcuts for some of the most commonly used date/time formats, or you can create your own:

Format String | Description | Results on the date 01-May-92 in the en-US Culture
d | Short date | 5/1/1992
D | Long date | Friday, May 01, 1992
t | Short time | 12:00 AM
T | Long time | 12:00:00 AM
f | Full date/time (short time) | Friday, May 01, 1992 12:00 AM
F | Full date/time (long time) | Friday, May 01, 1992 12:00:00 AM
g | General date/time (short time) | 5/1/1992 12:00 AM
G | General date/time (long time) | 5/1/1992 12:00:00 AM
M or m | Month day | May 01
R or r | RFC1123 pattern | Fri, 01 May 1992 00:00:00 GMT
Y or y | Year month | May, 1992
dddd | Custom day formatting | Friday
yyyy gg | Custom year formatting | 1992 A.D.

For more information, see MSDN's Custom DateTime Format Strings topic.

See Also

Getting Started: TextBox Report Item


Conditional Formatting

You can base the formatting of text on the value of the data to highlight items in your report using expressions in the style properties of the report item. For example, in an employee list, you can render the names of sales managers in bold with the following expression in the FontWeight property:

=iif(Fields!Title.Value = "Sales Manager", "Bold", "Normal")

Green Bar Reports

A commonly used report style which requires conditional formatting is the green bar report. To apply this style to the detail row in a table, select the detail row and use the following expression in the BackgroundColor property:

=iif(RowNumber(Nothing) Mod 2, "PaleGreen", "White")

Red Negatives

Another commonly used style which can be acheived using conditional formatting displays any negative dollar values in red. This can be accomplished using the following expression in the Color property of the textbox:

=iif(Fields!GrossProfit.Value < 0, "Red", "Black")

Highlighting

You can also highlight certain values, for example if you want to track sales of all products with a unit price of over $100, you can use the following expression in the BackgroundColor property of the UntiPrice textbox:

=iif(Fields!UnitPrice.Value > 100, "Yellow", "White")

As you can imagine, with more complex expressions the possibilities are virtually endless.

See Also

Tutorials: Walkthrough: Expressions

Reference: Expressions


Formatted Text Report Item

The FormattedText report item displays richly formatted text in XHTML. To format text in the FormattedText report item, enter XHTML code into the HTML property.

Supported HTML Tags

Please note that valid unsupported tags are ignored. Invalid tags throw an error. All text used in the Html property must be enclosed in <body></body> tags.

Tag | Description
<!-- --> | Defines a comment
<!DOCTYPE> | Defines the document type
<a> | Defines an anchor
<abbr> | Defines an abbreviation
<acronym> | Defines an acronym
<address> | Defines an address element
<b> | Defines bold text
<base /> | Defines a base URL for all the links in a page
<bdo> | Defines the direction of text display
<big> | Defines big text
<blockquote> | Defines a long quotation
<body> | Defines the body element (Required)
<br /> | Inserts a single line break
<caption> | Defines a table caption
<center> | Defines centered text
<cite> | Defines a citation
<code> | Defines computer code text
<col> | Defines attributes for table columns
<dd> | Defines a definition description
<del> | Defines deleted text
<dir> | Defines a directory list
<div> | Defines a section in a document
<dfn> | Defines a definition term
<dl> | Defines a definition list
<dt> | Defines a definition term
<em> | Defines emphasized text
<h1> to <h6> | Defines header 1 to header 6
<head> | Defines information about the document
<hr /> | Defines a horizontal rule
<html> | Defines an html document
<i> | Defines italic text
<img /> | Defines an image
<ins> | Defines inserted text
<kbd> | Defines keyboard text
<li> | Defines a list item
<map> | Defines an image map
<menu> | Defines a menu list
<ol> | Defines an ordered list
<p> | Defines a paragraph
<pre> | Defines preformatted text
<q> | Defines a short quotation
<s> | Defines strikethrough text
<samp> | Defines sample computer code
<small> | Defines small text
<span> | Defines a section in a document
<strike> | Defines strikethrough text
<strong> | Defines strong text
<style> | Defines a style definition
<sub> | Defines subscripted text
<sup> | Defines superscripted text
<table> | Defines a table
<tbody> | Defines a table body
<td> | Defines a table cell
<tfoot> | Defines a table footer
<th> | Defines a table header
<thead> | Defines a table header
<tr> | Defines a table row
<tt> | Defines teletype text
<u> | Defines underlined text
<ul> | Defines an unordered list
See Also

Getting Started: Report Items

Tutorials: Adding Hyperlinks


Graphical Elements

The use of graphics can be a vital element in helping readers to understand the data presented in a report.

Lines
Lines separate regions of data for clarity.
Rectangles
Rectangles group items together and keep them in place during rendering.
Images
Static images and images from a database add appeal to reports.


Lines

The Line report item is a graphical element that can be used to visually separate regions of data for ease of comprehension. In addition to the properties which control the appearance of the line, there is also a property that you can use to control when the line is rendered: RepeatWith.

Repeat a Line

The RepeatWith property allows you to choose a data region with which to repeat the Line. If you set this property to a data region which renders on multiple pages, the Line report item will render on each page containing the data region in the same position.

Note: Repeated items do not show up in the default Gallery mode of the preview tab, as it has no pages. To see the line repeated, change to Print Preview mode.
See Also

Graphical Elements | Line Report Item Smart Panel

Tutorials: Toggling Visibility

Getting Started: Report Items


Rectangles

The Rectangle report item is a container for other items. There are a variety of ways in which you can use it to enhance your reports.

Drawing a Box

You can set the BorderStyle, BorderColor, and BorderWidth properties of the Rectangle to create purely visual effects within your report.

Grouping Items

You can place report items within the Rectangle to group them visually, and to make it easier at design time to move a group of report items.

Note: Drawing a rectangle around existing items does not contain them. Instead you must drag the items into the rectangle.

Displaying an Image Behind Items

You can display an image behind a group of report items by setting the BackgroundImage property of the Rectangle.

Anchoring Items

Probably the most useful feature of the Rectangle report item is its ability to anchor report items which may otherwise be pushed down by a vertically expanding data region. For example, if you have a group of textboxes to the left or right of a table, and one or more of them is below the table's bottom edge, at run time the lower textboxes are pushed down below the expanded table while the upper textboxes remain where you placed them at design time. To prevent this from happening, place the group of textboxes within a rectangle.

See Also

Rectangle Report Item Smart Panel | Graphical Elements


Images

The Image report item displays an image that you embed in the report, add to the project, store in a database, or access through a URL. You can choose the image source from the property grid after you place the Image report item on the report.

Embedded Images

To embed an image in your report, from the Report menu select Embedded Images. Click under the Image column to reveal an ellipsis button (...) and select an image file from your local files. The Name and Mime Type columns are filled in automatically and the image file's data is stored in the report definition. The benefit of this is that there is no separate image file to locate or to keep track of when you move the report between projects. The drawback is that the larger the file size of the image you embed, the more inflated your report file size becomes.

To use an embedded image in an Image report item, set the Source property to Embedded. The Value property will then populate with the list of embedded images.

Database Images

Product catalogues are probably the most common scenario in which images stored in a database are used in reports. Images in a database cannot be used in Page Headers and Page Footers, because you cannot use a value expression which refers to a field in these sections. You can use images stored in a database in data regions to repeat for every row of data. For more information about using data regions to repeat data, see Using Data Regions.

To use a database image in an Image report item, set the Source property to Database. You can select the field containing the image in the Value property.

Note: Microsoft Access database images are generally stored as OLE objects and cannot be read by the Image report item.

Web Images

You can also use any image to which you can navigate via a URL. The benefit of this is that images stored in this way add nothing to the file size of the project or of the report, but the drawback is that if the web based image is moved, it will no longer show up in your report. To use this type of image, supply the URL.

To use a web image in an Image report item, set the Source property to External. You can supply the URL of the image in the Value property.

See Also

Image Report Item Smart Panel

Getting Started: Report Items

Tutorials: Adding Data Bound Images | Adding Data Bound Images


Barcodes

The Barcode report item offers 23 different barcode styles from which to choose. This saves you the time and expense of finding and integrating a separate component. As with other data-bound report items, you can use an expression to bind the value of a field to the Barcode value.

Aside from the barcode style, you can control the alignment, direction, color, background color, bar width, caption position, font, text, and whether checksum is enabled. There are more properties available with the Code49, PDF417, and QRCode barcode styles.

For more information, see Barcode Report Item.

See Also

Barcode Report Item Smart Panel

Getting Started: Report Items


Master Reports

Master reports are like dynamic templates that you can design for use with content reports to help your users create consistent reports department-wide or company-wide. You design the master report with report items, code, data sources, and layout properties that cannot be modified in content reports, and add content placeholders in which your users can place their content.

Master Reports differ from templates in that they are loaded each time the report is executed. Therefore, a master report can be modified and the changes to the master report will automatically appear in any reports that reference it.

Advantages

  • You can centralize common report functionality within master reports.
  • Changes in company information (such as an address change or data source change) can be accomplished more quickly in a single master than if they had to be made to every report.
  • You can create code, data sources, themes and page layouts to be shared across the application or enterprise.
  • You can hide report complexity from end users who will use the designer application to create content reports.

Designing Master Reports

When designing a master report, you use report items, code, data sources, and layout properties in the same way that you do in a normal report. The major difference you see at design time is one extra report item in the toolbox: the ContentPlaceHolder. Use this report item to designate where users of content reports can add content to the template you've created with the master report. Content placeholders appear as disabled rectangles on the master report at design time. In the master report, you cannot place any content in these placeholders, but you can use the placeholder's Text property to convey to users of the master the intended purpose of each placeholder.

A master report is valid on its own, and can be run without a content report.

To prevent end users from modifying a master report, you can set permissions on the file to Read Only for that user or group.

Creating Content Reports

When the user creates a new report and selects the check box next to Select Master Report and selects your master report, the design view is effectively the opposite of the design view of the master report: everything except the content placeholder is disabled. Users see any report items in the master as disabled. Any report items overlaid by content placeholders are not visible in the content report at design time, but are visible at run time. The only areas to which users can add report items are the content placeholder rectangles.

A content report is not valid on its own, and cannot be run without its specified master report.

While designing the content report the user cannot:

  • Modify or remove sections that exist in the master report.
  • Modify the disabled (grey) areas in the master report sections.
  • Remove a master report data source.
  • Remove a master report dataset or modify its query.
  • Modify the sort or filter on a master report dataset.
  • Remove images from the EmbeddedImages collection.
  • Remove parameters from the ReportParameters collection.
  • Modify the margins or page settings of the master report.
  • Modify or remove custom code that exists in the master report.
    Note: Code in the master report is hidden in the content report, so in order to allow content report users to access code, the master report developer must provide documentation.

The user can:

  • Add sections that do not exist in the master report.
  • Add new data sources that do not exist in the master report.
  • Add new datasets from a data source in the master report.
  • Add images to the EmbeddedImages collection.
  • Add parameters to the ReportParameters collection.
  • Add any number of report items into placeholder rectangles designated by the master report.
  • Modify the report name and description.
  • Add new custom code that does not exist in the master report.

Run-Time Sequence of Events

Here is what happens behind the scenes when you run a content report.

  1. Data Dynamics Reports loads the content report.
  2. The loader parses the master report tag on the content report and requests the master report from the resource resolver.
  3. The master report is loaded into the definition.
  4. As each ContentPlaceHolder in the content report is parsed, it finds the corresponding placeholder in the master report and loads the content from the content report into it.
  5. Data sources, datasets, and fields are merged. The master report has higher priority if there is a conflict.
  6. Themes are merged. The master report has higher priority if there is a conflict.
  7. Report properties from the content report are added to those of the master report. In the case of the following properties, the content report has a higher priority in case of conflict:
    • Report Description
    • Report Author
    • Report AutoRefresh
    • Report Custom
    • Report Language
    • Report DataTransform
    • Report DataSchema
    • Report ElementName
    • Report DataElementStyle
    • Dataset filters
    • Report Theme
    • Report Code
    • All content inside the content placeholders
See Also

Tutorials: Walkthrough: Master Reports


Subreports

Many of the situations in which you previously used subreports can now be handled with data regions for better performance. The reason for the improved performance is that while every instance of each subreport must be processed by the report server, data regions do not require the server to run multiple reports. Multiple report processing can become burdensome in very large reports with a large number of subreports. Using data regions to display separate groups of data can be much more efficient in such reports. For more information, see Using Data Regions.

However, subreports still make sense when you need to nest groups of data from different data sources within a single data region, or when you can reuse a subreport in a number of reports.

Notes: If you make changes to the subreport without changing the main report, the preview window does not re-run the report unless you click the Refresh icon.

If you are designing the parent report in the stand-alone Report Designer application, you must save the parent report to the same directory as the subreport for the subreport to render in the preview tab.

If there are borders set on both the Subreport report item and on the body of the report hosted in it, Data Dynamics Reports does not merge the two borders.

  • If the report hosted in the Subreport report item cannot be found or contains no rows, the border of the Subreport report item is rendered.
  • If the hosted report is found and does contain rows, the border of the hosted report body is rendered.

Parameters

You can use parameters supplied by the parent report to filter data displayed in a subreport. You can also pass parameters to a repeating subreport nested in a data region to filter each instance. For more information, see Passing Parameters.

See Also

Subreport Report Item Smart Panel

Tutorials: Walkthrough: Subreports


Interactive Reports

Data Dynamics Reports offers several features that help you to make reports interactive.

Parameters
Specify parameters to manipulate data.
Filters
Add filters to datasets and data regions.
Drill-Down Reports
Toggle report items between visible and hidden.
Links
Use hyperlinks to drill through to other reports and to link to bookmarks.
Document Maps
Add a Table of Contents to provide easy navigation.


Parameters

You can use parameters to filter the data displayed in reports. You can either prompt users for parameters so that they control the output, or supply the parameters behind the scenes. You can also pass values from the main report to a subreport's parameters to keep data synchronized.

Each parameter must be entered in three places: the Query page of the DataSet smart panel, the Parameters page of the DataSet smart panel, and the Report Parameters smart panel.

Query Parameters (DataSet smart panel Query page)

In your query, use the syntax specific to your data source type to create a parameter.

For example, with an OLEDB data source like the included sample Reels.mdb, to add a multi-value Movie Rating parameter to a query on the Movie table, use syntax like the following:

SELECT * FROM Movie WHERE MPAA IN (?)

A query parameter can get its value from the Report Parameters collection (entered by the user or from a value you supply), a field in another dataset, or an expression.

To pass a Report Parameter into the parameter in your query, select the Parameters page of the DataSet smart panel.

Enter the parameter name, and supply a value like:

=Parameters!MPAA.Value
To populate the list of fields and close the smart panel, click the Accept icon at the top right.

Report Parameters Smart Panel (Report Menu)

From the Report menu, select Report Parameters to open the smart panel. The Add button allows you to add parameters to the list.

Options in this smart panel allow you to control how and whether a user interface is presented to your users for each parameter. Each Report Parameter in the collection must have a unique name, and the name must match the name you call in the Parameters page of the Dataset smart panel. In the case of the example above, the name is MPAA.

You can also control the data type, the text used to prompt the user, whether to allow null, blank, or multiple values, and whether to hide the user interface on the General page. The data type of the parameter must match the data type of the field that it filters.

Select the Value icon below the list of parameters to select a default value and populate a list of available values from which users can choose. Use a separate dataset to populate this list.

To run the report without prompting the user, do not supply prompt text and instead select the Hidden check box. In this case, you must provide a default value.

Note: If you hide the user interface and do not provide a default value, the report will not run.

Parameter values are collected in the order they appear in the Report Parameters collection. You can change the order using the arrows in the Report Parameters smart panel. This order can only be affected by the existence of any cascading requirements between the parameters.

  • Prompting for Parameters
  • Hidden Parameters
  • Cascading Parameters
See Also

Tutorials: Passing Parameters | Walkthrough: Parameters


Prompting for Parameters

Prompting for Parameters

To prompt the user for parameters, provide prompt text in the General page of the Report Parameters smart panel, and ensure that the Hidden option is not selected.

Select the Value icon below the list of parameters to select a default value and populate a list of available values from which users can choose.

These values can be queried or non-queried. Non-queried values are a static set of values that you enter manually and can be in the form of static data or expressions. Since the values that are meaningful to your data source are often incomprehensible to the end user, you can provide a label for each value. Use a separate dataset to populate the list from a query. For example, to offer users a choice of movie ratings in the included Reels.mdb sample database, use a query like the following:

SELECT DISTINCT MPAA FROM Movie
Note: To avoid having values become obsolete between the time the user selects the value and when they run the report, be sure to write queries that return datasets that will not change rapidly. Obsolescence can also become a problem with non-queried values, such as expressions using the DateTime.Now property. To avoid this problem, instead write an expression that uses the DateTime.Today property.

If you select the Multivalue option, you must provide a list of valid values to the user. The list can be defined in the report or retrieved from a query. You can also provide an ALL value in the list which removes the filter.

See Also

Parameters

Tutorials: Passing Parameters | Walkthrough: Parameters | Creating an ALL Parameter


Hidden Parameters

Using Default Values Instead of Prompting

To run a report without any action on the part of the user, provide a default value for each parameter and select the Hidden check box in the Report Parameters smart panel.

Like the valid values list, default values can be queried or non-queried. A non-queried default value can be a static value or an expression.

A queried default value is a field value from a dataset. When using a query, the first returned row value is used as the parameter value.

Subreport Parameters

You can easily synchronize a subreport's data with that of the parent report by setting the Parameters property of the Subreport report item to the name of a Report Parameter in the report you are displaying in the Subreport report item, and then setting the Value to an expression pointing to a field or other object in the parent report.

For more information, see Passing Parameters.

Drillthrough Parameters

Drillthrough links to separate reports pass parameters via the Navigation page of the TextBox or Image smart panel. When you select Jump to report for the action, the parameters list is enabled. The name of the parameter you enter must exactly match the name of the parameter in the linked report, and it is case sensitive. You can pass a value from the current report to the parameter in the Value column of the list.

If a value is not supplied for an expected parameter in the linked report, or if the parameter names do not match, the linked report will not run.

See Also

Parameters | Drill Through | Subreports

Tutorials: Passing Parameters


Cascading Parameters

When a parameter’s value list depends on the value of another parameter, the report collects the required parameter value, then uses it to create the value list for the second parameter. For example, if the end user is looking for an airport, you first prompt them for the country to populate the list of valid cities, then when they choose the city, they will get a list of valid airport codes. Then they can select the airport code to display the report of arrivals and departures. This cascade of parameter values is sometimes called dependent or hierarchical parameters.

Tip: In order for the parameters to cascade, each must depend on the value of the previous parameter, which means that each must come from a separate table. If all of your queries come from the same table, no dependency exists, and all the data is pulled.

Here is an example of the steps involved in creating a report with cascading parameters using the included sample Reels database:

  1. Create a dataset named Regions which will be used to populate a combo box with names of the regions since most end users would not find the RegionID meaningful.
    SELECT RegionID, Region FROM Regions
  2. Create a dataset named Districts using a query which will populate a combo box with names of the districts rather than just the ID number. This query will rely on the Region parameter we will add to the Report Parameters collection.
    SELECT DistrictID, District FROM Districts WHERE Region = ?
  3. On the Parameters page of the Dataset smart panel, add a Region parameter with the value set to =Parameters!Region.Value so that it will look for the Region parameter we will add to the Report Parameters collection.
  4. Create a dataset named StoreNumbers using a query which will only retrieve products falling in the selected region from the selected district. This query will rely on the DistrictID parameter.
    SELECT StoreID, StoreName FROM Store WHERE NOT StoreID = 0 AND DistrictID = ?
  5. On the Parameters page of the Dataset smart panel, add a DistrictID parameter with the value set to =Parameters!DistrictID.Value so that it will look for the DistrictID parameter we will add to the Report Parameters collection.
  6. From the Report menu, choose Report Parameters and add a parameter named Region. Choose to create available values from a query, and set the dataset to Regions, the value field to RegionID, and the label field to Region.
  7. Add a second parameter named DistrictID, and choose to create available values from a query. Choose Districts for the dataset, DistrictID for the value field, and District for the label field.
  8. Click OK to close the Report Parameters smart panel.
  9. Add a table to the Layout view of the report, and drag the ProductName field onto the detail row.
  10. Preview the report, and notice the two combo boxes. You can select a region in the first, but the second combo box remains disabled until a region is selected. After selecting a region and a district, click the View Report button to see the data returned by your selection.
See Also

Parameters | Dataset Parameters Page


Filters

Filters perform their work on a larger set of data that has already been retrieved from the data source. You can use them with datasets and with data regions.

Although filters are not as efficient performance-wise as query parameters which filter data at the source, there are still use cases which demand them. The obvious case is when the data source does not support query parameters. Another case for using filters is when users who require different sets of data are viewing the same report. In this case, you need to pull all of the data into your dataset so that it is available for all of the users.

See Also

Tutorials: Adding Filters


Drill-Down Reports

You can add drill-down interactivity to your reports using the visibility properties of report items, groups, columns, or rows. Simply set the hidden property to true and set the toggle item to the name of another item in the report, usually a text box in the group containing the hidden item. At run time, this puts a plus sign next to the toggle item which the user can click to display the hidden data.

Tip: If you want detail information to collapse in a drill-down report, you must set the visibility properties of the entire data region, group, column, or row that you want to collapse. If you set it on a single text box, the adjacent text boxes will still be visible, and will prevent the row or column from collapsing.

Because you can use expressions in the Hidden property, you can also hide items based on the value of another report item.

Hidden Data in Exports

You can make your hidden data interactive in the report viewer, but when reports are exported, the various file formats handle hidden data differently.

Export Type | Filename Extension | Effect on Hidden Data
Web Archive | .mhtml | Hidden data is not shown unless it is in an expanded state when the report is exported.
Acrobat | .pdf | Hidden data is not shown unless it is in an expanded state when the report is exported.
Image | .bmp, .emf, .gif, .jpeg, .tiff, .png | Hidden data is not shown unless it is in an expanded state when the report is exported.
Extensible Markup Language | .xml | All hidden data is shown.
See Also

Tutorials: Toggling Visibility


Links

Links allow you to give the user access to more information. You can add links to the TextBox and Image report items.

Hyperlinks
Use hyperlinks to jump to web pages.
Bookmarks
Use bookmarks to jump to other pages in the report.
Drill-Through
Use drill-through links to jump to other reports.


Hyperlinks

You can add hyperlinks to the TextBox and Image report items. To do so, in the Action property of the report item choose the Jump to URL option and supply a valid URL. In the Data Dynamics Reports Viewer, the linked web page displays in a new browser instance. The various exports affect the behavior of hyperlinks differently.

Hyperlinks in Exports

Export Type | Effect on Hyperlinks
HTML | Hyperlinks display the web page in the current browser.
PDF | Depending on the user's settings, Acrobat can open the web page in Acrobat or in a web browser.
Image | All hyperlinks are lost.
See Also

Tutorials: Adding Hyperlinks


Bookmarks

A bookmark link is similar to a hyperlink, except that it moves the viewer to another area in the report instead of linking to a web page. There are two steps involved in creating this type of link. You must identify the place you allow a user to jump to with a Bookmark ID, and you must share that ID with the item that will link to it.

Providing a Bookmark ID

The Bookmark ID is like a URL in that it provides the information that the report viewer needs to locate the report item. You need to provide a Bookmark ID for any report item to which you want to allow users to jump via a Bookmark Link. To provide a Bookmark ID, right-click the report item and choose Properties. The Bookmark ID is located on the Navigation page. You can set a Bookmark ID on any report item or group.

Creating a Bookmark Link

To create a bookmark link, click the ellipsis button next to the Action property of the report item, choose the Jump to bookmark option, and supply a valid Bookmark ID. Bookmark links can only be added to the following report items:

  • TextBox
  • Image

Bookmark Links in Exports

Export Type | Effect on Bookmark Links
HTML | Bookmark links jump to the report item marked with the Bookmark ID in the browser.
PDF | All bookmark links are lost.
Image | All bookmark links are lost.

See Also

Image Navigation Page | TextBox Navigation Page


Drill Through

A drill-through link is similar to a hyperlink, except that instead of navigating to a web page, the link navigates to another report with more detail. A drill-through link is also more complex; you can pass parameters to the report called by the link.

Passing Parameters through a Drill-Through Link

To pass a parameter to a detail report from a drill-through link:

  1. In the summary report (for example Orders), right-click the report item (i.e. OrderID) that you want to handle the link and choose Properties.
  2. On the Navigation page under Hyperlink action, choose Jump to Report.
  3. Choose the report to jump to (i.e. Order Details), and click the Parameters button to the right.
  4. Under Parameter Name, choose the parameter in the jump-to report (i.e. OrderID).
  5. Under Parameter Value, choose the field in the summary report that corresponds to the parameter.

Drill-Through Links in Exports

Export Type | Effect on Drill-Through Links
HTML | Drill-through links are broken unless the drill-through target report is also exported to the same directory with the same name as the original.
PDF | All drill-through links are lost.
Image | All drill-through links are lost.
Extensible Markup Language | All drill-through links are lost.
See Also

Tutorials: Adding Drill-through Links | Walkthrough: Drill-Through


Document Maps

A document map, or table of contents, provides the user with a convenient way to navigate a lengthy report. Data Dynamics Reports creates the document map automatically when you provide a document map label for each report item you want to display for navigation. You can use an expression to create the label text which displays in the document map.

Document Maps in Exports

In the report viewer, the document map appears in a pane to the left of the report, but when you export your reports, the various file formats handle document maps differently.

Export Type | Effect on Document Map
HTML | The document map is lost.
PDF | The document map becomes the bookmarks collection.
Image | The document map is lost.

See Also

Tutorials: Adding Items to a Document Map


Expressions

You can use expressions in all of your report items to show precisely the data you want to show, exactly how you want to show it.

Data and Expressions
Learn to manipulate data and concatenate strings with expressions.
Global Collections
Learn to use global values, such as the date or page number, as well as your collection of fields or parameters in expressions.
Functions
Learn to use aggregate functions in datasets, data regions and groups.
Data Visualization
Learn to use data visualization expressions to emphasize data in your reports based on any criteria you set.
See Also

Tutorials: Walkthrough: Expressions | Building Reports


Data and Expressions

In most of the report item properties you can enter Microsoft Visual Basic® .NET expressions directly in the property grid or build expressions in the expression editor smart panel. You can use expressions to set the value of a report item, or to set conditions under which certain styles apply.

Note: All expressions must begin with an equal sign (=).

Even setting a basic field value for a text box is done using a simple expression:

=Fields!LastName.Value

Expressions are also used to aggregate data in summary fields. For more information, see Functions.

Using the Expression Editor

You can build many expressions much more quickly using the expression editor because it allows you to choose from a number of fields available to the report as well as to the particular property. Once you have chosen a field, you can replace the existing expression, insert the field into the expression at the cursor, or add the field onto the end of the expression. There are five types of fields available in the expression editor:

Constants
Constant fields are only available to properties which have enumerated values, such as TextDecoration or BorderStyle.
Globals
Global variables are run time values available to every property in every report. There are two variables in this list which come from the User collection: UserID and Language.
Parameters
Parameter fields are only available in reports which have report parameters. If available, you can choose a parameter from this field to retrieve the current value of the parameter.
Fields
If the report item is linked to a dataset, all of the fields in the dataset are available.
Datasets
All of the fields in each dataset in the report are available, but the report will retrieve only the sum or the first value of any field that is not within the current dataset scope.
Operations
More information will be added about this item prior to release.
Common Functions
More information will be added about this item prior to release.

Concatenating Fields and Strings

In its raw form, your data may not be ideally suited for display in a report. You can massage it into shape using expressions. You can concatenate fields with strings and with other fields. Here are a couple of examples followed by the results they yield:

=Fields!LastName.Value + ", " + Fields!FirstName.Value

Smith, Jane

=Fields!City.Value + ", " + Fields!Region.Value + " " + Fields!PostalCode.Value

Columbus, OH 43231

Conditional Formatting

You can highlight report items based on specific field values by using expressions in properties like Color, BackgroundColor, Font, and Border.

The basic formula for conditional formatting is:

=iif( Fields!YourFieldName.Value operator "Value to compare", "If condition is met, use this value.", "If not, use this one.")

You can also use a conditional expression to decide whether to hide a textbox. For example, if you put the following expression in the Visibility > Hidden property of a textbox that displays the text "Free Shipping," the textbox only shows up on invoices sent to Denmark:

=iif( Fields!ShipCountry.Value = "Denmark", False, True)

For more examples see Conditional Formatting.

Functions

You can use any of a number of aggregate and other functions in your expressions. Although the summary function is the most common, Data Dynamics Reports includes a range of others, including running functions, standard variance, population standard deviation, count, minimum and maximum. For more information, see Functions.


Global Collections

Data Dynamics Reports offers five Global Collections for use in expressions:

  • Globals
  • Parameters
  • Fields
  • ReportItems
  • User

You can access any of the global collections using Microsoft Visual Basic® .NET collection syntax, for example:

Collection!ObjectName
= User!Language
Collection.Item("ObjectName")
= User.Item("Language")
Collection("ObjectName")
= User("Language")

The Globals, Parameters, and User global collections also support Visual Basic® .NET property syntax, for example:

Collection.ObjectName
= Globals.PageNumber

The Globals and User collection members are of the data type variant. If you need to use a specific data type, use casting. For example,

CDate(Globals!ExecutionTime)

Here are the five collections, and their uses:

Globals

There are six global variables available for use in expressions:

  • PageNumber - gets the current page number in the report.
  • TotalPages - gets the total number of pages in the report.
  • ExecutionTime - gets the amount of time it took the report to execute.
  • ReportServerUrl - gets the URL of the report server.
  • ReportFolder - gets the name of the folder containing the report.
  • ReportName - gets the name of the report.

Example:

= Globals!ReportName

Parameters

All Report Parameters are available for use with queries, filters, and expressions. There are two properties on the Parameter object:

  • Value - returns the current value of the parameter.
  • Label - returns the more user-friendly version of the Value. For example, if the Value is the AirportCode, the Label might be the AirportName. If you did not specify a Label in the Parameter, the Value is used.

In a report item property, you can check the current Value of a parameter to decide whether to change a background color or hide a textbox. The following example, when used in the BackgroundColor property, makes the Bevarages report AliceBlue, but leaves reports on all other categories Transparent.

Example:

=iif( Parameters!CategoryID.Label = "Beverages", "AliceBlue", "Transparent")

Fields

Each dataset in your report contributes a Fields collection. All fields in these collections are available for use in expressions. There are two basic properties on the Fields object:

  • Value - returns the current value of the field. If the same field name exists in multiple collections, the report looks to context to determine which collection to use. In a data region, it uses the associated dataset. In an aggregate expression, it uses the dataset for the scope.
  • IsMissing - indicates whether the field is present in the dataset.
Note: Some data providers allow additional properties which you can access using the collection syntax.

Example:

= Fields!LastName.Value + ", " + Fields!FirstName.Value

ReportItems

Every report item in your report is available for use in expressions. There is one property on the ReportItems object:

  • Value

Example:

= ReportItems!textbox1.Value

User

There are two user variables available for use in expressions:

  • UserID - gets the machine name and user name of the current user.
  • Language - gets the language settings of the current user.

    You could use the UserID to retrieve user preferences or to grant or deny access to certain data. The Language can be used to determine time and date or currency formats. Unless you also have a conversion process in place though, it is best not to use the Language to determine currency formats so that you never end up with an invoice that should charge $5 but actually charges ¥5 (about four and a half cents).

    Example:

    = iif (User!Language = "en-US", "My fellow American", "Dear Madam or Sir")
    • See Also

    Data and Expressions | Functions


Functions

You can use functions in any report item property expression to perform actions on data in data regions, groupings, and datasets.

Scope

All functions have a Scope parameter which determines the grouping, data region, or dataset to be considered when calculating the aggregate or other function. Within a data region, the Scope parameter's default value is the innermost grouping to which the report item belongs. Alternately, you can specify the name of another grouping, dataset, or data region, or you can specify Nothing, which sets it to the outermost data region to which the report item belongs.

The Scope parameter must be a data region, grouping, or dataset that directly or indirectly contains the report item using the function in its expression. If the report item is outside of a data region, the Scope parameter refers to a dataset. If there is only one dataset in the report, you can omit the Scope parameter. If there are multiple datasets, you must specify which one to use to avoid ambiguity.

Note: You cannot set the Scope parameter to Nothing outside of a data region.

Aggregate Functions

You can use aggregate functions within report item value expressions to accrue data. Here are the aggregate functions supported by Data Dynamics Reports:

Function | Description
Aggregate | Calculates a custom aggregate from the data provider of the values returned by the expression.
Avg | Calculates the average of the non-null values returned by the expression.
Count | Calculates the number of non-null values returned by the expression.
CountDistinct | Calculates the number of non-repeated values returned by the expression.
CountRows | Calculates the number of rows in the scope returned by the expression.
First | Shows the first value returned by the expression.
Last | Shows the last value returned by the expression.
Max | Shows the largest non-null value returned by the expression.
Min | Shows the smallest non-null value returned by the expression
RowNumber | Shows a running count of all the rows in the scope returned by the expression.
RunningValue | Shows a running aggregate of values returned by the expression. (Takes one of the other aggregate functions as a parameter.)
StDev | Calculates the dispersion (standard deviation) of all non-null values returned by the expression.
StDevP | Calculates the population dispersion (population standard deviation) of all non-null values returned by the expression.
Sum | Calculates the summary of the values returned by the expression.
Var | Calculates the variance (standard deviation squared) of all non-null values returned by the expression.
VarP | Calculates the population variance (population standard deviation squared) of all non-null values returned by the expression.

Examples:

Aggregate:
Aggregate(Fields!LineTotal.Value, "Order")
Average:
Avg(Fields!Cost.Value, Nothing)
Count:
Count(Fields!EmployeeID.Value, Nothing)
Count Distinct:
CountDistinct(Fields!ManagerID.Value, "Department")
Count Rows:
CountRows("Department")
First Value:
First(Fields!ProductNumber.Value, "Category")
Last Value:
Last(Fields!ProductNumber.Value, "Category")
Maximum Value:
Max(Fields!OrderTotal.Value, "Year")
Minimum Value:
Min(Fields!OrderTotal.Value)
Running Count of Rows:
RowNumber(Nothing)
Running Value:
RunningValue(Fields!Cost.Value, Sum, Nothing)
Standard Deviation:
StDev(Fields!LineTotal.Value, "Order")
Population Standard Deviation:
StDevP(Fields!LineTotal.Value, "Order")
Summary:
Sum(Fields!LineTotal.Value, "Order")
Variation:
Var(Fields!LineTotal.Value, "Order")
Population Variation:
VarP(Fields!LineTotal.Value, "Order")

Other Functions

Data Dynamics Reports also offers several functions which do not aggregate data, but which you can use with an IIf function to help determine which data to display or how to display it.

Function | Description
InScope | Determines whether the current value is in the indicated scope.
Level | Returns the level of the current value in a recursive hierarchy. For more information, see Grouping and Sorting Data.
Previous | Returns the previous value within the indicated scope.

Examples:

In Scope:
InScope("Order")
Level:
Level("EmployeeID")
Previous:
Previous(Fields!OrderID.Value)

Other Ways to Use Functions

Custom Code
Learn to use custom code and custom assemblies in your reports.
See Also

Custom Code | Expressions


Custom Code

You can use custom code in your expressions to further extend the capabilities of Data Dynamics Reports. For complex functions, or those you will use many times in your report, embed the code in the report. For code that you will use in many different reports, maintain the code in a custom assembly and refer to its methods in your expressions.

Embedded Code

You can add code to your report on the Code tab.

You must use instance-based Visual Basic .NET code in the form of a code block. You can include multiple methods in your code block, and access those methods from expressions in report item properties.

Here is a simple example of a single method code block:

Public Function GetDueDate() as Date
  Return DateTime.Now.AddDays(30)
End Function

Here is the expression used to call the method in the above code block:

=Code.GetDueDate()

Custom Assemblies

You can create custom assemblies in C# or Visual Basic .NET to call from your reports. To make code available to multiple reports:

  1. Create or find the assembly you wish to use.
  2. Make the assembly available to the report engine.
    • If you are embedding the designer or viewer controls in your own application, copy the assembly to the same location as your executable.
    • If you are using the included designer or viewer, copy the assembly into the Data Dynamics Reports Assemblies folder (C:\Program Files\Data Dynamics\Reports\Build Number\Assemblies).
      Note: To make the assembly available for use in your own application and for use in designing reports for your application, copy it to both locations listed above. Or you can place the assembly in the Global Assembly Cache (C:\Windows\Assembly).
  3. Add an assembly reference to the report.
    • From the Report menu, choose Report Properties.
    • On the References page, add your assembly.
  4. Access the assembly through expressions.
    • To access static members (member denoted as public static in C# assemblies, or as Public Shared in Visual Basic assemblies):
      • =Namespace.Class.Member
    • To access class instances (see Creating an Instance Method):
      • =Code.InstanceName
See Also

Tutorials: Adding Code


Data Visualization

Within an expression, you can use data visualizations to emphasize data in your reports based on any criteria you set. For example, you can red flag an overdue account using the Flags icon set as a background image. The following links will take you to a deeper understanding of how each type of data visualization works.

Note: The terms "argument" and "parameter" may seem interchangeable, but within expressions, an argument is actually the returned value of a parameter, while a parameter may be a variable.
  • Color Scale 2
  • Color Scale 3
  • Data Bar
  • Icon Set
  • Range Bar
  • Range Bar Progress


Color Scale 2

The ColorScale2 data visualization displays a range of colors to indicate minimum and maximum values, and all shades in between.

Parameters

  • Value. This is the field value in the report to be evaluated. The data type is Single.
  • Minimum. If the Value evaluates to this number, the StartColor is rendered.
  • Maximum. If the Value evaluates to this number, the EndColor is rendered.
  • StartColor. The HTML color string to use if the Value evaluates to the Minimum value.
  • EndColor. The HTML color string to use if the Value evaluates to the Maximum value.

You can use static values or aggregate functions (e.g. Min or Max) to set the Minimum and Maximum parameters. For more information on these and other aggregate functions, see the Functions topic.

Syntax

=ColorScale2(Value, Minimum, Maximum, StartColor, EndColor)

Example

=ColorScale2(Fields!InStock.Value, 0, (Max(Fields!InStock.Value, Nothing)),
"Red", "Blue")
Usage

Use an expression like the example in any property which takes a color value, such as the BackgroundColor property of a control. This causes the background color to change depending on the value of the field you specified in the Value parameter, in the case of the example, InStock. Any values falling between the Minimum value and the Maximum render with a color between the StartColor and EndColor.

Default Behavior

The function returns Transparent in any of the following cases:

  1. The Value is out of range, i.e. does not fall between the Minimum and Maximum values.
  2. The Maximum is less than the Minimum.

If the argument for any of the parameters cannot be converted to the required data type, the default value is used instead.

Parameter | Default Value
Value | 0
Minimum | 0
Maximum | 0
StartColor | Red
EndColor | Green


Color Scale 3

The ColorScale3 data visualization displays a range of colors to indicate minimum, average, and maximum values, and all shades in between.

Parameters

  • Value. This is the field value in the report to be evaluated. The data type is Single.
  • Minimum. If the Value evaluates to this number, the StartColor is rendered.
  • Average. If the Value evaluates to this number, the MiddleColor is rendered.
  • Maximum. If the Value evaluates to this number, the EndColor is rendered.
  • StartColor. The HTML color string to use if the Value evaluates to the Minimum value.
  • MiddleColor. The HTML color string to use if the Value evaluates to the Average value.
  • EndColor. The HTML color string to use if the Value evaluates to the Maximum value.

You can use static values or aggregate functions (e.g. Min, Avg, or Max) to set the Minimum, Average, and Maximum parameters. For more information on these and other aggregate functions, see the Functions topic.

Syntax

=ColorScale3(Value, Minimum, Average, Maximum, StartColor, MiddleColor, EndColor)

Example

=ColorScale3(Fields!InStock.Value, 0, (Avg(Fields!InStock.Value, Nothing)),
(Max(Fields!InStock.Value, Nothing)), "Red", "Yellow", "Green")
Usage

Use an expression like the example in any property which takes a color value, such as the BackgroundColor property of a control. This causes the background color to change depending on the value of the field you specified in the Value parameter, in the case of the example, InStock. Any values falling between the Minimum value and the Average value render with a gradient scale color between the StartColor and MiddleColor. The closer the value is to the Minimum, the closer to red the color renders. In the same way, values falling between the Average and Maximum render with a color between the MiddleColor and EndColor, in this case, varying shades of yellow-green.

Default Behavior

The function returns Transparent in any of the following cases:

  1. The Value is out of range, i.e. does not fall between the Minimum and Maximum values.
  2. The Maximum is less than the Minimum.
  3. The Average is not between the Minimum and the Maximum.

If the argument for any of the parameters cannot be converted to the required data type, the default value is used instead.

Parameter | Default Value
Value | 0
Minimum | 0
Average | 0
Maximum | 0
StartColor | Red
MiddleColor | Yellow
EndColor | Green
See Also

Data Visualization

Tutorials: Walkthrough: Expressions


Data Bar

The DataBar data visualization displays a 96 by 96 dpi bar image, the size of which is defined by the Width and Height arguments. The Value argument determines the amount of colored bar to render to the right of the Zero argument (or to the left in the case of a negative value).

The Minimum and Maximum arguments determine the range of data. The area between the Value argument and the Maximum argument is transparent (or between the Value and the Minimum in the case of a negative value).

Parameters

  • Value. This is the field value in the report to be evaluated. The data type is Single.
  • Minimum. The lowest value in the range of data against which the Value argument is compared. This value corresponds to the leftmost edge of the image. If this argument is greater than the Zero argument, Zero becomes equal to Minimum. The data type is Single.
  • Maximum. The highest value in the range of data against which the Value argument is compared. This value corresponds to the rightmost edge of the image. If this argument is less than the Zero argument, Zero becomes equal to Maximum. The data type is Single.
  • Zero. This value determines the zero point to the left of which negative data is rendered, and to the right of which positive data is rendered. The data type is Single.
  • Color. The HTML color string to use in rendering the Value in the bar image.
  • Width. The total width of the control in which the DataBar renders. The data type is Length.
  • Height. The total height of the control in which the DataBar renders. The data type is Length.

You can use static values or aggregate functions (e.g. Min or Max) to set the parameters. For more information on these and other aggregate functions, see the Functions topic.

Syntax

=DataBar(Value, Minimum, Maximum, Zero, Color, Width, Height)

Simple Example

=DataBar(Fields!TotalAmount.Value, (Min(Fields!TotalAmount.Value, Nothing)),
(Max(Fields!TotalAmount.Value, Nothing)), 0, "BlueViolet", "2in", ".25in")

Usage

Use an expression like the example in any property which takes an image, such as the BackgroundImage property of a TextBox or the Value property of an Image. This renders a bar in the color specified, the width of which changes depending on the number returned by the Value parameter, in the case of the example, TotalAmount. If your data contains only positive values, Zero corresponds with Minimum at the left edge of the DataBar. The area between the Value and the Maximum is transparent.

Example Using Negative Values

=DataBar(Fields!Difference.Value, -10, 25, 0,
IIf(Fields!Difference.Value < 0, "Red", "Blue"), "4in", ".25in")

When your data contains negative as well as positive values, you can use an Immediate If expression for the Color parameter. In the example above, if the Difference value is negative, it is rendered in red, while positive values are rendered in blue. You can also see that negative values are rendered to the left of Zero and positive values are rendered to the right.

Default Behavior

The function returns null (i.e. no image is rendered) in any of the following cases:

  1. The Width or Height is invalid, i.e. the appropriate unit designator (such as "in" for inches or "cm" for centimeters) is not used.
  2. The Maximum is less than or equal to the Minimum.
  3. The expression is placed in a property which does not take an image.
  4. The Source property of the image is not set to Database.

If the argument for any of the parameters cannot be converted to the required data type, the default value is used instead.

Parameter | Default Value
Value | 0
Minimum | 0
Maximum | 0
Zero | 0
Color | Green
Width | 0in
Height | 0in


Icon Set

The IconSet data visualization allows you to use arguments to select an image from an image strip and display it either as a TextBox BackgroundImage, or as an Image Value. You can use the standard image strips included with Data Dynamics Reports, or create custom image strips.

Standard Image Strips

Name | Image
3TrafficLights |
Arrows |
Blank |
Flags |
GrayArrows |
Quarters |
Ratings |
RedToBlack |
Signs |
Symbols1 |
Symbols2 |
TrafficLights |

To use these image strips, place code like the following in the BackgroundImage property of a TextBox report item, or in the Value property of an Image report item.

Note: When using icon sets, you must set the Source property to Database.
=IconSet("Flags", False, True, False, False, False)

The first argument designates the name of the icon set to use. Following that argument, there are five Boolean arguments. The first argument to evaluate to True displays the corresponding image. Use data expressions that evaluate to a Boolean value to replace the literal values in the code above. For example:

=IconSet("Symbols1", (Fields!Quantity.Value > 700), False, (Fields!Quantity.Value < 600), False, False)

This expression displays the first symbol (the green check mark) on each row in which the Quantity exceeds 700, and displays the third symbol (the red x) on each row in which the quantity is below 600. Notice that because of the literal False value in the second argument, the yellow exclamation point symbol never appears.

In several of the included image strips, the last spots are empty. When using the 3TrafficLights, Flags, Signs, Symbols1, or Symbols2 image strip, it generally makes sense for the final two Boolean values to be False. By the same token, when using the RedToBlack or TrafficLights image strip, the last Boolean value should be False.

The Blank image strip is included so that you can customize it. See below for details.

Custom Image Strips

Custom image strips must conform to the following rules.

  1. The format must be of a type that is handled by the .NET framework.
  2. The size of the strip must be 120 x 24 pixels.
  3. Each image must be 24 x 24 pixels in size.
  4. There must be no more than five images in the strip.
  5. If there are fewer than five images in the strip, there must be blank spaces in the image to fill in.

Types of Custom Images

Here is the syntax for various types of custom images, followed by examples of each.

  • External image
    =IconSet(location of image strip, condition#1, condition#2, condition#3, condition#4, condition#5)

    Example:

    =IconSet("C:\Images\customstrip.bmp", 4 > 9, 5 > 9, 10 > 9, False, False)
=IconSet("http://mysite.com/images/customstrip.gif", 4 > 9, 5 > 9, 10 > 9, False, False)
  • Image from an assembly resource
    =IconSet("res:[Assembly Name]/Resource name", condition#1, condition#2, condition#3, condition#4, condition#5)

    Example:

    =IconSet("res:ReportAssembly, Version=1.1.1.1./ReportAssembly.Resources.Images.CustomImage.png", 4 > 9, 5 > 9, 10 > 9, False, False)
  • Embedded image
    =IconSet("embeddedImage:ImageName", condition#1, condition#2, condition#3, condition#4, condition#5)

    Example:

    =IconSet("embeddedImage:Grades", Fields!Score.Value >=90, Fields!Score.Value >=80, Fields!Score.Value >=70, Fields!Score.Value >=60, True)
  • Theme image
    =IconSet("theme:ThemeImageName", condition#1, condition#2, condition#3, condition#4, condition#5)

    Example:

    =IconSet("theme:Grades", Fields!Score.Value >=90, Fields!Score.Value >=80, Fields!Score.Value >=70, Fields!Score.Value >=60, True)
See Also

Data Visualization


Range Bar

The RangeBar data visualization displays a 96 by 96 dpi bar image, the size of which is defined by the Width and Height arguments. The colored bar renders as half the height of the image, centered vertically. The amount of colored bar to render to the right of the Start argument (or to the left in the case of a negative value) is based on the Length argument. If the Length argument is zero, a diamond renders.

The Minimum and Maximum arguments determine the range of data. The area between the Length argument and the Maximum argument is transparent (or between the Length and the Minimum in the case of a negative value).

Parameters

  • Minimum. The lowest value in the range of data. This value corresponds to the leftmost edge of the image. If this argument is greater than the Start argument, Start becomes equal to Minimum. The data type is Single.
  • Maximum. The highest value in the range of data. This value corresponds to the rightmost edge of the image. If this argument is less than the Start argument, Start becomes equal to Maximum. The data type is Single.
  • Color. The HTML color string to use in rendering the Length in the bar image.
  • Height. The total height of the control in which the RangeBar renders. The data type is Length.
  • Width. The total width of the control in which the RangeBar renders. The data type is Length.
  • Start. The point from which the RangeBar begins to be rendered. The data type is Single.
  • Length. The width of the bar to render within the control. Setting this value to 0 renders a diamond shape instead of a bar. The data type is Single.

You can use static values or aggregate functions (e.g. Min or Max) to set the parameters. For more information on these and other aggregate functions, see the Functions topic.

Syntax

=RangeBar(Minimum, Maximum, Color, Height, Width, Start, Length)

Simple Example

=RangeBar(0, Max(Fields!TotalAmount.Value), "BlueViolet",
".25in", "2in", 0, Fields!TotalAmount.Value)

Usage

Use an expression like the example in any property which takes an image, such as the BackgroundImage property of a TextBox or the Value property of an Image. This renders a bar in the color specified, the width of which changes depending on the number returned by the Value parameter, in the case of the example, TotalAmount. If your data contains only positive values, Start corresponds with Minimum at the left edge of the DataBar. The area between the Value and the Maximum is transparent.

Example Using Negative Values

=RangeBar(-10, 25, IIf(Fields!Difference.Value < 0, "Red", "Blue"),
".25in", "4in", 0, Fields!Difference.Value)

When your data contains negative as well as positive values, you can use an Immediate If expression for the Color parameter. In the example above, if the Difference value is negative, it is rendered in red, while positive values are rendered in blue. You can also see that negative values are rendered to the left of Zero and positive values are rendered to the right. A Length value of exactly zero is rendered as a diamond.

Default Behavior

The function returns null (i.e. no image is rendered) in any of the following cases:

    1. The Width or Height is invalid, i.e. the appropriate unit designator (such as "in" for inches or "cm" for centimeters) is not used.
    2. The Maximum is less than or equal to the Minimum.
    3. The expression is placed in a property which does not take an image.
    4. The Source property of the image is not set to Database.

The Start value changes in the following cases:

    1. If the Start value is less than the Minimum value, Start is the same as Minimum.
    2. If the Start value is greater than the Maximum value, Start is the same as Maximum.

The Length value changes in the following cases:

    1. If the Start value plus the Length value is less than the Minimum value, Length becomes Minimum minus Start.
    2. If the Start value plus the Length value is greater than the Maximum value, Length becomes Maximum minus Start.

If the argument for any of the parameters cannot be converted to the required data type, the default value is used instead.

Parameter | Default Value
Minimum | 0
Maximum | 0
Color | Green
Height | 0in
Width | 0in
Start | 0
Length | 0


Range Bar Progress

The RangeBarProgress data visualization displays a 96 by 96 dpi double bar image, the size of which is defined by the Width and Height arguments. The first colored bar renders as half the height of the image, centered vertically. The amount of colored bar to render to the right of the Start argument (or to the left in the case of a negative value) is based on the Length argument. If the Length argument is zero, a diamond renders.

The second colored bar renders using the ProgressColor as one fourth of the height of the image, centered vertically over the Length bar. The amount of colored bar to render to the right of the Start argument (or to the left in the case of a negative value) is based on the Progress argument. If the Progress argument is zero, a smaller diamond renders.

The Minimum and Maximum arguments determine the range of data. The area between the Length and Progress arguments and the Maximum argument is transparent (or between the Length/Progress and the Minimum in the case of a negative value).

Parameters

  • Minimum. The lowest value in the range of data. This value corresponds to the leftmost edge of the image. If this argument is greater than the Start argument, Start becomes equal to Minimum. The data type is Single.
  • Maximum. The highest value in the range of data. This value corresponds to the rightmost edge of the image. If this argument is less than the Start argument, Start becomes equal to Maximum. The data type is Single.
  • Color. The HTML color string to use in rendering the Length, or first bar in the bar image.
  • Height. The total height of the control in which the RangeBarProgress renders. The data type is Length.
  • Width. The total width of the control in which the RangeBarProgress renders. The data type is Length.
  • Start. The point from which the RangeBarProgress begins to be rendered. The data type is Single.
  • Length. The width of the bar to render within the control. Setting this value to 0 renders a diamond shape instead of a bar. The data type is Single.
  • ProgressColor. The HTML color string to use in rendering the Progress, or second bar in the bar image.
  • Progress. The width of the second bar to render within the control. Setting this value to 0 renders a diamond shape instead of a bar. The data type is Single.

You can use static values or aggregate functions (e.g. Min or Max) to set the parameters. For more information on these and other aggregate functions, see the Functions topic.

Syntax

=RangeBarProgress(Minimum, Maximum, Color, Height, Width, Start, Length, ProgressColor, Progress)

Simple Example

=RangeBarProgress(0, Max(Fields!TotalAmount.Value), "BlueViolet",
".25in", "2in", 0, Fields!SalesAmount.Value, "Gold", Fields!TotalAmount.Value)

Usage

Use an expression like the example in any property which takes an image, such as the BackgroundImage property of a TextBox or the Value property of an Image. This renders a double bar in the colors specified, the width of which changes depending on the number returned by the Length parameter for the thick bar, in the case of the example, SalesAmount. The thin bar width is based on the value returned by the Progress parameter, in this case, TotalAmount. If your data contains only positive values, Start corresponds with Minimum at the left edge of the DataBar. The area between the Length/Progress and the Maximum is transparent.

Example Using Negative Values

=RangeBarProgress(-10, 25, IIf(Fields!Difference.Value < 0, "Red", "Blue"),
".25in", "4in", 0, Fields!Difference.Value, "Purple", Fields!InStock.Value)

When your data contains negative as well as positive values, you can use an Immediate If expression for the Color parameter. In the example above, if the Difference value is negative, it is rendered in red, while positive values are rendered in blue. You can also see that negative values are rendered to the left of Zero and positive values are rendered to the right. A Length value of exactly zero is rendered as a diamond. The thinner purple bar represents the InStock value.

Default Behavior

The function returns null (i.e. no image is rendered) in any of the following cases:

    1. The Width or Height is invalid, i.e. the appropriate unit designator (such as "in" for inches or "cm" for centimeters) is not used.
    2. The Maximum is less than or equal to the Minimum.
    3. The expression is placed in a property which does not take an image.
    4. The Source property of the image is not set to Database.

The Start value changes in the following cases:

    1. If the Start value is less than the Minimum value, Start is the same as Minimum.
    2. If the Start value is greater than the Maximum value, Start is the same as Maximum.

The Length value changes in the following cases:

    1. If the Start value plus the Length value is less than the Minimum value, Length becomes Minimum minus Start.
    2. If the Start value plus the Length value is greater than the Maximum value, Length becomes Maximum minus Start.

The Progress value changes in the following cases:

    1. If the Start value plus the Progress value is less than the Minimum value, Progress becomes Minimum minus Start.
    2. If the Start value plus the Progress value is greater than the Maximum value, Progress becomes Maximum minus Start.

If the argument for any of the parameters cannot be converted to the required data type, the default value is used instead.

Parameter | Default Value
Minimum | 0
Maximum | 0
Color | Green
Height | 0in
Width | 0in
Start | 0
Length | 0
ProgressColor | Red
Progress | 0


Converting Reports

You can convert your old reports to report definitions using the command prompt.

ActiveReports for .NET
Learn to convert your ActiveReports to report definitions.
See Also

Tutorials: Building Reports


ActiveReports for .NET

The ActiveReports import utility converts an ActiveReports for .NET 1.0, 2.0, or 3.0 RPX layout file to an RDLX file containing a BandedList report item, which most closely simulates the ActiveReports layout. If the import utility is unable to convert any of the controls or data sources from the original report, a status report within the command window informs you of which items were not converted.

To save an RPX layout of an ActiveReport, open the report in Visual Studio and from the Report menu, select Save Layout.

To convert the RPX layout to RDLX, open a command prompt, navigate to the installation directory's Assemblies folder, and input the name of the utility (DataDynamics.Reports.Imports.ActiveReports.exe) and the path and file name of the RPX layout (i.e. C:\rptSample.rpx).

DataDynamics.Reports.Imports.ActiveReports.exe C:\rptSample.rpx

The converted file is written to the same directory as the original RPX layout.

You need not have ActiveReports installed for this utility to run, but please be aware of the following limitations.

Necessary Adjustments

Due to differences between products, the extent to which your reports are converted depends on your specific report layout.

Data Dynamics Reports features more flexibility than ActiveReports with report items (including a banded data region) that you can place anywhere on the report. Data regions can even be placed adjacent to one another, often eliminating the need for subreports. For this reason, once you import your ActiveReports, you may want to rework them to take advantage of this new flexibility.

Data Dynamics Reports offers a banded page header and page footer similar to that found in ActiveReports, so during conversion controls in those sections are placed in corresponding sections in Data Dynamics Reports. Report items in group headers and footers and in detail sections are imported into bands in the BandedList control to closely mirror the look and behavior of ActiveReports.

Report headers and footers, however, require some adjustment, as they are placed in the body of the report rather than in separate bands.

Not Converted

  • VB and C# code
  • Scripting
  • Unbound and XML data sources
  • DataField expressions beginning with "="
  • Section properties
    • BackColor
    • Visibility
  • GroupHeader section properties
    • UnderlayNext
    • ColumnLayout
    • ColumnGroupKeepTogether
  • Full justify alignment
  • Page breaks
  • Styles
  • Page 'n' of 'm' in sections other than the page header or footer
  • Page totals
  • The following SummaryFunc values (the rest of the SummaryFunc values are converted)
    • DSum (summary distinct)
    • DAvg
    • DVar
    • DVarP
    • DStdDev
    • DStdDevP
  • SummaryGroup (if SummaryType is not SubTotal)

Converted Differently

  • Only the size and position of a chart is converted.
  • Only JPG and PNG images are converted.
  • Unsupported controls convert to rectangle placeholders with the names of the original controls.
  • Checkbox controls convert to textbox report items.
  • The following GroupHeader section properties convert to KeepTogether = True
    • RepeatStyle: All, OnPage, and OnPageIncludeNoDetail
    • GroupKeepTogether: All and FirstDetail
  • Supported summary functions are converted to RDL expressions.
See Also

Converting Reports

Tutorials: Building Reports


Rendering and Transforming Reports

You can render reports in a number of viewing or printing formats or transform the data for use in other formats using the Export button in the viewer.

Rendering Reports
Discover the viewing or printing formats available in Data Dynamics Reports.
Transforming Reports
Learn about the data formats available in Data Dynamics Reports.
See Also

User Guide


Rendering

These are the types of files into which you can render your reports which support some or all of your formatting.

Image
Renders reports to any one of a number of image formats, including TIFF.
HTML
Renders reports for viewing in an internet browser.
PDF
Renders reports for viewing or printing in the Adobe Acrobat Viewer.
XML
Transforms reports into a data rendering for sharing data with other applications.
Word
Renders reports in Word HTML for viewing or printing with Microsoft Word 2000 or 2003.


Rendering to Images

You can render your reports into any of six different image formats when you select Image as the export type: BMP, EMF, GIF, JPEG, TIFF, and PNG. The format is set using the ImageType property.

Options

Each ImageType supports a set of options to control the output. Here are the ones common to all image types, as well as links to topics on type-specific options.

  • BMP Options
  • EMF Options
  • GIF Options
  • JPEG Options
  • TIFF Options
  • PNG Options
DpiX
Adjust the horizontal resolution of rendered images. The default value is 96.
DpiY
Adjust the vertical resolution of rendered images. The default value is 96.
Tip: A dot matrix printer typically prints in the 60 to 90 DPI range, a laser printer may be in the range of 600 to 1200 DPI, an inkjet printer may be in the range of 1200 to 9600 DPI, and 72 DPI is sufficient for web use.
EndPage
The default value of 0 in this property renders all of the report pages. Otherwise, set this value to the number of the last page to render. Please note that if the StartPage property is set to 0, all of the pages of the report render. In order to use the EndPage property, you must set the StartPage property to a valid non-zero number.
ImageType
Select the type of image to which you want to render the report. Supported types are BMP, EMF, GIF, JPEG, TIFF, and PNG.
MarginBottom
Set the value in inches to use for the bottom margin of the image. The format is an integer or decimal with "in" as the suffix, for example "1in" for 1 inch. By default, no margins are used. The value set in this property overrides the report's settings.
MarginLeft
Set the value in inches to use for the left margin of the image. The format is an integer or decimal with "in" as the suffix, for example "1in" for 1 inch. By default, no margins are used. The value set in this property overrides the report's settings.
MarginRight
Set the value in inches to use for the right margin of the image. The format is an integer or decimal with "in" as the suffix, for example "1in" for 1 inch. By default, no margins are used. The value set in this property overrides the report's settings.
MarginTop
Set the value in inches to use for the top margin of the image. The format is an integer or decimal with "in" as the suffix, for example "1in" for 1 inch. By default, no margins are used. The value set in this property overrides the report's settings.
PageHeight
Set the value in inches to use for the height of the image. The format is an integer or decimal with "in" as the suffix, for example "11in" for 11 inches. The value set in this property overrides the report's settings.
PageWidth
Set the value in inches to use for the width of the image. The format is an integer or decimal with "in" as the suffix, for example "8in" for 8 inches. The value set in this property overrides the report's settings.
Pagination
By default, each page of a report is rendered as a separate image. Set this value to False to render the entire report as a single image.
PrintLayoutMode
Select how to lay out the pages of the report in the image.
  • OneLogicalPageOnSinglePhysicalPage
  • TwoLogicalPagesOnSinglePhysicalPage
  • FourLogicalPagesOnSinglePhysicalPage
  • EightLogicalPagesOnSinglePhysicalPage
  • BookletMode (lays the pages out for booklet printing)
SizeToFit
By default, rendered report pages are not resized to fit within the selected image size. Set this value to True to resize the report pages.
StartPage
The default value of zero in this and the EndPage properties render all of the report pages to images. Otherwise, set this value to the number of the first page to render.
WatermarkAngle
Specify the degree of angle for the watermark text on the image. Valid values range from 0 to 359, where 0 is horizontal, left to right.
WatermarkColor
Select a color for the watermark text on the image. The default value for the watermark color is gray, but you can select any Web, System, or Custom color.
WatermarkFont
Set the font to use for the watermark to any valid System.Drawing.Font.
WatermarkTitle
Enter text (i.e. CONFIDENTIAL) to use as the watermark on the image.

Interactivity

Reports rendered as images do not support any of the interactive features of Data Dynamics Reports. Any data hidden at the time of export is hidden in the image. To display all data in a drill-down report, expand all toggle items prior to exporting.

See Also

Rendering to HTML | Rendering to PDF

Tutorials: Exporting Reports


Rendering to HTML

HTML is one of the formats to which you can export Data Dynamics Reports from the Viewer.

Options

Data Dynamics Reports offers several options to control how reports render to HTML.

Fragment
Set the Fragment property to True to return a stream containing only the content found inside the <body> tags when you want to embed the stream in a Web page. The default value is False.
MhtOutput
Set the MhtOutput property to True to save your report as a Web archive file. This saves the report in Multipurpose Internet Mail Extension HTML format, embeds images in the file instead of saving them as separate files, and remaps any relative links. The default value is False.
StyleStream
By default, the StyleStream property is set to True. This creates an external .css file containing style information from your report items' style properties. If you prefer to have style information embedded in the HTML file, set the StyleStream property to False.
JavaScript
JavaScript is used to provide interactive features in reports rendered to HTML. If you set this property to False, none of the interactive features mentioned below are supported. The default value is True.
LinkTarget
Specify a link target to control whether drill down reports and other links open in a new window or reuse the current window. By default, no value is set and links open in the same window. A value of _blank opens the link in a new window, or you can specify a window using window_name.
Mode
The default value is Galley mode which renders the report in one HTML stream with one page header at the beginning and one page footer at the end. Select Paginated mode to render each page as a section inside the HTML document, with page headers and footers and height and width dictated by the layout of the report.

Limitations

HTML is a very good format for delivering content because virtually all computer users have an HTML browser. It does, however, have its limitations.

Printing. For printable documents, we recommend the PDF rendering extension.

Vertical-align style. This style is always Top for text boxes in HTML reports. If Bottom or Middle vertical alignment is an essential style element in your report, we recommend a format other than HTML.

Interactivity

Reports rendered in HTML support full interactivity in connected mode, when the layout and report are accessible and can be run again (for example in the Web viewer or a WinForm application).

Reports rendered in HTML support limited interactivity in disconnected mode (for example in a single HTML file e-mailed to a customer).

Hyperlinks
Both connected and disconnected modes support valid hyperlinks.
BookmarkLinks
Both connected and disconnected modes support valid bookmark links.
Drill Through
Both modes support drill through to separate reports. In disconnected mode, ".html" appends to the report name, so the drill through reports must also be available in HTML format.
Visibility Toggle
Only connected mode supports visibility toggling or drill-down reporting.
Table of Contents
Both modes support an interactive table of contents so long as JavaScript is enabled.
See Also

Rendering to PDF | Rendering to Images


Rendering to PDF

Portable Document Format (PDF) is one of the formats to which you can export Data Dynamics Reports from the Viewer, and is recommended for printing.

Options

Data Dynamics Reports offers many options to control how reports render to PDF.

Application

Set the value that appears for "Application" in the Document Properties dialog of the Acrobat viewer application. By default, the text is set to "Data Dynamics Reports."
Author
Enter the name of the author to appear in the Document Properties dialog of the Acrobat viewer application.
CenterWindow
Set to True to position the document's window in the center of the screen.
Columns
Set the number of columns to use in the report. This value overrides the report's original settings. The default value of -1 uses the report's original settings.
ColumnSpacing
Enter a value in inches (i.e. 0.5in) to set the amount of space between columns. This value overrides the report's original settings.
DisplayMode
Specifies how the document is displayed when opened. By default nothing is specified, but you can select from Outlines, Thumbs, or FullScreen. FullScreen mode displays the document with no menu bar, window controls, or any other window visible.
DisplayTitle
Set to True to display text you enter in the Title property in the window’s title bar. The default value of False displays the name of the PDF file.
DpiX
Adjust the horizontal resolution of the rendered PDF file. The default value is 300.
DpiY
Adjust the vertical resolution of the rendered PDF file. The default value is 300.
Encrypt
Set to True to encrypt the document. This allows you to set the Permissions property to restrict what users without the OwnerPassword can do with the document.
Note: If Encrypt is set to False, permissions and passwords have no effect.
EndPage
The default value of 0 in this property renders all of the report pages. Otherwise, set this value to the number of the last page to render. Please note that if the StartPage property is set to 0, all of the pages of the report render. In order to use the EndPage property, you must set the StartPage property to a valid non-zero number.
FitWindow
Set to True to resize the window to fit the size of the first displayed page when the PDF document is opened.
HideMenubar
Set to True to hide Acrobat Reader’s menu bar when the document is active.
HideToolbar
Set to True to hide Acrobat Reader’s toolbars when the document is active.
HideWindowUI
Set to True to hide user interface elements in Acrobat Reader (such as scroll bars and navigation controls) leaving only the document’s contents displayed.
Keywords
Enter keywords associated with the document contents for use by search engines.
MarginBottom
Enter a value in inches (i.e. 0.5in) for the amount of space between the bottom of the report and the bottom edge of the page. This value overrides the report's original settings.
MarginLeft
Enter a value in inches (i.e. 0.5in) for the amount of space between the left edge of the report and the left edge of the page. This value overrides the report's original settings.
MarginRight
Enter a value in inches (i.e. 0.5in) for the amount of space between the right edge of the report and the right edge of the page. This value overrides the report's original settings.
MarginTop
Enter a value in inches (i.e. 0.5in) for the amount of space between the top edge of the report and the top edge of the page. This value overrides the report's original settings.
OwnerPassword
Enter text that can be used in the reader to permit full access to the document regardless of the specified user permissions.
PageHeight
Enter a value in inches (i.e. 11in) to set the height of the report's pages. This value overrides the report's original settings.
PageWidth
Enter a value in inches (i.e. 8.5in) to set the width of the report's pages. This value overrides the report's original settings.
Permissions
Select user permissions for the document. Permissions can be combined using a comma between values. By default, all permissions are granted. In order to use AllowFillin, AllowAccessibleReaders, and AllowAssembly permissions, you must set the Use128Bit property to True.
PrintLayoutMode
Select how to lay out the pages of the report in the PDF document.
  • OneLogicalPageOnSinglePhysicalPage
  • TwoLogicalPagesOnSinglePhysicalPage
  • FourLogicalPagesOnSinglePhysicalPage
  • EightLogicalPagesOnSinglePhysicalPage
  • BookletMode (lays the pages out for booklet printing)
SizeToFit
Determines whether PDF pages are fit to the selected paper size.
StartPage
The default value of 0 in this property renders all of the report pages. Otherwise, set this value to the number of the first page to render.
Subject
The subject of the document.
Title
Enter the document’s title. Set the DisplayTitle property to True to show this title in the Acrobat Reader title bar.
Use128Bit
A setting of True uses 128 bit encryption with full permissions capability. Set to False to use 40 bit encryption with limited permissions. AllowFillin, AllowAccessibleReaders, and AllowAssembly permissions are not applied unless this property is set to True.
UserPassword
Enter text that can be entered in the Acrobat Reader to decrypt the document. If this value is empty, the user is not prompted for a password but is still restricted by the specified permissions.
WatermarkAngle
Specify the degree of angle for the watermark text on the PDF document. Valid values range from 0 to 359, where 0 is horizontal, left to right.
WatermarkColor
Select a color for the watermark text on the PDF document. The default value for the watermark color is gray, but you can select any Web, System, or Custom color.
WatermarkFont
Set the font to use for the watermark to any valid System.Drawing.Font.
WatermarkTitle
Enter text (i.e. CONFIDENTIAL) to use as the watermark on the PDF document.

Limitations

PDF is the best format for printing. It does, however, have its limitations.

Interactivity. If drill down and visibility toggling are essential to your report, we recommend the HTML rendering extension.

Interactivity

Hyperlinks

Both in-document and external hyperlinks are supported.
BookmarkLinks
Valid bookmark links are supported.
Drill-Down
Drill-down interactivity is lost. Only what is visible in the report at the time of export is rendered in the PDF file.
Visibility Toggle
Visibility toggling is not supported in PDF documents.
Table of Contents
Document maps (or table of contents) become bookmarks in PDF documents.
See Also

Rendering to HTML | Rendering to Images | PDF Permissions


PDF Permissions

In order to control permissions to the documents you export to PDF format, you must set the Encrypt property to True. If the Encrypt property is left on its default value of False, permissions and passwords have no effect.

The values you to set in the Permissions property allow users without the OwnerPassword to perform the specified action on the document, and no other action. To combine permission values, enter all of the values you wish to permit separated by commas.

Permission Value | Description
None | Grants users read-only permission on the document unless they decrypt it using the OwnerPassword.
AllowPrint | Grants users permission to print the document.
AllowModifyContents | Grants users permission to edit the document.
AllowCopy | Grants users permission to copy from the document.
AllowModifyAnnotations | Grants users permission to add or edit annotations on the document.
AllowFillIn (requires 128 bit encryption*) | Grants users permission to fill in fields in interactive forms.
AllowAccessibleReaders (requires 128 bit encryption*) | Grants users permission to expose the text in the document to screen readers or other accessible devices.
AllowAssembly (requires 128 bit encryption*) | Grants users permission to insert, rotate, and delete pages and to create bookmarks and thumbnails.
Default | Grants users permission to perform all of the above actions on the document.

*Keep the default True value of the Use128Bit property to use 128 bit encryption with full permissions capability. Setting the value to False uses 40 bit encryption which does not support AllowFillin, AllowAccessibleReaders, or AllowAssembly.

Note: 128 bit encryption is only supported in Adobe Acrobat Reader 5.0 or higher. Older versions use 40 bit encryption.

Supply a value in the OwnerPassword property to allow anyone who enters the password in the reader to perform all of the above actions on the document regardless of the specified user permissions. If this value is left empty, no one will be able to perform any actions except those set in the Permissions property.

Supply a value in the UserPassword property to prompt users for a password upon opening the document. If this value is left empty the user will not be prompted for a password, but will be restricted to the actions set in the Permissions property.

See Also

Rendering to PDF


Rendering to Word

Word is one of the formats to which you can export Data Dynamics Reports from the Viewer. Since this export uses Word HTML, only Microsoft® Word 2000 and 2003 are supported.

Options

Data Dynamics Reports offers several options to control how reports render to Word.

Author

Enter the name of the author to appear in the File Properties dialog of the Microsoft® Word application on the Summary tab in the Author field.
BaseUrl
Enter a base URL for any relative hyperlinks used in the report. This value appears in the File Properties dialog of the Microsoft® Word application on the Summary tab in the Hyperlink base field.
Generator
Set the identity of the document generator in a meta-data file stamp. The default value is Data Dynamics Reports.
PageHeight
Enter a value in inches (i.e. 11in) to set the height of the report's pages. This value overrides the report's original settings.
PageWidth
Enter a value in inches (i.e. 8.5in) to set the width of the report's pages. This value overrides the report's original settings.
Title
Enter the document’s title. This value appears in the File Properties dialog of the Microsoft® Word application on the Summary tab in the Title field.
UseMhtOutput
Set UseMhtOutput to True so it will embed resources in the Word document using MIME HTML. Otherwise it creates a folder for images and XML. If that folder is deleted, the Word document shows a red x for each missing image.
Note: Only Word 2003 supports this format. For Word 2000, UseMhtOutput must remain False.

Limitations

Interactivity. If drill down and visibility toggling are essential to your report, we recommend the HTML rendering extension. If a Table of Contents (document map) is essential to your report, we recommend the PDF rendering extension.

Section Background Color. Although background colors for controls export to Word documents, background colors for sections such as Body and Page Header or Footer do not.

Interactivity

Hyperlinks

Both in-document and external hyperlinks are supported.
BookmarkLinks
Valid bookmark links are supported.
Drill-Down
Drill-down interactivity is lost. Only what is visible in the report at the time of export is rendered in the Word document.
Visibility Toggle
Visibility toggling is not supported in Word documents.
Table of Contents
Document maps (or table of contents) are not supported documents.


Rendering to XML

XML is one of the formats to which you can export Data Dynamics Reports from the Viewer.

Options

Data Dynamics Reports offers one option in the dialog to control how the data in the report is transformed to XML.

Encoding
Select the encoding schema to use in the XML transformation.

XML is a good format for delivering data to other applications. The resulting XML file opens in an internet browser.

Controlling XML Output

You can also control XML output through properties on the individual report items. These properties are:

  • DataElementName Indicates the name to use for the data element or attribute.
  • DataElementOutput Indicates whether the report items renders in the XML output.
  • DataElementStyle Indicates whether a text box renders as an element or an attribute.
  • DetailDataCollectionName Indicates the name to use for the collection of all instances of the detail group in the XML output.
  • DetailDataElementName Indicates the name to use for instances of the detail group in the XML output.
  • DetailDataElementOutput Indicates whether the details appear in the XML output.
  • DataInstanceElementOutput Indicates whether a list appears in the XML output. (This property is ignored if there is a grouping in the list.)
  • DataInstanceName Indicates the name to use for instances of the list in the XML output.
See Also

Report Data Output Page


Getting Help

To get support for Data Dynamics Reports, please visit our support forum here: http://www.datadynamics.com/forums/78/ShowForum.aspx


Troubleshooting

Problem: With a group of textboxes to the left or right of a table (one or more below the table's bottom edge) at run time the lower textboxes are pushed down below the expanded table while the upper textboxes remain where you placed them at design time.

Solution: Place the group of textboxes within a rectangle.

Problem: Setting the PageBreakAtEnd property of the List data region does not cause the report to break to a new page until all of the data in the list has rendered. How can I cause the report to break to a new page for each new record?

Solution: Add a Detail Grouping to the list and set the PageBreakAtEnd property of the grouping.

Problem: An expression using a numeric field name does not display any data at run time.

i.e. =Fields!2004.Value

Cause: Visual Basic syntax does not allow an identifier that begins with a number.

Solution: Make the numeric field name a string.

i.e. =Fields("2004").Value

or =Fields.Item("2004").Value

Tip: If you have a problem that is not listed here, you may find the solution in the Forums.
See Also

Getting Help

Tutorials: Building Reports | How-To Section


How-To Section

This section gives information on how to perform common tasks with Data Dynamics Reports.

Adding drill-through links
Explains how to add a link to drill through to another report.
Adding filters
Explains how to add filters to your datasets and data regions.
Adding hyperlinks
Explains how to add a hyperlink to a URL.
Adding page breaks
Explains how to add a page break to a report.
Adding code
Explains how to add code to a project.
Adding data-bound images
Explains how to add images from your database.
Adding items to a document map
Explains how to add items to document map or table of contents.
Adding static rows and columns to a matrix
Explains how to add fixed rows or columns for extra detail to a matrix.
Adding subtotals to a matrix
Explains how to add subtotals for rows or columns to a matrix.
Allowing Users to Sort Data in the Viewer
Explains how to add interactive sorting to a textbox.
Changing the page size
Explains how to change the page size.
Creating a shared data source
Explains how to create a shared data source.
Creating a report in the designer
Explains how to create a report using the designer.
Creating an ALL parameter
Explains how to create a multivalue parameter report with an option for users to select all records.
Creating an instance method for a custom assembly
Explains how to create an instance method from a referenced custom assembly that can be used in expressions throughout your report.
Exporting a report
Explains how to export a report to each of the supported formats.
Grouping
Explains how to add grouping to your data.
Hiding a page header or footer on the first or last page
Explains how to hide a page header or footer on the first or last page.
Passing parameters to a subreport
Explains how to pass parameters to a subreport.
Previewing a report
Explains how to preview a report.
Printing a report
Explains how to print a report.
Rendering N Records per page
Explains how to render a specified number of records on each page.
Rendering Reports to other formats
Explains how to render reports to other formats.
Sorting
Explains how to add sorting to your data.
Subtotaling
Explains how to add subtotaling to your data regions.
Toggling visibility for a report item
Explains how to toggle visibility for a report item.


Adding Drill-through Links

Use drill-through links to connect a line in a summary report to a more detailed report. To provide the most relevant information, use a detail report with parameters to jump right to the desired information. For example, if your summary report contains a list of invoice numbers and delivery dates for each customer, you could use a drill-through link with the invoice number as the parameter to allow the user to jump to the relevant invoice.

Note: The drill-through link will work without parameters, but it may leave the user searching a huge detail report for the relevant information.

To add a drill-through link

  1. In the Layout view of the report, right-click the report item you want to link to another report and choose Properties. Currently, only images and textboxes support drill-through links.
  2. On the Navigation page, under Hyperlink Action, select Jump to Report and enter the name of the report to which you want to jump in the Report Name text box.
  3. Enter a Parameter Name.
    Note: The Parameter Name must exactly match the name of the parameter in the detail report. If any parameter is spelled differently, capitalized differently, or if an expected parameter is not supplied, the drill-through report will fail.
  4. Enter a Parameter Value to pass to the detail report. This value must evaluate to a valid value for the parameter.
See Also

How-To Section | Walkthrough: Drill-Through

Reference: Drill Through | Parameters


Adding Filters

You can add a filter to any of the following items:

  • Dataset
  • Data region
  • Table or Matrix group
  • List group
  • BandedList group
  • Chart group
See Also

Grouping

Reference: Filters


Filtering a Dataset

Normally you would filter your data using parameters in the query, but if your data source does not support parameters, you are using the dataset from a Master Report, or if you want to pull all of the data from the data source before filtering it, you can use the following method.

To filter a dataset

  1. In the Data Explorer right-click the dataset to filter and select Edit.
  2. From the Data smart panel, select the Filters page.

  3. Type or use the expression editor to provide the Expression by which to filter the data.

  4. Select the Operator to decide how to compare the Expression to the left with the Value to the right.
    = Select this operator if you want to choose only data for which the value on the left is equal to the value on the right.
    Like | Select this operator if you want to choose data for which the value on the left is similar to the value on the right. For more information on using the Like operator, see the MSDN Web site.
    != Select this operator if you want to choose only data for which the value on the left is not equal to the value on the right.
    > Select this operator if you want to choose only data for which the value on the left is greater than the value on the right.
    >= Select this operator if you want to choose only data for which the value on the left is greater than or equal to the value on the right.
    < Select this operator if you want to choose only data for which the value on the left is less than the value on the right.
    <= Select this operator if you want to choose only data for which the value on the left is less than or equal to the value on the right.
    Top N | Select this operator if you want to choose only items from the value on the left which are the top number specified in the value on the right.
    Bottom N | Select this operator if you want to choose only items from the value on the left which are the bottom number specified in the value on the right.
    Top % | Select this operator if you want to choose only items from the value on the left which are the top percent specified in the value on the right.
    Bottom % | Select this operator if you want to choose only items from the value on the left which are the bottom percent specified in the value on the right.
    In | Select this operator if you want to choose only items from the value on the left which are in the array of values on the right. Values on the right are separated by commas.
    Between | Select this operator if you want to choose only items from the value on the left which fall between the two values on the right. Values on the right are separated by commas.

  5. Enter the Value with which to compare the expression results. For multiple values (used with the In and Between operators) separate values using commas.

See Also

Adding Filters | How-To Section

Reference: Filters | Grouping and Sorting Data


Filtering a Data Region

Normally you would filter your data using parameters in the query, but if your data source does not support parameters, or if you want to pull all of the data from the data source before filtering it, you can use the following method.

To filter a data region

  1. In the Layout view of the report, select the data region, and right-click its edge or corner.
  2. Select Properties.
  3. On the Filters page, type or use the expression editor to provide the Expression to use for evaluating whether data is included in the data region.
  4. Select the Operator to decide how to compare the Expression to the left with the Value to the right.
    = Select this operator if you want to choose only data for which the value on the left is equal to the value on the right.
    Like | Select this operator if you want to choose data for which the value on the left is similar to the value on the right. For more information on using the Like operator, see the MSDN Web site.
    != Select this operator if you want to choose only data for which the value on the left is not equal to the value on the right.
    > Select this operator if you want to choose only data for which the value on the left is greater than the value on the right.
    >= Select this operator if you want to choose only data for which the value on the left is greater than or equal to the value on the right.
    < Select this operator if you want to choose only data for which the value on the left is less than the value on the right.
    <= Select this operator if you want to choose only data for which the value on the left is less than or equal to the value on the right.
    Top N | Select this operator if you want to choose only items from the value on the left which are the top number specified in the value on the right.
    Bottom N | Select this operator if you want to choose only items from the value on the left which are the bottom number specified in the value on the right.
    Top % | Select this operator if you want to choose only items from the value on the left which are the top percent specified in the value on the right.
    Bottom % | Select this operator if you want to choose only items from the value on the left which are the bottom percent specified in the value on the right.
    In | Select this operator if you want to choose only items from the value on the left which are in the array of values on the right. Values on the right are separated by commas.
    Between | Select this operator if you want to choose only items from the value on the left which fall between the two values on the right. Values on the right are separated by commas.
  5. Enter the Value to compare with the expression on the left based on the selected operator. For multiple values (used with the In and Between operators) separate values using commas.
See Also

Adding Filters

Reference: Filters | Using Data Regions


Filtering a Table or Matrix Group

Normally you would filter your data using parameters in the query, but if your data source does not support parameters, or if you want to pull all of the data from the data source before filtering it, you can use the following method.

To filter a table or matrix group

  1. In the Layout view of the report, right-click the table or matrix group and choose Edit Group.
  2. On the Filters page, type or use the expression editor to provide the Expression to use for evaluating whether data is included in the group.
  3. Select the Operator to decide how to compare the Expression to the left with the Value to the right.
    = Select this operator if you want to choose only data for which the value on the left is equal to the value on the right.
    Like | Select this operator if you want to choose data for which the value on the left is similar to the value on the right. For more information on using the Like operator, see the MSDN Web site.
    != Select this operator if you want to choose only data for which the value on the left is not equal to the value on the right.
    > Select this operator if you want to choose only data for which the value on the left is greater than the value on the right.
    >= Select this operator if you want to choose only data for which the value on the left is greater than or equal to the value on the right.
    < Select this operator if you want to choose only data for which the value on the left is less than the value on the right.
    <= Select this operator if you want to choose only data for which the value on the left is less than or equal to the value on the right.
    Top N | Select this operator if you want to choose only items from the value on the left which are the top number specified in the value on the right.
    Bottom N | Select this operator if you want to choose only items from the value on the left which are the bottom number specified in the value on the right.
    Top % | Select this operator if you want to choose only items from the value on the left which are the top percent specified in the value on the right.
    Bottom % | Select this operator if you want to choose only items from the value on the left which are the bottom percent specified in the value on the right.
    In | Select this operator if you want to choose only items from the value on the left which are in the array of values on the right. Values on the right are separated by commas.
    Between | Select this operator if you want to choose only items from the value on the left which fall between the two values on the right. Values on the right are separated by commas.
  4. Enter the Value to compare with the expression on the left based on the selected operator. For multiple values (used with the In and Between operators) separate values using commas.
See Also

Adding Filters

Reference: Filters | Table | Matrix | Grouping and Sorting Data


Filtering a List Group

Normally you would filter your data using parameters in the query, but if your data source does not support parameters, or if you want to pull all of the data from the data source before filtering it, you can use the following methods.

To filter a list detail group

  1. In the Layout view of the report, right-click the list and select Properties to open the data region smart panel, then select the Detail Grouping page.
  2. On the Filters page, type or use the expression editor to provide the Expression to use for evaluating whether data is included in the group.
  3. Select the Operator to decide how to compare the Expression to the left with the Value to the right.
    = Select this operator if you want to choose only data for which the value on the left is equal to the value on the right.
    Like | Select this operator if you want to choose data for which the value on the left is similar to the value on the right. For more information on using the Like operator, see the MSDN Web site.
    != Select this operator if you want to choose only data for which the value on the left is not equal to the value on the right.
    > Select this operator if you want to choose only data for which the value on the left is greater than the value on the right.
    >= Select this operator if you want to choose only data for which the value on the left is greater than or equal to the value on the right.
    < Select this operator if you want to choose only data for which the value on the left is less than the value on the right.
    <= Select this operator if you want to choose only data for which the value on the left is less than or equal to the value on the right.
    Top N | Select this operator if you want to choose only items from the value on the left which are the top number specified in the value on the right.
    Bottom N | Select this operator if you want to choose only items from the value on the left which are the bottom number specified in the value on the right.
    Top % | Select this operator if you want to choose only items from the value on the left which are the top percent specified in the value on the right.
    Bottom % | Select this operator if you want to choose only items from the value on the left which are the bottom percent specified in the value on the right.
    In | Select this operator if you want to choose only items from the value on the left which are in the array of values on the right. Values on the right are separated by commas.
    Between | Select this operator if you want to choose only items from the value on the left which fall between the two values on the right. Values on the right are separated by commas.
  4. Enter the Value to compare with the expression on the left based on the selected operator. For multiple values (used with the In and Between operators) separate values using commas.
See Also

Adding Filters | Grouping a List | Grouping a Banded List | Filtering a BandedList Group

Reference: Filters | List | Banded List | Grouping and Sorting Data


Filtering a BandedList Group

Normally you would filter your data using parameters in the query, but if your data source does not support parameters, or if you want to pull all of the data from the data source before filtering it, you can use the following methods.

To filter a banded list group

  1. In the Layout view of the report, right-click the banded list group and select Edit Group.
  2. Choose the Filters page of the Groups smart panel.
  3. Enter or select the expression to use for evaluating whether data is included in the group.
  4. Select the Operator to decide how to compare the Expression to the left with the Value to the right.
    = Select this operator if you want to choose only data for which the value on the left is equal to the value on the right.
    Like | Select this operator if you want to choose data for which the value on the left is similar to the value on the right. For more information on using the Like operator, see the MSDN Web site.
    != Select this operator if you want to choose only data for which the value on the left is not equal to the value on the right.
    > Select this operator if you want to choose only data for which the value on the left is greater than the value on the right.
    >= Select this operator if you want to choose only data for which the value on the left is greater than or equal to the value on the right.
    < Select this operator if you want to choose only data for which the value on the left is less than the value on the right.
    <= Select this operator if you want to choose only data for which the value on the left is less than or equal to the value on the right.
    Top N | Select this operator if you want to choose only items from the value on the left which are the top number specified in the value on the right.
    Bottom N | Select this operator if you want to choose only items from the value on the left which are the bottom number specified in the value on the right.
    Top % | Select this operator if you want to choose only items from the value on the left which are the top percent specified in the value on the right.
    Bottom % | Select this operator if you want to choose only items from the value on the left which are the bottom percent specified in the value on the right.
    In | Select this operator if you want to choose only items from the value on the left which are in the array of values on the right. Values on the right are separated by commas.
    Between | Select this operator if you want to choose only items from the value on the left which fall between the two values on the right. Values on the right are separated by commas.
  5. Enter the Value to compare with the expression on the left based on the selected operator. For multiple values (used with the In and Between operators) separate values using commas.
See Also

Adding Filters | Grouping | How-To Section

Reference: Banded List


Filtering a Chart Group

Normally you would filter your data using parameters in the query, but if your data source does not support parameters, or if you want to pull all of the data from the data source before filtering it, you can use the following method.

(More information about filtering a chart group rather than the entire chart will be added later.)

To filter the entire chart

  1. In the Layout view of the report, right-click the chart and choose Properties.
  2. On the Data page, select Filters.
  3. Type or use the expression editor to provide the Expression to use for evaluating whether data is included in the group.
  4. Select the Operator to decide how to compare the Expression to the left with the Value to the right.
    = Select this operator if you want to choose only data for which the value on the left is equal to the value on the right.
    Like | Select this operator if you want to choose data for which the value on the left is similar to the value on the right. For more information on using the Like operator, see the MSDN Web site.
    != Select this operator if you want to choose only data for which the value on the left is not equal to the value on the right.
    > Select this operator if you want to choose only data for which the value on the left is greater than the value on the right.
    >= Select this operator if you want to choose only data for which the value on the left is greater than or equal to the value on the right.
    < Select this operator if you want to choose only data for which the value on the left is less than the value on the right.
    <= Select this operator if you want to choose only data for which the value on the left is less than or equal to the value on the right.
    Top N | Select this operator if you want to choose only items from the value on the left which are the top number specified in the value on the right.
    Bottom N | Select this operator if you want to choose only items from the value on the left which are the bottom number specified in the value on the right.
    Top % | Select this operator if you want to choose only items from the value on the left which are the top percent specified in the value on the right.
    Bottom % | Select this operator if you want to choose only items from the value on the left which are the bottom percent specified in the value on the right.
    In | Select this operator if you want to choose only items from the value on the left which are in the array of values on the right. Values on the right are separated by commas.
    Between | Select this operator if you want to choose only items from the value on the left which fall between the two values on the right. Values on the right are separated by commas.
  5. Enter the Value to compare with the expression on the left based on the selected operator. For multiple values (used with the In and Between operators) separate values using commas.
See Also

Adding Filters

Reference: Chart


Adding Hyperlinks

Use hyperlinks to allow users to jump to a Web page for further information.

To add a hyperlink

  1. In the Layout view of the report, right-click the report item you want to link to a Web page and choose Properties.
  2. Select the Jump to URL radio button.
  3. Type or use the expression editor to provide a valid Web page address.

To add a hyperlink to a FormattedText report item

  1. In the Html property of the FormattedText report item, enter HTML code like the following.
    <body><a href="http://www.datadynamics.com">Data Dynamics</a></body>

Currently only the Image, TextBox, and FormattedText report items support hyperlink actions.

See Also

Reference: Hyperlinks


Adding Page Breaks

Use the PageBreakAtStart and PageBreakAtEnd properties to control where the report breaks to a new page. These properties are available on the following report items as well as on Groupings:

  • Rectangle
  • List
  • Table
  • Matrix
  • Chart

To add a page break before or after a report item

  1. In the Layout view of the report, select the report item before or after which you want to add a page break.
  2. On the General page under Page breaks, select the check box for Insert a page break before or Insert a page break after or both.

To add a page break before or after a grouping

  1. In the Layout view of the report, select the grouping before or after which you want to add a page break.
  2. Right-click the grouping and choose Edit Group.
  3. Select the check box for Page break at start or Page break at end or both.
See Also

Reference: Grouping and Sorting Data

Getting Started: Report Items


Adding Code

Add custom code to a report to make it available for use in expressions.

To add code

  1. On the Code tab of the report, enter your custom code in the provided text box using instance based Visual Basic .NET. For example:
    Function CalcDiscount (x As Double, y As Double, z As Double) As Double
    Dim disc As Double
    disc = (x * y * z)
    Return disc
End Function
  2. On the Layout tab of the report, use your custom code in report item expressions with syntax like the following.
    =Code.CalcDiscount(Fields!Quantity.Value, Fields!Price.Value, Fields!Discount.Value)
See Also

How-To Section | Walkthrough: Custom Code

Reference: Custom Code | Expressions


Adding Data Bound Images

Use the Image smart panel to add an image to your report. The image can be located in a database or on the web, or you can embed an image in the project or in the report.

To add a data bound image

  1. Drag an Image report item from the toolbox onto your report.
  2. Set the Source property to Database.
  3. Set the MIMEType property to the type of the image (i.e. image/jpeg).
  4. Set the Value property to the field that contains the image (i.e. =Fields!image.Value).
See Also

Reference: Images


Adding Items to a Document Map

Allow users to navigate to the item by clicking the label you add to the Document Map (table of contents).

To add an item to the document map

  1. In the Layout view of the report, select and right-click the report item and choose Properties.
  2. Click the Navigation page.
  3. Under Document map label, enter an expression that evaluates to the value you want to display in the document map for the item.

You can also add groups and detail groups to the Document Map.

To add a group or detail group to the document map

  1. In the Layout view of the report, right-click the UI to the left of (or above) the group and choose Edit Group.
  2. On the General page, under Document map label, enter an expression that evaluates to the value you want to display in the document map for the group.

To add the detail group of a list to the document map

  1. In the Layout view of the report, right-click the list report item and choose Properties.
  2. Select the Detail Grouping page.
  3. On the General page, under Document map label, enter an expression that evaluates to the value you want to display in the document map for the group.
See Also

Reference: Document Maps

Getting Started: Document Map


Adding Static Rows and Columns to a Matrix

You can add fixed rows and columns to provide space for additional detail data or labels.

To automatically add static columns and rows to a matrix

  1. In the Layout view of the report, drag a field from the Data Explorer onto the bottom right (detail) cell in the matrix.
  2. Drag an additional field onto the detail cell to split the cell and create an additional static column or row. (A grey bar indicates where the field will be dropped.) This creates a static cell on the selected side of the original detail cell, and adds a label using the field name.
    Dropping an additional field.
    New static column.

The label is added in the position indicated in the following table, depending on the side of the original detail cell on which the static column or row is placed.

Position Relative to Detail | Position of Label | Description
Above | Left | Static row that appears above the detail. The row header (bottom left cell) spans both rows. An empty label cell is added so that you can label the details.
Below | Left | Static row that appears below the detail. The row header (bottom left cell) spans both rows. An empty label cell is added so that you can label the details.
Left | Above | Static column that appears to the left of the detail. The column header (top right cell) spans both columns. An empty label cell is added so that you can label the details.
Right | Above | Static column that appears to the right of the detail. The column header (top right cell) spans both columns. An empty label cell is added so that you can label the details.

To manually add static columns and rows to a matrix

  1. In the Layout view of the report, right-click the bottom right (detail) cell and select Add Column or Add Row.
  2. Cells are added to the table as indicated in the following table. You can add text or expressions to the cells as needed.
Selection | Position Relative to Detail | Position of Label | Description
Add Row | Below | Left | Static row that appears below the detail. The row header (bottom left cell) spans both rows. An empty label cell is added so that you can label the details.
Add Column | Right | Above | Static row that appears below the detail. The row header (bottom left cell) spans both rows. An empty label cell is added so that you can label the details.
See Also

Tutorials: Grouping in a Matrix Using Dynamic Columns and Rows | Walkthrough: Matrix Data Region

Reference: Matrix


Adding Subtotals to a Matrix

You can add subtotals to the groups in your matrix quickly and easily.

To add subtotals to a matrix

  1. Right-click a row or column group header cell in the matrix. (The row group header is the bottom left cell; the column group header is the top right.)
  2. Select Subtotal. This adds a subtotal column to the right of a column group, or a subtotal row below a row group. In the new column or row, a Total label appears with a green corner.
  3. You can change the text of the label as you would any other textbox by clicking anywhere in the textbox that is not green and entering static text or an expression either directly into the textbox or into the Value property in the property grid.
  4. The summary data is shown in a column to the right of the detail data at run time, or in a row below the detail data, and uses the same formatting as the detail cell. To change the appearance of the summary data, click the green corner of the subtotal cell. MatrixSubtotal1 appears in the drop-down box above the property grid and you can set the properties as you would any other textbox. You cannot, however, change the Value of the subtotal.
See Also

Adding Static Rows and Columns to a Matrix

Tutorials: Walkthrough: Matrix Data Region | Grouping in a Matrix Using Dynamic Columns and Rows | Sorting a Matrix | Filtering a Table or Matrix Group

Reference: Matrix


Allowing Users to Sort Data in the Viewer

You can allow users to sort data interactively by setting the interactive sort properties on a textbox.

To set interactive sort properties on a textbox

  1. Right-click the textbox on which you want the users to click and select Properties.
  2. On the TextBox smart panel that appears, select the Interactive Sort page.
  3. Select the checkbox next to Add an interactive sort action to this textbox.
  4. Under Sort expression, enter an expression containing the value of the field on which you want to provide sorting.
  5. Under Data region or group to sort, choose either the option to sort on the current scope, or choose a different scope from the Choose data region or grouping combo box.
  6. Under Evaluate sort expression in this scope, choose either the option to evaluate the sort expression on the current scope, or choose a different scope from the Choose data region or grouping combo box.
  7. Click the Accept icon at the top to close the smart panel and accept the changes.
See Also

Reference: Textbox Interactive Sort Page


Changing the Page Size

To change the page size

  1. In Layout or Data view, open the Report menu, and choose Report Properties.
  2. On the Appearance page, set the Page width and Page height properties to the dimensions you want. (The unit of measure is based on your locale, but you can change it by typing in a different unit designator such as cm or pt after the number.)

Or

  1. In Layout view, select the report in the Properties grid.
  2. Expand the PageSize property, and set the Width and Height in the grid.
Note: The page size is not reflected in the Report Preview. Select Print Preview to see a rendering with the actual page size.


Creating a Shared Data Source

To create a shared data source

  1. Click the Data Explorer icon to the bottom left of the report.
  2. Click the Add Data Source icon.
  3. In the Report DataSource smart panel that appears, select the General page.
  4. Enter a Name (i.e. Factbook), Type (i.e. XML), and Connection String (i.e. XmlDoc=C:\Factbook.xml) for the data source.
  5. Click the Accept icon at the top to close the smart panel and see the data source appear in the Data Explorer.
  6. Right-click the data source in the Data Explorer and choose Share Data Source.
    Note: Once the data source has been shared, right-clicking it in the Data Explorer of any report using it offers the option to Edit Shared Data Source.
  7. Enter a File name for the Shared Data Source File and navigate to the folder in which you want to save it.
  8. Click the Save button.
See Also

Reference: Connecting to a Data Source

Getting Started: Data Explorer


Creating a Report in the Designer

You can create a report definition freeform without using the wizard. There are usually four basic tasks involved in report creation:

  • Creating a Data Dynamics Report
  • Connecting the report to a data source
  • Adding a dataset
  • Adding controls to contain data

Creating a Data Dynamics Report

To create a report in the Report Designer application

  1. From the Windows Start menu go to All Programs, Data Dynamics, Reports and select Data Dynamics Reports Designer.
  2. From the File menu, select Save As.
  3. In the combo box next to Save in, navigate to the directory under which you want to save the report.
  4. Enter a File name and click the Save button.

Connecting the report to a data source

To connect the report to a data source

  1. Click the Data Explorer icon to the bottom left of the report.
  2. Click the Add Data Source icon.
  3. In the Report DataSource smart panel that appears, select the General page.
  4. Change the Name to any text that you want to appear in the Data Explorer as the name of the data source.
  5. Select the Type of data you will use. (With SQL, OleDb, and Oracle data types, there is also a Connection Properties page for your convenience.)
  6. Enter a Connection String.
  7. Click the Validate icon to validate the connection string. (The Validate icon becomes inactive to indicate success. An error message indicates an invalid connection string.)
  8. On the Credentials page, you can specify password, credentials, or Windows authentication.
  9. Click the Accept icon at the top to close the smart panel and see your data source appear in the Data Explorer.

Adding a dataset

To add a dataset

  1. Click the Add DataSet icon.
  2. In the DataSet smart panel that appears, select the General page.
  3. Change the Name to any text that you want to appear in the Data Explorer as the name of the dataset.
  4. On the Query page, select a Command Type.
    • If the Command Type is Text enter a SQL command or XML path into the Query text box.
    • If the Command Type is StoredProcedure enter the name of the stored procedure.
    • If the Command Type is TableDirect enter the name of the table.
  5. Click the Validate icon to validate the query and to populate the Fields list.
  6. For XML data, manually enter fields on the Fields page using valid XPath expressions.
  7. You can optionally set parameters, filters, and data options on the other pages.
  8. Click the Accept icon at the top to close the smart panel and see your dataset and selected fields appear in the Data Explorer.

Adding controls to contain data

To add controls to the report

  1. Click the Layout tab at the bottom of the report and click the Toolbox icon below the Data Explorer.
  2. From the toolbox, drag report items onto the body of the report.
    Note: To render data from each row in your data source, you must use a Data Region.
  3. Click the Data Explorer icon to the bottom left of the report.
  4. Drag fields from the Data Explorer onto a data region, or to display only the first record, drop fields directly onto the body of the report.
See Also

Reference: Creating Reports


Creating an ALL Parameter

You can create an ALL parameter for your users by providing the following:

  • A dataset to populate the parameter values
  • A report parameter
  • A list of values for the report parameter
  • A dataset with a parameter

This how-to topic uses the Reels.mdb data source.

To create a dataset to populate the parameter values

  1. Click the Add DataSet icon.
  2. In the DataSet smart panel that appears, select the Query page.
  3. Enter a SQL command like the following into the Query text box where a UNION SELECT statement combines the results of the ALL query with those of the query for the individual values.

    SELECT -1 AS ProductionID, "(All)" AS Name
    FROM Producers
    UNION
    SELECT ProductionID, Name
    FROM Producers;

  4. Click the Accept icon at the top to close the smart panel and see the dataset and the selected fields appear in the Data Explorer.

To add a Report Parameter

  1. In Layout view, click in or below the report body to ensure that the report has focus.
  2. From the Report menu, select Report Parameters.
  3. In the Report Parameters smart panel that appears, click the Add button to add a parameter.
  4. Ensure that the Data type matches that of the field (i.e. Integer for ProductionID).
  5. Enter text to prompt users for a value.
  6. Select the check box next to Multivalue to allow users to select more than one item from the list.

To provide a list of values for the Report Parameter

  1. Just below the list of parameters, click the Values icon.
  2. Under Available Values, select From query.
  3. Under Dataset, select the dataset created above.
  4. Under Value field, select the field given for -1 (i.e. ProductionID).
  5. Under Label field, select the field given for "All" (i.e. Name).
  6. Click the Accept icon at the top to close the smart panel and add the parameter to the collection.

To add a dataset with a parameter

  1. Click the Add DataSet icon.
  2. On the Parameters page, add parameters like the following to the dataset to provide values for the parameters we add to the query in step 3 below.
    • Parameter Name: Param1; Value: =Parameters!ProductionID.Value
    • Parameter Name: Param2; Value: =Parameters!ProductionID.Value
  3. On the Query page, enter a SQL command like the following in the Query text box:

    SELECT Movie.Title, Movie.YearReleased, Movie.UserRating, Producers.Name
    FROM Producers INNER JOIN (Movie INNER JOIN MovieProducers ON Movie.MovieID = MovieProducers.MovieID) ON Producers.ProductionID = MovieProducers.ProductionID
    WHERE (MovieProducers.ProductionID IN (?)) OR (-1 IN (?))
    ORDER BY MovieProducers.ProductionID, Movie.YearReleased;

  4. Click the Validate icon to validate the query and to populate the Fields list.
  5. Click the Accept icon at the top to close the smart panel and see the dataset and the selected fields appear in the Data Explorer.
See Also

Walkthrough: Parameters

Reference: Dataset Smart Panel | Dataset Query Page | Report Parameters Smart Panel | Dataset Parameters Page


Creating an Instance Method

You can create instance methods that draw on your custom C# or Visual Basic assemblies and use them in expressions in your reports.

To create an instance method

  1. Create a custom assembly.
  2. Make the assembly available to the report definition by saving a copy of it in the Data Dynamics Reports Assemblies folder (C:\Program Files\Data Dynamics\Reports\Build Number\Assemblies).
  3. Add an assembly reference to the report.
    • From the Report menu, choose Report Properties to open the Report smart panel.
    • On the References page under Assemblies, add your assembly using the Add icon.
  4. On the References page under Classes, enter the namespace and class name (for example, if you have an Invoicing assembly which contains a Tax class, you would enter Invoicing.Tax under Class name).
  5. Under Instance name, enter the name you want to use in your expressions.
  6. Click the Accept icon to accept the changes and close the smart panel.

To use an instance method in an expression

  1. In the Value property of a textbox, enter an expression like the following:
    =Code.InstanceName.Method(parameter)
    For example:
    =Code.Inv.GetTax("CA")
See Also

Reference: Custom Code


Exporting Reports

You can export reports to any of the following formats: HTML, PDF, and Image types BMP, EMF, GIF, JPEG, TIFF, PNG, and XML.

To export a report

  1. Open the report that you want to export.
  2. On the Preview tab, click the Export icon and select a format.
  3. Enter the directory to which you want to save the file and set other properties as desired.
  4. Click Export.
See Also

Reference: Rendering to HTML | Rendering to PDF | Rendering to Images


Grouping

You can add grouping to any of the following report items:

  • List
  • Banded List
  • Table
  • Matrix
See Also

Reference: Aggregates and Scope | Grouping and Sorting Data


Grouping a List

Use the details group to group data within a list. You can place lists within lists to create nested grouping.

To group a list

  1. In the Layout view of the report, right-click the List report item and choose Properties.
  2. On the Detail Grouping page, enter a Name for the group.
  3. Under Group on, enter an expression by which to group the data.
  4. Under Document map label, you can optionally set a label to add the item to the document map (table of contents).
  5. Under Parent group, you can optionally set the parent group for a recursive hierarchy. See Grouping and Sorting Data for more information.
See Also

Filtering a Data Region | Grouping

Reference: Grouping and Sorting Data | List | List Detail Grouping Page


Grouping a Banded List

Use groups to organize data in a banded list. There are several ways to do this, and you can use detail grouping as well.

To group a banded list

  1. Right-click the BandedList data region and select Insert Group.
  2. In the Groups smart panel that appears, under Group on enter an expression by which to group the data. The following is an example using the Reels database movie rating field in the movie table.
    =Fields!MPAA.Value
    Note: The name for the group is disabled until after you enter the Group on expression.
  3. Click the Accept icon to accept the change.

Or

  1. Right-click the BandedList data region and choose Properties.
  2. In the smart panel that appears, select the Groups page and click the Add button.
  3. Under Group on enter an expression by which to group the data. The following is an example using the Reels database movie rating field in the movie table.
    =Fields!MPAA.Value
    Note: The name for the group is disabled until after you enter the Group on expression.
  4. Click the Accept icon to accept the change.

Optional grouping settings

  • Under Document map label you can set a label to add the item to the document map (table of contents).
  • Under Parent group you can set the parent group for a recursive hierarchy. See Grouping and Sorting Data for more information.
  • You can also select the following options on this page:
    • Page break at start (begins the group on a new page)
    • Page break at end (begins a new page after the group)
    • Include group header (selected by default)
    • Include group footer (selected by default)
    • Repeat group header (repeats the group header on a new page when necessary)
    • Repeat group footer (repeats the group footer on a new page when necessary)

There are also other pages that allow you to further control each group. The icons for these pages are just below the list of groups.

  • On the Filters page, you can set expressions and operators and values to filter the data. See Filtering a List or Banded List Group for more information.
  • On the Sorting page, you can sort the data by fields in expressions. See Sorting a Banded List for more information.
  • On the Visibility page, you can optionally change the initial visibility of the group. See Toggling Visibility for more information.
  • On the Data Output page, you can optionally control how data is exported to XML.
See Also

Grouping | Walkthrough: BandedList Data Region

Reference: Banded List | Grouping and Sorting Data | BandedList Groups Page


Grouping a Table

Use groups to organize data in a table. There are several ways to do this, and you can use detail grouping to as well.

To group a table

  1. In the Layout view of the report, right-click the UI on the left side of the table and choose Insert Group.
  2. Type a Name for the group.
  3. Under Group on, type or use the Expression Editor to create an expression by which to group the data.
  4. Under Document map label, you can optionally set a label to add the item to the document map (table of contents).
  5. Under Parent group, you can optionally set the parent group for a recursive hierarchy. See Grouping and Sorting Data for more information.
  6. You can also select the following options on this page:
    • Page break at start
    • Page break at end
    • Include group header
    • Include group footer
    • Repeat group header (on each new page)
    • Repeat group footer

To group a table's details

  1. In the Layout view of the report, select the detail row and right-click in the UI on the left side of the table and choose Edit Group.
  2. Type a Name for the group.
  3. Under Group on, type or use the Expression Editor to create an expression by which to group the data.
  4. Under Document map label, you can optionally set a label to add the item to the document map (table of contents).
  5. Under Parent group, you can optionally set the parent group for a recursive hierarchy. See Grouping and Sorting Data for more information.
  6. You can also select the Page break at start and Page break at end options on this page.
See Also

Grouping

Reference: Grouping and Sorting Data | Table | Table Groups Page | Table Detail Grouping Page


Grouping in a Matrix Using Dynamic Columns and Rows

You can use dynamic column and row groups to organize data in a matrix.

To automatically group a matrix using dynamic columns and rows

  1. In the Layout view of the report, drag fields from the Data Explorer onto a row or column header in the matrix. This action adds both an expression to the textbox in the cell and a grouping to the matrix.
    Note: The row header is the bottom left cell. The column header is the top right cell.
  2. Drag an additional field onto a row or column header to split it into another dynamic row or column. (A bar indicates whether the field is added above or below the original column header, or to the left or right of the original row header.) This action adds both an expression to the textbox in the new cell and another grouping to the matrix.

To manually group a matrix using dynamic columns and rows

  1. Right-click a row or column header and choose Add Column Group or Add Row Group. This adds a new cell below the original column header or to the right of the original row header.
  2. In the Column Groups or Row Groups smart panel that appears, enter a Group on expression by which to group the data.
  3. You can optionally enter an expression or static text in the textbox in the new cell.

Or

  1. Select the Matrix report item by clicking the handle at the top left of the matrix, right-click the edge, and choose Properties.
  2. On the Column Groups or Row Groups page, click the Add button to add a new group and a new cell below the original column header or to the right of the original row header.
  3. Enter a name for the group and a Group on expression by which to group the data.
  4. You can optionally enter an expression or static text in the textbox in the new cell.
See Also

Grouping | Walkthrough: Matrix Data Region

Reference: Matrix | Grouping and Sorting Data

Getting Started: Adding Static Rows and Columns to a Matrix


Hiding Page Headers and Footers

Data Dynamics Reports allows you to easily suppress Page Headers and Page Footers on the first and last pages of your reports.

To hide a Page Header or Footer on the first or last page

  1. On the layout page of the report, click the Page Header or Page Footer.
  2. In the Properties Grid, set the PrintOnFirstPage or PrintOnLastPage property to False.
See Also

Getting Started: Layout


Passing Parameters

When you use a subreport to which you have added parameters, you can pass values to those parameters from the parent report or from the data region which hosts the subreport.

To pass parameters to a subreport

  1. On the layout tab of the report, right-click the subreport and choose Properties.
  2. In the Subreport Properties smart panel, select Parameters.
  3. Under Parameter Name, type the exact name of a parameter in the subreport.
  4. Under Parameter Value, enter a value for the parameter. (You can create an expression for this value that calls a field in the parent report.)
  5. Repeat steps 3 and 4 for every parameter in the subreport.
    Note: If you do not provide all of the parameters for the subreport, it will not render.
  6. Click the Accept icon at the top to close the smart panel.

To pass parameters from a data region to a repeating subreport

  1. On the layout tab of the report, right-click the subreport and choose Properties.
  2. In the Subreport Properties smart panel, click the Parameters page.
  3. Under Parameter Name, enter the exact name of a parameter in the subreport.
  4. Under Parameter Value, enter an expression value for the parameter that calls a field in the data region.
  5. Repeat steps 3 and 4 for every parameter in the subreport.
    Note: If you do not provide all of the parameters for the subreport, it will not render.
  6. Click the Accept icon at the top to close the smart panel.
See Also

Walkthrough: Parameters

Reference: Subreports | Parameters


Previewing

Data Dynamics Reports provides a design time Preview tab for quick viewing of your reports as you work. The Preview tab contains the Report Preview control with buttons for print preview and exporting options.

To preview a report

  1. Open Microsoft Visual Studio® .NET and open a project containing a Data Dynamics Reports report.
  2. Click the Preview tab.
  3. If the report requires parameters, enter a valid parameter to view the report; otherwise the report displays automatically.
Note: If your report contains a subreport, changes made in the subreport do not automatically update. Click the refresh button to do so manually.
See Also

Exporting Reports


Printing

In order to print a report, you must first render or transform it into a printable format or use the Print Preview. HTML is not generally a recommended format for printing. You may also automate printing using code.

To print a report using Print Preview

  1. On the Preview tab of a report, ensure that the Print Preview icon is depressed.
  2. Click the Print button.
  3. Select your printer, print range, and number of copies.
  4. Click the OK button.

To print a report in other printable formats

  1. On the Preview tab of a report or in the Report Viewer application, click the Export icon and choose a format (other than HTML).
  2. Enter the directory to which you want to save the file and set other properties as desired.
  3. Click Export.
  4. Open the exported report in an application appropriate to the format.
  5. From the File menu of the application in which the exported report opens, select Print.
See Also

Exporting Reports | Previewing

Reference: Rendering and Transforming Reports


BMP Options

The BMP (bitmap) ImageType property in the image export dialog offers a choice of ColorDepth in addition to all of the common options.

ColorDepth
Select the number of bits per pixel for PNG and BMP rendered images. The default value is 8 bits per pixel, but you can choose 1, 4, 16, 24, 32, or 64 bits.
DpiX
Adjust the horizontal resolution of rendered images. The default value is 96.
DpiY
Adjust the vertical resolution of rendered images. The default value is 96.
Tip: A dot matrix printer typically prints in the 60 to 90 DPI range, a laser printer may be in the range of 600 to 1200 DPI, an inkjet printer may be in the range of 1200 to 9600 DPI, and 72 to 150 DPI is sufficient for web use. The higher DPI ranges take longer to print, so consider whether a high value is necessary for the image.
EndPage
The default value of zero in this and the StartPage properties render all of the report pages to images. Otherwise, set this value to the number of the last page to render.
ImageType
Select the type of image to which you want to render the report. Supported types are BMP, EMF, GIF, JPEG, TIFF, and PNG.
MarginBottom
Set the value in inches to use for the bottom margin of the image. The format is an integer or decimal with "in" as the suffix, for example "1in" for 1 inch. By default, no margins are used. The value set in this property overrides the report's settings.
MarginLeft
Set the value in inches to use for the left margin of the image. The format is an integer or decimal with "in" as the suffix, for example "1in" for 1 inch. By default, no margins are used. The value set in this property overrides the report's settings.
MarginRight
Set the value in inches to use for the right margin of the image. The format is an integer or decimal with "in" as the suffix, for example "1in" for 1 inch. By default, no margins are used. The value set in this property overrides the report's settings.
MarginTop
Set the value in inches to use for the top margin of the image. The format is an integer or decimal with "in" as the suffix, for example "1in" for 1 inch. By default, no margins are used. The value set in this property overrides the report's settings.
PageHeight
Set the value in inches to use for the height of the image. The format is an integer or decimal with "in" as the suffix, for example "11in" for 11 inches. The value set in this property overrides the report's settings.
PageWidth
Set the value in inches to use for the width of the image. The format is an integer or decimal with "in" as the suffix, for example "8in" for 8 inches. The value set in this property overrides the report's settings.
Pagination
By default, each page of a report is rendered as a separate image. Set this value to False to render the entire report as a single image.
PrintLayoutMode
Select how to lay out the pages of the report in the image.
  • OneLogicalPageOnSinglePhysicalPage
  • TwoLogicalPagesOnSinglePhysicalPage
  • FourLogicalPagesOnSinglePhysicalPage
  • EightLogicalPagesOnSinglePhysicalPage
  • BookletMode (lays the pages out for booklet printing)
SizeToFit
By default, rendered report pages are not resized to fit within the selected PageHeight and PageWidth. Set this value to True to resize the report pages.
StartPage
The default value of zero in this and the EndPage properties render all of the report pages to images. Otherwise, set this value to the number of the first page to render.
WatermarkAngle
Specify the degree of angle for the watermark text on the image. Valid values range from 0 to 359, where 0 is horizontal, left to right.
WatermarkColor
Select a color for the watermark text on the image. The default value for the watermark color is gray, but you can select any Web, System, or Custom color.
WatermarkFont
Set the font to use for the watermark to any valid System.Drawing.Font.
WatermarkTitle
Enter text (i.e. CONFIDENTIAL) to use as the watermark on the image.
See Also

Reference: Rendering to Images


EMF Options

The EMF (Enhanced Metafile) ImageType property in the image export dialog offers all of the common options.

DpiX
Adjust the horizontal resolution of rendered images. The default value is 96.
DpiY
Adjust the vertical resolution of rendered images. The default value is 96.
Tip: A dot matrix printer typically prints in the 60 to 90 DPI range, a laser printer may be in the range of 600 to 1200 DPI, an inkjet printer may be in the range of 1200 to 9600 DPI, and 72 DPI is sufficient for web use.
EndPage
The default value of zero in this and the StartPage properties render all of the report pages to images. Otherwise, set this value to the number of the last page to render.
ImageType
Select the type of image to which you want to render the report. Supported types are BMP, EMF, GIF, JPEG, TIFF, and PNG.
MarginBottom
Set the value in inches to use for the bottom margin of the image. The format is an integer or decimal with "in" as the suffix, for example "1in" for 1 inch. By default, no margins are used. The value set in this property overrides the report's settings.
MarginLeft
Set the value in inches to use for the left margin of the image. The format is an integer or decimal with "in" as the suffix, for example "1in" for 1 inch. By default, no margins are used. The value set in this property overrides the report's settings.
MarginRight
Set the value in inches to use for the right margin of the image. The format is an integer or decimal with "in" as the suffix, for example "1in" for 1 inch. By default, no margins are used. The value set in this property overrides the report's settings.
MarginTop
Set the value in inches to use for the top margin of the image. The format is an integer or decimal with "in" as the suffix, for example "1in" for 1 inch. By default, no margins are used. The value set in this property overrides the report's settings.
PageHeight
Set the value in inches to use for the height of the image. The format is an integer or decimal with "in" as the suffix, for example "11in" for 11 inches. The value set in this property overrides the report's settings.
PageWidth
Set the value in inches to use for the width of the image. The format is an integer or decimal with "in" as the suffix, for example "8in" for 8 inches. The value set in this property overrides the report's settings.
Pagination
By default, each page of a report is rendered as a separate image. Set this value to False to render the entire report as a single image.
PrintLayoutMode
Select how to lay out the pages of the report in the image.
  • OneLogicalPageOnSinglePhysicalPage
  • TwoLogicalPagesOnSinglePhysicalPage
  • FourLogicalPagesOnSinglePhysicalPage
  • EightLogicalPagesOnSinglePhysicalPage
  • BookletMode (lays the pages out for booklet printing)
SizeToFit
By default, rendered report pages are not resized to fit within the selected image size. Set this value to True to resize the report pages.
StartPage
The default value of zero in this and the EndPage properties render all of the report pages to images. Otherwise, set this value to the number of the first page to render.
See Also

Reference: Rendering to Images


GIF Options

The GIF (Graphics Interchange Format) ImageType property in the image export dialog offers all of the common options.

DpiX
Adjust the horizontal resolution of rendered images. The default value is 96.
DpiY
Adjust the vertical resolution of rendered images. The default value is 96.
Tip: A dot matrix printer typically prints in the 60 to 90 DPI range, a laser printer may be in the range of 600 to 1200 DPI, an inkjet printer may be in the range of 1200 to 9600 DPI, and 72 DPI is sufficient for web use.
EndPage
The default value of zero in this and the StartPage properties render all of the report pages to images. Otherwise, set this value to the number of the last page to render.
ImageType
Select the type of image to which you want to render the report. Supported types are BMP, EMF, GIF, JPEG, TIFF, and PNG.
MarginBottom
Set the value in inches to use for the bottom margin of the image. The format is an integer or decimal with "in" as the suffix, for example "1in" for 1 inch. By default, no margins are used. The value set in this property overrides the report's settings.
MarginLeft
Set the value in inches to use for the left margin of the image. The format is an integer or decimal with "in" as the suffix, for example "1in" for 1 inch. By default, no margins are used. The value set in this property overrides the report's settings.
MarginRight
Set the value in inches to use for the right margin of the image. The format is an integer or decimal with "in" as the suffix, for example "1in" for 1 inch. By default, no margins are used. The value set in this property overrides the report's settings.
MarginTop
Set the value in inches to use for the top margin of the image. The format is an integer or decimal with "in" as the suffix, for example "1in" for 1 inch. By default, no margins are used. The value set in this property overrides the report's settings.
PageHeight
Set the value in inches to use for the height of the image. The format is an integer or decimal with "in" as the suffix, for example "11in" for 11 inches. The value set in this property overrides the report's settings.
PageWidth
Set the value in inches to use for the width of the image. The format is an integer or decimal with "in" as the suffix, for example "8in" for 8 inches. The value set in this property overrides the report's settings.
Pagination
By default, each page of a report is rendered as a separate image. Set this value to False to render the entire report as a single image.
PrintLayoutMode
Select how to lay out the pages of the report in the image.
  • OneLogicalPageOnSinglePhysicalPage
  • TwoLogicalPagesOnSinglePhysicalPage
  • FourLogicalPagesOnSinglePhysicalPage
  • EightLogicalPagesOnSinglePhysicalPage
  • BookletMode (lays the pages out for booklet printing)
SizeToFit
By default, rendered report pages are not resized to fit within the selected image size. Set this value to True to resize the report pages.
StartPage
The default value of zero in this and the EndPage properties render all of the report pages to images. Otherwise, set this value to the number of the first page to render.
See Also

Reference: Rendering to Images


JPEG Options

The JPEG (Joint Photographic Experts Group) ImageType property in the image export dialog offers a choice of Quality in addition to all of the common options.

DpiX
Adjust the horizontal resolution of rendered images. The default value is 96.
DpiY
Adjust the vertical resolution of rendered images. The default value is 96.
Tip: A dot matrix printer typically prints in the 60 to 90 DPI range, a laser printer may be in the range of 600 to 1200 DPI, an inkjet printer may be in the range of 1200 to 9600 DPI, and 72 DPI is sufficient for web use.
EndPage
The default value of zero in this and the StartPage properties render all of the report pages to images. Otherwise, set this value to the number of the last page to render.
ImageType
Select the type of image to which you want to render the report. Supported types are BMP, EMF, GIF, JPEG, TIFF, and PNG.
MarginBottom
Set the value in inches to use for the bottom margin of the image. The format is an integer or decimal with "in" as the suffix, for example "1in" for 1 inch. By default, no margins are used. The value set in this property overrides the report's settings.
MarginLeft
Set the value in inches to use for the left margin of the image. The format is an integer or decimal with "in" as the suffix, for example "1in" for 1 inch. By default, no margins are used. The value set in this property overrides the report's settings.
MarginRight
Set the value in inches to use for the right margin of the image. The format is an integer or decimal with "in" as the suffix, for example "1in" for 1 inch. By default, no margins are used. The value set in this property overrides the report's settings.
MarginTop
Set the value in inches to use for the top margin of the image. The format is an integer or decimal with "in" as the suffix, for example "1in" for 1 inch. By default, no margins are used. The value set in this property overrides the report's settings.
PageHeight
Set the value in inches to use for the height of the image. The format is an integer or decimal with "in" as the suffix, for example "11in" for 11 inches. The value set in this property overrides the report's settings.
PageWidth
Set the value in inches to use for the width of the image. The format is an integer or decimal with "in" as the suffix, for example "8in" for 8 inches. The value set in this property overrides the report's settings.
Pagination
By default, each page of a report is rendered as a separate image. Set this value to False to render the entire report as a single image.
PrintLayoutMode
Select how to lay out the pages of the report in the image.
  • OneLogicalPageOnSinglePhysicalPage
  • TwoLogicalPagesOnSinglePhysicalPage
  • FourLogicalPagesOnSinglePhysicalPage
  • EightLogicalPagesOnSinglePhysicalPage
  • BookletMode (lays the pages out for booklet printing)
Quality
Specify the quality to use for a report rendered as a JPEG image. The default value is 50, and values range from 1 to 100 percent.
SizeToFit
By default, rendered report pages are not resized to fit within the selected image size. Set this value to True to resize the report pages.
StartPage
The default value of zero in this and the EndPage properties render all of the report pages to images. Otherwise, set this value to the number of the first page to render.
See Also

Reference: Rendering to Images


TIFF Options

The TIFF (Tagged Image File Format) ImageType property in the image export dialog offers a choice of Compression and Dither in addition to all of the common options.

Compression
Select the type of compression to use for reports rendered as TIFF images. The default value is Ccitt3, or you can choose None, Rle, or Lzw.
Dither
Specify whether a report rendered as a TIFF image is dithered when saving to a black and white output format such as Ccitt3 or Rle. If the Compression property is set to Lzw or None (indicating color output) this property has no effect.
DpiX
Adjust the horizontal resolution of rendered images. The default value is 96.
DpiY
Adjust the vertical resolution of rendered images. The default value is 96.
Tip: A dot matrix printer typically prints in the 60 to 90 DPI range, a laser printer may be in the range of 600 to 1200 DPI, an inkjet printer may be in the range of 1200 to 9600 DPI, and 72 DPI is sufficient for web use.
EndPage
The default value of zero in this and the StartPage properties render all of the report pages to images. Otherwise, set this value to the number of the last page to render.
ImageType
Select the type of image to which you want to render the report. Supported types are BMP, EMF, GIF, JPEG, TIFF, and PNG.
MarginBottom
Set the value in inches to use for the bottom margin of the image. The format is an integer or decimal with "in" as the suffix, for example "1in" for 1 inch. By default, no margins are used. The value set in this property overrides the report's settings.
MarginLeft
Set the value in inches to use for the left margin of the image. The format is an integer or decimal with "in" as the suffix, for example "1in" for 1 inch. By default, no margins are used. The value set in this property overrides the report's settings.
MarginRight
Set the value in inches to use for the right margin of the image. The format is an integer or decimal with "in" as the suffix, for example "1in" for 1 inch. By default, no margins are used. The value set in this property overrides the report's settings.
MarginTop
Set the value in inches to use for the top margin of the image. The format is an integer or decimal with "in" as the suffix, for example "1in" for 1 inch. By default, no margins are used. The value set in this property overrides the report's settings.
PageHeight
Set the value in inches to use for the height of the image. The format is an integer or decimal with "in" as the suffix, for example "11in" for 11 inches. The value set in this property overrides the report's settings.
PageWidth
Set the value in inches to use for the width of the image. The format is an integer or decimal with "in" as the suffix, for example "8in" for 8 inches. The value set in this property overrides the report's settings.
Pagination
By default, each page of a report is rendered as a separate image. Set this value to False to render the entire report as a single image.
PrintLayoutMode
Select how to lay out the pages of the report in the image.
  • OneLogicalPageOnSinglePhysicalPage (default)
  • TwoLogicalPagesOnSinglePhysicalPage
  • FourLogicalPagesOnSinglePhysicalPage
  • EightLogicalPagesOnSinglePhysicalPage
  • BookletMode (lays the pages out in a single file for booklet printing)
SizeToFit
By default, rendered report pages are not resized to fit within the selected image size. Set this value to True to resize the report pages.
StartPage
The default value of zero in this and the EndPage properties render all of the report pages to images. Otherwise, set this value to the number of the first page to render.
See Also

Reference: Rendering to Images


PNG Options

The PNG (Portable Network Graphics) ImageType property in the image export dialog offers a choice of ColorDepth in addition to all of the common options.

ColorDepth
Specify the number of bits per pixel for PNG and BMP rendered images. The default value is 8 bits per pixel, but you can choose 1, 4, 16, 24, 32, or 64 bits.
DpiX
Adjust the horizontal resolution of rendered images. The default value is 96.
DpiY
Adjust the vertical resolution of rendered images. The default value is 96.
Tip: A dot matrix printer typically prints in the 60 to 90 DPI range, a laser printer may be in the range of 600 to 1200 DPI, an inkjet printer may be in the range of 1200 to 9600 DPI, and 72 DPI is sufficient for web use.
EndPage
The default value of zero in this and the StartPage properties render all of the report pages to images. Otherwise, set this value to the number of the last page to render.
ImageType
Select the type of image to which you want to render the report. Supported types are BMP, EMF, GIF, JPEG, TIFF, and PNG.
MarginBottom
Set the value in inches to use for the bottom margin of the image. The format is an integer or decimal with "in" as the suffix, for example "1in" for 1 inch. By default, no margins are used. The value set in this property overrides the report's settings.
MarginLeft
Set the value in inches to use for the left margin of the image. The format is an integer or decimal with "in" as the suffix, for example "1in" for 1 inch. By default, no margins are used. The value set in this property overrides the report's settings.
MarginRight
Set the value in inches to use for the right margin of the image. The format is an integer or decimal with "in" as the suffix, for example "1in" for 1 inch. By default, no margins are used. The value set in this property overrides the report's settings.
MarginTop
Set the value in inches to use for the top margin of the image. The format is an integer or decimal with "in" as the suffix, for example "1in" for 1 inch. By default, no margins are used. The value set in this property overrides the report's settings.
PageHeight
Set the value in inches to use for the height of the image. The format is an integer or decimal with "in" as the suffix, for example "11in" for 11 inches. The value set in this property overrides the report's settings.
PageWidth
Set the value in inches to use for the width of the image. The format is an integer or decimal with "in" as the suffix, for example "8in" for 8 inches. The value set in this property overrides the report's settings.
Pagination
By default, each page of a report is rendered as a separate image. Set this value to False to render the entire report as a single image.
PrintLayoutMode
Select how to lay out the pages of the report in the image.
  • OneLogicalPageOnSinglePhysicalPage
  • TwoLogicalPagesOnSinglePhysicalPage
  • FourLogicalPagesOnSinglePhysicalPage
  • EightLogicalPagesOnSinglePhysicalPage
  • BookletMode (lays the pages out for booklet printing)
SizeToFit
By default, rendered report pages are not resized to fit within the selected image size. Set this value to True to resize the report pages.
StartPage
The default value of zero in this and the EndPage properties render all of the report pages to images. Otherwise, set this value to the number of the first page to render.
See Also

Reference: Rendering to Images


Sorting

You can add sorting to any of the following data regions:

  • Matrix
  • List
  • Banded List
  • Table
See Also

How-To Section

Reference: Grouping and Sorting Data


Sorting a Matrix

Sort the data in a matrix by fields or expressions.

To sort a matrix

  1. In the Layout view, select the matrix, right-click and choose Properties to open the Matrix Data Region smart panel. (Or select a row or column of the matrix, right-click and choose Add Column Group or Add Row Group to open the Row or Column Groups smart panel.)
  2. On the Row Groups or Column Groups page, select the group you wish to sort and click the Sorting icon.
  3. Enter an expression in the Expression column by which to sort the data in the selected row or column group.

  4. In the Direction column, select whether you want to sort the data in an Ascending or Descending direction.

See Also

Sorting | Grouping in a Matrix Using Dynamic Columns and Rows | Walkthrough: Matrix Data Region

Reference: Matrix | Grouping and Sorting Data


Sorting a List

Sort the data in a list by fields or expressions.

To sort a list

  1. In the Layout view, select the list, right-click and choose Properties.
  2. On the Sorting page, enter an expression in the Expression column by which to sort the data in the list.

  3. In the Direction column, select whether you want to sort the data in an Ascending or Descending direction.

See Also

Sorting

Reference: Grouping and Sorting Data | List


Sorting a Banded List

You can sort groups in a BandedList data region by fields or expressions. Note that you cannot sort data in the detail band of a BandedList, only the groups. For example, if you group on the YearReleased field in the Reels database, you can sort ascending from 1937 through 2005, or reverse the order by using descending for the direction.

To sort a group in a banded list

  1. Right-click a group header or footer in the BandedList and choose Edit Group.
  2. On the Groups smart panel that appears, select the group in which you want to sort data.
  3. From the row of icons that appears below the list of groups, select the Sorting icon.
  4. Enter an expression in the Expression column by which to sort the data in the group.

  5. In the Direction column, select whether you want to sort the data in an Ascending or Descending direction.

See Also

Sorting | Grouping a Banded List | Walkthrough: BandedList Data Region

Reference: Banded List | Grouping and Sorting Data


Sorting a Table

Sort the data in a table by fields or expressions.

To sort a table

  1. In the Layout view, select the table, right-click and choose Properties.
  2. On the Sorting page, enter an expression in the Expression column by which to sort the data in the table.

  3. In the Direction column, select whether you want to sort the data in an Ascending or Descending direction.

See Also

Sorting

Reference: Table | Grouping and Sorting Data


Subtotaling in Data Regions

Dragging a numeric field directly onto the body of a report automatically creates an expression using the Sum function. Since the scope of a report item directly on the body of the report is the entire dataset, this yields a grand total for the report.

You can also add grand totals and subtotals to groups in any of the following data regions:

  • Matrix
  • List
  • Banded List
  • Table

Subtotaling is generally accomplished using the Sum function in an expression, along with the scope parameter. The expression uses the default scope, generally the group level in which the report item containing the expression resides, if one is not specified. For more information on scope, see the Functions topic.

See Also

How-To Section

Reference: Using Data Regions | Expressions | Functions


Subtotaling in Matrix Groups

Use subtotaling in matrix groups to add meaning to your data. Dragging a numeric field into the detail cell of a matrix automatically creates an expression using the Sum function to give an aggregation of the data at that point, but you can also add subtotals and grand totals.

To add a subtotal to a matrix group

  1. In the Layout view of the report, right-click a row header or column header cell in the matrix.
  2. Select Subtotal. A new column or row with a header labeled Total is added.
  3. To edit the properties of the subtotal, left-click the green corner of the new header and the properties appear in the property grid.

To add a grand total to a matrix

  1. Follow the steps above to add subtotals to both the row header and the column header.
  2. The bottom right cell of the rendered matrix reflects the grand total.
See Also

Subtotaling in Data Regions | Grouping in a Matrix Using Dynamic Columns and Rows

Reference: Matrix


Subtotaling in Lists

Use subtotaling in lists to add meaning to your data. You can add subtotals using detail grouping, and grand totals for a list can be easily added to the body of the report just below the list.

To add a subtotal to a list

  1. In the Layout view of the report, drag a numeric field onto a list. With no changes, this field would repeat for each row of data in the associated dataset.
  2. Change the expression in the value of the resulting textbox to use the Sum function to calculate the total. (i.e. change =Fields!SalesAmount.Value to read =Sum(Fields!SalesAmount.Value).)
    Note: If you preview the report at this point, you will notice that the summary field renders the grand total for the dataset after each sales amount, which is probably not the behavior we want.
  3. Add a detail grouping to the list.
    • Right-click the list and select Properties.
    • On the Detail Grouping page, select a Group on expression by which to group the data. (i.e. =Fields!Store.Value)
    • Click the Accept icon at the top to close the smart panel and apply the change.
  4. Now when you preview the report, a subtotal of the sales amount for each store is shown.

To add a grand total to a list

  1. Drag the same field that shows subtotals in your list onto the body of the report just below the list.
  2. The expression in the resulting textbox automatically uses the Sum function.
  3. Preview the report to see that the new textbox supplies a grand total for the list.
See Also

Subtotaling in Data Regions | Grouping a List

Reference: List


Subtotaling in BandedList Groups

Use subtotaling in banded lists to add meaning to your data. You can add subtotals using group header and footer rows, and grand totals using banded list header and footer rows.

To add a subtotal to a banded list

  1. In the Layout view of the report, drag a numeric field onto the detail band of the banded list. (i.e. =Fields!SalesAmount.Value) This field repeats for each row of data in the associated dataset. This action also sets the DataSetName property of the banded list to the name of the dataset from which you dragged the field.
  2. Add a grouping to the banded list.
    • Right-click the list and select Insert Group.
    • On the Groups smart panel that appears, select a Group on expression by which to group the data. (i.e. =Fields!Store.Value)
    • Click the Accept icon at the top to close the smart panel and apply the change. A new pair of bands appears between the detail band and the header and footer bands.
  3. Drag the same numeric field into the group footer band.
  4. The expression in the resulting textbox automatically uses the Sum function. This field repeats for each group (i.e. Store) in the data and displays a subtotal for that group.

To add a grand total to a banded list

  1. Drag the same numeric field used above into the footer band at the bottom of the banded list.
  2. The expression in the resulting textbox automatically uses the Sum function.
  3. Preview the report to see that the new textbox supplies a grand total for the banded list.
See Also

Subtotaling in Data Regions | Grouping a Banded List

Reference: Banded List


Subtotaling in Table Groups

Use subtotaling in table groups to add meaning to your data. You can add subtotals using group header and footer rows, and grand totals using table header and footer rows.

To add a subtotal to a table group

  1. In the Layout view of the report, drag a numeric field into the detail row of the table. (i.e. =Fields!SalesAmount.Value) This field repeats for each row of data in the associated dataset. This action also sets the DataSetName property of the table to the name of the dataset from which you dragged the field.
  2. Add a grouping to the table.
    • Click inside the table to reveal the row and column handles along the left and top edges of the table.
    • Right-click in the row handles along the left edge of the table and select Insert Group.
    • On the Groups smart panel that appears, select a Group on expression by which to group the data. (i.e. =Fields!Store.Value)
    • Click the Accept icon at the top to close the smart panel and apply the change. A new pair of rows appears between the detail row and the header and footer rows.
  3. Drag the same numeric field into the group footer row.
  4. The expression in the resulting textbox automatically uses the Sum function. This field repeats for each group (i.e. Store) in the data and displays a subtotal for that group.

To add a grand total to a table

  1. Drag the same numeric field used above into the footer row at the bottom of the table.
  2. The expression in the resulting textbox automatically uses the Sum function.
  3. Preview the report to see that the new textbox supplies a grand total for the table.
See Also

Subtotaling in Data Regions | Grouping a Table

Reference: Table


Toggling Visibility

You can set the initial visibility of report items to Hidden and allow the user to toggle them by clicking other report items.

To toggle visibility

  1. Right-click the report item for which you want to toggle visibility and select Properties.
  2. On the Visibility page, under Initial visibility, select Hidden.
  3. Select the check box to indicate that Visibility can be toggled by another report item.
  4. In the Report item combo box, enter the report item you want to toggle the hidden item.


Samples and Walkthroughs

This section contains example code and sample applications that illustrate basic techniques and uses of Data Dynamics Reports.

In This Section

Samples
Review various samples in C# and Visual Basic .NET.
Walkthroughs
Learn how to create various reports and report constituents with step-by-step instructions.

Related Sections

Introducing Data Dynamics Reports
Find out about the components and features included in Data Dynamics Reports, as well as copyright and license information. This section also contains the answers to some Frequently Asked Questions.
Getting Help
This topic shows you how to locate Readme information as well as how to obtain technical support for Data Dynamics Reports.


Samples

Data Dynamics Reports includes samples to demonstrate the various features and functions of the product. These samples show the use of a combination of report items and code to produce various reports. The samples are located in the installation directory under Samples.

Included Samples

Factbook Sample
The Factbook sample reports demonstrate the use of the XML data source and various features.
Reels Sample
The Reels sample reports use an OLEDB data source to demonstrate many Data Dynamics Reports features.
Sample Gallery
The Sample Gallery is an application demonstrating how reports can be used within other applications and includes many helpful explanations of features.

Additional Information

Walkthroughs
Walkthroughs give basic step-by-step instructions for common reporting scenarios using Data Dynamics Reports. This feature makes walkthroughs an excellent way to learn more about the basic features of the product.


Walkthroughs

Learn step by step how to create many common types of reports.

In this section

Walkthrough: Basic Report
Learn to create a basic report using the table control.
Walkthrough: Page Numbering
Learn to add page numbering to a report.
Walkthrough: Master-Detail Reports
Learn to create master-detail reports.
Walkthrough: XML Data
Learn to use an XML data source and the list control.
Walkthrough: Sorting
Learn to use sorting in a table.
Walkthrough: BandedList Data Region
Learn to use nested grouping in a banded list.
Walkthrough: Matrix Data Region
Learn to use nested grouping, drilldown, and subtotals in a matrix.
Walkthrough: Expressions
Learn to use expressions for visibility, background color, and value properties.
Walkthrough: Charts
Learn to create a report with charts.
Walkthroughs: Interactive Reports
Learn to use the interactive features.
Walkthrough: Recursive Hierarchy
Learn to use a recursive hierarchy along with the Level function to display parent-child relations.
Walkthrough: Master Reports
Learn to create master reports and content reports.
Walkthrough: Subreports
Learn to use subreports.
Walkthrough: Dynamic Queries
Learn to use dynamic queries in reports.
Walkthrough: Custom Code
Learn to add custom code to reports for added functionality.
Walkthrough: Web Report Viewer
Learn to display reports in the Web Report Viewer.
See Also

Samples


Walkthrough: Basic Report

You can create a basic report in minutes using the Data Dynamics Reports Table control.

This walkthrough illustrates how to create a simple tabular report.

The walkthrough is split up into the following activities:

  • Creating a Data Dynamics Report
  • Connecting the report to a data source
  • Adding a Dataset
  • Adding controls to the report to contain data
  • Viewing the report

To complete the walkthrough, you must have access to the Reels sample database included with this installation.

When you are finished you will have a report that looks similar to the following.

Creating a Data Dynamics Report

To create a report in the Report Designer application

  1. From the Windows Start menu go to All Programs, Data Dynamics, Reports and select Data Dynamics Reports Designer.
  2. From the File menu, select Save As.
  3. In the combo box next to Save in, navigate to the directory under which you want to save the report.
  4. Enter MovieRatings.rdlx as the File name and click the Save button.

Connecting the report to a data source

To connect the report to a data source

  1. Click the Data Explorer icon to the bottom left of the report.
  2. Click the Add Data Source icon.
  3. In the Report DataSource smart panel that appears, select the General page.
  4. Change the Name to Reels.
  5. Change the Type to OLEDB.
  6. Use the following Connection String, replacing the text your name and build number with the actual name and build number on your machine:

    Provider=Microsoft.Jet.OLEDB.4.0;Data Source=C:\Documents and Settings\your name\My Documents\Data Dynamics\Reports\build number\Samples\Reels\Data\Reels.mdb;User id=admin;password=;

    Note: In Windows Vista, the path is C:\User\your name\Documents\Data Dynamics\Reports\build number\Samples\Reels\Data\Reels.mdb.
  7. Click the Validate icon to validate the connection string. (The Validate icon becomes inactive to indicate success. An error message indicates an invalid connection string.)
  8. Click the Accept icon at the top to close the smart panel and see Reels appear in the Data Explorer.

Adding a dataset

To add a dataset

  1. Click the Add DataSet icon.
  2. In the DataSet smart panel that appears, select the General page.
  3. Change the Name to MovieRatings.
  4. On the Query page, paste the following SQL command into the Query text box:

    SELECT Movie.MovieID, Movie.Title, Movie.YearReleased, Movie.MPAA FROM Movie ORDER BY Movie.YearReleased;

  5. Click the Validate icon to validate the query and to populate the Fields list.
  6. Click the Accept icon at the top to close the smart panel and see MovieRatings and the selected fields appear in the Data Explorer.

Adding controls to contain data

To add controls to the report

  1. Click the Toolbox icon below the Data Explorer.
  2. From the toolbox, drag a Table data region onto the body of the report.
  3. With the table selected in the property grid, set the DataSetName property to MovieRatings.
  4. Click inside the table to display the row and column handles along the left and top edges of the table.
  5. From MovieRatings in the Data Explorer, drag the Title field into the first column of the Detail row.
    Note: This automatically places an expression in the detail row and simultaneously places a static label in the header row of the same column.
  6. Drag the MPAA field into the second column of the Detail row of the table.
  7. Drag the YearReleased field into the third column of the Detail row.
  8. To optionally display the static labels in bold at the top of every page of the report:
    • Select the Header row by clicking the table handle to the left of the row.
    • In the Report Formatting tool bar, click the Bold button.
    • In the Properties grid, set the RepeatOnNewPage property to True.
  9. To improve the appearance of the report:
    • Select the second column and change its Width property to 1in.
    • Select the third column and change its Width property to 1.1in.
    • Select the first column and change its Width property to 4.4in.
    Tip: Making some columns narrower before making other columns wider prevents your report width from changing.
  10. To add a page header to the report:
    • Click below the report to give it focus and from the Report menu, select Page Header.
    • From the toolbox, select Textbox and draw it onto the page header section to span the entire width of the report.
    • Set the TextAlign property to Center and the FontSize property to 14pt.
    • Click inside the textbox and enter the text Movie Ratings.
  11. From the File menu, select Save.

Viewing the report

Any report designed with Data Dynamics Reports can be opened in the included Data Dynamics Reports Viewer application or you can view it at design time.

To view the report at design time

  1. Click the Preview tab of the report designer.


Walkthrough: Page Numbering

You can add page numbering to a report using the Globals collection.

This walkthrough illustrates how to add page numbering to a report.

The walkthrough is split up into the following activities:

  • Creating a Data Dynamics Report
  • Connecting the report to a data source
  • Adding a Dataset
  • Adding controls to the report to contain data
  • Adding page numbering to the report
  • Viewing the report

To complete the walkthrough, you must have access to the Reels sample database included with this installation.

Note: If you have already created the report outlined in the Basic Report walkthrough, you can open that report and go directly to the Adding page numbering to the report section of this walkthrough.

Creating a Data Dynamics Report

To create a report in the Report Designer application

  1. From the Windows Start menu go to All Programs, Data Dynamics, Reports and select Data Dynamics Reports Designer.
  2. From the File menu, select Save As.
  3. In the combo box next to Save in, navigate to the directory under which you want to save the report.
  4. Enter MovieRatings.rdlx as the File name and click the Save button.

Connecting the report to a data source

To connect the report to a data source

  1. Click the Data Explorer icon to the bottom left of the report.
  2. Click the Add Data Source icon.
  3. In the Report DataSource smart panel that appears, select the General page.
  4. Change the Name to Reels.
  5. Change the Type to OLEDB.
  6. Use the following Connection String, replacing the text your name and build number with the actual name and build number on your machine:

    Provider=Microsoft.Jet.OLEDB.4.0;Data Source=C:\Documents and Settings\your name\My Documents\Data Dynamics\Reports\build number\Samples\Reels\Data\Reels.mdb;User id=admin;password=;

    Note: In Windows Vista, the path is C:\User\your name\Documents\Data Dynamics\Reports\build number\Samples\Reels\Data\Reels.mdb.
  7. Click the Validate icon to validate the connection string. (The Validate icon becomes inactive to indicate success. An error message indicates an invalid connection string.)
  8. Click the Accept icon at the top to close the smart panel and see Reels appear in the Data Explorer.

Adding a dataset

To add a dataset

  1. Click the Add DataSet icon.
  2. In the DataSet smart panel that appears, select the General page.
  3. Change the Name to MovieRatings.
  4. On the Query page, paste the following SQL command into the Query text box:

    SELECT Movie.Title, Movie.YearReleased, Movie.MPAA FROM Movie ORDER BY Movie.YearReleased;

  5. Click the Validate icon to validate the query and to populate the Fields list.
  6. Click the Accept icon at the top to close the smart panel and see MovieRatings and the selected fields appear in the Data Explorer.

Adding controls to contain data

To add controls to the report

  1. Click the Layout tab at the bottom of the report and click the Toolbox icon below the Data Explorer.
  2. From the toolbox, drag a Table data region onto the body of the report.
  3. With the table selected in the property grid, set the DataSetName property to MovieRatings.
  4. From MovieRatings in the Data Explorer, drag the Title field into the first column of the Detail row.
    Note: This automatically places an expression in the detail row and simultaneously places a static label in the header row of the same column.
  5. Drag the MPAA field into the second column of the Detail row of the table.
  6. Drag the YearReleased field into the third column of the Detail row.
  7. To optionally display the static labels in bold at the top of every page of the report:
    • Select the Header row by clicking the table handle to the left of the row.
    • In the Report Formatting tool bar, click the Bold button.
    • In the Properties grid, set the RepeatOnNewPage property to True.
  8. To improve the appearance of the report:
    • Select the second column and change its Width property to 1in.
    • Select the third column and change its Width property to 1.1in.
    • Select the first column and change its Width property to 4.4in.
      Tip: Making some columns narrower before making other columns wider prevents your report width from changing.
  9. To add a page header to the report:
    • Open the Report menu and select Page Header.
    • From the toolbox, select Textbox and draw it onto the PageHeader section to span the entire width of the report.
    • Set the alignment to center and the font size to 14pt.
    • Enter Movie Ratings for its value.

Adding page numbering to the report

To add page numbering to the report

  1. Open the Report menu and select Page Footer.
  2. From the toolbox, select TextBox and draw it onto the PageFooter section to span the entire width of the report.
  3. Click the Justify Center icon to center the text in the text box.
  4. In the property grid, select Value and open the combo box to choose <expression>.
  5. In the Fields tree view, expand the Globals node, select PageNumber, and click the Insert button.
  6. In the Expression editor text box, set your cursor to the right of PageNumber and type & " of " &.
  7. In the Fields tree view, select TotalPages and click the Append button so that the expression looks like the following.
    =Globals!PageNumber & " of " & Globals!TotalPages
  8. Click the OK button to accept the expression.
  9. From the File menu, select Save.

Viewing the report

Any report designed with Data Dynamics Reports can be opened in the included Data Dynamics Reports Viewer application or you can view it at design time.

To view the report at design time

  1. Click the Preview tab of the report designer.
See Also

Walkthroughs


Walkthrough: Master Detail

You can create a master detail report using the Data Dynamics Reports Table control and grouping.

This walkthrough illustrates how to create a simple tabular report.

The walkthrough is split up into the following activities:

  • Creating a Data Dynamics Report
  • Connecting the report to a data source
  • Adding a dataset to the report
  • Adding controls to the report to contain data
  • Viewing the report

To complete the walkthrough, you must have access to the Reels sample database.

Creating a Data Dynamics Report

To create a report in the Report Designer application

  1. From the Windows Start menu go to All Programs, Data Dynamics, Reports and select Data Dynamics Reports Designer.
  2. From the File menu, select Save As.
  3. In the combo box next to Save in, navigate to the directory under which you want to save the report.
  4. Enter CustomerOrders.rdlx as the File name and click the Save button.

Connecting the report to a data source

To connect the report to a data source

  1. Click the Data Explorer icon to the bottom left of the report.
  2. Click the Add Data Source icon.
  3. In the Report DataSource smart panel that appears, select the General page.
  4. Change the Name to Reels.
  5. Change the Type to OLEDB.
  6. Use the following Connection String, replacing the text your name and build number with the actual name and build number on your machine:

    Provider=Microsoft.Jet.OLEDB.4.0;Data Source=C:\Documents and Settings\your name\My Documents\Data Dynamics\Reports\build number\Samples\Reels\Data\Reels.mdb;User id=admin;password=;

    Note: In Windows Vista, the path is C:\User\your name\Documents\Data Dynamics\Reports\build number\Samples\Reels\Data\Reels.mdb.
  7. Click the Validate icon to validate the connection string. (The Validate icon becomes inactive to indicate success. An error message indicates an invalid connection string.)
  8. Click the Accept icon at the top to close the smart panel and see Reels appear in the Data Explorer.

Adding a dataset

To add a dataset

  1. Click the Add DataSet icon.
  2. In the DataSet smart panel that appears, select the General page.
  3. Change the Name to CustomerOrders.
  4. On the Query page, paste the following SQL command into the Query text box:

    SELECT CustomerID, Title, LastName, Quantity, Price, [Quantity]*[Price] AS Total FROM CustomerOrders WHERE CustomerID < 1010;

  5. Click the Validate icon to validate the query and to populate the Fields list.
  6. Click the Accept icon at the top to close the smart panel and see CustomerOrders and the selected fields appear in the Data Explorer.

Adding controls to contain data

To add a Table control with grouping to the report

  1. On the Layout tab, click the Toolbox icon below the Data Explorer.
  2. From the toolbox, drag a Table data region onto the body of the report.
  3. With the table selected in the property grid, set the DataSetName property to CustomerOrders.
  4. Click inside the table to display the column and row handles along the top and left sides of the table.
  5. To visually group the data within the report, right-click the icon to the left of the detail row and select Insert Group.
  6. In the Table Data Region - Groups smart panel that appears, under Expression select
    =Fields!CustomerID.Value
    This groups all details from each customer.
  7. Change the Name to Customer.
    Note: You cannot change the name of a table group until after you have set the expression.
  8. Click the Accept icon at the top to close the smart panel and see the group header and footer rows added to the table.

To add a fourth column to the table

  1. Select the second column and change its Width property to 0.92in.
  2. Select the third column and change its Width property to 1.04in.
  3. Select the first column and change its Width property to 3.5in.

            Tip: Making some columns narrower before making other columns wider prevents your report width from changing.
  4. Right-click the grey table header above the third column and select Insert Column to the Right. The inserted fourth column has the same width as the third column, 1.04in.

      To add data to the table

      1. From CustomerOrders in the Data Explorer, drag the LastName field into the first column of the group header row of the table and set the font size to 12pt. This automatically places an expression in the group header row and simultaneously places a static label in the table header row.
      2. Delete the static label Last Name from the table header row.
      3. To display static labels at the beginning of each new group, right-click the icon to the left of the group header row and select Insert Row Below.
      4. Drag the Title field into the first column of the detail row and type Title into the text box immediately above it.
      5. Delete the static label Title from the table header row.
      6. Drag the Quantity field into the second column of the detail row of the table. This automatically places an expression in the detail row and simultaneously places a static label in the header row of the same column.
      7. Cut the static label and paste it into the inserted row immediately above the detail row.
      8. Drag the Price field into the third column of the detail row of the table and set its Format property to C for currency.
      9. Cut the static label from the group header and paste it into the inserted row immediately above the detail row.
      10. Drag the Total field into the fourth column of the detail row of the table and set its Format property to C for currency.
      11. Cut the static label from the group header and paste it into the inserted row immediately above the detail row.

      To refine the look of the report

      1. To remove the table header row since it is not being used:
        • Right-click in the row headers to the left of the table.
        • Select Table Header. The table header row is removed.
      2. To display the static labels in bold at the top of every page of the report on which the table renders:
        • Select the Header row containing the labels by clicking in the table handle to the left of the row.
        • In the Report Formatting tool bar, click the Bold button.
        • In the Property grid, set the RepeatOnNewPage property to True.
      3. To add subtotaling to the group, drag the Total field into the group footer row in the fourth column. Notice that the expression automatically uses the Sum function.
        • Set the Format property to C for currency.
        • In the Report Formatting tool bar, click the Bold button.
      4. To add grand totaling to the table, drag the Total field into the table footer row in the fourth column.
        • Set the Format property to C for currency.
        • In the Report Formatting tool bar, click the Bold button.
        • Delete the static label Total from the top row.
      5. To add a page header to the report, open the Report menu and select Page Header.
        • From the toolbox, select TextBox and draw it onto the PageHeader section to span the entire width of the report.
        • Set the alignment to center and the font size to 14pt.
        • Enter Customer Orders for the value.
      6. From the File menu, select Save.

      Viewing the report

      Any report designed with Data Dynamics Reports can be opened in the included Data Dynamics Reports Viewer application or you can view it at design time.

      To view the report at design time

      1. Click the Preview tab of the report designer.
      See Also

      Walkthroughs | Grouping a Table

      Reference: Table


Walkthrough: XML Data

This walkthrough explains the steps involved in connecting to an XML data source and creating a dataset. It also demonstrates the use of the List control.

The walkthrough is split up into the following activities:

  • Creating a Data Dynamics Report
  • Connecting the report to an XML data source
  • Adding a Dataset
  • Adding controls to the report to contain data
  • Viewing the report

To complete the walkthrough, you must have access to the Factbook sample database included with this installation.

Creating a Data Dynamics Report

To create a report in the Report Designer application

  1. From the Windows Start menu go to All Programs, Data Dynamics, Reports and select Data Dynamics Reports Designer.
  2. From the File menu, select Save As.
  3. In the combo box next to Save in, navigate to the directory under which you want to save the report.
  4. Enter ExchangeRates.rdlx as the File name and click the Save button.

Connecting the report to a data source

To connect the report to a data source

  1. Click the Data Explorer icon to the bottom left of the report.
  2. Click the Add Data Source icon.
  3. In the Report DataSource smart panel that appears, select the General page.
  4. Change the Name to Factbook.
  5. Change the Type to XML.
  6. Use the following Connection String, replacing the text your name and build number with the actual name and build number on your machine:

    XmlDoc=C:\Documents and Settings\your name\My Documents\Data Dynamics\Reports\build number\Samples\Factbook\Data\Factbook.xml
    Note: In Windows Vista, the path is C:\User\your name\Documents\Data Dynamics\Reports\build number\Samples\Factbook\Data\Factbook.xml.

  7. Click the Accept icon at the top to close the smart panel and see Factbook appear in the Data Explorer.

Adding a dataset

To add a dataset

  1. Click the Add DataSet icon.
  2. In the DataSet smart panel that appears, select the General page.
  3. Change the Name to ExchangeRates.
  4. On the Query page, enter the following XML path into the Query text box to access data for every country except "World":

    //country [@name != 'World']

  5. On the Fields page, enter the values in the table below to create fields for your report. Values for XML data fields must be valid XPath expressions.
    Field Name | Type | Value
    Name | Database Field | @name
    Currency | Database Field | ./ExchangeRates/Currency
    2004 | Database Field | ./ExchangeRates/VsUSD2004
    2003 | Database Field | ./ExchangeRates/VsUSD2003
    2002 | Database Field | ./ExchangeRates/VsUSD2002
    2001 | Database Field | ./ExchangeRates/VsUSD2001
    2000 | Database Field | ./ExchangeRates/VsUSD2000
  6. Click the Accept icon at the top to close the smart panel and see ExchangeRates and the fields appear in the Data Explorer.

Adding controls to contain data

To add controls to the report

  1. Click the Toolbox icon below the Data Explorer.
  2. From the Toolbox drag a List data region onto the body of the report and set its DataSetName property to ExchangeRates.
  3. Resize the List to fill the entire body of the report.
  4. From ExchangeRates in the Data Explorer, drag the Name field onto the list, center it at the top, and set the font size to 14.
  5. Drag the following fields onto the list with properties set as described in the table below.
    Field Name | Location | Size
    Currency | 1.125in, 0.5in | 2.25in, 0.25in
    2004 | 4.5in, 0.875in | 1in, 0.25in
    2003 | 4.5in, 1.25in | 1in, 0.25in
    2002 | 4.5in, 1.625in | 1in, 0.25in
    2001 | 4.5in, 2in | 1in, 0.25in
    2000 | 4.5in, 2.375in | 1in, 0.25in
    Note: You will notice that the expressions created for these fields are different than usual. Because Visual Basic syntax does not allow an identifier that begins with a number, any numeric field names must be treated as strings in expressions.
  6. Drag a TextBox onto the list with properties set as described in the table below to combine static text with a field value.
    Value | Location | Size
    ="Value of " & Fields!Currency.Value & " versus US$ for year:" | 0.125in, 0.875in | 3in, 0.25in
  7. Drag TextBox controls onto the list with properties set as described in the table below to create static labels.
    Value Location Size Other
    Currency: 0.125in, 0.5in 0.75in, 0.25in Bold
    2004: 3.375in, 0.875in 1in, 0.25in TextAlign=Right
    2003: 3.375in, 1.25in 1in, 0.25in TextAlign=Right
    2002: 3.375in, 1.625in 1in, 0.25in TextAlign=Right
    2001: 3.375in, 2in 1in, 0.25in TextAlign=Right
    2000: 3.375in, 2.375in 1in, 0.25in TextAlign=Right
  8. From the File menu, select Save.

Viewing the report

Any report designed with Data Dynamics Reports can be opened in the included Data Dynamics Reports Viewer application or you can view it at design time.

To view the report at design time

  1. Click the Preview tab of the report designer.
See Also

Walkthroughs

Reference: Connecting to a Data Source


Walkthrough: Sorting

This walkthrough illustrates how to sort data when using a data source that does not allow sorting within the query.

The walkthrough is split up into the following activities:

  • Creating a Data Dynamics Report
  • Connecting the report to an XML data source
  • Adding a Dataset
  • Adding controls to the report to contain data
  • Previewing the unsorted report
  • Sorting the data
  • Viewing the report

To complete the walkthrough, you must have access to the Factbook sample database included with this installation.

When you are finished you will have a report that looks similar to the following.

Creating a Data Dynamics Report

To create a report in the Report Designer application

  1. From the Windows Start menu go to All Programs, Data Dynamics, Reports and select Data Dynamics Reports Designer.
  2. From the File menu, select Save As.
  3. In the combo box next to Save in, navigate to the directory under which you want to save the report.
  4. Enter Elevation.rdlx as the File name and click the Save button.

Connecting the report to a data source

To connect the report to a data source

  1. Click the Data Explorer icon to the bottom left of the report.
  2. Click the Add Data Source icon.
  3. In the Report DataSource smart panel that appears, select the General page.
  4. Change the Name to Factbook.
  5. Change the Type to XML.
  6. Use the following Connection String, replacing the text your name and build number with the actual name and build number on your machine:

    XmlDoc=C:\Documents and Settings\your name\My Documents\Data Dynamics\Reports\build number\Samples\Factbook\Data\Factbook.xml
    Note: In Windows Vista, the path is C:\User\your name\Documents\Data Dynamics\Reports\build number\Samples\Factbook\Data\Factbook.xml.

  7. Click the Accept icon at the top to close the smart panel and see Factbook appear in the Data Explorer.

Adding a dataset

To add a dataset

  1. Click the Add DataSet icon.
  2. In the DataSet smart panel that appears, select the General page.
  3. Change the Name to Elevation.
  4. On the Query page, enter the following XML path into the Query text box to access data for every country except "World":

    //country [@name != 'World']

  5. On the Fields page, enter the values in the table below to create fields for your report. Values for XML data fields must be valid XPath expressions. The three fields marked in bold are the minimum required to make this walkthrough run.
    Tip: XML data always returns strings, so in order to sort by numeric values, you must first convert the data to numeric format. This is accomplished using calculated fields (LowNumber and HighNumber below).
    Field Name | Type | Value
    CountryName | Database Field | @name
    LowPoint | Database Field | ./ElevationExtremesM/LowestPointName
    LowElevation | Database Field | ./ElevationExtremesM/LowestPointElevation
    HighPoint | Database Field | ./ElevationExtremesM/HighestPointName
    HighElevation | Database Field | ./ElevationExtremesM/HighestPointElevation
    LowNumber | Calculated | =Convert.ToDouble(Fields!LowElevation.Value)
    HighNumber | Calculated | =Convert.ToDouble(Fields!HighElevation.Value)
    Difference | Calculated | =Fields!HighNumber.Value - Fields!LowNumber.Value
  6. Click the Accept icon at the top to close the smart panel and see Elevation and the fields appear in the Data Explorer.

Adding controls to contain data

To add controls to the report

  1. Click the Toolbox icon below the Data Explorer.
  2. From the Toolbox drag a Table data region onto the body of the report and in the Property grid, select values for the following properties as indicated:
    • DataSetName Elevation
    • RepeatHeaderOnNewPage True
  3. Click inside the table to reveal the column and row handles above and to the left of the table.
  4. Right-click any of the column handles above the table and select Insert Column to the Left.
  5. Repeat the previous step until there is a total of seven columns in the table. (You can skip this step if you are only using minimal fields to make the report run.)
  6. Drag the following fields into the detail row of the table and set the Width of each column as indicated below.
    The two fields marked in bold are the minimum required to make this walkthrough run.
    Field Name | Column | Width
    CountryName | TableColumn1 | 1.25in
    LowPoint | TableColumn2 | 1.7in
    LowNumber | TableColumn3 | 0.7in
    Leave this column blank. | TableColumn4 | 0.2in
    HighPoint | TableColumn5 | 1.7in
    HighNumber | TableColumn6 | 0.7in
    Difference | TableColumn7 | 0.75in
  7. Now that the width of the table is back down to 7in, select the Body of the report and set its Width property to 7in.
  8. Select Report in the combobox above the Property grid, and set the Margins to 0.75in, 0.75in, 0.75in, 0.75in.
    Tip: If the value of the Body Width plus Left Margin plus Right Margin exceeds the paper width, the report shows correctly in Galley mode, but cuts off the right-most column in Print Preview mode and renders it on a separate page.
  9. Click inside the table to reveal the column and row handles, then click the header row handle to select the entire row. In the Property grid, select values for the following properties as indicated:
    • BackgroundColor Gainsboro
    • FontWeight Bold

Previewing the unsorted report

To preview the report

  1. Click the Preview tab of the report designer.
  2. Notice that the data is sorted by country name, as it is in the XML data source.

Sorting the data

To sort the data

  1. Click the Layout tab to return to the report designer.
  2. In the combo box above the Property grid, select the table.
  3. Right-click the edge of the table and select Properties.
  4. In the Table Data Region smart panel that appears, select the Sorting page.
  5. Under Expression, select
    =Fields!HighNumber.Value
  6. Set the Direction to Descending to display the highest points in the world first. (Alternately, you could sort by LowNumber or Difference.)
  7. Click the Accept icon at the top to close the smart panel and accept the sort.
  8. From the File menu, select Save.

Viewing the report

Any report designed with Data Dynamics Reports can be opened in the included Data Dynamics Reports Viewer application or you can view it at design time.

To view the report at design time

  1. Click the Preview tab of the report designer.
See Also

Walkthroughs | Sorting


Walkthrough: BandedList Data Region

You can create a freeform report with groupings in minutes using the Data Dynamics Reports BandedList control.

This walkthrough illustrates how to create a grouped banded list report.

The walkthrough is split up into the following activities:

  • Creating a Data Dynamics Report
  • Connecting the report to a data source
  • Adding a Dataset
  • Adding a BandedList with nested grouping to the report
  • Adding report items to the BandedList
  • Viewing the report

To complete the walkthrough, you must have access to the Reels sample database included with this installation.

When you are finished you will have a report that looks similar to the following.

Creating a Data Dynamics Report

To create a report in the Report Designer application

  1. From the Windows Start menu go to All Programs, Data Dynamics, Reports and select Data Dynamics Reports Designer.
  2. From the File menu, select Save As.
  3. In the combo box next to Save in, navigate to the directory under which you want to save the report.
  4. Enter MovieDetails.rdlx as the File name and click the Save button.

Connecting the report to a data source

To connect the report to a data source

  1. Click the Data Explorer icon to the bottom left of the report.
  2. Click the Add Data Source icon.
  3. In the Report DataSource smart panel that appears, select the General page.
  4. Change the Name to Reels.
  5. Change the Type to OLEDB.
  6. Use the following Connection String, replacing the text your name and build number with the actual name and build number on your machine:

    Provider=Microsoft.Jet.OLEDB.4.0;Data Source=C:\Documents and Settings\your name\My Documents\Data Dynamics\Reports\build number\Samples\Reels\Data\Reels.mdb;User id=admin;password=;

    Note: In Windows Vista, the path is C:\User\your name\Documents\Data Dynamics\Reports\build number\Samples\Reels\Data\Reels.mdb.
  7. Click the Validate icon to validate the connection string. (Disabling of the icon indicates success.)
  8. Click the Accept icon at the top to close the smart panel and see Reels appear in the Data Explorer.

Adding a dataset

To add a dataset

  1. Click the Add DataSet icon.
  2. In the DataSet smart panel that appears, select the General page.
  3. Change the Name to Movies.
  4. On the Query page, change the Command Type to TableDirect and enter the "Movie" table into the Query text box.
  5. Click the Validate icon to validate the table and to populate the Fields list.
  6. Click the Accept icon at the top to close the smart panel and see Movies and all of the fields in the table appear in the Data Explorer.

Adding a BandedList with Nested Grouping to the Report

To add a BandedList with nested grouping

  1. Click the Toolbox icon below the Data Explorer to access the toolbox.
  2. From the toolbox, drag a BandedList data region onto the body of the report. The banded list automatically spreads from the left edge to the right edge of the report body and contains a header, detail, and footer band.
  3. With the banded list selected in the combo box above the property grid, set the DataSetName property to Movies. This makes it easier to add groupings to the list because it populates the Group on Expression box with fields.
    Note: To select the banded list, click inside any band in the list and click the four-way arrow that appears at the top left of the control.

  4. Right-click inside the banded list and select Footer. This removes the footer band which we will not be using, and eliminates white space.
  5. Right-click inside the banded list and select Insert Group. This adds a group header between the BandedList header and the detail section, and a group footer below the detail section, and opens the Groups smart panel.
  6. In the Groups smart panel:
    • Drop down the list of expressions in the Group on Expression box and select
      =Fields!YearReleased.Value
      to group the movies based on the year in which they were released.
    • Change the Name to Year.
    • Clear the Include group footer checkbox since we won't be using it.
  7. Click the Add icon. This adds a second group header above the first, and a group footer below the detail section.
  8. Still in the Groups smart panel:
    • Select the newly added group in the list of groups.
    • Drop down the list of expressions in the Group on Expression box and select
      =Fields!MPAA.Value
      to group the movies based on the rating (i.e. G, PG, et cetera).
    • Change the Name to MPAA.
    • Clear the Include group footer checkbox since we won't be using it.
    • Click the Accept icon at the top to close the smart panel and accept the changes.

Adding Report Items to the BandedList

To add report items to the BandedList

  1. From the toolbox, drag a TextBox report item onto the topmost band (BandedList1_Header).
    • Set the BackgroundColor property to Gray.
    • Set the Color property to White.
    • Expand the Font property and set its sub-properties to:
      • FontSize 14pt
      • FontWeight Bold
    • Set the Location property to 0in, 0in.
    • Set the Size property to 6.5in, 0.25in.
    • Set the TextAlign property to Center.
    • Set the Value property to Movie Details to create a static label.
  2. Click the BandedList1_Header band adorner (the grey bar along the top of the band) to select it, and in the property grid, change the RepeatOnNewPage property to True. This ensures that the label appears at the top of each page.
  3. Set the Height property of the header band to 0.25in.
  4. Click the Data Explorer icon to the bottom left of the report.
  5. From the Data Explorer, drag the YearReleased field into the second band (Year_Header) of the banded list.
    • Set the BackgroundColor property to DarkGray.
    • Expand the Font property and set its sub-property FontWeight to Bold.
    • Set the Location property to 0in, 0in.
    • Set the Size property to 6.5in, 0.25in.
    • Set the TextAlign property to Left.
    • Change the Value property expression from the Sum aggregate to the First aggregate to display the first year released for each group. (A summary of the YearReleased field would not be very useful.)
  6. Click the Year_Header band adorner (the grey bar along the top of the band) to select it, and in the property grid, set the Height property of the header band to 0.25in.
  7. Drag the MPAA field into the third band (MPAA_Header).
    • Set the BackgroundColor property to Silver.
    • Set the BorderColor property to Gray and the BorderStyle property to Solid.
    • Expand the Font property and set its sub-property FontWeight to Bold.
    • Set the Location property to 0in, 0in.
    • Set the Size property to 6.5in, 0.25in.
    • Note that the Value property is automatically set to an expression using the First aggregate. This displays the movie rating for each group.
  8. Click the MPAA_Header band adorner (the grey bar along the top of the band) to select it, and in the property grid, set the Height property of the header band to 0.25in.
  9. Click inside the detail band to select it and set its Height property to 1.2in.
  10. Drag the following six fields onto the detail band and set their properties as indicated.
    Field | Location | Size | Formatting
    Title | 0in, 0.25in | 3.75in, 0.25in
    Country | 1.25in, 0.5in | 1in, 0.25in
    Language | 1.25in, 0.75in | 1in, 0.25in
    Length | 5.375in, 0in | 1in, 0.25in | TextAlign = Left
    UserRating | 5.375in, 0.5in | 1in, 0.25in | TextAlign = Left
    IsColor | 5.375in, 0.75in | 1in, 0.25in
  11. Once you've arranged the fields, select the IsColor field and change the Value property to the following expression so that instead of "True" or "False," it will read "Color" or "Black and White."
    =Iif(Fields!IsColor.Value=True, "Color", "Black and White")
  12. Click the Toolbox icon below the Data Explorer to go back to the toolbox.
  13. Drag six TextBox report items onto the detail band and set their properties as indicated.
    Value Location Size Formatting
    Movie Title: 0in, 0in 1in, 0.25in FontWeight = Bold
    Country of origin: 0in, 0.5in 1.25in, 0.25in FontWeight = Bold
    Language: 0in, 0.75in 1in, 0.25in FontWeight = Bold
    Length: 4.25in, 0in 1in, 0.25in FontWeight = Bold; TextAlign = Right
    User Rating: 4.25in, 0.5in 1in, 0.25in FontWeight = Bold; TextAlign = Right
    Format: 4.25in, 0.75in 1in, 0.25in FontWeight = Bold; TextAlign = Right
  14. Draw a Line report item onto the detail band below all of the text boxes.
    • Set the LineColor property to Gray.
    • Set the LineWidth property to 3pt.
    • Set the Location property to 0in, 1.12in.
    • Set the EndPoint property to 6.5in, 1.12in.
  15. From the File menu, select Save.

Viewing the report

Any report designed with Data Dynamics Reports can be opened in the included Data Dynamics Reports Viewer application or you can view it at design time.

To view the report at design time

  1. Click the Preview tab of the report designer.
See Also

Walkthroughs

Reference: Banded List


Walkthrough: Matrix Data Region

You can create a drilldown report in minutes using the Data Dynamics Reports Matrix control.

This walkthrough illustrates how to create a matrix report.

The walkthrough is split up into the following activities:

  • Creating a Data Dynamics Report
  • Connecting the report to a data source
  • Adding a Dataset with calculated fields
  • Adding controls to the report to contain data
    • Adding nested grouping and drilldown to the matrix
    • Adding subtotals to the matrix
    • Improving the appearance of the report
  • Viewing the report

To complete the walkthrough, you must have access to the Reels sample database included with this installation.

When you are finished you will have a report that looks similar to the following.

Creating a Data Dynamics Report

To create a report in the Report Designer application

  1. From the Windows Start menu go to All Programs, Data Dynamics, Reports and select Data Dynamics Reports Designer.
  2. From the File menu, select Save As.
  3. In the combo box next to Save in, navigate to the directory under which you want to save the report.
  4. Enter SalesByStore.rdlx as the File name and click the Save button.

Connecting the report to a data source

To connect the report to a data source

  1. Click the Data Explorer icon to the bottom left of the report.
  2. Click the Add Data Source icon.
  3. In the Report DataSource smart panel that appears, select the General page.
  4. Change the Name to Reels.
  5. Change the Type to OLEDB.
  6. Use the following Connection String, replacing the text your name and build number with the actual name and build number on your machine:

    Provider=Microsoft.Jet.OLEDB.4.0;Data Source=C:\Documents and Settings\your name\My Documents\Data Dynamics\Reports\build number\Samples\Reels\Data\Reels.mdb;User id=admin;password=;

    Note: In Windows Vista, the path is C:\User\your name\Documents\Data Dynamics\Reports\build number\Samples\Reels\Data\Reels.mdb.
  7. Click the Validate icon to validate the connection string. (The Validate icon becomes inactive to indicate success. An error message indicates an invalid connection string.)
  8. Click the Accept icon at the top to close the smart panel and see Reels appear in the Data Explorer.

Adding a dataset

To add a dataset

  1. Click the Add DataSet icon.
  2. In the DataSet smart panel that appears, select the General page.
  3. Change the Name to Sales.
  4. On the Query page, paste the following SQL command into the Query textbox:

    SELECT Store, SaleDate, SalesAmount FROM Sale ORDER BY Store, SaleDate;

  5. Click the Validate icon to validate the query.
  6. On the Fields page, enter three new calculated fields with the values in the following table.
    Field Name | Type | Value
    Month | Calculated Field | =Fields!SaleDate.Value.Month
    Quarter | Calculated Field | =Choose(1 + ((Fields!Month.Value - 1)\3), "Q1", "Q2", "Q3", "Q4")
    Year | Calculated Field | =Fields!SaleDate.Value.Year
  7. Click the Accept icon at the top to close the smart panel and see the six fields appear in the Data Explorer.

Adding controls to contain data

The Matrix data region can be used to group data in complex ways. This walkthrough adds just enough complexity to show you what is possible.

To add controls to the report

  1. Click the Layout tab at the bottom of the report and click the Toolbox icon below the Data Explorer.
  2. From the toolbox, drag a Matrix data region onto the body of the report in the top left corner. The matrix initially has four textbox cells.
  3. From Sales in the Data Explorer, drag the Store field into the bottom left cell in the matrix. This is the row header, and dragging a field into it automatically adds a Row Group which groups data by store in rows down the page at run time.
  4. To concatenate a string with the field value and make the Store value more user-friendly at run time, replace the expression in the value property with this expression:
    ="Store Number " & Fields!Store.Value
  5. To make the column wide enough to accommodate the text, click the right edge of the grey column handle at the top of the first column and drag it to the right to the 1.5 inch mark on the ruler.
  6. Drag the Year field into the top right cell in the matrix. This is the column header, and automatically groups data in columns to the right at run time.
  7. With the Year cell selected, in the report formatting toolbar click the Justify Center button to center the year over the information below it.
  8. Drag the SalesAmount field into the bottom right cell in the matrix. This is the detail data cell, and displays aggregated data for the intersection of each column and row at run time.
  9. With the SalesAmount cell selected, in the Property window set the Format property to C for currency.

To add nested grouping and drilldown features to the matrix

  1. From the Data Explorer, drag the Quarter field to the top right Year cell and move the cursor down slightly so that the bar appears at the bottom edge of the cell before dropping it. This adds a cell below the Year cell and automatically adds a Quarter grouping to the Column Groups for the matrix.
  2. With the new Quarter cell selected, in the report formatting toolbar click the Justify Center button to center the quarter over the information below it.
  3. By default, the Year cell is named TextBox3. If you have changed it, make note of the new name.
  4. Right-click the grey column handle above the Year cell and select Properties to open the Matrix Data Region smart panel.
  5. On the Column Groups page, select the Matrix1_Quarter group, and click the Visibility icon below it.
  6. Change the Initial visibility to Hidden and select the check box next to Visibility can be toggled by another report item.
    Tip: Intuition might tell you to set visibility on the text box or column, but in order to provide drilldown functionality, we must set visibility on the group we want to hide.
  7. In the Report item drop down box that becomes enabled below it, enter TextBox3 so that at run time, users can click the plus sign next to the year to view the quarterly detail.
  8. Click the Accept icon at the top to close the smart panel.
  9. From the Data Explorer, drag the Month field to the Quarter cell and move the cursor down slightly so that the bar appears at the bottom edge of the cell before dropping it. This adds a cell below the Year cell and automatically adds a Month grouping to the Column Groups for the matrix.
  10. By default, the Quarter cell is named TextBox5. If you have changed it, make note of the new name.
  11. Right-click the grey column handle above the Year cell and select Properties to open the Matrix Data Region smart panel.
  12. On the Column Groups page, select the Matrix1_Month group, and click the Visibility icon below it.
  13. Change the Initial visibility to Hidden and select the check box next to Visibility can be toggled by another report item.
  14. In the Report item drop down box that becomes enabled below it, enter TextBox5 so that at run time, users can click the plus sign next to the quarter to view the monthly detail.
  15. Click the Accept icon at the top to close the smart panel.

To add subtotals to the matrix

Without subtotals, viewing the report at run time shows data for each year, or if expanded, for each quarter or month. Adding subtotals displays totals for each group in a new column to the right of the group.

  1. Right click the Year cell and select Subtotal. A new column appears to the right with the text Total and a green mark at the top right corner. (Clicking the green mark displays the MatrixSubtotal1 properties in the Property grid.)
  2. Select the new Total cell and in the report formatting toolbar click the Justify Center button to center the total over the information below it.
  3. Click inside the cell and change the text to Grand Total.
  4. Right click the Quarter cell and select Subtotal.
  5. Select the new Total cell and in the report formatting toolbar click the Justify Center button to center the total over the information below it.
  6. Click inside the cell and change the text to an expression that displays the year and Total:
    =Fields!Year.Value & " Total"
  7. Right click the Month cell and select Subtotal.
  8. Select the new Total cell and in the report formatting toolbar click the Justify Center button to center the total over the information below it.
  9. Click inside the cell and change the text to an expression that displays the quarter and Total:
    =Fields!Quarter.Value & " Total"

To improve the appearance of the report

If you preview the report at this point, you will notice that although all of the data shows correctly, it is very difficult to look at when you start drilling down into the data. This can be improved with background colors and borders.

  1. To display the name of each month instead of a number:
    • Select the textbox that contains the month field and change the expression to read:
      =Fields!SaleDate.Value
      Note: Changing the textbox value does not affect the grouping value, so the data is still grouped by month.
    • In the property grid, enter MMMM for the Format property.
  2. Holding down the Shift key, select the two textboxes in the top row containing the Year and Grand Total cells and make the following changes:
    • In the property grid, change the BackgroundColor property to Gainsboro.
    • Set the BorderStyle property to Solid. This draws a border line around the groups that defines their limits when expanded at run time.
  3. Select the two textboxes in the second row containing the expressions =Fields!Quarter.Value and =Fields!Year.Value & " Total" and make the following changes:
    • In the property grid, change the BackgroundColor property to LightSteelBlue.
    • Set the BorderStyle property to Solid.
  4. Holding down the Shift key, select the two textboxes in the third row containing the month and quarterly total cells and make the following changes:
    • In the property grid, change the BackgroundColor property to AliceBlue.
    • Set the BorderStyle property to Solid.
  5. Holding down the Shift key, select the two textboxes in the fourth row containing the store number and detail cells and make the following change:
    • In the property grid, set the BorderStyle property to Solid.
  6. To add a page header to the report:
    • Click below the report to give it focus and from the Report menu, select Page Header.
    • Click the Toolbox icon below the Data Explorer and from the toolbox, select Textbox and draw a textbox onto the page header section to span the entire width of the report.
    • Set the TextAlign property to Center and the FontSize property to 14pt.
    • Click inside the textbox and enter the text Sales by Store.
  7. From the File menu, select Save.

Viewing the report

Any report designed with Data Dynamics Reports can be opened in the included Data Dynamics Reports Viewer application or you can view it at design time.

To view the report at design time

  1. Click the Preview tab of the report designer.
See Also

Walkthroughs | Filtering a Table or Matrix Group | Grouping in a Matrix Using Dynamic Columns and Rows | Sorting a Matrix

Reference: Matrix


Walkthrough: Expressions

You can use expressions in many report item properties to calculate their values. You can use an expression to concatenate fields, to concatenate strings with fields, to aggregate data, to set formatting based on field values, to show or hide other report items based on field values and even to display a graphical representation of the data.

This walkthrough illustrates the usefulness of expressions to achieve many different effects.

The walkthrough is split up into the following activities:

  • Creating a Data Dynamics Report
  • Connecting the report to a data source
  • Adding a Dataset
  • Adding controls to the report to contain data
  • Adding a field expression to a text box to multiply two field values
  • Adding an Immediate If expression to show or hide a report item
  • Adding a Data Visualization expression to display data graphically
  • Viewing the report

To complete the walkthrough, you must have access to the Reels sample database included with this installation.

When you are finished you will have a report that looks similar to the following.

Creating a Data Dynamics Report

To create a report in the Report Designer application

  1. From the Windows Start menu go to All Programs, Data Dynamics, Reports and select Data Dynamics Reports Designer.
  2. From the File menu, select Save As.
  3. In the combo box next to Save in, navigate to the directory under which you want to save the report.
  4. Enter ProductStock.rdlx as the File name and click the Save button.

Connecting the report to a data source

To connect the report to a data source

  1. Click the Data Explorer icon to the bottom left of the report.
  2. Click the Add Data Source icon.
  3. In the Report DataSource smart panel that appears, select the General page.
  4. Change the Name to Reels.
  5. Change the Type to OLEDB.
  6. Use the following Connection String, replacing the text your name and build number with the actual name and build number on your machine:

    Provider=Microsoft.Jet.OLEDB.4.0;Data Source=C:\Documents and Settings\your name\My Documents\Data Dynamics\Reports\build number\Samples\Reels\Data\Reels.mdb;User id=admin;password=;

    Note: In Windows Vista, the path is C:\User\your name\Documents\Data Dynamics\Reports\build number\Samples\Reels\Data\Reels.mdb.
  7. Click the Validate icon to validate the connection string. (The Validate icon becomes inactive to indicate success. An error message indicates an invalid connection string.)
  8. Click the Accept icon at the top to close the smart panel and see Reels appear in the Data Explorer.

Adding a dataset

To add a dataset

  1. Click the Add DataSet icon.
  2. In the DataSet smart panel that appears, select the General page.
  3. Change the Name to DVDStock.
  4. On the Query page, paste the following SQL command into the Query text box:

    SELECT * FROM DVDStock;

  5. Click the Validate icon to validate the query and to populate the Fields list.
  6. Click the Accept icon at the top to close the smart panel and see MovieRatings and the selected fields appear in the Data Explorer.

Adding controls to the report to contain data

To add controls to the report

  1. Click the Layout tab at the bottom of the report and click the Toolbox icon below the Data Explorer.
  2. From the toolbox, drag a Table data region onto the body of the report.
  3. With the table selected in the property grid, set the DataSetName property to DVDStock.
  4. Click inside the table to display the row and column handles along the left and top edges of the table.
  5. Select the second column using the column handle at the top and set the Width property to 1in.
  6. Select the third column using the column handle at the top and set the Width property to 1in.
  7. Right-click in the column handle at the top of the third column and choose Insert Column to the Right to add a fourth column of the same width.
  8. Select the first column using the column handle at the top and set the Width property to 3.5in.
    Tip: Making some columns narrower before adding columns or making others wider prevents the table from pushing the width of the report.
  9. From DVDStock in the Data Explorer, drag the following fields into the detail row and set their properties as shown below.
    Field | Column | Special Formatting
    Title | TableColumn1
    StorePrice | TableColumn2 | C (for currency formatting)
    InStock | TableColumn3
  10. Dragging fields into the detail row automatically places static labels in the header row. Select the header row using the row handle to the left and click the Bold button.

Adding a field expression to a text box to multiply two field values

To add a field expression to a text box to multiply two field values

  1. In the detail row of the fourth column, enter the following expression.
    = Fields!InStock.Value* Fields!StorePrice.Value
  2. In the Property grid, set the Format property of the text box to C for currency formatting.
  3. In the header row immediately above this text box, enter Stock Value for the static label.

Adding an Immediate If expression to show or hide a report item

To add an iif expression to show or hide a report item

  1. Select the cell in which we multiplied two field values (in the detail row of the fourth column) and in the Property grid, expand the Visibility property.
  2. In the Hidden property, enter the following immediate if expression to hide the text box if there is no stock for the item.
    =iif(Fields!InStock.Value=0, True, False)

Adding a Data Visualization expression to display data graphically

The ColorScale3 visualizer function displays a range of colors to indicate minimum, average, and maximum values in the data. For information on other visualizer functions, see the Data Visualization topic.

To add a data visualization expression

  1. Select the cell in the detail row under the In Stock label and enter the following expression in the BackgroundColor property.
    =ColorScale3(Fields!InStock.Value, 0, (Avg(Fields!InStock.Value, Nothing)),
 (Max(Fields!InStock.Value, Nothing)), "Red", "Yellow", "Green")
    Note: The parameters of the ColorScale3 function evaluate to (Value, Minimum, Average, Maximum, StartColor, MiddleColor, EndColor). Note that aggregate functions (Avg and Max) are used within the ColorScale3 function. For more information on these and other aggregate functions, see the Functions topic.
  2. From the File menu, select Save.

Viewing the report

Any report designed with Data Dynamics Reports can be opened in the included Data Dynamics Reports Viewer application or you can view it at design time.

To view the report at design time

  1. Click the Preview tab of the report designer.
See Also

Walkthrough: Custom Code | Walkthroughs

Reference: Data Visualization | Expressions


Walkthrough: Charts

You can create a report with a chart using the Data Dynamics Chart control.

This walkthrough illustrates how to create a report with a chart.

The walkthrough is split up into the following activities:

  • Creating a Data Dynamics Report
  • Connecting the report to a data source
  • Adding a dataset
  • Adding a chart control with data and grouping to the report
  • Configuring the appearance of the chart
  • Setting titles, labels, and scale on the axes
  • Viewing the report

To complete the walkthrough, you must have access to the Reels sample database included with this installation.

When you are finished you will have a report that looks similar to the following.

Creating a Data Dynamics Report

To create a report in the Report Designer application

  1. From the Windows Start menu go to All Programs, Data Dynamics, Reports and select Data Dynamics Reports Designer.
  2. From the File menu, select Save As.
  3. In the combo box next to Save in, navigate to the directory under which you want to save the report.
  4. Enter ProfitsByGenre.rdlx as the File name and click the Save button.

Connecting the report to a data source

To connect the report to a data source

  1. Click the Data Explorer icon to the bottom left of the report.
  2. Click the Add Data Source icon.
  3. In the Report DataSource smart panel that appears, select the General page.
  4. Change the Name to Reels.
  5. Change the Type to OLEDB.
  6. Use the following Connection String, replacing the text your name and build number with the actual name and build number on your machine:

    Provider=Microsoft.Jet.OLEDB.4.0;Data Source=C:\Documents and Settings\your name\My Documents\Data Dynamics\Reports\build number\Samples\Reels\Data\Reels.mdb;User id=admin;password=;

    Note: In Windows Vista, the path is C:\User\your name\Documents\Data Dynamics\Reports\build number\Samples\Reels\Data\Reels.mdb.
  7. Click the Validate icon to validate the connection string. (The Validate icon becomes inactive to indicate success. An error message indicates an invalid connection string.)
  8. Click the Accept icon at the top to close the smart panel and see Reels appear in the Data Explorer.

Adding a dataset

To add a dataset

  1. Click the Add DataSet icon.
  2. In the DataSet smart panel that appears, select the General page.
  3. Change the Name to ProfitsByGenre.
  4. On the Query page, paste the following SQL command into the Query text box:

    SELECT Profit, SalesID, SaleDate, GenreName FROM SalesByGenre WHERE (SalesID < 1090) AND (GenreName = "Comedy" OR GenreName = "Drama" OR GenreName = "Adventure") ORDER BY SalesID;

  5. On the Fields page, add a new field by clicking in the empty cell below the fields listed in the Field Name column and giving it the name Month.
  6. Change the Type of the new field to Calculated Field.
  7. Set the Value of the new field to:
    =Fields!SaleDate.Value.Month
    This parses out the month from the date field.
  8. Click the Validate icon to validate the query and to populate the Fields list.
  9. Click the Accept icon at the top to close the smart panel and see ProfitsByGenre and the selected fields appear in the Data Explorer.

Adding a chart control with data and grouping to the report

To add a chart control to the report

  1. On the Layout tab of the report, click in the Body section of the report to select it.
  2. In the property grid, set the Size property to 6.5in, 4.5in to accommodate the chart.
  3. Drag a Chart control from the Toolbox onto the report. Set the Location property to 0in, 0in and the Size property to 6.5in, 4.5in.
  4. Click inside the chart to display the UI along the top, right, and bottom of the chart.
  5. From the ProfitsByGenre dataset, drag the Month field into the area below the chart labeled "Drop category fields here." This automatically binds the Month field to the X axis.
  6. To show user-friendly month labels on the X axis
    • Right-click the month category group and select Edit to open the Category Groups smart panel.
    • Enter the following expression under Label: =MonthName(Fields!Month.Value).
    • Click the Accept icon at the top to close the smart panel and accept the change.
  7. Drag the Profit field into the area above the chart labeled "Drop data fields here." This plots the profits to the Y axis of the chart.
  8. Drag the GenreName field into the area to the right of the chart labeled "Drop series fields here." This sets the series to be charted in the chart area.
  9. To show genre names in the legend
    • Right-click the genre series group and select Edit to open the Series Groups smart panel.
    • Select the following expression under Label: =Fields!GenreName.Value.
    • Click the Accept icon at the top to close the smart panel and accept the change.
Note: The default chart type used here is the simple column chart. For information on other chart types, see the Chart Types topic.

Configuring the appearance of the chart

You can set chart properties in any number of ways with Data Dynamics Reports to make your charts more visually appealing. Here are some ideas to improve on the basic chart you just created.

To configure the appearance of the chart

  1. Right-click the chart and select Properties from the shortcut menu to open the Chart Report Item smart panel. (Use the back arrow at the top left to return to the main panel after each modification below.)
  2. To add a title to your chart
    • From the Appearance page, select Title and enter Profits by Genre in the Chart title text box.
    • Change the Size property to 14pt.
  3. To change the color of the bars in the chart
    • From the Appearance page, select Chart Palette and drop down the list to select Light. (This is a good color choice because it differentiates between genres without highlighting one of them unintentionally.)

    Setting titles, labels, and scale on the axes

    To set titles, labels, and scale on the axes

    1. To add labels along the X Axis
      • From the Chart Axes page, select X-Axis.
      • Select Labels and select the Show x-axis labels check box.
    2. To remove the default title of the X Axis
      • Click the X-Axis Title icon.
      • Remove the default "Axis X" text under X-Axis title.
    3. To remove the default title of the Y Axis
      • Click the Y-Axis icon.
      • Select the Title page.
      • Remove the default "Axis Y" text under Y-Axis title.
    4. To add labels along the Y Axis
      • Click the Y-Axis Labels icon.
      • Select the Show y-axis labels check box.
      • Set the Format code to currency formatting.
    5. To set the currency labels to start at zero on the Y axis
      • Click the Y-Axis Scale icon.
      • Enter 0 (zero) for the Minimum.
    6. Click the Accept icon at the top to close the smart panel and apply your changes.
    7. From the File menu, select Save.

    Viewing the report

    Any report designed with Data Dynamics Reports can be opened in the included Data Dynamics Reports Viewer application or you can view it at design time.

    To view the report at design time

    1. Click the Preview tab of the report designer.
    See Also

    Walkthroughs

    Reference: Chart


Walkthroughs: Interactive Reports

Data Dynamics Reports offers a variety of ways to make reports interactive. Follow these walkthroughs to learn about some of them.

  • Bookmarks allow users to follow a link to another part of the report.
  • Drilldown Reports allow users to drill down into more detail that is initially hidden.
  • Drill-through Reports allow users to drill through into more detail in separate reports.
  • Parameters allow users to select which data to use in the report.
See Also

Walkthroughs

Reference: Interactive Reports


Walkthrough: Bookmarks

You can assign a bookmark ID to any report item and link a text box or image to it to allow users to easily navigate between items in the finished report. The bookmark link works like a hyperlink, except that clicking a bookmark link jumps to another page or area of the report instead of to a Web page.

This walkthrough explains the steps involved in setting up bookmarks and links.

The walkthrough is split up into the following activities:

  • Creating a Data Dynamics Report
  • Connecting the report to an XML data source
  • Adding a Dataset
  • Adding controls to the report to contain data
  • Assigning a bookmark ID to a report item
  • Adding a bookmark link to a report item
  • Viewing the report

To complete the walkthrough, you must have access to the Factbook sample database included with this installation.

Note: If you have already created the report outlined in the XML Data walkthrough, you can open that report and go directly to the Assigning a Bookmark ID section of this walkthrough.

Creating a Data Dynamics Report

To create a report in the Report Designer application

  1. From the Windows Start menu go to All Programs, Data Dynamics, Reports and select Data Dynamics Reports Designer.
  2. From the File menu, select Save As.
  3. In the combo box next to Save in, navigate to the directory under which you want to save the report.
  4. Enter ExchangeRates.rdlx as the File name and click the Save button.

Connecting the report to an XML data source

To connect the report to an XML data source

  1. Click the Data Explorer icon to the bottom left of the report.
  2. Click the Add Data Source icon.
  3. In the Report DataSource smart panel that appears, select the General page.
  4. Change the Name to Factbook.
  5. Change the Type to XML.
  6. Use the following Connection String, replacing the text your name and build number with the actual name and build number on your machine:

    XmlDoc=C:\Documents and Settings\your name\My Documents\Data Dynamics\Reports\build number\Samples\Factbook\Data\Factbook.xml
    Note: In Windows Vista, the path is C:\User\your name\Documents\Data Dynamics\Reports\build number\Samples\Factbook\Data\Factbook.xml.

  7. Click the Accept icon at the top to close the smart panel and see Factbook appear in the Data Explorer.

Adding a dataset

To add a dataset

  1. Click the Add DataSet icon.
  2. In the DataSet smart panel that appears, select the General page.
  3. Change the Name to ExchangeRates.
  4. On the Query page, enter the following XML path into the Query text box to access data for every country except "World":

    //country [@name != 'World']

  5. On the Fields page, enter the values in the table below to create fields for your report. Values for XML data fields must be valid XPath expressions.
    Field Name | Type | Value
    Name | Database Field | @name
    Currency | Database Field | ./ExchangeRates/Currency
    2004 | Database Field | ./ExchangeRates/VsUSD2004
    2003 | Database Field | ./ExchangeRates/VsUSD2003
    2002 | Database Field | ./ExchangeRates/VsUSD2002
    2001 | Database Field | ./ExchangeRates/VsUSD2001
    2000 | Database Field | ./ExchangeRates/VsUSD2000
  6. Click the Accept icon at the top to close the smart panel and see ExchangeRates and the fields appear in the Data Explorer.

Adding controls to the report to contain data

To add controls to the report

  1. Click the Toolbox icon below the Data Explorer.
  2. From the Toolbox drag a List control onto the body of the report and set its DataSetName property to ExchangeRates.
  3. Set the Location of the list to 0in, 0in and resize it to 6.5in, 2.625in.
  4. From ExchangeRates in the Data Explorer, drag the Name field onto the list at the top.
  5. Set the TextAlign property to Center and the FontSize property to 14pt.
  6. Drag the following fields onto the list with properties set as described in the table below.
    Field Name | Location | Size
    Currency | 1.125in, 0.5in | 2.25in, 0.25in
    y2004 | 4.5in, 0.875in | 1in, 0.25in
    y2003 | 4.5in, 1.25in | 1in, 0.25in
    y2002 | 4.5in, 1.625in | 1in, 0.25in
    y2001 | 4.5in, 2in | 1in, 0.25in
    y2000 | 4.5in, 2.375in | 1in, 0.25in
  7. Drag a TextBox onto the list with properties set as described in the table below to combine static text with a field value.
    Value | Location | Size
    ="Value of " & Fields!Currency.Value & " versus US$ for year:" | 0.125in, 0.875in | 3in, 0.25in
  8. Drag TextBox controls onto the list with properties set as described in the table below to create static labels.
    Value Location Size Other
    Currency: 0.125in, 0.5in 0.75in, 0.25in Bold
    2004: 3.375in, 0.875in 1in, 0.25in TextAlign=Right
    2003: 3.375in, 1.25in 1in, 0.25in TextAlign=Right
    2002: 3.375in, 1.625in 1in, 0.25in TextAlign=Right
    2001: 3.375in, 2in 1in, 0.25in TextAlign=Right
    2000: 3.375in, 2.375in 1in, 0.25in TextAlign=Right

Assigning a bookmark ID to a report item

A bookmark ID marks any report item as something to which a bookmark link can navigate.

To assign a bookmark ID to a report item

  1. Right-click the Name text box at the top of the list and select Properties.
  2. On the Textbox Report Item smart panel, select the Navigation page.
  3. Enter Name as the bookmark ID string.
    Note: Every bookmark ID in a report must be a unique string. If you have duplicates, a link to it will navigate only to the first one it finds.

Adding a bookmark link to a report item

A bookmark link is like a hyperlink that navigates to a report item marked with a bookmark ID instead of to a URL. We will add a text box below the list we already created to display at the bottom of the report. This text box will have a bookmark link to the bookmark ID we created in the last procedure.

To add a bookmark link to a report item

  1. Set the Height of the report Body to 3in.
  2. From the toolbox, drag a text box onto the report below the list and set the properties as in the following table.
    Value | Location | Size | TextAlign
    Back to Top | 0in, 2.75in | 6.5in, 0.25in | Center
  3. Right-click the text box and select Properties.
  4. On the Textbox Report Item smart panel, select the Navigation page.
  5. Select the Jump to Bookmark radio button and enter the bookmark ID created in the procedure above, Name.
  6. Click the Accept icon at the top to close the smart panel and save your changes.
  7. From the File menu, select Save.

Viewing the report

Any report designed with Data Dynamics Reports can be opened in the included Data Dynamics Reports Viewer application or you can view it at design time.

To view the report at design time

  1. Click the Preview tab of the report designer.
See Also

Walkthroughs | Walkthrough: XML Data

Reference: Bookmarks


Walkthrough: Drilldown

This walkthrough expands upon the report created in the Master Detail report walkthrough. If you have not created the Master Detail report (CustomerOrders.rdlx) already, please do so before continuing.

This walkthrough illustrates how to create a drilldown report using the Hidden and ToggleItem properties.

The walkthrough is split up into the following activities:

  • Opening the Master Detail Report
  • Hiding table rows and setting a toggle item
  • Viewing the report

To complete the walkthrough, you must have access to the included Reels sample database.

Opening the Master Detail Report

To open the report in the Report Designer application

  1. From the Windows Start menu go to All Programs, Data Dynamics, Reports and select Data Dynamics Reports Designer.
  2. From the File menu, select Open.
  3. Navigate to the directory under which you saved the Master Detail report.
  4. Select CustomerOrders.rdlx and click the Open button.

Hiding table rows and setting a toggle item

To hide the static labels and the detail row of the table and set a toggle item

  1. Click inside the table to display the column and row handles along the top and left sides of the table.
  2. Select the second group header row containing the static labels (Title, Quantity, and Price) by clicking the row handle to the left of it.
  3. Hold the SHIFT key and select the detail row containing field expressions to add to the selection.
  4. In the property grid, expand the Visibility property.
  5. Change the Hidden property to True.
  6. Change the ToggleItem property to TextBox10, or the textbox containing the expression =First(Fields!LastName.Value).
  7. From the File menu, select Save.

Viewing the report

Any report designed with Data Dynamics Reports can be opened in the included Data Dynamics Reports Viewer application or you can view it at design time.

To view the report at design time

  1. Click the Preview tab of the report designer.
  2. Click the + icon next to a customer to display order details for that customer.
  3. Click the - icon to hide the details.
See Also

Walkthroughs

Reference: Drill-Down Reports


Walkthrough: Drill-Through

This walkthrough expands upon the report created in the Walkthrough: Basic Report. If you have not created the basic report already, please do so before continuing.

This walkthrough illustrates how to create a drill-through link to another report containing details about the linked item.

The walkthrough is split up into the following activities:

  • Creating a detail report and saving it into the basic report folder
  • Connecting the detail report to a data source
  • Adding a Dataset with a parameter
  • Creating a Dataset to populate the parameter values
  • Adding a Report Parameter
  • Adding controls to the report to contain data
  • Adding a drill-through link from the basic report to the detail report and passing a parameter
  • Viewing the report

To complete the walkthrough, you must have access to the Reels sample database included with this installation.

When you are finished you will have a report that looks similar to the following.

Creating a detail report and saving it into the basic report folder

To create a report in the Report Designer application

  1. From the Windows Start menu go to All Programs, Data Dynamics, Reports and select Data Dynamics Reports Designer.
  2. From the File menu, select Save As.
  3. In the combo box next to Save in, navigate to the directory under which you saved the Basic Report (MovieRatings.rdlx) in the previous walkthrough.
  4. Enter MovieDetails.rdlx as the File name and click the Save button.

Connecting the detail report to a data source

To connect the detail report to a data source

  1. Click the Data Explorer icon to the bottom left of the report.
  2. Click the Add Data Source icon.
  3. In the Report DataSource smart panel that appears, select the General page.
  4. Change the Name to Reels.
  5. Change the Type to OLEDB.
  6. Use the following Connection String, replacing the text your name and build number with the actual name and build number on your machine:

    Provider=Microsoft.Jet.OLEDB.4.0;Data Source=C:\Documents and Settings\your name\My Documents\Data Dynamics\Reports\build number\Samples\Reels\Data\Reels.mdb;User id=admin;password=;

    Note: In Windows Vista, the path is C:\User\your name\Documents\Data Dynamics\Reports\build number\Samples\Reels\Data\Reels.mdb.
  7. Click the Validate icon to validate the connection string. (The Validate icon becomes inactive to indicate success. An error message indicates an invalid connection string.)
  8. Click the Accept icon at the top to close the smart panel and see Reels appear in the Data Explorer.

Adding a Dataset with a parameter

To add a Dataset with a parameter

  1. Click the Add DataSet icon.
  2. In the DataSet smart panel that appears, select the General page.
  3. Change the Name to MovieInfo.
  4. On the Parameters page under Parameter Name enter MovieID.
  5. Under Value enter
    =Parameters!MovieID.Value
  6. On the Query page, paste the following SQL command into the Query text box:

    SELECT * FROM MovieCastInformation;

  7. Click the Validate icon to validate the query and to populate the Fields list.
  8. Click the Accept icon at the top to close the smart panel and see MovieInfo and the selected fields appear in the Data Explorer.

Creating a Dataset to populate the parameter values

To create a Dataset to populate the parameter values

  1. Click the Add DataSet icon.
  2. In the DataSet smart panel that appears, select the General page.
  3. Change the Name to MovieTitles.
  4. On the Query page, paste the following SQL command into the Query text box:

    SELECT MovieID, Title FROM Movie
    ORDER BY Title ASC;

  5. Click the Validate icon to validate the query and to populate the Fields list.
  6. Click the Accept icon at the top to close the smart panel and see MovieTitles and the selected fields appear in the Data Explorer.

Adding a Report Parameter

To add a Report Parameter

    1. In Layout view, click in or below the report body to ensure that the report has focus.
    2. From the Report menu, select Report Parameters.
    3. In the Report Parameters smart panel that appears, click the Add button to add a parameter.
    4. Change the Name to MovieID.
    5. Change the Data type to Integer. (This data type must match that of the field.)
    6. Enter the following text to prompt users for a value: Movie.

  1. To provide a list of values for the Report Parameter

    1. Just below the list of parameters, click the Values icon.
    2. Under Available Values, select From query.
    3. Under Dataset, select MovieTitles.
    4. Under Value field, select MovieID.
    5. Under Label field, select Title.
    6. Click the Accept icon at the top to close the smart panel and add the parameter to the collection.

Adding controls to the report to contain data

To add data regions to the report

  1. Click the Toolbox icon below the Data Explorer.
  2. From the toolbox, drag a List data region onto the body of the report.
    • With the new list selected in the property grid, set the DataSetName property to MovieInfo.
    • Set the Location property to 0in, 0in.
    • Set the Name property to MovieList.
    • Set the Size property to 6.5in, 1.25in.
    • Right-click the list and select Properties.
    • On the Detail Grouping page, set the Group on: Expression to =Fields!MovieID.Value.
    • Click the Accept icon at the top to close the smart panel and accept the changes.
  3. From the toolbox, drag another List data region onto the first list.
    • With the new list selected in the property grid, set the DataSetName property to MovieInfo.
    • Set the Size property to 1.5in, 0.25in.
    • Set the Location property to 4.75in, 1in.
    • Set the Name property to GenreList.
    • Right-click the list and select Properties.
    • On the Detail Grouping page, set the Group on: Expression to =Fields!GenreID.Value.
    • Click the Accept icon at the top to close the smart panel and accept the changes.
  4. From the toolbox, drag another List data region onto the first list to the left of GenreList.
    • With the new list selected in the property grid, set the DataSetName property to MovieInfo.
    • Set the Size property to 3.125in, 0.25in.
    • Set the Location property to 0in, 1in.
    • Set the Name property to CrewList.
    • Right-click the list and select Properties.
    • On the Detail Grouping page, set the Group on: Expression to =Fields!CrewTitleID.Value.
    • Click the Accept icon at the top to close the smart panel and accept the changes.
  5. From the toolbox, draw another List data region onto CrewList. (Draw it small so that it doesn't change the size of CrewList.)
    • With the new list selected in the property grid, set the DataSetName property to MovieInfo.
    • Set the Size property to 1.875in, 0.25in.
    • Set the Location property to 1in, 0in.
    • Set the Name property to CastNameList.
    • Right-click the list and select Properties.
    • On the Detail Grouping page, set the Group on: Expression to =Fields!MoviePersonID.Value.
    • Click the Accept icon at the top to close the smart panel and accept the changes.

To add data fields to the report

  1. Click the Data Explorer icon to the bottom left of the report.
  2. From the Data Explorer, drag the Title field onto the main MovieList data region.
    • With the new textbox selected in the property grid, set the Location property to 0in, 0in.
    • Set the Name property to MovieTitle.
    • Set the Size property to 6.5in, 0.375in.
    • Set the TextAlign property to Center and the FontSize property to 14pt.
  3. From the Data Explorer, drag the YearReleased field onto the main MovieList data region just below the Title textbox.
    • With the new textbox selected in the property grid, set the Location property to 1in, 0.375in.
    • Set the Name property to YearReleased.
    • Set the Size property to 0.75in, 0.25in.
    • Set the TextAlign property to Left.
  4. From the Data Explorer, drag the MPAA field onto the main MovieList data region to the right of the YearReleased textbox.
    • With the new textbox selected in the property grid, set the Size property to 0.5in, 0.25in.
    • Set the Location property to 6in, 0.375in.
    • Set the Name property to MPAA.
  5. From the Data Explorer, drag the UserRating field onto the main MovieList data region below the YearReleased textbox.
    • With the new textbox selected in the property grid, set the Location property to 1in, 0.625in.
    • Set the Name property to UserRating.
    • Set the Size property to 0.25in, 0.25in.
    • Set the TextAlign property to Left.
  6. From the Data Explorer, drag the Length field onto the main MovieList data region below the MPAA textbox.
    • With the new textbox selected in the property grid, set the Location property to 4.75in, 0.625in.
    • Set the Name property to Length.
    • Set the Size property to 1.75in, 0.25in.
    • Set the TextAlign property to Left.
    • Add a string to the length data value so that it reads: =Fields!Length.Value & " minutes"
  7. From the Data Explorer, drag the CrewTitle field onto the CrewList data region and drop it in the top left corner of the list.
    • With the new textbox selected in the property grid, set the Location property to 0in, 0in.
    • Set the Name property to CrewTitle.
    • Set the Size property to 0.875in, 0.25in.
    • In the Report Formatting tool bar, click the Bold button.
    • Add a string to the CrewTitle data value so that it reads: =Fields!CrewTitle.Value & "s:"
  8. From the Data Explorer, drag the CastName field onto the nested CastNameList data region and drop it in the top left corner of the list.
    • With the new textbox selected in the property grid, set the Location property to 0.125in, 0in.
    • Set the Name property to CastName.
    • Set the Size property to 1.75in, 0.25in.
  9. From the Data Explorer, drag the GenreName field onto the GenreList data region to the right of the CrewTitle textbox.
    • With the new textbox selected in the property grid, set the Location property to 0.125in, 0in.
    • Set the Name property to GenreName.
    • Set the Size property to 1.25in, 0.25in.

To add labels to the report

  1. Click the Toolbox icon below the Data Explorer.
  2. From the toolbox, drag a TextBox onto the main MovieList data region to the left just below the Title textbox.
    • With the new textbox selected in the property grid, set the Location property to 0in, 0.375in.
    • Set the Name property to ReleaseLabel.
    • Set the Size property to 1in, 0.25in.
    • Set the Value property to Released in:.
    • In the Report Formatting tool bar, click the Bold button.
  3. From the toolbox, drag a TextBox onto the main MovieList data region to the right of the ReleaseLabel textbox.
    • With the new textbox selected in the property grid, set the Location property to 4.125in, 0.375in.
    • Set the Name property to MPAALabel.
    • Set the Size property to 1.875in, 0.25in.
    • Set the Value property to The MPAA rated this film:.
    • In the Report Formatting tool bar, click the Bold button.
  4. From the toolbox, drag a TextBox onto the main MovieList data region below the ReleaseLabel textbox.
    • With the new textbox selected in the property grid, set the Location property to 0in, 0.625in.
    • Set the Name property to UserRatingLabel.
    • Set the Size property to 1in, 0.25in.
    • Set the Value property to User rating:.
    • In the Report Formatting tool bar, click the Bold button.
  5. From the toolbox, drag a TextBox onto the main MovieList data region to the right of the UserRatingLabel textbox.
    • With the new textbox selected in the property grid, set the Location property to 1.125in, 0.625in.
    • Set the Name property to OutOfTenLabel.
    • Set the Size property to 0.625in, 0.25in.
    • Set the Value property to out of 10.
  6. From the toolbox, drag a TextBox onto the main MovieList data region below the MPAALabel textbox.
    • With the new textbox selected in the property grid, set the Location property to 4.125in, 0.625in.
    • Set the Name property to LengthLabel.
    • Set the Size property to 0.625in, 0.25in.
    • Set the Value property to Length:.
    • In the Report Formatting tool bar, click the Bold button.
  7. From the toolbox, drag a TextBox onto the main MovieList data region below the LengthLabel textbox.
    • With the new textbox selected in the property grid, set the Location property to 4.125in, 1in.
    • Set the Name property to GenreLabel.
    • Set the Size property to 0.625in, 0.25in.
    • Set the Value property to Genre:.
    • In the Report Formatting tool bar, click the Bold button.
  8. From the toolbox, drag a TextBox onto the main CastNameList data region to the right of the CrewTitle textbox.
    • With the new textbox selected in the property grid, set the Location property to 0in, 0in.
    • Set the Name property to CrewBullet.
    • Set the Size property to 0.125in, 0.25in.
    • Set the Value property to • (a bullet).
  9. From the toolbox, drag a TextBox onto the main GenreList data region to the right of the GenreLabel textbox.
    • With the new textbox selected in the property grid, set the Location property to 0in, 0in.
    • Set the Name property to GenreBullet.
    • Set the Size property to 0.125in, 0.25in.
    • Set the Value property to • (a bullet).
  10. From the File menu, select Save.

Adding a drill-through link to the basic report and passing a parameter

Pass a parameter to the target report to show only relevant data.

To add a drill-through link

  1. Open MovieRatings.rdlx in the designer.
  2. Right-click the title field in the detail section of the table (=Fields!Title.Value) and select Properties.
  3. On the Textbox Report Item smart panel that appears, select the Navigation page.
  4. Under Action, select Jump to report and select MovieDetails from the drop-down box.

To pass a parameter to the report

  1. Under Jump to report set the Name of the parameter to MovieID.
  2. Set the Value to =Fields!MovieID.Value.
    Caution: The parameter name must exactly match the parameter in the target report.
  3. Click the Accept icon at the top to close the smart panel and accept the changes.
  4. From the File menu, select Save.

Viewing the report

Any report designed with Data Dynamics Reports can be opened in the included Data Dynamics Reports Viewer application or you can view it at design time.

To view the report at design time

  1. Click the Preview tab of the report designer.
  2. Click any movie title to drill through to details about the movie.
  3. Click the Back to parent report icon to return to the Movie Ratings report.
See Also

Walkthroughs | Adding Drill-through Links

Reference: Drill Through


Walkthrough: Parameters

You can create a parameterized report with Data Dynamics Reports and provide an "All" choice for users who want to see all of the data as well as the ability to select multiple values for those who want to see data for several items.

This walkthrough illustrates how to create a report with multivalue parameters and an option to select all of the data.

The walkthrough is split up into the following activities:

  • Creating a Data Dynamics Report
  • Connecting the report to a data source
  • Adding a Dataset with a parameter
  • Creating a Dataset to populate the parameter values
  • Adding a Report Parameter
  • Adding controls to the report to contain data
  • Viewing the report

To complete the walkthrough, you must have access to the Reels sample database included with this installation.

When you are finished you will have a report that looks similar to the following.

Creating a Data Dynamics Report

To create a report in the Report Designer application

  1. From the Windows Start menu go to All Programs, Data Dynamics, Reports and select Data Dynamics Reports Designer.
  2. From the File menu, select Save As.
  3. In the combo box next to Save in, navigate to the directory under which you want to save the report.
  4. Enter MoviesByProducer.rdlx as the File name and click the Save button.

Connecting the report to a data source

To connect the report to a data source

  1. Click the Data Explorer icon to the bottom left of the report.
  2. Click the Add Data Source icon.
  3. In the Report DataSource smart panel that appears, select the General page.
  4. Change the Name to Reels.
  5. Change the Type to OLEDB.
  6. Use the following Connection String, replacing the text your name and build number with the actual name and build number on your machine:

    Provider=Microsoft.Jet.OLEDB.4.0;Data Source=C:\Documents and Settings\your name\My Documents\Data Dynamics\Reports\build number\Samples\Reels\Data\Reels.mdb;User id=admin;password=;

    Note: In Windows Vista, the path is C:\User\your name\Documents\Data Dynamics\Reports\build number\Samples\Reels\Data\Reels.mdb.
  7. Click the Validate icon to validate the connection string. (The Validate icon becomes inactive to indicate success. An error message indicates an invalid connection string.)
  8. Click the Accept icon at the top to close the smart panel and see Reels appear in the Data Explorer.

Creating a dataset to populate the parameter values

To create a dataset to populate the parameter values

  1. Click the Add DataSet icon.
  2. In the DataSet smart panel that appears, select the General page.
  3. Change the Name to Producers.
  4. On the Query page, paste the following SQL command into the Query text box:

    SELECT -1 AS ProductionID, "(All)" AS Name
    FROM Producers
    UNION
    SELECT ProductionID, Name
    FROM Producers;

  5. Click the Validate icon to validate the query and to populate the Fields list.
  6. Click the Accept icon at the top to close the smart panel and see Producers and the selected fields appear in the Data Explorer.

Adding a Report Parameter

The Report Parameters collection holds parameters for the report and allows you to control how data is collected for the parameters.

To add a Report Parameter

  1. In Layout view, click in or below the report body to ensure that the report has focus.
  2. From the Report menu, select Report Parameters.
  3. In the Report Parameters smart panel that appears, click the Add button to add a parameter.
  4. Change the Name to ProductionID.
  5. Change the Data type to Integer. (This data type must match that of the field.)
  6. Enter the following text to prompt users for a value: Select a production company.
  7. Select the check box next to Multivalue to allow users to select more than one production company from the list.

To provide a list of values for the Report Parameter

  1. Just below the list of parameters, click the Values icon.
  2. Under Available Values, select From query.
  3. Under Dataset, select Producers.
  4. Under Value field, select ProductionID.
  5. Under Label field, select Name.
  6. Click the Accept icon at the top to close the smart panel and add the parameter to the collection.

Adding a dataset with a parameter

To add a dataset with a parameter

  1. Click the Add DataSet icon.
  2. In the DataSet smart panel that appears, select the General page.
  3. Change the Name to Movies.
  4. On the Parameters page, add the following parameters to the dataset to provide values for the parameters we add to the query in the next step.
    • Parameter Name: Param1; Value: =Parameters!ProductionID.Value
    • Parameter Name: Param2; Value: =Parameters!ProductionID.Value
  5. On the Query page, paste the following SQL command into the Query text box:

    SELECT Movie.Title, Movie.YearReleased, Movie.UserRating, Producers.Name
    FROM Producers INNER JOIN (Movie INNER JOIN MovieProducers ON Movie.MovieID = MovieProducers.MovieID) ON Producers.ProductionID = MovieProducers.ProductionID
    WHERE (MovieProducers.ProductionID IN (?)) OR (-1 IN (?))
    ORDER BY MovieProducers.ProductionID, Movie.YearReleased;

  6. Click the Validate icon to validate the query and to populate the Fields list.
  7. Click the Accept icon at the top to close the smart panel and see Movies and the selected fields appear in the Data Explorer.

Adding controls to contain data

To add controls to the report

  1. Click the Toolbox icon below the Data Explorer.
  2. Drag a Table data region from the toolbox onto the body of the report, and set its DataSetName property to Movies.
  3. Click inside the table to display the column and row handles along the top and left sides of the table.
  4. To visually group the data within the report, right-click the icon to the left of the detail row and select Insert Group.
  5. In the Table Data Region - Groups smart panel that appears, under Expression select
    =Fields!Name.Value
    This groups all details from each producer.
  6. Change the Name to Producer.
    Note: You cannot change the name of a table group until after you have set the expression.
  7. Select the check box next to Repeat group header to ensure that the header is printed at the top of each page.
  8. Clear the check box next to Include group footer as we will not be using it for this report.
  9. Click the Accept icon at the top to close the smart panel and add the group to the table.
  10. Click the Data Explorer icon to the bottom left of the report.
  11. From the Movies DataSet in the Data Explorer, drag the following fields into the detail row of the table and set their properties as in the following table.
    Field | Column | Width
    Title | TableColumn1 | 3.9in
    YearReleased | TableColumn2 | 1.3in
    UserRating | TableColumn3 | 1.3in
  12. Static labels with the field names are automatically created in the table header row. To improve the appearance of the report, select the table header row, and set the text to Bold and change the FontSize to 11pt.
  13. From the Movies DataSet in the Data Explorer, drag the Name field into the first column of the group header row of the table and set its FontWeight property to Bold, and its BackgroundColor property to Thistle.
    Tip: Use the Shift key to select all three text boxes in the group header row, right-click and select Merge Cells to prevent long production company names from wrapping.
  14. To optionally add a page header to the report:
    • Open the Report menu and select Page Header.
    • Drag one text box from the toolbox onto the page header, and set its properties as in the following table.
      Value | Location | Size | Formatting
      Movies by Producer | 0in, 0in | 6.5in, 0.25in | FontSize: 14pt, TextAlign: Center
  15. From the File menu, select Save.

Viewing the report

Any report designed with Data Dynamics Reports can be opened in the included Data Dynamics Reports Viewer application or you can view it at design time.

To view the report at design time

  1. Click the Preview tab of the report designer.
  2. Select the production companies you want to see and click the View Report button.
  3. To change your selections, click the Show or Hide Sidebar Pane button.
See Also

Samples | Walkthroughs

Reference: Parameters


Walkthrough: Recursive Hierarchy

You can create a report using a recursive hierarchy and the Level function to show parent-child relationships in data.

This walkthrough illustrates how to create a recursive hierarchy report.

The walkthrough is split up into the following activities:

  • Creating a Data Dynamics Report
  • Connecting the report to a data source
  • Creating a dataset to populate the parameter values
  • Adding a Report Parameter
  • Adding a dataset for the report
  • Adding controls to the report to contain data
  • Setting up a recursive hierarchy
  • Using the Level function to display the hierarchy
  • Viewing the report

To complete the walkthrough, you must have access to the Reels sample database included with this installation.

When you are finished you will have a report that looks similar to the following.

Creating a Data Dynamics Report

To create a report in the Report Designer application

  1. From the Windows Start menu go to All Programs, Data Dynamics, Reports and select Data Dynamics Reports Designer.
  2. From the File menu, select Save As.
  3. In the combo box next to Save in, navigate to the directory under which you want to save the report.
  4. Enter StoreEmployees.rdlx as the File name and click the Save button.

Connecting the report to a data source

To connect the report to a data source

  1. Click the Data Explorer icon to the bottom left of the report.
  2. Click the Add Data Source icon.
  3. In the Report DataSource smart panel that appears, select the General page.
  4. Change the Name to Reels.
  5. Change the Type to OLEDB.
  6. Use the following Connection String, replacing the text your name and build number with the actual name and build number on your machine:

    Provider=Microsoft.Jet.OLEDB.4.0;Data Source=C:\Documents and Settings\your name\My Documents\Data Dynamics\Reports\build number\Samples\Reels\Data\Reels.mdb;User id=admin;password=;

    Note: In Windows Vista, the path is C:\User\your name\Documents\Data Dynamics\Reports\build number\Samples\Reels\Data\Reels.mdb.
  7. Click the Validate icon to validate the connection string. (The Validate icon becomes inactive to indicate success. An error message indicates an invalid connection string.)
  8. Click the Accept icon at the top to close the smart panel and see Reels appear in the Data Explorer.

Creating a dataset to populate the parameter values

To create a dataset to populate the parameter values

  1. Click the Add DataSet icon.
  2. In the DataSet smart panel that appears, select the General page.
  3. Change the Name to Stores.
  4. On the Query page, enter the following SQL command into the Query text box:

    SELECT StoreID FROM Store;

  5. Click the Validate icon to validate the query and to populate the Fields list.
  6. Click the Accept icon at the top to close the smart panel and see Stores and the selected fields appear in the Data Explorer.

Adding a Report Parameter

The Report Parameters collection holds parameters for the report and allows you to control how data is collected for the parameters.

To add a Report Parameter

  1. In Layout view, click in or below the report body to ensure that the report has focus.
  2. From the Report menu, select Report Parameters.
  3. In the Report Parameters smart panel that appears, click the Add button to add a parameter.
  4. Change the Name to StoreID.
  5. Change the Data type to Integer. (This data type must match that of the field.)
  6. Enter the following text to prompt users for a value: Select a store number.

To provide a list of values for the Report Parameter

  1. Just below the list of parameters, click the Values icon.
  2. Under Available Values, select From query.
  3. Under Dataset, select Stores.
  4. Under Value field, select StoreID.
  5. Under Label field, select StoreID.
  6. Click the Accept icon at the top to close the smart panel and add the parameter to the collection.

Adding a dataset for the report

To add a dataset

  1. Click the Add DataSet icon.
  2. In the DataSet smart panel that appears, select the General page.
  3. Change the Name to Employees.
  4. On the Parameters page, add a parameter with the following properties.
    • Parameter Name: @StoreID
    • Value: =Parameters!StoreID.Value
  5. On the Query page, change the Command Type to StoredProcedure.
  6. Enter the following stored procedure into the Query text box (the question mark denotes the parameter):

    EmployeesForStore ?

  7. Click the Validate icon to validate the query and to populate the Fields list.
  8. Click the Accept icon at the top to close the smart panel and see Employees and the selected fields appear in the Data Explorer.

Adding controls to contain data

To add controls to the report

  1. Click the Toolbox icon below the Data Explorer.
  2. From the toolbox, drag a Table data region onto the body of the report.
  3. With the table selected in the property grid, set the DataSetName property to Employees.
  4. Set the Location property to 0in, 0in.
  5. Click inside the table to display the row and column handles along the left and top edges of the table.
  6. To add a column to the table without widening the report:
    • Select the second column by clicking the grey column header above the column and change its Width property to 1.5in.
    • Select the third column and change its Width property to 1.05in.
    • Select the first column and change its Width property to 2.2in.
    • Right-click the grey column header above the third column and select Insert Column to the Right.
    • Select the fourth column and change its Width property to 1.75in.
    Tip: Making some columns narrower before adding columns or making other columns wider prevents your report width from changing.
  7. Click the Data Explorer icon to the bottom left of the report.
  8. From Employees in the Data Explorer, drag the Title field into the first column of the Detail row.
    Note: This automatically places an expression in the detail row and simultaneously places a static label in the header row of the same column.
  9. Drag the LastName field into the second column of the Detail row of the table.
    • To display the Employee ID number along with each employee's last name, change the expression to read =Fields!LastName.Value & " " & Fields!EmployeeID.Value.
    • Change the static label to read Last Name and ID.
  10. Drag the Supervisor field into the third column of the Detail row.
    • Set the TextAlign property to Center.
    • Change the static label to read Supervisor ID.
  11. Drag the Department field into the fourth column of the Detail row.
  12. To change the appearance of the header row:
    • Select the Header row by clicking the table handle to the left of the row.
    • In the Report Formatting tool bar, click the Bold button and the Justify Center button.
    • In the Properties grid, set the BackgroundColor property to Black.
    • Set the Color property to White.
  13. To add another header row to the table:
    • Right-click the table handle to the left of the header row and select Insert Row Above.
    • While holding down the SHIFT key, click each of the cells in the newly added top row.
    • Right-click inside the selected cells and select Merge Cells to create a cell that spans the table.
    • Set the TextAlign property to Center and the FontSize property to 14pt.
    • Click inside the textbox and enter the expression ="Store Number " & Parameters!StoreID.Value.
  14. To remove the footer row from the table, right-click the table handle to the left of the row and select Table Footer.
  15. To draw borders around the cells, select the Detail row and in the property grid, change the BorderStyle property to Solid.
  16. From the File menu, select Save.

Setting up a recursive hierarchy

To set up a recursive hierarchy

  1. Right-click the table handle to the left of the Detail row and select Edit Group to open the Detail Grouping smart panel.
  2. Under Group on: Expression, select =Fields!EmployeeID.Value.
  3. Under Parent group:, select =Fields!Supervisor.Value.
  4. Click the Accept icon at the top to close the smart panel and accept the changes.

Using the Level function to display the hierarchy

You can use the Level function to change the appearance of the report in a number of ways.

To use the Level function in the Padding property of a textbox

  1. Select the cell in the first column of the Detail row that reads =Fields!Title.Value and in the property grid, expand the Padding property.
  2. In the Padding > Left property, enter the expression =2 + (Level() * 15) & "pt".
    Note: Adding 2 to the result ensures that a normal amount of padding is always used.
  3. Click the Accept icon at the top to close the smart panel and accept the changes.

To use the Level function with themes in the BackgroundColor property of a textbox

  1. To copy a theme from the samples, use Windows Explorer to navigate to C:\Documents and Settings\your name\My Documents\Data Dynamics\Reports\build number\Samples\Reels.
    Note: In Windows Vista, the path is C:\User\your name\Documents\Data Dynamics\Reports\build number\Samples\Reels.
  2. Copy the file Reels.rdlx-theme and paste it into the folder in which you saved your report.
  3. To use the theme for the report, click below the body of the report so that Report is selected in the property grid.
  4. In the Theme property, enter the theme file name: Reels.rdlx-theme.
  5. Click the table handle to the left of the Detail row to select the entire row.
  6. In the property grid, for the BackgroundColor property, enter the Expression =Theme.Colors(Level() + 1, 4).
  7. From the File menu, select Save.

Viewing the report

Any report designed with Data Dynamics Reports can be opened in the included Data Dynamics Reports Viewer application or you can view it at design time.

To view the report at design time

  1. Click the Preview tab of the report designer.
  2. Select a store number and click the View Report button.


Walkthrough: Master Reports

You can create a master report using Data Dynamics Reports that can be reused with many content reports. Information in the master report can be modified and the changes will automatically appear in any reports that reference it.

This walkthrough illustrates how to create a simple letterhead master report and a customer letter content report.

The walkthrough is split up into the following activities:

  • Creating a Master Report
  • Connecting the report to a data source
  • Adding a Dataset
  • Adding controls to the report to contain data
  • Creating a Content Report
  • Adding controls to the content placeholder
  • Viewing the report

To complete the walkthrough, you must have access to the Reels sample database included with this installation.

When you are finished you will have a report that looks similar to the following.

Creating a Master Report

To create a master report in the Report Designer application

  1. From the Windows Start menu go to All Programs, Data Dynamics, Reports and select Data Dynamics Reports Designer.
  2. From the File menu, select New.
  3. Under Templates, select Master Report and name it Letterhead.rdlx-master.
  4. Click the OK button.
  5. From the File menu, select Save As.
  6. In the combo box next to Save in, navigate to the directory under which you want to save the report and click the Save button.

Connecting the report to a data source

To connect the report to a data source

  1. Click the Data Explorer icon to the bottom left of the report.
  2. Click the Add Data Source icon.
  3. In the Report DataSource smart panel that appears, select the General page.
  4. Change the Name to Reels.
  5. Change the Type to OLEDB.
  6. Use the following Connection String, replacing the text your name and build number with the actual name and build number on your machine:

    Provider=Microsoft.Jet.OLEDB.4.0;Data Source=C:\Documents and Settings\your name\My Documents\Data Dynamics\Reports\build number\Samples\Reels\Data\Reels.mdb;User id=admin;password=;

    Note: In Windows Vista, the path is C:\User\your name\Documents\Data Dynamics\Reports\build number\Samples\Reels\Data\Reels.mdb.
  7. Click the Validate icon to validate the connection string. (The Validate icon becomes inactive to indicate success. An error message indicates an invalid connection string.)
  8. Click the Accept icon at the top to close the smart panel and see Reels appear in the Data Explorer.

Adding a dataset

To add a dataset

  1. Click the Add DataSet icon.
  2. In the DataSet smart panel that appears, select the General page.
  3. Change the Name to Addresses.
  4. On the Query page, paste the following SQL command into the Query text box:

    SELECT FirstName & " " & LastName AS Name, Address1, Address2, City & ", " & Region & " " & PostalCode AS CityStateZip FROM CustomerMailingList WHERE Country = "USA" AND Region = "WA";

  5. Click the Validate icon to validate the query and to populate the Fields list.
  6. Click the Accept icon at the top to close the smart panel and see Addresses and the selected fields appear in the Data Explorer.

Adding controls to contain data

To add controls to the master report

  1. To add a page header to the report:
    • In Layout view, click in or below the report body to ensure that the report has focus.
    • Open the Report menu and select Page Header.
    • Select the page header and change the BackgroundColor property to Khaki.
    • Expand the Size property and change the Height to 1in.
  2. Click the Toolbox icon below the Data Explorer.
  3. Drag four text boxes from the toolbox onto the page header, and set their properties as in the following table.
    Value | Location | Size | Formatting
    Mass Mailers, Inc. | 0in, 0in | 6.5in, 0.25in | FontSize: 16pt, Bold, TextAlign: Center
    4579 Coastal Cows Drive | 0in, 0.25in | 6.5in, 0.2in | TextAlign: Center
    Jenner, California 95450 | 0in, 0.45in | 6.5in, 0.2in | TextAlign: Center
    (707) 555-8686 | 0in, 0.65in | 6.5in, 0.2in | TextAlign: Center
  4. To add a page footer to the report:
    • Open the Report menu and select Page Footer.
    • Click in the new page footer to select it and change the BackgroundColor property to LightGoldenrodYellow.
  5. Drag two text boxes from the toolbox onto the page footer, and set their properties as in the following table.
    Value | Location | Size | Formatting
    Mass Mailers, Inc. | 0in, 0in | 6.5in, 0.25in | Bold, TextAlign: Center
    "Improving life through the constant exercise of mailbox hinges." | 0in, 0.25in | 6.5in, 0.25in | TextAlign: Center

To add a region which Content Report users can use

  1. Click the Toolbox icon below the Data Explorer.
  2. Drag a ContentPlaceHolder report item (available only in Master Reports) from the toolbox onto the body of the report and set its properties as in the following table. The Text property allows you to provide instruction for those creating Content Reports based on your Master Report.
    Location | Size | Text
    0in, 0in | 6.5in, 3.25in | Drag report items from the toolbox into this area to create your form letter.

To set report properties

  1. From the Report menu, select Report Properties.
  2. In the Report smart panel that appears, go to the Appearance page.
  3. Set the values of the Left, Right, Top, and Bottom margins to 1in.
  4. Click the Accept icon at the top to close the smart panel.
  5. From the File menu, select Save.

Creating a Content Report

To create a content report in the Report Designer application

  1. From the File menu, select New.
  2. Under Templates, select Report and name it LetterContent.rdlx.
  3. Select the check box to the left of Select Master Report.
  4. Drop down the box to right of Select Master Report and choose Letterhead.rdlx-master.
  5. Click the OK button.
  6. From the File menu, select Save.
  7. Ensure that you are saving to the same directory under which you saved the master report and click the Save button.

Adding controls to contain data

Notice that all of the report items added to the master report are disabled in the content report. The only area of the content report to which you can add controls is the ContentPlaceHolder. When you click the Data Explorer icon, you can access data used in the master report, and you can add your own data source and data sets.

To add controls to the content report

  1. From the toolbox, drag a List data region onto the body of the report and in the property grid, set its properties as in the following table. (The list data region will repeat for every row of data in any data fields it contains.)
    DataSetName | Location | Size
    Addresses | 0in, 0in | 6.5in, 3in
  2. Right-click the List data region and select Properties to open the List Data Region smart panel.
  3. Select the Detail Grouping page, and set the Group on Expression to:
    =Fields!Name.Value
    Tip: The reason for setting this grouping is so that we can set Page break at end in the next step. If we set the PageBreakAtEnd property on the List itself, it would not break until after all of the data was processed.
  4. Select the Page break at end check box to start each letter on a new page.
  5. Click the Accept icon at the top to close the smart panel.
  6. Drag a TextBox report item onto the list at the Location 5in, 0in, and set the Size to 1.5in, 0.25in.
  7. In the property grid, drop down the box next to the Value property and select <Expression...>.
  8. In the Expression Editor under Fields, expand the Globals node and double-click ExecutionTime. This automatically renders the current time and date when the report is executed. Click the OK button to accept the change.
  9. In the property grid, set the Format property for the text box to d for short date formatting.
  10. Click the Data Explorer icon to the bottom left of the report.
  11. From Addresses in the Data Explorer, drag the following fields onto the list and set their properties as in the following table.
    Field | Location | Size | Other
    Name | 0in, 0in | 3.5in, 0.2in
    Address1 | 0in, 0.2in | 3.5in, 0.2in
    Address2 | 0in, 0.4in | 3.5in, 0.2in | CanShrink: True
    CityStateZip | 0in, 0.6in | 3.5in, 0.2in
  12. Click the Toolbox icon below the Data Explorer.
  13. Drag five text boxes from the toolbox onto the list below the fields, and set their properties as in the following table. (Placing static text boxes on the list ensures that the text is repeated after each row of data in the fields.)
    Value | Location | Size | Formatting
    Dear Madam or Sir, | 0in, 1in | 1.3in, 0.25in
    Thank you for taking the time to fill out our Movie User Ratings survey. As a token of our appreciation, we are enclosing a gift certificate in the amount of $10 which can be used at any Reels Movie location. You can find a Reels Movie location near you on their Web site at www.reels.com. | 0in, 1.375in | 6.5in, 0.625in
    Best Regards, | 5in, 2.125in | 1.5in, 0.25in | TextAlign: Right
    Neal Marmoset | 5in, 2.75in | 1.5in, 0.25in | TextAlign: Right
    Survey Administration | 5in, 3in | 1.5in, 0.25in | TextAlign: Right
  14. From the File menu, select Save.

Viewing the report

Any report designed with Data Dynamics Reports can be opened in the included Data Dynamics Reports Viewer application or you can view it at design time.

To view the report at design time

  1. Click the Preview tab of the report designer.
  2. To see page settings such as margins, click the Print Preview icon.
See Also

Walkthroughs

Reference: Master Reports


Walkthrough: Subreports

You can create a report that hosts a subreport using Data Dynamics Reports.

Tip: Data Regions are more efficient and have less overhead than subreports unless you need to reuse the subreport in other reports.

This walkthrough illustrates how to create a report using a subreport.

The walkthrough is split up into the following activities:

  • Creating a report for the subreport
  • Connecting the subreport to a data source
  • Adding a dataset with a parameter to the subreport
  • Adding a report parameter to the subreport
  • Adding report items to display data on the subreport
  • Creating the main report
  • Connecting the main report to a data source
  • Adding a dataset to the main report
  • Adding report items to display data on the main report
  • Viewing the report

To complete the walkthrough, you must have access to the Reels.mdb sample database included with this installation.

When you are finished you will have a report that looks similar to the following.

Creating a report for the subreport

To create a report in the Report Designer application

  1. From the Windows Start menu go to All Programs, Data Dynamics, Reports and select Data Dynamics Reports Designer.
  2. From the File menu, select Save As.
  3. In the combo box next to Save in, navigate to the directory under which you want to save the report.
  4. Enter Sales.rdlx as the File name and click the Save button.

Connecting the subreport to a data source

To connect the Sales report to a data source

  1. Click the Data Explorer icon to the bottom left of the report.
  2. Click the Add Data Source icon.
  3. In the Report DataSource smart panel that appears, select the General page.
  4. Change the Name to Reels.
  5. Change the Type to OLEDB.
  6. Use the following Connection String, replacing the text your name and build number with the actual name and build number on your machine:

    Provider=Microsoft.Jet.OLEDB.4.0;Data Source=C:\Documents and Settings\your name\My Documents\Data Dynamics\Reports\build number\Samples\Reels\Data\Reels.mdb;User id=admin;password=;

    Note: In Windows Vista, the path is C:\User\your name\Documents\Data Dynamics\Reports\build number\Samples\Reels\Data\Reels.mdb.
  7. Click the Validate icon to validate the connection string. (The Validate icon becomes inactive to indicate success. An error message indicates an invalid connection string.)
  8. Click the Accept icon at the top to close the smart panel and see Reels appear in the Data Explorer.

Adding a dataset with a parameter to the subreport

When you add a query parameter using the syntax required by your database (in this case, Access requires [?]) you must add a parameter to the Parameters page to ensure that the parameter value is passed to the query from the Report Parameters collection.

To add a dataset with a parameter to the subreport

  1. Click the Add DataSet icon.
  2. In the DataSet smart panel that appears, select the General page.
  3. Change the Name to EmployeeSales.
  4. On the Parameters page under Parameter Name enter EmpID.
  5. Under Value enter
    =Parameters!EmpID.Value
  6. On the Query page, paste the following SQL command into the Query text box:

    SELECT * FROM EmployeeSales;

  7. Click the Validate icon to validate the query and to populate the Fields list.
  8. Select the Fields page to populate the Fields list.
  9. Click the Accept icon at the top to close the smart panel and see EmployeeSales and the selected fields appear in the Data Explorer.

Adding a report parameter to the subreport

To add a report parameter to the subreport

  1. On the Layout tab of the report, from the Report menu, select Report Parameters.
  2. Click the Add icon.
  3. Under Name enter EmpID.
  4. Under Data type select Integer.
  5. Under Prompt enter Enter employee ID. (This is not necessary for the subreport, but it will allow you to preview the report.)
  6. Click the Accept icon at the top to close the smart panel.

Adding controls to display data on the subreport

To add a Table control with grouping to the subreport

  1. Click the Toolbox icon below the Data Explorer.
  2. From the toolbox, drag a Table data region onto the body of the report.
  3. With the table selected in the combobox at the top of the property grid, set the DataSetName property to EmployeeSales.
  4. Click inside the table to display the column and row handles along the top and left sides of the table.
  5. Right-click the handle above the rightmost column and select Insert Column to the Right.
  6. Click the column handle at the top of each column in turn to select it, and in the property grid, set the Width property as indicated in the table.
    Column | Width
    First | 1.5in
    Second | 1.5in
    Third | 1.2in
    Fourth | 1.55in
    Tip: In most cases it is easier to resize existing columns before adding new columns because this prevents the table from growing horizontally and pushing the report width beyond what will fit on paper.
  7. Right-click the handle to the left of the Detail row and select Insert Group.
  8. In the Groups smart panel, select Table1_Group1.
  9. Under Expression select
    =Fields!EmployeeID.Value
    This groups all details from each employee.
  10. Change the Name to Employee.
    Note: You cannot change the name of a table group until after you have set the expression.
  11. Click the Accept icon at the top to close the smart panel.
  12. Right-click the handle to the left of the detail row and select Edit Group to access the Detail Grouping smart panel.
  13. Under Expression select
    =Fields!SaleID.Value
    This lists the total amount of each sale instead of listing each item sold within each SaleID.
  14. Click the Accept icon at the top to close the smart panel.
  15. Right-click the handle to the left of the header row for the grouping and select Insert Row Below. We will use this new row for static labels which will repeat at the top of each new group.
  16. Right-click any handle to the left of the table and select Table Header to toggle off the table header.
  17. Right-click any handle to the left of the table and select Table Footer to toggle off the table footer.
  18. Select Body in the property grid and set the Size property to 5.75in, 1in so that it will fit inside the subreport control on the main report.

To add data fields to the Table data region

  1. From the EmployeeSales dataset in the Data Explorer, drag the following field onto the first group header row of the table.

    Data Field | Column | Special Formatting
    Name | TableColumn1 | Bold
  2. Use the Shift key and the mouse to select the first two cells in the first group header row, right-click and select Merge Cells. This allows the employee name to span two columns in the table.
  3. Using the handle to the left of the first group header row, select the row and set the BackgroundColor property to LightSteelBlue.
    Tip: Even if you will not be using colors in your finished report, it is often helpful to do so during the design of a report to make identification of the various sections easier for troubleshooting when you preview it.
  4. Enter the following text into the cells in the second group header row of the table.
    Text | Column | Special Formatting
    Sale Date | TableColumn1 | Bold, TextAlign Right
    Sale Number | TableColumn2 | Bold, TextAlign Right
    Quantity | TableColumn3 | Bold, TextAlign Right
    Total | TableColumn4 | Bold, TextAlign Right

  5. Since the details are grouped by SalesID, only one detail row is shown for each SalesID. To show a summary of the quantity and total fields for each SalesID, add the Sum aggregate to the expression for each of those two fields:
    • =Sum(Fields!Quantity.Value)
    • =Sum(Fields!Total.Value)
  6. Using the handle to the left of the second group header row, select the row and in the BackgroundColor property select LightGray.
  7. From the EmployeeSales dataset in the Data Explorer, drag the following fields onto the detail row of the table.
    Data Field | Column | Special Formatting
    SaleDate | TableColumn1 | Format property: d (uses short date formatting)
    SaleID | TableColumn2
    Quantity | TableColumn3
    Total | TableColumn4 | Format property: C (uses currency formatting)
  8. Using the handle to the left of the group footer row, select the row and in the BackgroundColor property select LightGray.
  9. From the EmployeeSales dataset in the Data Explorer, drag the following fields onto the group footer row of the table. Notice that the value of fields dragged onto the group footer row automatically use the Sum aggregate function.
    Data Field | Column | Special Formatting
    Quantity | TableColumn3
    Total | TableColumn4 | Format property: C (uses currency formatting)
  10. Enter the following text into the indicated cell in the group footer row of the table.
    Text Column Special Formatting
    Employee Total: TableColumn2 Bold, TextAlign Right

  11. From the File menu, select Save.
  12. Go to the Preview tab, enter 1035 for the employee ID, and click the View Report button.
  13. Your report should look similar to this.

Creating the main report

To create a report in the Report Designer application

  1. From the File menu, select New.
  2. In the Templates window, select Report and name the report Employee.rdlx and click the OK button.
  3. From the File menu, select Save or Save As, navigate to the directory under which you saved the subreport, and click the Save button.
    Caution: If you don't save your main report in the same directory as the subreport, or if you don't save it at all, the subreport will not render in the preview.

Connecting the main report to a data source

To connect the Employee report to a data source

  1. Click the Data Explorer icon to the bottom left of the report.
  2. Click the Add Data Source icon.
  3. In the Report DataSource smart panel that appears, select the General page.
  4. Change the Name to Reels.
  5. Change the Type to OLEDB.
  6. Use the following Connection String, replacing the text your name and build number with the actual name and build number on your machine:

    Provider=Microsoft.Jet.OLEDB.4.0;Data Source=C:\Documents and Settings\your name\My Documents\Data Dynamics\Reports\build number\Samples\Reels\Data\Reels.mdb;User id=admin;password=;

    Note: In Windows Vista, the path is C:\User\your name\Documents\Data Dynamics\Reports\build number\Samples\Reels\Data\Reels.mdb.
  7. Click the Accept icon at the top to close the smart panel and see Reels appear in the Data Explorer.

Adding a dataset to the main report

To add a dataset to the main report

  1. Click the Add DataSet icon.
  2. In the DataSet smart panel that appears, select the General page.
  3. Change the Name to EmployeeInfo.
  4. On the Query page, paste the following SQL command into the Query text box:

    SELECT * FROM EmployeeInfo;

  5. Click the Validate icon to validate the query and to populate the Fields list.
  6. Click the Accept icon at the top to close the smart panel and see EmployeeInfo and the selected fields appear in the Data Explorer.

Adding report items to display data on the main report

To add a static label to the top of the main report

  1. On the Layout tab of the report, drag a TextBox report item onto the body of the report from the toolbox and set the properties as follows.
    Property | Setting
    FontSize | 14pt
    Location | 0in, 0in
    Size | 6.5in, 0.25in
    TextAlign | Center
    Value | Employee Report by City and Store

To add a List data region that repeats data for each city

  1. Drag a List data region from the toolbox onto the report and set the properties as follows.
    Property | Setting
    BackgroundColor | Silver
    DataSetName | EmployeeInfo
    Location | 0in, 0.25in
    Size | 6.5in, 2.375in
  2. Right-click the list and select Properties.
  3. In the List smart panel, select Detail Grouping.
  4. Under Expression, select

    =Fields!City.Value

  5. Click the Accept icon at the top to close the smart panel and accept the change.
  6. From the Data Explorer, drag the City field onto the list and set the properties as follows.
    Property | Setting
    FontSize | 12pt
    Location | 0in, 0in
    Size | 6.5in, 0.25in
    TextAlign | Center

To nest a second List data region that repeats data for each store within the city

  1. Drag a List data region from the toolbox onto the first list and set the properties as follows.
    Property | Setting
    BackgroundColor | Beige
    DataSetName | EmployeeInfo
    Location | 0.125in, 0.3in
    Size | 6.25in, 1.9in
  2. Right-click the list and select Properties.
  3. In the List smart panel, select Detail Grouping.
  4. Under Expression, select

    =Fields!StoreName.Value

  5. Click the Accept icon at the top to close the smart panel and accept the change.
  6. From the Data Explorer, drag the StoreName field onto the list and set the properties as follows.
    Property | Setting
    FontWeight | Bold
    Location | 0in, 0in
    Size | 1.375in, 0.25in

To nest a third List data region that repeats data for each employee in the store

  1. Drag a List data region from the toolbox onto the second list and set the properties as follows.
    Property | Setting
    BackgroundColor | White
    DataSetName | EmployeeInfo
    Location | 0.125in, 0.25in
    Size | 6in, 1.5in
  2. Right-click the list and select Properties.
  3. In the List smart panel, select Detail Grouping.
  4. Under Expression, select

    =Fields!EmployeeID.Value

  5. Click the Accept icon at the top to close the smart panel and accept the change.
  6. From the Data Explorer, drag the following fields onto the list and set the properties as follows.
    DataField | Location | Size | Special Formatting
    Name | 0.875in, 0in | 2.875in, 0.25in
    Education | 1.125in, 0.25in | 2.625in, 0.25in
    DateOfBirth | 5in, 0in | 0.875in, 0.25in | Format: d (short date)
    PhoneNumber | 4.875in, 0.25in | 1in, 0.25in
  7. From the toolbox, drag five text boxes onto the list and set the properties as follows.
    Value | Location | Size | Special Formatting | Name
    Name: 0.125in, 0in 0.625in, 0.25in Bold
    Education: 0.125in, 0.25in 0.875in, 0.25in Bold
    Date of Birth: 3.875in, 0in 1in, 0.25in Bold
    Phone: 3.875in, 0.25in 0.875in, 0.25in Bold
    Sales Record | 0.125in, 0.5in | 1.125in, 0.25in | Bold | SalesRecord

To add a Subreport control to the main report

  1. From the toolbox, drag a Subreport control onto the list below the text boxes and set the properties as follows.
    Property | Setting
    Location | 0.125in, 0.75in
    NoRows | No sales recorded for this employee during 2005.
    ReportName | Sales (ensure that this report is saved in the same directory as the Sales report)
    Size | 6in, 1.5in
    Visibility: Hidden | True (hides the subreport initially)
    Visibility: ToggleItem | SalesRecord text box (puts a toggle image next to the text that shows the subreport when clicked)
  2. Right-click the Subreport control and select Properties.
  3. On the Parameters page of the Subreport smart panel, set the Parameter Name to EmpID (must match the parameter in the subreport exactly) and the Parameter Value to

    =Fields!EmployeeID.Value

  4. Click the Accept icon at the top to close the smart panel.
  5. From the File menu, select Save.

Viewing the report

Any report designed with Data Dynamics Reports can be opened in the included Data Dynamics Reports Viewer application or you can view it at design time.

To view the report at design time

  1. Click the Preview tab for the Employee report.
  2. Click the + to the left of Sales Record to see the subreport.
See Also

Walkthroughs

Reference: Subreports


Walkthrough: Dynamic Queries

You can create dynamic queries with Data Dynamics Reports to change the structure of a query at run time.

This advanced walkthrough illustrates how to create a simple dynamic query.

The walkthrough is split up into the following activities:

  • Creating a Data Dynamics Report
  • Connecting the report to a data source
  • Adding a Dataset
  • Adding controls to the report to contain data
  • Creating a second dataset for use by the parameter list
  • Adding parameters to the report
  • Changing the Products dataset to use a dynamic query
  • Adding a page header to display the chosen parameter label
  • Viewing the report

To complete the walkthrough, you must have access to the Reels sample database included with this installation.

When you are finished you will have a report that looks similar to the following.

Creating a Data Dynamics Report

To create a report in the Report Designer application

  1. From the Windows Start menu go to All Programs, Data Dynamics, Reports and select Data Dynamics Reports Designer.
  2. From the File menu, select Save As.
  3. In the combo box next to Save in, navigate to the directory under which you want to save the report.
  4. Enter ProductsInStock.rdlx as the File name and click the Save button.

Connecting the report to a data source

To connect the report to a data source

  1. Click the Data Explorer icon to the bottom left of the report.
  2. Click the Add Data Source icon.
  3. In the Report DataSource smart panel that appears, select the General page.
  4. Change the Name to Reels.
  5. Change the Type to OLEDB.
  6. Use the following Connection String, replacing the text your name and build number with the actual name and build number on your machine:

    Provider=Microsoft.Jet.OLEDB.4.0;Data Source=C:\Documents and Settings\your name\My Documents\Data Dynamics\Reports\build number\Samples\Reels\Data\Reels.mdb;User id=admin;password=;

    Note: In Windows Vista, the path is C:\User\your name\Documents\Data Dynamics\Reports\build number\Samples\Reels\Data\Reels.mdb.
  7. Click the Validate icon to validate the connection string. (The Validate icon becomes inactive to indicate success. An error message indicates an invalid connection string.)
  8. Click the Accept icon at the top to close the smart panel and see Reels appear in the Data Explorer.

Adding a dataset

In this activity, we use a temporary static query which we will later replace with a dynamic query. The reason for the temporary static query is that the dynamic query does not populate the fields list, making it more difficult to add controls to the report in the next activity.

To add a dataset

  1. Click the Add DataSet icon.
  2. In the DataSet smart panel that appears, select the General page.
  3. Change the Name to Products.
  4. On the Query page, paste the following SQL command into the Query text box:

    SELECT Movie.Title, Product.InStock, Product.StorePrice
    FROM MediaType INNER JOIN (Movie INNER JOIN (Product INNER JOIN MovieProduct ON Product.ProductID = MovieProduct.ProductID) ON Movie.MovieID = MovieProduct.MovieID) ON MediaType.MediaID = MovieProduct.MediaType
    WHERE (((MediaType.MediaID)=1))
    ORDER BY Movie.Title;

  5. Click the Validate icon to validate the query and to populate the Fields list.
  6. Click the Accept icon at the top to close the smart panel and see Products and the selected fields appear in the Data Explorer.

Adding controls to the report to contain data

To add controls to the report

  1. Click the Layout tab at the bottom of the report and click the Toolbox icon below the Data Explorer.
  2. From the toolbox, drag a Table data region onto the body of the report.
  3. From Products in the Data Explorer, drag the Title field into the first column of the Detail row.
    Note: This automatically places an expression in the detail row and simultaneously places a static label in the header row of the same column.
  4. Drag the InStock field into the second column of the detail row of the table.
  5. Drag the StorePrice field into the third column of the detail row of the table.
  6. To optionally display the static labels in bold at the top of every page of the report:
    • Select the Header row by clicking the table handle to the left of the row.
    • In the Report Formatting tool bar, click the Bold button.
    • In the Properties grid, set the BackgroundColor property to DarkSeaGreen.
    • Set the RepeatOnNewPage property to True.
  7. To improve the appearance of the report, set the following properties in the Property grid:
    • Select the StorePrice field in the detail row and set its Format property to C for currency.
    • Select the second and third columns by holding the CTRL key and clicking the table handles above the columns and change their Width properties to 1in.
    • Select the first column and change its Width property to 4.5in.
    Tip: Making some columns narrower before making other columns wider prevents your report width from changing.

Creating a second dataset for use by the parameter list

To create a second dataset

  1. Click the Data Explorer icon to the bottom left of the report.
  2. Click the Add DataSet icon.
  3. In the DataSet smart panel that appears, select the General page.
  4. Change the Name to MediaType.
  5. On the Query page, paste the following SQL command into the Query text box:
    SELECT 0 AS MediaID, "All" AS Description
FROM MediaType
UNION
SELECT MediaID, Description
FROM MediaType
ORDER BY Description;
  6. Click the Validate icon to validate the query and to populate the Fields list.
  7. Click the Accept icon at the top to close the smart panel and see Products and the selected fields appear in the Data Explorer.

Adding parameters to the report

To add parameters to the report

  1. In Layout view, click in or below the report body to ensure that the report has focus.
  2. From the Report menu, select Report Parameters.
  3. In the Report Parameters smart panel that appears, click the Add button to add a parameter.
  4. Change the Name to MediaType.
  5. Leave the Data type set to the default value of String. (This data type must match that of the field.)
  6. Enter the following text to prompt users for a value: Select a media type.

To provide a list of values for the Report Parameter

  1. Just below the list of parameters, click the Values icon.
  2. Under Available Values, select From query.
  3. Under Dataset, select MediaType.
  4. Under Value field, select MediaID.
  5. Under Label field, select Description to provide a more readily understandable label in the list.
  6. Click the Accept icon at the top to close the smart panel and add the parameter to the collection.

Changing the Products dataset to use a dynamic query

To change the Products dataset to use a dynamic query

  1. In the Data Explorer, right-click Products and select Edit.
  2. In the DataSet smart panel that appears, select the Query page.
  3. In the Query field, change the query to the following expression:
    ="SELECT Movie.Title, Product.InStock, Product.StorePrice, MediaType.Description
FROM MediaType
INNER JOIN (Movie INNER JOIN (Product INNER JOIN MovieProduct
ON Product.ProductID = MovieProduct.ProductID)
ON Movie.MovieID = MovieProduct.MovieID)
ON MediaType.MediaID = MovieProduct.MediaType" & IIf(Parameters!MediaType.Value = 0, "","
WHERE (MediaType = " & Parameters!MediaType.Value & ")") & "
ORDER BY Movie.Title"
  4. Click the Accept icon at the top to close the smart panel and save the changes.

Adding a page header to display the chosen parameter label

To add a page header

  1. In Layout view, click in or below the report body to ensure that the report has focus.
  2. Open the Report menu and select Page Header.
  3. Click the Toolbox icon below the Data Explorer.
  4. From the toolbox, select Textbox and drag it onto the page header section.
  5. Set the Location property to 0in, 0in and the Size property to 6.5in, 0.25in.
  6. Set the TextAlign property to Center and the FontSize property to 14pt.

  7. Enter the following expression for the Value of the textbox to display the selected media type in the page header:

    =Parameters!MediaType.Label & " Movies in Stock"
    Note: Using Label instead of Value in the expression displays the more readily understandable Description field instead of the MediaID field we used for the parameter's value.
  8. From the File menu, select Save.

Viewing the report

Any report designed with Data Dynamics Reports can be opened in the included Data Dynamics Reports Viewer application or you can view it at design time.

To view the report at design time

  1. Click the Preview tab of the report designer.
  2. Select a media type from the parameters list and click the View Report button.
See Also

Walkthroughs

Reference: Parameters

Getting Started: Data Explorer


Walkthrough: Custom Code

You can easily create a report using custom code with Data Dynamics Reports.

This walkthrough illustrates how to create a report with simple custom code.

The walkthrough is split up into the following activities:

  • Creating a Data Dynamics Report
  • Connecting the report to a data source
  • Adding a Dataset
  • Adding controls to the report to contain data
  • Embedding code in a report and referencing it in a field expression
  • Viewing the report

To complete the walkthrough, you must have access to the Reels sample database included with this installation.

When you are finished you will have a report that looks similar to the following.

Creating a Data Dynamics Report

To create a report in the Report Designer application

  1. From the Windows Start menu go to All Programs, Data Dynamics, Reports and select Data Dynamics Reports Designer.
  2. From the File menu, select Save As.
  3. In the combo box next to Save in, navigate to the directory under which you want to save the report.
  4. Enter Districts.rdlx as the File name and click the Save button.

Connecting the report to a data source

To connect the report to a data source

  1. Click the Data Explorer icon to the bottom left of the report.
  2. Click the Add Data Source icon.
  3. In the Report DataSource smart panel that appears, select the General page.
  4. Change the Name to Reels.
  5. Change the Type to OLEDB.
  6. Use the following Connection String, replacing the text your name and build number with the actual name and build number on your machine:

    Provider=Microsoft.Jet.OLEDB.4.0;Data Source=C:\Documents and Settings\your name\My Documents\Data Dynamics\Reports\build number\Samples\Reels\Data\Reels.mdb;User id=admin;password=;

    Note: In Windows Vista, the path is C:\User\your name\Documents\Data Dynamics\Reports\build number\Samples\Reels\Data\Reels.mdb.
  7. Click the Validate icon to validate the connection string. (The Validate icon becomes inactive to indicate success. An error message indicates an invalid connection string.)
  8. Click the Accept icon at the top to close the smart panel and see Reels appear in the Data Explorer.

Adding a dataset

To add a dataset

  1. Click the Add DataSet icon.
  2. In the DataSet smart panel that appears, select the General page.
  3. Change the Name to Districts.
  4. On the Query page, paste the following SQL command into the Query text box:

    SELECT Store.StoreName, Address.City, Address.Region AS StateProvince, Address.Country, Districts.District
    FROM Address INNER JOIN (Districts INNER JOIN Store ON Districts.DistrictID = Store.DistrictID) ON Address.AddressID = Store.Address
    WHERE NOT Districts.DistrictID = 0
    ORDER BY Districts.District;

  5. Click the Validate icon to validate the query and to populate the Fields list.
  6. Click the Accept icon at the top to close the smart panel and see Districts and the selected fields appear in the Data Explorer.

Adding controls to contain data

To add controls to the report

  1. Click the Layout tab at the bottom of the report and click the Toolbox icon below the Data Explorer.
  2. From the toolbox, drag a Table data region onto the body of the report.
  3. With the table selected in the property grid, set the DataSetName property to Districts.
  4. Click inside the table to display the row and column handles along the left and top edges of the table.
  5. Right-click in any of the row handles to the left of the table and select Insert Group.
  6. In the Table Data Region - Groups smart panel that appears, under Group on, select the following expression:
    =Fields!District.Value
  7. Set the Name to District.
  8. Click the Accept icon at the top to close the smart panel and see header and footer rows for the new group appear.
  9. From Districts in the Data Explorer, drag the District field into the second column of the group header row of the table. This automatically places an expression in the group header row and simultaneously places a static label in the table header row. (You can delete the static label from the table header row.)
  10. In the first column of the group header row, just to the left of the District field, enter District Name: for the Value.
  11. Click the row handle to the left of the group header row to select the entire row and set the following properties:
    • Set the FontSize to 12pt.
    • Set the FontWeight to Bold.
    • Set the BackgroundColor to MediumPurple.
    • Set the Color to White. (The Color property controls the color of the text.)
  12. Right-click in any row handle to the left of the table and select Table Header to remove the table header.
  13. Right-click in any row handle to the left of the table and select Table Footer to remove the table footer.
  14. From Districts in the Data Explorer, drag the following fields onto the detail row of the table in the indicated column.
    Field | Column
    StoreName | TableColumn1
    City | TableColumn2
    StateProvince | TableColumn3
  15. Right-click the row handle for the group header row and select Insert Row Below to add a row for static labels that will appear once for each group.
  16. In the new row, enter the following values for static labels.
    Value | Column | FontWeight
    Store Name | TableColumn1 | Bold
    City | TableColumn2 | Bold
    =iif(Fields!Country.Value="USA", "State", "Province")
             TableColumn3 Bold
    Note: The expression in the third column displays the label "State" when the country is the USA, and displays "Province" when it is not.
  17. To add a page header to the report:
    • Open the Report menu and select Page Header.
    • From the toolbox, select TextBox and draw it onto the PageHeader section to span the entire width of the report.
    • Set the TextAlign property to Center and the FontSize to 14pt.
    • Enter District Locations for its value.

Embedding code in a report and referencing it in a field expression

This custom code creates a URL to Yahoo!® Maps for each city in the report.

To embed code in a report

  1. On the Code tab of the report, enter the following Visual Basic .NET code to create a URL.
    Public Function MapLink(ByVal Country, ByVal City, ByVal StateProvince) As String
    Dim Link As String
    Dim _Country As String = Country.ToString()
    Dim _City As String = City.ToString()
    Dim _StateProvince As String = StateProvince.ToString()

    Select Case _Country
        Case "USA"
            Link = "http://maps.yahoo.com/maps_result?addr=&csz=" & _City & "%2C+" & _StateProvince & "&country=us&new=1&name=&qty="
        Case "Canada"
            Link = "http://ca.maps.yahoo.com/maps_result?csz=" & _City & "%2C+" & _StateProvince & "&country=ca"
        Case Else
            Link = ""
    End Select

    Return Link
End Function
Note: Custom code is helpful if you intend to reuse code throughout the report or if code is too complex to use in an expression. Code must be instance based and written in Visual Basic .NET. You can include multiple methods, but if you want to use classes or other .NET languages, create a custom assembly.

To reference embedded code in a field expression

  1. On the Layout tab of the report, right-click the detail cell in the second table column (containing the expression =Fields!City.Value) and select Properties.
  2. In the Textbox Report Item smart panel that appears, select the Navigation page.
  3. Select the radio button next to Jump to URL at the bottom, and enter the following expression in the combo box below it.
    = Code.MapLink(Fields!Country.Value, Fields!City.Value, Fields!StateProvince.Value)
  4. Click the Accept icon at the top to close the smart panel and use the code to create a hyperlink for the field.
  5. From the File menu, select Save.

Viewing the report

Any report designed with Data Dynamics Reports can be opened in the included Data Dynamics Reports Viewer application or you can view it at design time.

To view the report at design time

  1. Click the Preview tab of the report designer.
  2. Click a city name to open a browser and view the map.
See Also

Walkthroughs | Walkthrough: Expressions | Adding Code | Adding Code | Creating an Instance Method

Reference: Custom Code


Walkthrough: Web Report Viewer

You can create a Web project to display a report on the Web in minutes using the Data Dynamics Reports pre-packaged WebReportViewer control.

This walkthrough illustrates how to create a simple WebReportViewer project.

The walkthrough is split up into the following activities:

  • Adding the WebReportViewer to a Visual Studio Web site
  • Adding the MoviesByProducer.rdlx report to the project
  • Connecting the report to the viewer
  • Viewing the report

To complete the walkthrough, you must have Internet Information Services (IIS) installed and the Default Web Site running on your machine. You must also have completed the Walkthrough: Parameters.

Caution: In order for the E-mail Report button to function, the Default SMTP Virtual Server in IIS must also be running.

Adding the WebReportViewer to a Visual Studio Web Site

To add the WebReportViewer to your Web site

  1. Open an ASP.NET Web Application project in Visual Studio.
  2. If you haven't done so already, add the WebReportViewer to the Visual Studio toolbox.
  3. From the toolbox, drag the WebReportViewer control onto the design surface of the ASPX form. This automatically adds a CoreHandler.ashx file to the project. (In Visual Studio 2005, you must manually add the DataDynamics.Reports.Web reference.)
  4. In the properties grid, change the Dock property of the viewer to True so that it will fill the Web page and resize along with the window.

Adding the MoviesByProducer Report to the Project

To add the MoviesByProducer report to the project

  1. From the Visual Studio Project menu (Website menu in Visual Studio 2005), select Add Existing Item.
  2. Navigate to the MoviesByProducer.rdlx file you created in the Parameters walkthrough and select it.
  3. Click Add.

Connecting the Report to the Viewer

To connect the report to the viewer

  1. With the WebReportViewer selected in the properties grid, click in the ReportName property and click the ellipsis button that appears. This opens the Select URL dialog.
  2. In the Contents of folder pane, select MoviesByProducer.rdlx and click the OK button.

Viewing the report

To view the report at design time

  1. Click the Preview tab of the report designer.

To view the report at run time

  1. Run the project.
  2. Select a parameter for the report.
  3. Click the View Report button.
See Also

Walkthrough: Parameters | Walkthroughs

Getting Started: Web Viewer

Support: Troubleshooting


What's New

Data Dynamics Reports has many new features since the first Technical Preview release. Many of the features already in place at that time have been improved as well. We appreciate the feedback you've given us, and would appreciate any feedback you have regarding these new features. Thank you for your continued assistance in helping us to make a product of which we can all be proud.

Master Reports
When you create a new report, you now have the option to create a Master Report. This allows you to create a consistent look and functionality that can be used in Content Reports. For more information, see Master Reports.
Data Smart Panel
The Data Page has been replaced with a Data smart panel that offers more features. One very welcome addition is the connection builder.
Embedded Images Smart Panel
The Report menu now includes Embedded Images. Images added via this smart panel are saved into the RDLX file. When you add an Image report item to a report and set the Source property to Embedded, embedded images are available in the Value property.
Support for Shared Data Sources
Shared data sources are now displayed in the Data Explorer tree view. Any data source can be shared, and a shared data source can be specified for any report.
Support for Themes
Themes are now available for use in color and font properties. Themes allow report authors to use a set of colors and fonts, and change those colors and fonts for all reports using the theme by editing one file. The UI for creating them will be available in the next release.
RDL 2005 Support
Data Dynamics Reports now supports reports created using the RDL 2005 specification.


Viewer Guide

In the Viewer Guide

Report Viewer Features
Find out about the features included in the report viewer application.
Opening Reports
Opening reports is simple and intuitive.
Keyboard Controls
Learn which operations you can perform using the keyboard.
Page Setup
Learn of the options available for changing the appearance of a report in the viewer.
Printing
Find out how to print reports directly from the viewer, or to export them to various printable formats.
Exporting Reports
Here you will find information about the various formats in which reports may be rendered.
Samples
Here is a list of included sample reports. You can open these samples in the viewer application to see many of the features of Data Dynamics Reports in action.
Getting Help
Find out about product support and registration requirements.
Data Dynamics Reports License Agreement
Find the details of the license agreement and limited warranty.


Viewer Features

The Data Dynamics Report Viewer offers many features for developers and end users alike. The Report Viewer application opens RDL and RDLX files and allows users to print or export reports.

Note: More features not documented here will be added prior to release.

Navigational and Interactive Features:

  • Parameters
  • Document map (table of contents)
  • Bookmark links
  • Hyperlinks
  • Drillthrough links
  • Drill down reports
  • Search with metadata query support
  • First, previous, next, and last page
  • Page number and page N of M
  • Cancel and Refresh
  • Back to parent report
  • Scroll bar jump buttons

Exporting Features:

  • Rendering to HTML (XHTML)
  • Rendering to PDF
  • Rendering to Image (BMP, EMF, GIF, JPEG, TIFF, and PNG)
  • Transforming to XML
  • Rendering to Word

Extra Features:

  • Pan mode
  • Snapshot mode
  • Selection mode
  • Preview modes
    • Print preview
    • Layout preview
  • Copy
  • Zoom
See Also

Viewer Guide


Parameters in the Viewer

Parameters are used in some reports to narrow down the selection of data displayed. When you open such a report in the Data Dynamics Reports Viewer, you are presented with a user interface like that pictured below. You can select a value for each parameter to display only the data in which you are interested. You may also select NULL to display all available data. Once you have made your selections, click the View Report button to see the report.

Cascading Parameters

For some reports, cascading parameters are used. In this type of report, initially only the first parameter offers a selection of values. Once you select a value for this parameter, the next parameter offers a selection of values which have been narrowed down by the first value, and so on. Once you have made your selections, click the View Report button to see the report.

Multi-Value Parameters

For other reports, multi-value parameters allow you to select more than one item from a list of values to create a report containing only the information you want to see. A value of All is selected by default so that if you click the View Report button without making any selections, all of the values are included in the report.

Once you've selected parameters, the report is displayed and the sidebar pane is hidden. To select different parameters, click the Show or Hide Sidebar Pane icon.

See Also

Viewer Guide

Reference: Parameters

Tutorials: Passing Parameters | Walkthrough: Parameters


Document Map Sidebar

If a report includes a Document Map, or Table of Contents, you can view it in the sidebar pane and click an item in the document map to navigate to it in the report.

To view the sidebar pane, click the Show or Hide sidebar pane icon, or from the View menu, select Sidebar Pane.

At the bottom of the pane, click the Document map icon to display the document map. If there is no document map associated with the report, the icon does not appear at the bottom of the pane.

Click an item in the document map to navigate to the corresponding section of the report in the viewer.

See Also

Parameters in the Viewer | Viewer Guide | Keyboard Controls


Bookmark Links, Hyperlinks, and Drillthrough Links

Some reports contain links that you can identify by the way that the cursor changes when you hover your mouse over them. When your mouse is over a clickable link of any kind, the cursor changes into a hand with a pointing finger.

Drill down links are obvious because of the plus sign that shows that you can expand a section of the report, but the other types may not be so obvious.

Bookmark Links

When you click a bookmark link, the viewer navigates to a bookmarked item within the current report.

Hyperlinks

When you click a hyperlink, your machine's default internet browser opens to display a Web page.

Drillthrough Links

When you click a drillthrough link, the viewer navigates to another report, usually one with more details about the item you clicked. If you want to return to the main report after clicking a drillthrough link, click the Back to Parent Report button in the toolbar.


Drill Down

When you open a report with Drill Down features, part of the data is hidden so that you only see high-level data until you request more detail. A plus-sign image appears next to each toggle item in the report. Clicking on the toggle image, or plus sign, expands hidden content into view and the toggle image changes to a minus sign. Clicking on the minus-sign image hides the content and returns the report to its previous state.

If you export a drill-down report to HTML, PDF, or an image format, any content which is hidden at the time of export remains hidden in the exported file. If you want all of the content to appear in the exported file, you must first expand each area of hidden data.

If you export a drill-down report to XML, all hidden data is exported regardless of whether it is hidden at the time of export.


Search

To open the Search sidebar pane, click the Find icon.

Basic Search

By default, the basic search is displayed. Enter search text and select additional criteria as needed, and hit the Enter key or click the Search button to display results.

The results are displayed in the Find results as well as in a navigation bar between the report and the vertical scroll bar. Each item containing the search string is represented as a green hairline so that you can see where the hit is in relation to the entire report. Hover the cursor over a green hairline to see the full text of the field returned by the search. Click the hairline to navigate to that point in the report.

Search results within the report are highlighted in blue.

Advanced Search

Click Use Advanced Search Options to select whether to match the exact word or phrase, or to match any of the words in your search text.

You may also narrow your search by limiting it to certain areas of the report, such as a name or address field.

See Also

Viewer Guide


Navigation

First, Previous, Next, and Last Page

When you have navigated beyond the first page of a report, the First Page and Previous Page buttons are enabled. The First Page button takes you to the beginning of the report, and the Previous Page button navigates to the page number prior to the current page.

When you are not on the last page of a report, the Next Page and Last Page buttons are enabled. The Last Page button takes you to the end of the report, and the Next Page button navigates to the page number following the current page.

Page Number and Page N of M

You can see the current page (N) and the total pages (M) of a report in two places: between the navigation buttons above, and at the bottom of the viewer on the left.

To go directly to a page number, replace the numbers in the box between the navigation buttons with the page number you want and hit the Enter key.

Cancel and Refresh

The Cancel button is enabled when it appears in red.

When a long report is loading, click the Cancel button to stop it from processing.

You can reload a report with fresh data by clicking the Refresh button, or by hitting the F5 button on your keyboard.

Back to Parent Report

When you have followed a drill-through link from one report to another, return to the main report by clicking the Back to parent report button.

Scroll Bar Jump Buttons

At the bottom of the viewer's horizontal scroll bar, you will find jump buttons. By default, clicking the up and down arrow buttons navigates to the previous and next page respectively.

To change this behavior, click the center button and select from Pages, Find Results, or Data Regions.

If you select Find Results, the jump buttons navigate between pages containing the text from a search.

If you select Data Regions, the jump buttons navigate between different data regions within the report. (This feature only takes effect if multiple data regions exist in the report.) For example, if you have two charts within the report for two consecutive years, you can easily jump between the two charts to compare the data using the Data Regions setting of the jump buttons.


Modes

Pan mode

The default mode for the viewer is Pan mode. In this mode, the cursor is represented by a hand which you can use to grab the page and move it around. It works in much the same way as moving a sheet of paper around on your desk with your hand.

Snapshot mode

If you click the Snapshot mode icon, you can select a rectangular area of the report with your cursor and paste it as an image into any application that accepts pasted images. This makes it a snap to copy a chart from a report into an MS Word document.

Selection mode

If you want to copy text from a report:

  • Click the Selection mode icon
  • Select a rectangular area of the report with your cursor
  • Click the Copy icon (see image below)
  • Paste the text into any application that accepts pasted text

Preview modes

The default preview mode for the Data Dynamics Reports Viewer application is Print Preview (the Print Preview icon is depressed as above).

Clicking the Print Preview icon changes the preview mode to Galley mode (the icon appears in its up state as pictured below). Galley mode is a viewer-only mode which does not generate automatic page breaks, and does not allow you to print reports. This mode does honor page breaks created in the report, but if the report uses automatic page breaks, it appears as a single page in Galley mode.

Copy

First, click the Selection mode icon to enable copying.

Select text and click the Copy icon to copy the text to the clipboard. You can paste the contents of the clipboard into any application that accepts pasted text.

Note: Images and formatting are not copied.

Zoom

Click the Zoom In icon to change the cursor function to zoom in on the section of the report that you click. Click the Zoom Out icon for the opposite effect.

You can also set the Zoom level of the report using the combo box next to the Zoom In and Zoom Out icons.

You can set a custom zoom level in the Zoom dialog. From the View menu, select Zoom to open the dialog. Enter a numeric value between 10 and 500 and click the OK button.

See Also

Viewer Features


Opening Reports in the Viewer

You can open any RDL or RDLX format report in the viewer application.

To open a report in the viewer application

  1. In the viewer tool bar, click the Open Report icon Open report icon to display the Open Report dialog.
  2. Navigate to the report you want to open.
    Note: There are a number of sample reports available in C:\Documents and Settings\your name\My Documents\Data Dynamics\Reports\build number\Samples\Reels\Data. (In Windows Vista, the path is C:\User\your name\Documents\Data Dynamics\Reports\build number\Samples\Reels\Data.)
  3. Select the report and click the Open button.


Keyboard Controls

You can use the following keys and key combinations to control functions in the viewer.

Key | Function
F5 | Refresh the report.
Page Dn | Move to the next page.
Page Up | Move to the previous page.
Ctrl + Home | Move to the first page.
Ctrl + End | Move to the last page.
Home | Move to the top of the current page.
End | Move to the bottom of the current page.
Arrows | Scroll in the current page in the direction of the arrow.
Ctrl + F | Open or close the sidebar.
See Also

Viewer Guide | Document Map Sidebar


Page Setup

The Data Dynamics Reports Viewer allows you to change a report's paper size and orientation, margins, number of pages per sheet, and even add watermarks.

To enable the Page Setup icon, first click the Print Preview icon just to the left of it.

Click the Page Setup icon to open the Page setup dialog.

To change the paper size

  1. On the Page tab of the Page Setup dialog, select a Paper Size.
  2. Click the OK button.

To change the paper source

  1. On the Page tab of the Page Setup dialog, under Paper Source choose Auto Select or Manual Feed.
  2. Click the OK button.

To change the page orientation

  1. On the Page tab of the Page Setup dialog, click the Portrait or Landscape button.
  2. Click the OK button.

To change the page margins

  1. On the Layout tab of the Page Setup dialog, enter values for each margin.
  2. Click the OK button.

To change the number of pages per sheet

  1. On the Layout tab of the Page Setup dialog, click the Portrait or Landscape button.
  2. Click the OK button.
Note: Select the SizeToFit check box to scale the report to fill the selected paper size.

To add a watermark to the report

  1. On the Watermark tab of the Page Setup dialog, click in the Text box and enter the text you want to display for your watermark.
  2. Select the Font Name, Size, and Color for the text.
  3. Enter a numeric value between 0 and 359 for the Angle of the text. (A value of 0 renders straight left-to-right text. A value of 180 renders inverted text.)
  4. Click the OK button.
See Also

Viewer Guide

Tutorials: Printing


Smart Panel Guide

Here are all of the main categories of smart panels that you will encounter in using Data Dynamics Reports. These categories contain lists of all of the smart panels and information about what you can accomplish using them.

  • Data Explorer smart panels
  • Report Menu smart panels
  • Designer View smart panels
See Also

User Guide

Viewer: Viewer Guide


Data Explorer Smart Panels

The following smart panels are the ones that you can access from the Data Explorer of a Data Dynamics Report. To access the Data Explorer in the Designer, click the Data Explorer button below the toolbox.

  • Report DataSource smart panel
  • Shared DataSource smart panel
  • Dataset smart panel
See Also

Smart Panel Guide | Data

Getting Started: Data Explorer


Report DataSource Smart Panel

You can access the DataSource smart panel from the Data Explorer of a Data Dynamics Report by clicking the Add Data Source icon at the top left of the Data Explorer, or by right-clicking an existing data source and selecting Edit.

The Report DataSource smart panel contains the following pages:

  • General
  • Credentials
See Also

Data

Reference: Data Explorer Smart Panels


Data Source General Page

The General page of the Report DataSource smart panel is where you can set the Name, Type and Connection string of a new data source, or choose to use a shared data source reference.

You must always set the Name field for any data source to a unique name within the report.

If the Shared Reference checkbox is not selected, you can set the Type of the data source you want to use.

Data Dynamics Reports supports nearly any data source. Here are some of the more common ones that you can find under Type:

  • Microsoft SQL Client Provider
  • DataSet Provider
  • Microsoft ODBC Provider
  • Microsoft OleDB Provider
  • Object Provider
  • Oracle Client Provider
  • XML Provider

If you select a Type value of SQL, OleDB, or Oracle, there are icons under Connection for three pages. (The other types have only a Connection String page.)

  • Connection String
  • Connection Properties
  • Advanced Settings

If the Shared Reference checkbox is selected, you can choose the shared data source you want by clicking the Browse button. Once you have chosen a shared data source, the Edit button to access the Shared Data Source becomes available.

You can also elect to execute datasets that use this data source in a single transaction by checking the Use Single Transaction checkbox.

See Also

Dataset Query Page | Connection Properties Page | Shared DataSource Smart Panel | Report DataSource Smart Panel | DataSet and ObjectDataSource Providers


Connection String Page

The Connection String page is displayed by default, but after exploring other pages you can access it from the General page of the Report DataSource smart panel by clicking the Connection String icon under Connection.

Enter a connection string in the provided text box, or use the Connection Properties page to create one for SQL, OleDB, or Oracle data types. Here is sample connection string for the Access NorthWind database in the C directory:

data source=nwind.mdb;persist security info=False;location=c:\;provider=Microsoft.Jet.OLEDB.4.0;integrated security=SSPI;

See Also

Connection Properties Page | Data Source General Page | Data Explorer Smart Panels


Connection Properties Page

You can access the Connection Properties page from the General page of the Report DataSource smart panel by clicking the Connection Properties icon under Connection.

The Connection Properties page gives access to properties specific to each data type.

SQL

With the SQL data type, Connection Properties consist of

  • Server name
  • Log on to server (select whether to use Windows authentication or server authentication which requires a user name and password)
  • Connect to a database (select whether to enter a database name or attach a database file)

OleDB

With the OleDB data type, Connection Properties consist of

  • OLE DB Provider
  • Enter a server or file name and location
  • Log on to server (select whether to use Windows NT integrated security or use a specific user name and password
  • Initial catalog

Oracle

With the Oracle data type, Connection Properties consist of

  • Server name
  • Log on to server (enter user name and password)
See Also

Data Source General Page | Data Explorer Smart Panels


Advanced Settings Page

You can access the Advanced Settings page from the General page of the Report DataSource smart panel by clicking the Advanced Settings icon under Connection.

The Advanced Settings page gives access to properties specific to each data type.

SQL

With the SQL data type, Advanced Settings consist of the following. Descriptions of each are provided at the bottom of the smart panel when they are selected. You can drag the grab handle above the description to provide more room for longer descriptions.

  • Application Name
  • Auto Translate
  • Current Language
  • Network Address
  • Network Library
  • Packet Size
  • Trusted Connection
  • Use Procedure for Prepare
  • Workstation ID

OleDB

With the OleDB data type, Advanced Settings consist of all of the Microsoft Jet OLEDB provider-specific connection parameters. Descriptions of each are provided at the bottom of the smart panel when they are selected, or you can find them on the msdn Web site at: http://msdn.microsoft.com/library/default.asp?url=/library/en-us/ado270/htm/mdrefjetprovspec.asp.

Oracle

With the Oracle data type, Advanced Settings consist of

See Also

Data Source General Page | Report DataSource Smart Panel


Data Source Credentials Page

The Credentials page of the Report Data Source smart panel gives you four options for the level of security you need for the data in your report.

Use Windows Authentication (Integrated Security)
Select this option when you know that any users with a valid Windows account are cleared for access to the data, and you do not want to prompt them for a user name and password.
Use a specific user name and password
Select this option when you want to allow only a single user name and password to access the data in the report.
Prompt for credentials
Select this option when there is a subset of users who can access the data. The Prompt string textbox allows you to customize the text requesting a user name and password from users.
No credentials
Select this option only if the data in the report is for general public consumption.
Note: This page is disabled if the shared data source option is selected on the General page.

If you need to provide credentials automatically at run time, this can be done in code using the LocateCredentials event. For more information, see Credentials.

See Also

Data Source General Page | Report DataSource Smart Panel | Credentials


Shared DataSource Smart Panel

You can access the Shared Data Source smart panel by clicking the Edit Shared Data Source icon at the top of the Data Explorer, or by right-clicking the data source in the tree view and selecting Edit Shared Data Source.

Note: This is only enabled after you have selected the Shared Reference option in the Report DataSource smart panel.

The Shared Data Source smart panel contains the following pages:

  • General
  • Credentials
See Also

Data Source General Page | Report DataSource Smart Panel | Data Explorer Smart Panels | Connecting to a Data Source

Tutorials: Creating a Shared Data Source


Shared Data Source General Page

The General page of the Shared Data Source smart panel allows you to view and edit the Name, Type, and Connection string of the shared data source. Please note that editing this information changes the shared data source itself and will affect all other reports that use it.

The options available on this page exactly duplicate those on the Report DataSource General page, except for the option to use a Shared Reference (because it is already using one).

See Also

Shared DataSource Smart Panel | Data Source General Page


Shared Data Source Credentials Page

The Credentials page of the Shared Data Source gives you four options for the level of security you need for the data in your shared data source.

Use Windows Authentication (Integrated Security)
Select this option when you know that any users with a valid Windows account are cleared for access to the data, and you do not want to prompt them for a user name and password.
Use a specific user name and password
Select this option when you want to allow only a single user name and password to access the data in the shared data source.
Prompt for credentials
Select this option when there is a subset of users who can access the data. The Prompt string textbox allows you to customize the text requesting a user name and password from users.
No credentials
Select this option only if the data in the shared data source is for general public consumption.

If you need to provide credentials automatically at run time, this can be done in code using the LocateCredentials event. For more information, see Credentials.

See Also

Shared DataSource Smart Panel | Report DataSource Smart Panel | Credentials


Dataset Smart Panel

You can access the Dataset smart panel by clicking the Add DataSet icon at the top of the Data Explorer, or by right-clicking an existing dataset and selecting Edit.

The Dataset smart panel contains the following pages:

  • General
  • Query
  • Options
  • Fields
  • Parameters
  • Filters
See Also

Data Explorer Smart Panels


Dataset General Page

The General page of the Dataset smart panel is where you can set or change the name of the dataset.

Name:
The name of the dataset is shown in the tree view of the Data Explorer. The name can also be used to call the dataset in code. This is the name you will use to choose which dataset to work with, and must be unique within the report.
See Also

Dataset Smart Panel | Data Explorer Smart Panels


Dataset Query Page

The Query page of the Dataset smart panel is where you can set or change the command type, the query string, and the timeout.

Command type:
You can choose from three enumerated command types.
Type | Description
Text | Choose Text if you want to write a SQL query to retrieve data.
StoredProcedure | Choose this if you want to use a stored procedure.
TableDirect | Choose TableDirect if you want to return all rows and columns from one or more tables.
Query string:
Write the SQL query that retrieves data from your data source here if your command type is Text; otherwise use the name of the stored procedure or the name of the table or tables.
Note: If you are using the TableDirect command type, you may need to use escape characters or qualifying characters if any of the table names include special characters. To choose multiple tables, use a comma-delimited list of table names without any spaces or padding.
Timeout:
Set the number of seconds that you want the report server to wait for the query to return your data before it stops trying.
See Also

Dataset Smart Panel | Data Explorer Smart Panels


Dataset Options Page

The Options page of the Dataset smart panel has five properties that you can set to control how your query is handled.

CaseSensitivity:
Set this value to Auto, True, or False to indicate whether distinctions are made between upper and lower case letters. Auto, the default value, causes the report server to get the value from the data provider. If the data provider does not set the value, the report runs without case sensitivity.
Collation:
Choose from Default, or a country from the list to indicate which collation sequence is used to sort the data. A value of Default causes the report server to get the value from the data provider. If the data provider does not set the value, the report uses the server locale. This is important with international data, as the sort order for different languages can be quite different from the machine sort.
KanaTypeSensitivity:
Set this value to Auto, True, or False with Japanese data to indicate whether distinctions are made between Hiragana and Katakana kana types. Auto, the default value, causes the report server to get the value from the data provider. If the data provider does not set the value, the report runs without kana type sensitivity.
WidthSensitivity:
Set this value to Auto, True, or False with Japanese data to indicate whether distinctions are made between single-byte (half-width) characters and double-byte (full-width) characters. Auto, the default value, causes the report server to get the value from the data provider. If the data provider does not set the value, the report runs without width sensitivity.
AccentSensitivity:
Set this value to Auto, True, or False to indicate whether distinctions are made between accented and unaccented letters. Auto, the default value, causes the report server to get the value from the data provider. If the data provider does not set the value, the report runs without accent sensitivity.
See Also

Dataset Smart Panel | Data Explorer Smart Panels


Dataset Fields Page

The Fields page of the Dataset smart panel is automatically populated based on the information you provide in the Query page. To see the Field Name, Type, and Value columns populated in the Fields page, first enter a valid query, table name, or stored procedure in the Query page.

You can edit the populated fields, move them up or down with the arrow buttons, delete them using the X button, or add new ones by scrolling to the bottom of the list and entering a new field name in the blank cell next to the asterisk (*). The field name must be unique within the dataset.

The Type of the field can be set to DatabaseField or CalculatedField. The Value of a DatabaseField must be the name of a field returned by the query, while the Value of a CalculatedField can be an expression. Any fields you add in this list show in the Report Explorer tree view and can be dragged onto reports like any other field.

See Also

Dataset Smart Panel | Dataset Query Page | Data Explorer Smart Panels


Dataset Parameters Page

The Parameters page of the Dataset smart panel is where you can pass a Report Parameter into the parameter you entered in the Query page. See the Parameters topic for more information on how this is done. Enter a Name (must match the name of the Report Parameter) and a Value for each parameter in this page.

You can edit the parameters, move them up or down using the arrow buttons, delete them using the X button, or add new ones by scrolling to the bottom of the list and entering a new parameter name in the blank cell next to the asterisk (*). The parameter name must be unique within the dataset.

The Value of a parameter can be a static value or an expression referring to an object within the report. The Value cannot refer to a report item or field.

See Also

Dataset Smart Panel | Data Explorer Smart Panels | Parameters

Tutorials: Walkthrough: Parameters


Dataset Filters Page

The Filters page of the Dataset smart panel allows you to filter data after it has been returned from the data source. This is useful when you have a data source (i.e. XML) that does not support query parameters.

There are three fields that you can use to create your filters, as well as one that is automatically populated.

Expression
Type or use the expression editor to provide the expression by which to filter the data.
Operator
Select the operator by which to compare the expression results with the Value.
Value
Enter the value with which to compare the expression results. For multiple values (used with the In and Between operators) separate values using commas.
See Also

Dataset Smart Panel | Data Explorer Smart Panels

Tutorials: Adding Filters


Report Menu Smart Panels

The following smart panels are the ones that you can access from the Report menu.

  • Report Parameters smart panel
  • Embedded Images smart panel
  • Report Properties smart panel
See Also

Smart Panel Guide | Layout View Smart Panels


Report Parameters Smart Panel

You can access the Report Parameters smart panel while in the Layout view of a report by opening the Report menu and choosing Report Parameters or by clicking the ellipsis button next to the ReportParameters (Collection) property of the report.

You can also access this by right-clicking in the area below the report, selecting Properties, and clicking the Parameters page.

The Report Parameters smart panel has two main sections: Parameters and Properties.

Parameters

The Parameters section displays a list of the current report parameters. Add parameters to match those in your query by clicking the Add icon. You can add, remove, or change the order of the parameters using the buttons.

Properties

The Properties section allows you to set specific properties for the selected parameter.

General Page

  • Name: The value you supply for this property appears in the parameters list and must match its corresponding query parameter.
  • Data type: This value dictates the type of interface presented to the user in addition to indicating the data type. This value must match the data type of the field.
    • Boolean: presents the user with a drop-down selection of True or False
    • DateTime: presents the user with a calendar picker if you do not supply a default value (see Values below) or a drop-down selection of available values
    • Integer: presents the user with a text box or a drop-down selection of available values
    • Float: presents the user with a text box or a drop-down selection of available values
    • String: presents the user with a text box or a drop-down selection of available values
  • Text for prompting users for a value: The value you supply for this property appears in the user interface to request information from the user. By default this is the same as the Name property.
  • Allow null value: Select this check box if you want to allow null values to be passed for the parameter. It is not selected by default.
  • Allow blank value: Select this check box if you want to allow blank values to be passed for the parameter. It is not selected by default.
  • Multivalue: Select this check box to allow the user to select multiple items in the available values list.
  • Hidden: Select this check box to hide the parameter interface from the user and instead provide a default value or pass in values from a subreport or drillthrough link.

Values Page

For each parameter in the list, you can provide a list of available values from which the user can select. Create a separate dataset to supply values for dataset parameters. You can also supply a default value. The Value is what is passed to the query parameter, and the Label is what is shown to the user. For example, if the Value is an employee number, you might want to supply a more user-friendly Label showing employee names.

  • Available values: These values are used to fill a drop-down list from which the end user can choose.
    • Non-queried: You can supply Labels and Values by typing in static values or using expressions.
    • From query: You can select a Dataset from which to select a Value field and Label field.
  • Default values: This is the value that you give for the parameter if the user does not supply one, or if you hide the parameter user interface.
    • Non-queried: You can supply a default Label and Value by entering a static value or using an expression.
    • From query: You can select a Dataset from which to select a Value field and Label field.
    • None: You can have your users provide a value for the parameter.
See Also

Layout View Smart Panels | Report Menu Smart Panels | Parameters


Embedded Images Smart Panel

You can access the Embedded Images smart panel from the Report menu, or by clicking the ellipsis button next to the EmbeddedImages property in the property grid for the report.

Images that you add using this smart panel are available for use within the report, and are (as the name implies) embedded into the report rather than called from an external source. You can add images to the embedded images collection using the Add button or by clicking in the empty box under Image and clicking the ellipsis button that appears.

Either action displays the Open file dialog, where you can navigate to any image you wish to select. Once you select an image file and click the Open button, a thumbnail of the image is displayed in the Image column, and the Name and MIME Type values are automatically populated in their respective columns.

Click the Accept icon to accept the changes and close the smart panel.

Once you have added images here, you will be able to use them with the image report item by setting the image's Source property to Embedded. Once that property is set, the Value property is populated with a list of embedded images.

See Also

Report Menu Smart Panels | Layout View Smart Panels | Images


Report Properties Smart Panel

You can access the Report Properties smart panel by right-clicking below the report and choosing Properties, or by opening the Report menu and selecting Report Properties. The Report Properties smart panel contains the following pages:

  • General
  • Appearance
  • Parameters
  • Images
  • References
  • Data Output
See Also

Layout View Smart Panels | Report Menu Smart Panels


Report General Page

The General page of the Report Properties smart panel allows you to control the following items:

  • Author: Enter the name of the report author here.
  • Description: Enter a description of the report here.
  • Draw grid: Clear this check box to remove the grid marks from the report design area.
  • Snap to grid: Clear this check box to allow free placement of report items on the report design area instead of the automatic alignment of report items with grid marks.
  • Grid spacing: Enter the spacing between grid marks in inches. The default value is 0.125 inches.
  • Page headers: these options are disabled if you have not added a Page Header to the Report.
    • Print on first page - Clear this check box to remove the page header from the first page of the report.
    • Print on last page -Clear this check box to remove the page header from the last page of the report.
  • Page footers: these options are disabled if you have not added a Page Footer to the Report.
    • Print on first page - Clear this check box to remove the page footer from the first page of the report.
    • Print on last page - Clear this check box to remove the page footer from the last page of the report.
  • Auto refresh: Select this check box to automatically refresh the pages of the report at regular intervals. When this check box is selected, you can supply the interval to use in seconds.
See Also

Report Properties Smart Panel | Report Menu Smart Panels


Report Appearance Page

The Appearance page of the Report Properties smart panel allows you to control the page layout for your report.

Columns

  • Number of columns: Enter the number of columns you want to use in your report.
  • Spacing: Enter the number of inches of space to use between columns.

Page Layout

  • Page width: Enter the number of inches to use for the width of the page.
  • Page height: Enter the number of inches to use for the height of the page.
  • Left margin: Enter the number of inches to use for the left margin.
  • Right margin: Enter the number of inches to use for the right margin.
  • Top margin: Enter the number of inches to use for the top margin.
  • Bottom margin: Enter the number of inches to use for the bottom margin.
See Also

Report Properties Smart Panel | Report General Page


Report References Page

The References page of the Report Properties smart panel allows you to add references to assemblies and classes so that you can call methods from them in expressions throughout your report. You can also access the References smart panel by selecting the Classes (Collection) or References (Collection) property of a report and clicking the ellipsis button that appears.

Assemblies

This is a list of the assemblies available for use in your report. You can delete assemblies using the Remove button, or add them using the Add button which presents the Open file dialog. You can then navigate to the assembly you want to add, select it, and press the Open button.

Note: Any assemblies you reference must be copied to the Data Dynamics Reports Assemblies folder (C:\Program Files\Data Dynamics\Reports\Build Number\Assemblies) on your development machine as well as on any server to which you deploy your reports.

To use code from referenced assemblies,

Classes

This is a list of instance-based classes you can create for use in your report.

  • Class name: Enter the namespace and name of the class here. (i.e. Invoicing.GetDueDate)
  • Instance name: Enter a name for the instance of the class here. (i.e. m_myGetDueDate)

To use code from these classes,

See Also

Report Properties Smart Panel | Custom Code

Tutorials: Walkthrough: Custom Code | Adding Code


Report Data Output Page

The Data Output page of the Report Properties smart panel allows you to control how the report's data is rendered in XML exports.

  • Element name: Enter the name you want to appear as the top level data element in your exported XML file.
  • Data transform: Enter the name of the XSL file you want to use as a style sheet for the exported XML file.
  • Data schema: Enter the schema or namespace to use for validating data types in the exported XML file.
  • Render textboxes as: Choose whether to render textboxes as Attributes or Elements in the exported XML file.
    • Attributes example:
      <table1 textbox3="Report created on: 7/26/2005 1:13:00 PM">
    • Elements example:
      <table1> <textbox3>Report created on: 7/26/2005 1:13:28 PM</textbox3>
See Also

Report Properties Smart Panel | Rendering to XML


Layout View Smart Panels

The following smart panels are the ones that you can access from the Layout view of a Data Dynamics Report.

  • Report Parameters smart panel
  • Embedded Images smart panel
  • Report Properties smart panel
  • Report References smart panel
  • Expression Editor smart panel
  • Report Item and Data Region smart panels
See Also

Smart Panel Guide | Data Explorer Smart Panels | Report Menu Smart Panels


Expression Editor Dialog

You can access the Expression Editor by selecting nearly any property of a report item or data region and choosing <Expression...> from the list.

The Expression Editor has two sections, Fields and Expression.

Fields

The Fields section of the Expression Editor displays all of the sources available to the report item for use in the expression. The treeview displays five categories of fields, as well as Operations and Common Functions.

  • Constants are available only for properties which have enumerated values.
  • Globals consist of the following globally available items:
    • PageNumber prints the current page number.
    • TotalPages prints the total number of pages in the report.
    • ExecutionTime prints the date and time at which the report is run.
    • ReportFolder prints the full path to the folder in which the report is saved.
    • ReportName prints the name of the report.
    • UserID prints the computer name\user name of the person running the report.
    • Language prints the short string value for the language and country of the current locale.
  • Parameters are populated if the report has a parameters collection.
  • Fields are populated if the report item is linked to a dataset.
  • Datasets are populated with any datasets associated with the report.

Expression

This section of the Expression Editor is where you create the expression. You can type the expression and replace, insert, or append fields from the Fields section to the left. For more information, see Expressions in the User Guide.

See Also

Layout View Smart Panels | Expressions


Report Item and Data Region Smart Panels

Each report item and data region in the Data Dynamics Reports toolbox has one or more associated smart panels.

  • Chart Data Region smart panel
  • Image Report Item smart panel
  • Line Report Item smart panel
  • List Data Region smart panel
  • Matrix Data Region smart panel
  • Rectangle Report Item smart panel
  • Subreport Report Item smart panel
  • Table Data Region smart panel
  • Textbox Report Item smart panel
  • BandedList Data Region smart panel
  • Barcode Properties smart panel
See Also

Layout View Smart Panels

Getting Started: Report Items | Data Regions


Chart Data Region Smart Panel

You can access the Chart smart panel by selecting a chart report item, right-clicking it, and choosing Properties. On the Home page of the smart panel, you can set the Name property and select from the other pages to access other properties.

Name: Type a name for the chart that is unique within the report. This name can be called in code.

The Chart smart panel has the following pages:

  • Chart Gallery
  • Data
  • Appearance
  • Chart Axes
  • Legend
See Also

Report Item and Data Region Smart Panels | Chart Appearance Chart Area Page | Chart Appearance Plot Area Page | Chart Data Values Page | Chart Legend General Page | Chart

Tutorials: Walkthrough: Charts


Chart Gallery Page

The Gallery page of the Chart smart panel allows you to choose whether to use a two-dimensional or three-dimensional style, and to select a chart type and sub-type.

See the Chart Types topic in the User Guide for more information on each type.

See Also

Chart Appearance Chart Area Page | Chart Appearance Plot Area Page | Chart Data Region Smart Panel | Report Item and Data Region Smart Panels | Chart


Chart Data Page

The Data page of the Chart smart panel allows you to control the following item:

  • Dataset name: Select a dataset to associate with the chart. The list is populated with all of the datasets in the report's dataset collection.

This page also gives you access to the following related pages:

  • Values
  • Category Groups
  • Series Groups
  • Filters
See Also

Chart Data Region Smart Panel | Report Item and Data Region Smart Panels | Chart

Tutorials: Walkthrough: Charts


Chart Data Values Page

Add at least one Value series to determine the size of the chart element. Click the Add button to open the General page. Once you have one or more value series in place, you can use the arrow buttons to change the order or the X button to delete them.

Another way to add Chart Data Values is to drag fields from the Data Explorer onto the tray along the top edge of the chart that reads "Drop data fields here."

If you have already added values, you can right-click any value displayed in the UI along the top of the chart and choose Edit to open this smart panel.

The Chart Data Values page has the following sub-pages:

  • General
  • Series Style
  • Data Markers
  • Point Labels
  • Action
  • Data Output
See Also

Chart Data Page | Chart Data Region Smart Panel | Report Item and Data Region Smart Panels | Chart

Tutorials: Walkthrough: Charts


Chart Data Values General Page

The General sub-page of the Chart Data Values page (or the Series Values smart panel if you open it by right-clicking a field in the tray along the top of the chart and selecting Edit) allows you to control different items depending on the Chart Type you have chosen.

All Chart Types

  • Label: Enter an expression to use as a series label to display in the legend.

Scatter or Bubble Chart Types

  • X: Enter an expression to use as an X value.
  • Y: Enter an expression to use as a Y value.
  • Size: If the chart type is bubble, enter an expression to use as the bubble size value.

Stock Chart Type

  • High: Enter an expression to use as the high value.
  • Low: Enter an expression to use as the low value.
  • Open: Enter an expression to use as the open value.
  • Close: Enter an expression to use as the close value.

Column, Bar, Line, Pie, Area, or Doughnut Chart Types

  • Value: Enter an expression to use as a series value.
Note: You can select <Expression...> in any of these properties to open the Expression Editor.
See Also

Chart Data Values Page | Chart Data Page | Expression Editor Dialog | Chart

Tutorials: Walkthrough: Charts


Chart Data Values Series Style Page

The Series Style sub-page of the Chart Data Values smart panel (or the Series Values smart panel if you open it by right-clicking a field in the tray along the top of the chart and selecting Edit) allows you to set the Border and Fill properties for the series.

Border

You can set the following properties to control the appearance of the border line drawn around the edges of the series in the chart:

  • Style: Choose one of the enumerated styles for the border.
  • Width: Choose a width value between 0.25pt and 6pt for the thickness of the border.
  • Color: Choose a Web or Custom color to use for the border line.

Fill

You can set the following properties to paint the background of the series:

  • Fill Color: Choose a Web or Custom color to fill the background of the series.
  • Gradient: Choose from one of the following gradient styles.
    • None: No gradient is used. A single color (defined by the Fill Color property above) is used to fill the area and the Gradient End Color property remains disabled.
    • LeftRight: A gradient is used. The Fill Color property defines the color at the left, and the Gradient End Color property defines the color at the right. The two colors are gradually blended in between these areas.
    • TopBottom: A gradient is used. The Fill Color property defines the color at the top, and the Gradient End Color property defines the color at the bottom. The two colors are gradually blended in between these areas.
    • Center: A gradient is used. The Fill Color property defines the color at the center, and the Gradient End Color property defines the color at the edges. The two colors are gradually blended in between these areas.
    • DiagonalLeft: A gradient is used. The Fill Color property defines the color at the top left, and the Gradient End Color property defines the color at the bottom right. The two colors are gradually blended in between these areas.
    • DiagonalRight: A gradient is used. The Fill Color property defines the color at the top right, and the Gradient End Color property defines the color at the bottom left. The two colors are gradually blended in between these areas.
    • HorizontalCenter: A gradient is used. The Gradient End Color property defines the horizontal band of color across the center, and the Fill Color property defines the color at the top and bottom. The two colors are gradually blended in between these areas.
    • VerticalCenter: A gradient is used. The Gradient End Color property defines the vertical band of color across the center, and the Fill Color property defines the color at the left and right. The two colors are gradually blended in between these areas.
  • Gradient End Color: When you choose any gradient style other than None, this property becomes available. Choose a Web or Custom color to blend with the Fill Color in the background of the series.
Note: You can select <Expression...> in any of these properties to open the Expression Editor.
See Also

Chart Data Values Page | Chart Data Region Smart Panel | Report Item and Data Region Smart Panels | Chart

Tutorials: Walkthrough: Charts


Chart Data Values Markers Page

The Markers sub-page of the Chart Data Values smart panel allows you to control the following items:

  • Marker type: Choose one of the following values to determine the shape of the marker or whether one is displayed.
    • None - Markers are not used. (Default)
    • Square - Markers are square.
    • Circle - Markers are circular.
    • Diamond - Markers are diamond shaped.
    • Triangle - Markers are triangular.
    • Cross - Markers are cross shaped.
    • Auto - A shape is chosen automatically.
  • Marker size: Enter a value between 2pt and 10pt to determine the size of the plotting area of the markers.
  • Plot data as line: If the chart type is column, you can select this check box to display lines instead of columns to show the data.
See Also

Chart Data Values Page | Chart Data Page | Chart Data Region Smart Panel | Report Item and Data Region Smart Panels | Chart

Tutorials: Walkthrough: Charts


Chart Data Values Point Labels Page

The Point Labels sub-page of the Chart Data Values smart panel allows you to control the following items:

  • Show point labels: Select this check box to display a label for each chart value. Selecting this box enables the rest of the properties on this page.
  • Data label: Enter a value to use as the label, or select <Expression...> to open the Expression Editor.
  • Format code: Select one of the provided format codes or use a custom .NET formatting code to format dates or numbers. For more information, see MSDN's Formatting Types topic.
  • Position: Leave Auto selected to use the default point label position for the chart type, or select an enumerated value to position the labels.
  • Angle: Enter the value in tenths of degrees to use for the angle of the point label text. The default (0°) position denotes no angle and renders regular horizontal text.
  • The Font section allows you to control the following aspects of the font for the point labels:
    • Family: Choose the font family name.
    • Size: Choose the size in points for the font.
    • Style: Choose Normal or Italic.
    • Weight: Choose from Lighter, Thin, ExtraLight, Light, Normal, Medium, SemiBold, Bold, ExtraBold, Heavy, and Bolder.
    • Color: Select a Web or custom color for the font.
    • Decoration: Choose from None, Underline, Overline, and LineThrough.
    Note: You can select <Expression...> within any of these properties to create an expression to determine the value, or you can select a theme to use.
See Also

Chart Data Values Page | Chart Data Page | Expression Editor Dialog | Report Item and Data Region Smart Panels | Chart


Chart Data Values Action Page

The Action sub-page of the Chart Data Values smart panel allows you to choose from the following actions to perform when the user clicks on the chart element:

  • None: The default behavior is to do nothing when a user clicks the chart element at run time.
  • Jump to report: For drill-through reporting, select this option and provide the name of a local report, the relative path of a report in another folder, or the full path of a report on another server.
    • Name: Supply the exact names of any parameters required for the targeted report. Note that parameter names you supply in this must match parameters in the target report.
      Note: The Parameter Name must exactly match the name of the parameter in the detail report. If any parameter is spelled differently, capitalized differently, or if an expected parameter is not supplied, the drill-through report will fail.
    • Value: Enter a Parameter Value to pass to the detail report. This value must evaluate to a valid value for the parameter.
    • Omit: Select this check box to omit this parameter from the report.
  • Jump to bookmark: Select this option and provide a valid Bookmark ID (see Bookmark ID in the Textbox Navigation page) to allow the user to jump to the report item with that Bookmark ID.
  • Jump to URL: Select this option and provide a valid URL to create a hyperlink to a Web page.
See Also

Chart Data Values Page | Chart Data Page | Report Item and Data Region Smart Panels | Chart | Hyperlinks | Bookmarks | Drill Through


Chart Data Values Data Output Page

The Data Output sub-page of the Chart Data Values smart panel allows you to control the following properties when you export to XML:

  • Element name: Enter a name to be used in the XML output for this chart element.
  • Output: Choose Yes or No to decide whether to include this chart element in the XML output.
See Also

Chart Data Values Page | Chart Data Page | Report Item and Data Region Smart Panels | Chart | Rendering to XML


Chart Data Category Groups Page

Add Category Groups to group data and provide labels for the chart elements. Click the Add button to open the General page. Once you have one or more category groups in place, you can use the arrow buttons to change the order or the X button to delete them.

Another way to add Category Groups is to drag fields from the Data Explorer onto the tray along the bottom edge of the chart that reads "Drop category fields here."

If you have already added values, you can right-click the value displayed in the UI along the bottom of the chart and choose Edit to open this smart panel.

The Chart Data Category Groups smart panel has the following pages:

  • General
  • Filters
  • Sorting
  • Data Output
See Also

Chart Data Region Smart Panel | Report Item and Data Region Smart Panels | Chart Data Page | Chart


Chart Category Group General Page

The General sub-page of the Category Groups smart panel allows you to control the following items:

  • Name: Enter a name for the group that is unique within the report. This name can be called in code.
  • Group on: Enter an expression to use for grouping the data.
  • Label: Enter an expression to use as a label for the group. You can select <Expression...> to open the Expression Editor.
  • Parent group: For use in recursive hierarchies. Enter an expression to use as the parent group.
See Also

Chart Data Page | Expression Editor Dialog | Expressions | Grouping and Sorting Data


Chart Category Group Filters Page

The Filters sub-page of the Chart Category Groups smart panel allows you to control the Filter grid collection for the group. Use the arrow and X buttons to move or delete filters. You need to provide three values to add a new filter to the collection:

  • Expression: Enter the expression to use for evaluating whether data should be included in the group.
  • Operator: Select from the following operators to decide how to compare the expression to the left with the value to the right:
    • = Select this operator if you want to choose only data for which the value on the left is equal to the value on the right.
    • Like Select this operator if you want to choose data for which the value on the left is similar to the value on the right. For more information on using the Like operator, see the MSDN Web site.
    • != Select this operator if you want to choose only data for which the value on the left is not equal to the value on the right.
    • > Select this operator if you want to choose only data for which the value on the left is greater than the value on the right.
    • >= Select this operator if you want to choose only data for which the value on the left is greater than or equal to the value on the right.
    • < Select this operator if you want to choose only data for which the value on the left is less than the value on the right.
    • <= Select this operator if you want to choose only data for which the value on the left is less than or equal to the value on the right.
    • Top N Select this operator if you want to choose only items from the value on the left which are the top number specified in the value on the right.
    • Bottom N Select this operator if you want to choose only items from the value on the left which are the bottom number specified in the value on the right.
    • Top % Select this operator if you want to choose only items from the value on the left which are the top percent specified in the value on the right.
    • Bottom % Select this operator if you want to choose only items from the value on the left which are the bottom percent specified in the value on the right.
    • In Select this operator if you want to choose only items from the value on the left which are in the array of values specified on the right. Values on the right are separated by commas.
    • Between Select this operator if you want to choose only items from the value on the left which fall between the pair of values you specify on the right. Values on the right are separated by commas.
  • Value: Enter a value to compare with the expression on the left based on the selected operator. For multiple values (used with the In and Between operators) separate values using commas.
See Also

Chart Data Page | Chart Data Region Smart Panel | Chart | Filters


Chart Category Group Sorting Page

The Sorting sub-page of the Chart Category Groups smart panel allows you to enter new sort expressions and remove or change the order of them using the X or arrow buttons. For each sort expression in this list, you can also choose the direction.

In the Expression column, enter an expression by which to sort the data in the group.

In the Direction column, select whether you want to sort the data in an Ascending or Descending direction.

See Also

Chart Data Page | Chart | Grouping and Sorting Data | Report Item and Data Region Smart Panels

Tutorials: Sorting


Chart Category Group Data Output Page

The Data Output page of the Chart Category Groups smart panel allows you to control the following properties when you export to XML:

  • Element name: Enter a name to be used in the XML output for this group.
  • Collection: Enter a name to be used in the XML output for the collection of all instances of this group.
  • Output: Choose Yes or No to decide whether to include this group in the XML output.
See Also

Chart Data Page | Report Item and Data Region Smart Panels | Chart | Rendering to XML


Chart Data Series Groups Page

Optionally add Series Groups for extra levels of data (i.e. Orders by Country can be broken down by year as well). Labels for the series are displayed in the chart legend. Click the Add button to open the General page. Once you have one or more series groups in place, you can use the arrow buttons to change the order or the X button to delete them.

Another way to add Series Groups is to drag fields from the Data Explorer onto the tray along the right edge of the chart that reads "Optionally drop series fields here."

If you have already added values, you can right-click the value displayed in the UI along the right edge of the chart and choose Edit to open this smart panel.

The Chart Data Series Groups smart panel has the following pages:

  • General
  • Filters
  • Sorting
  • Data Output
See Also

Chart Data Region Smart Panel | Report Item and Data Region Smart Panels | Chart


Chart Series Group General Page

The General sub-page of the Chart Series Groups smart panel allows you to control the following items:

  • Name: Enter a name for the group that is unique within the report. This name can be called in code.
  • Group on: Enter an expression to use for grouping the data.
  • Label: Enter an expression to use as a label for the group. You can select <Expression...> to open the Expression Editor.
  • Parent group: For use in recursive hierarchies. Enter an expression to use as the parent group.
See Also

Chart Data Page | Expression Editor Dialog | Expressions | Grouping and Sorting Data


Chart Series Group Filters Page

The Filters sub-page of the Chart Series Groups smart panel allows you to control the Filter grid collection for the group. Use the arrow and X buttons to move or delete filters. You need to provide three values to add a new filter to the collection:

  • Expression: Enter the expression to use for evaluating whether data should be included in the group.
  • Operator: Select from the following operators to decide how to compare the expression to the left with the value to the right:
    • = Select this operator if you want to choose only data for which the value on the left is equal to the value on the right.
    • Like Select this operator if you want to choose data for which the value on the left is similar to the value on the right. For more information on using the Like operator, see the MSDN Web site.
    • != Select this operator if you want to choose only data for which the value on the left is not equal to the value on the right.
    • > Select this operator if you want to choose only data for which the value on the left is greater than the value on the right.
    • >= Select this operator if you want to choose only data for which the value on the left is greater than or equal to the value on the right.
    • < Select this operator if you want to choose only data for which the value on the left is less than the value on the right.
    • <= Select this operator if you want to choose only data for which the value on the left is less than or equal to the value on the right.
    • Top N Select this operator if you want to choose only items from the value on the left which are the top number specified in the value on the right.
    • Bottom N Select this operator if you want to choose only items from the value on the left which are the bottom number specified in the value on the right.
    • Top % Select this operator if you want to choose only items from the value on the left which are the top percent specified in the value on the right.
    • Bottom % Select this operator if you want to choose only items from the value on the left which are the bottom percent specified in the value on the right.
    • In Select this operator if you want to choose only items from the value on the left which are in the array of values specified on the right. Values on the right are separated by commas.
    • Between Select this operator if you want to choose only items from the value on the left which fall between the pair of values you specify on the right. Values on the right are separated by commas.
  • Value: Enter a value to compare with the expression on the left based on the selected operator. For multiple values (used with the In and Between operators) separate values using commas.
See Also

Chart Data Page | Chart Data Region Smart Panel | Chart | Filters


Chart Series Group Sorting Page

The Sorting sub-page of the Chart Series Groups smart panel allows you to enter new sort expressions and remove or change the order of them using the X or arrow buttons. For each sort expression in this list, you can also choose the direction.

In the Expression column, enter an expression by which to sort the data in the group.

In the Direction column, select whether you want to sort the data in an Ascending or Descending direction.

See Also

Chart Data Page | Chart | Grouping and Sorting Data | Report Item and Data Region Smart Panels

Tutorials: Sorting


Chart Series Group Data Output Page

The Data Output page of the Chart Series Groups smart panel allows you to control the following properties when you export to XML:

  • Element name: Enter a name to be used in the XML output for this group.
  • Collection: Enter a name to be used in the XML output for the collection of all instances of this group.
  • Output: Choose Yes or No to decide whether to include this group in the XML output.
See Also

Chart Data Page | Report Item and Data Region Smart Panels | Chart | Rendering to XML


Chart Data Filters Page

The Filters page of the Chart Data smart panel allows you to control the Filter grid collection for the chart. Use the arrow and X buttons to move or delete filters. You need to provide three values to add a new filter to the collection:

  • Expression: Enter the expression to use for evaluating whether data should be included in the group.
  • Operator: Select from the following operators to decide how to compare the expression to the left with the value to the right:
    • = Select this operator if you want to choose only data for which the value on the left is equal to the value on the right.
    • Like Select this operator if you want to choose data for which the value on the left is similar to the value on the right. For more information on using the Like operator, see the MSDN Web site.
    • != Select this operator if you want to choose only data for which the value on the left is not equal to the value on the right.
    • > Select this operator if you want to choose only data for which the value on the left is greater than the value on the right.
    • >= Select this operator if you want to choose only data for which the value on the left is greater than or equal to the value on the right.
    • < Select this operator if you want to choose only data for which the value on the left is less than the value on the right.
    • <= Select this operator if you want to choose only data for which the value on the left is less than or equal to the value on the right.
    • Top N Select this operator if you want to choose only items from the value on the left which are the top number specified in the value on the right.
    • Bottom N Select this operator if you want to choose only items from the value on the left which are the bottom number specified in the value on the right.
    • Top % Select this operator if you want to choose only items from the value on the left which are the top percent specified in the value on the right.
    • Bottom % Select this operator if you want to choose only items from the value on the left which are the bottom percent specified in the value on the right.
    • In Select this operator if you want to choose only items from the value on the left which are in the array of values specified on the right. Values on the right are separated by commas.
    • Between Select this operator if you want to choose only items from the value on the left which fall between the pair of values you specify on the right. Values on the right are separated by commas.
  • Value: Enter a value to compare with the expression on the left based on the selected operator. For multiple values (used with the In and Between operators) separate values using commas.
See Also

Chart Data Page | Chart Data Region Smart Panel | Chart | Filters


Chart Appearance Page

The Appearance page of the Chart smart panel gives you access to the following pages:

  • Title
  • Palette
  • Chart Area
  • Plot Area
  • 3D Effect
See Also

Chart Data Region Smart Panel | Chart


Chart Appearance Title Page

The Title page of the Chart Appearance smart panel allows you to control the following aspects of the title displayed at the top of the chart.

  • Chart title: Enter the text to use for the title.

Font

  • Family: Choose the font family name.
  • Size: Choose the size in points for the font.
  • Style: Choose Normal or Italic.
  • Weight: Choose from Lighter, Thin, ExtraLight, Light, Normal, Medium, SemiBold, Bold, ExtraBold, Heavy, and Bolder.
  • Color: Select a Web or custom color for the font.
  • Decoration: Choose from None, Underline, Overline, and LineThrough.
Note: You can select <Expression...> within any of these properties to create an expression to determine the value, or you can select a theme to use.
See Also

Chart Data Region Smart Panel | Chart Appearance Page | Report Item and Data Region Smart Panels | Chart


Chart Appearance Palette Page

The Palette page of the Chart Appearance smart panel allows you to select an enumerated palette of colors to use for the chart.

  • Default: A palette of rich jewel tones.
  • EarthTones: A palette of autumnal browns, oranges, and greens.
  • Excel: A palette of muted plums, blues, and creams.
  • GrayScale: A palette of patterns suitable for printing to a black and white printer.
  • Light: A palette of pale pinks and peaches.
  • Pastel: A palette of blues, greens, and purples.
  • SemiTransparent: A palette of primary and tertiary colors that allows the backdrop to show through.
See Also

Chart Data Region Smart Panel | Chart Appearance Page | Chart


Chart Appearance Chart Area Page

The Chart Area page of the Chart Appearance smart panel allows you to set style properties on the Border and Fill of the chart area.

Border

  • Style: Choose from one of the following enumerated styles for the border.
    • None
    • Solid
    • Dotted
    • Dashed
  • Width: Choose a width value between 0.25pt and 6pt.
  • Color: Select a Web or Custom color.

Fill

  • Fill Color: Select a Web or Custom color.
  • Gradient: Choose from one of the following gradient styles.
    • None: No gradient is used. The Fill Color is used to fill the area and the Gradient End Color property is ignored.
    • LeftRight: A gradient is used. The Fill Color property defines the color at the left, and the Gradient End Color property defines the color at the right. The two colors are gradually blended in between these areas.
    • TopBottom: A gradient is used. The Fill Color property defines the color at the top, and the Gradient End Color property defines the color at the bottom. The two colors are gradually blended in between these areas.
    • Center: A gradient is used. The Fill Color property defines the color at the center, and the Gradient End Color property defines the color at the edges. The two colors are gradually blended in between these areas.
    • DiagonalLeft: A gradient is used. The Fill Color property defines the color at the top left, and the Gradient End Color property defines the color at the bottom right. The two colors are gradually blended in between these areas.
    • DiagonalRight: A gradient is used. The Fill Color property defines the color at the top right, and the Gradient End Color property defines the color at the bottom left. The two colors are gradually blended in between these areas.
    • HorizontalCenter: A gradient is used. The Gradient End Color property defines the horizontal band of color across the center, and the Fill Color property defines the color at the top and bottom. The two colors are gradually blended in between these areas.
    • VerticalCenter: A gradient is used. The Gradient End Color property defines the vertical band of color across the center, and the Fill Color property defines the color at the left and right. The two colors are gradually blended in between these areas.
  • Gradient End Color: When you choose any gradient style other than None, this property becomes available. Choose a Web or Custom color.
Note: You can select <Expression...> within any of these properties to create an expression to determine the value, or you can select a theme to use.
See Also

Chart Data Region Smart Panel | Chart | Chart Appearance Page


Chart Appearance Plot Area Page

The Plot Area page of the Chart Appearance smart panel allows you to set style properties on the Border and Fill of the plot area.

Border

  • Style: Choose from one of the following enumerated styles for the border.
    • None
    • Solid
    • Dotted
    • Dashed
  • Width: Choose a width value between 0.25pt and 6pt.
  • Color: Select a Web or Custom color.

Fill

  • Fill Color: Select a Web or Custom color.
  • Gradient: Choose from one of the following gradient styles.
    • None: No gradient is used. The Fill Color is used to fill the area and the Gradient End Color property is ignored.
    • LeftRight: A gradient is used. The Fill Color property defines the color at the left, and the Gradient End Color property defines the color at the right. The two colors are gradually blended in between these areas.
    • TopBottom: A gradient is used. The Fill Color property defines the color at the top, and the Gradient End Color property defines the color at the bottom. The two colors are gradually blended in between these areas.
    • Center: A gradient is used. The Fill Color property defines the color at the center, and the Gradient End Color property defines the color at the edges. The two colors are gradually blended in between these areas.
    • DiagonalLeft: A gradient is used. The Fill Color property defines the color at the top left, and the Gradient End Color property defines the color at the bottom right. The two colors are gradually blended in between these areas.
    • DiagonalRight: A gradient is used. The Fill Color property defines the color at the top right, and the Gradient End Color property defines the color at the bottom left. The two colors are gradually blended in between these areas.
    • HorizontalCenter: A gradient is used. The Gradient End Color property defines the horizontal band of color across the center, and the Fill Color property defines the color at the top and bottom. The two colors are gradually blended in between these areas.
    • VerticalCenter: A gradient is used. The Gradient End Color property defines the vertical band of color across the center, and the Fill Color property defines the color at the left and right. The two colors are gradually blended in between these areas.
  • Gradient End Color: When you choose any gradient style other than None, this property becomes available. Choose a Web or Custom color.
Note: You can select <Expression...> within any of these properties to create an expression to determine the value, or you can select a theme to use.
See Also

Chart Data Region Smart Panel | Chart Appearance Page | Chart


Chart Appearance 3D Effect Page

The 3D Effect page of the Chart Appearance smart panel allows you to control the following items:

  • Display the chart with 3D visual effects: Select this check box to enable all of the following properties.
  • Horizontal rotation: Move the slider to rotate the chart to left and right. All the way to the left (-90°) shows the chart from the left side, while all the way to the right (90°) shows it from the right side. The default value is 20°.
  • Vertical rotation: Move the slider to rotate the chart up and down. All the way to the left (-90°) shows the chart from the bottom, while all the way to the right (90°) shows it from the top. The default value is 20°.
  • Wall thickness: Move the slider to change the thickness of the walls at the axes. The default value is 0% and the range of values is 0% (left) to 100% (right). If the chart type is pie or doughnut, this property is ignored.
  • Perspective: Move the slider to change the perspective from which the chart is displayed. The default value is 0% and the range of values is 0% (left) to 100% (right). If you select Orthographic Projection, this property is ignored.
  • Orthographic Projection: Select this check box to use orthographic or "true drawing" projection. This type of projection is ignored with pie and doughnut chart types.
  • Shading: Select the type of shading to apply to the chart. The default value is Simple.
    • None: Colors are uniform.
    • Simple: Colors are darkened in areas where the light source does not hit them.
    • Realistic: Colors are darkened in areas where the light source does not hit them, and lightened in areas where the light source is strongest.
  • Clustered: With chart types of bar and column, select this check box to cluster series groups. Other chart types ignore this setting.
  • Display bars as cylinders: With chart types of bar and column, select this check box to display cylinders instead of bars or columns.
  • Defaults button: Click this button when you want to set all of the 3D effect properties back to their default values.
See Also

Chart Data Region Smart Panel | Report Item and Data Region Smart Panels | Chart Appearance Page | Chart


Chart Axes Page

The Chart Axes page of the Chart smart panel gives you access to the X and Y axes of the chart.

  • Chart X Axis page
  • Chart Y Axis page
See Also

Chart Data Region Smart Panel | Report Item and Data Region Smart Panels | Chart


Chart X Axis Page

The X Axis page of the Chart Axes smart panel (disabled if your chart type is doughnut or pie) gives you access to the following pages:

  • Title
  • Labels
  • Major Grid Lines
  • Minor Grid Lines
  • Scale
  • Other
See Also

Chart Data Region Smart Panel | Report Item and Data Region Smart Panels | Chart


Chart X Axis Title Page

The Title page of the Chart X Axis smart panel allows you to control the following aspects of the title displayed along the X axis of the chart.

  • X-Axis title: Enter text to display near the X axis of the chart.
  • Text alignment: Choose Center, Near, or Far.

Font

  • Family: Choose the font family name.
  • Size: Choose the size in points for the font.
  • Style: Choose Normal or Italic.
  • Weight: Choose from Lighter, Thin, ExtraLight, Light, Normal, Medium, SemiBold, Bold, ExtraBold, Heavy, and Bolder.
  • Color: Select a Web or custom color for the font.
  • Decoration: Choose from None, Underline, Overline, and LineThrough.
Note: You can select <Expression...> within any of these properties to create an expression to determine the value, or you can select a theme to use.
See Also

Chart X Axis Page | Chart Data Region Smart Panel | Chart


Chart X Axis Labels Page

The Labels page of the Chart X Axis smart panel allows you to control whether and how to display labels along the X axis of the chart.

  • Show x-axis labels: Select this check box to show labels along the X axis and to enable the rest of the properties on this page.
  • Format code: Select a format code from the list or use a custom .NET formatting code to format dates or numbers. For more information, see MSDN's Formatting Types topic.

Font

  • Family: Choose the font family name.
  • Size: Choose the size in points for the font.
  • Style: Choose Normal or Italic.
  • Weight: Choose from Lighter, Thin, ExtraLight, Light, Normal, Medium, SemiBold, Bold, ExtraBold, Heavy, and Bolder.
  • Color: Select a Web or custom color for the font.
  • Decoration: Choose from None, Underline, Overline, and LineThrough.
Note: You can select <Expression...> within any of these properties to create an expression to determine the value, or you can select a theme to use.
See Also

Chart X Axis Page | Chart Data Region Smart Panel | Chart


Chart X Axis Major Grid Lines Page

The Major Grid Lines page of the Chart X Axis smart panel allows you to control whether and how to display major grid lines for the X axis of the chart.

  • Show major grid lines: Select this check box to show grid lines for the X axis.
  • Interval: Set the interval at which you want to show major grid lines or tick marks or both.

Font

Setting these properties also affects the style of major tick marks.

  • Family: Choose the font family name.
  • Size: Choose the size in points for the font.
  • Style: Choose Normal or Italic.
  • Weight: Choose from Lighter, Thin, ExtraLight, Light, Normal, Medium, SemiBold, Bold, ExtraBold, Heavy, and Bolder.
  • Color: Select a Web or custom color for the font.
  • Decoration: Choose from None, Underline, Overline, and LineThrough.

Tick mark: Choose one of the following values to determine whether and where to display major tick marks. The style and interval of the tick marks are set with the above properties.

  • None: No tick mark is displayed.
  • Inside: Tick marks are displayed inside the X axis.
  • Outside: Tick marks are displayed outside the X axis.
  • Cross: Tick marks are displayed crossing the X axis.

Note: You can select <Expression...> within any of the Font properties to create an expression to determine the value, or you can select a theme to use.
See Also

Chart X Axis Page | Chart Data Region Smart Panel | Chart


Chart X Axis Minor Grid Lines Page

The Minor Grid Lines page of the Chart X Axis smart panel allows you to control whether and how to display minor grid lines for the X axis of the chart.

  • Show minor grid lines: Select this check box to show minor grid lines for the X axis.
  • Interval: Set the interval at which you want to show minor grid lines or tick marks or both.

Font

  • Family: Choose the font family name.
  • Size: Choose the size in points for the font.
  • Style: Choose Normal or Italic.
  • Weight: Choose from Lighter, Thin, ExtraLight, Light, Normal, Medium, SemiBold, Bold, ExtraBold, Heavy, and Bolder.
  • Color: Select a Web or custom color for the font.
  • Decoration: Choose from None, Underline, Overline, and LineThrough.

Tick mark: Choose one of the following values to determine whether and where to display minor tick marks. The style and interval of the tick marks are set with the above properties.

  • None: No tick mark is displayed.
  • Inside: Tick marks are displayed inside the X axis.
  • Outside: Tick marks are displayed outside the X axis.
  • Cross: Tick marks are displayed crossing the X axis.

Note: You can select <Expression...> within any of these properties to create an expression to determine the value, or you can select a theme to use.
See Also

Chart X Axis Page | Chart Data Region Smart Panel | Chart


Chart X Axis Scale Page

The Scale page of the Chart X Axis smart panel allows you to set the minimum and maximum values to use in the X axis. These values only take effect when you select the Numeric or time scale values check box.

  • Minimum: Leave this value blank to allow the data to determine the minimum value to use.
  • Maximum: Leave this value blank to allow the data to determine the maximum value to use.
  • Logarithmic scale: Select this check box to display X axis data as a percentage of change instead of as absolute arithmetic values.
  • Numeric or time scale values: Select this check box to indicate that the data on the X axis is scalar so that the chart fills in missing numbers or dates between data values.
See Also

Chart X Axis Page | Chart Data Region Smart Panel | Chart


Chart X Axis Other Page

The Other page of the Chart X Axis smart panel allows you to set properties that determine the behavior of the X axis.

  • Cross at: Leave this value blank to allow the chart type to determine where the X axis should cross the Y axis, or you can enter a custom value. You must select the Numeric or time scale values check box on the Scale page for a custom value to take effect.
  • Side margins: Select this check box to add padding between the data and the edges of the chart.
  • Interlaced strips: Select this check box to display alternating light and dark strips between major intervals specified on the Major Grid Lines page. If none are specified, a default value of 1 is used.
  • Reversed: Select this check box to reverse the direction of the chart. This will have different effects depending on chart type.
See Also

Chart X Axis Scale Page | Chart X Axis Major Grid Lines Page | Chart X Axis Page | Report Item and Data Region Smart Panels | Chart


Chart Y Axis Page

The Y Axis page of the Chart Axes smart panel (disabled if your chart type is doughnut or pie) gives you access to the following pages:

  • Title
  • Labels
  • Major Grid Lines
  • Minor Grid Lines
  • Scale
  • Other
See Also

Chart Data Region Smart Panel | Report Item and Data Region Smart Panels


Chart Y Axis Title Page

The Title page of the Chart Y Axis smart panel allows you to control the following aspects of the title displayed along the Y axis of the chart.

  • Y-Axis title: Enter text to display near the Y axis of the chart.
  • Text alignment: Choose Center, Near, or Far.

Font

  • Family: Choose the font family name.
  • Size: Choose the size in points for the font.
  • Style: Choose Normal or Italic.
  • Weight: Choose from Lighter, Thin, ExtraLight, Light, Normal, Medium, SemiBold, Bold, ExtraBold, Heavy, and Bolder.
  • Color: Select a Web or custom color for the font.
  • Decoration: Choose from None, Underline, Overline, and LineThrough.
Note: You can select <Expression...> within any of these properties to create an expression to determine the value, or you can select a theme to use.
See Also

Chart Y Axis Page | Report Item and Data Region Smart Panels | Chart


Chart Y Axis Labels Page

The Labels page of the Chart Y Axis smart panel allows you to control whether and how to display labels along the Y axis of the chart.

  • Show y-axis labels: Select this check box to show labels along the Y axis and to enable the rest of the properties on this page.
  • Format code: Select a format code from the list or use a custom .NET formatting code to format dates or numbers. For more information, see MSDN's Formatting Types topic.

Font

  • Family: Choose the font family name.
  • Size: Choose the size in points for the font.
  • Style: Choose Normal or Italic.
  • Weight: Choose from Lighter, Thin, ExtraLight, Light, Normal, Medium, SemiBold, Bold, ExtraBold, Heavy, and Bolder.
  • Color: Select a Web or custom color for the font.
  • Decoration: Choose from None, Underline, Overline, and LineThrough.
Note: You can select <Expression...> within any of these properties to create an expression to determine the value, or you can select a theme to use.
See Also

Chart Y Axis Page | Report Item and Data Region Smart Panels | Chart


Chart Y Axis Major Grid Lines Page

The Major Grid Lines page of the Chart Y Axis smart panel allows you to control whether and how to display major grid lines for the Y axis of the chart.

  • Show major grid lines: Select this check box to show grid lines for the Y axis.
  • Interval: Set the interval at which you want to show major grid lines or tick marks or both.

Font

Setting these properties also affects the style of major tick marks.

  • Family: Choose the font family name.
  • Size: Choose the size in points for the font.
  • Style: Choose Normal or Italic.
  • Weight: Choose from Lighter, Thin, ExtraLight, Light, Normal, Medium, SemiBold, Bold, ExtraBold, Heavy, and Bolder.
  • Color: Select a Web or custom color for the font.
  • Decoration: Choose from None, Underline, Overline, and LineThrough.

Tick mark: Choose one of the following values to determine whether and where to display major tick marks. The style and interval of the tick marks are set with the above properties.

  • None: No tick mark is displayed.
  • Inside: Tick marks are displayed inside the Y axis.
  • Outside: Tick marks are displayed outside the Y axis.
  • Cross: Tick marks are displayed crossing the Y axis.

Note: You can select <Expression...> within any of the Font properties to create an expression to determine the value, or you can select a theme to use.
See Also

Chart Y Axis Page | Chart Data Region Smart Panel | Chart


Chart Y Axis Minor Grid Lines Page

The Minor Grid Lines page of the Chart Y Axis smart panel allows you to control whether and how to display minor grid lines for the Y axis of the chart.

  • Show minor grid lines: Select this check box to show minor grid lines for the Y axis.
  • Interval: Set the interval at which you want to show minor grid lines or tick marks or both.

Font

  • Family: Choose the font family name.
  • Size: Choose the size in points for the font.
  • Style: Choose Normal or Italic.
  • Weight: Choose from Lighter, Thin, ExtraLight, Light, Normal, Medium, SemiBold, Bold, ExtraBold, Heavy, and Bolder.
  • Color: Select a Web or custom color for the font.
  • Decoration: Choose from None, Underline, Overline, and LineThrough.

Tick mark: Choose one of the following values to determine whether and where to display minor tick marks. The style and interval of the tick marks are set with the above properties.

  • None: No tick mark is displayed.
  • Inside: Tick marks are displayed inside the Y axis.
  • Outside: Tick marks are displayed outside the Y axis.
  • Cross: Tick marks are displayed crossing the Y axis.

Note: You can select <Expression...> within any of these properties to create an expression to determine the value, or you can select a theme to use.
See Also

Chart Y Axis Page | Chart Data Region Smart Panel | Chart


Chart Y Axis Scale Page

The Scale page of the Chart Y Axis smart panel allows you to set the minimum and maximum values to use in the Y axis. These values only take effect when you select the Numeric or time scale values check box.

  • Minimum: Leave this value blank to allow the data to determine the minimum value to use.
  • Maximum: Leave this value blank to allow the data to determine the maximum value to use.
  • Logarithmic scale: Select this check box to display Y axis data as a percentage of change instead of as absolute arithmetic values.
  • Numeric or time scale values: Select this check box to indicate that the data on the Y axis is scalar so that the chart fills in missing numbers or dates between data values.
See Also

Chart Y Axis Page | Report Item and Data Region Smart Panels | Chart


Chart Y Axis Other Page

The Other page of the Chart Y Axis smart panel allows you to set properties that determine the behavior of the Y axis.

  • Cross at: Leave this value blank to allow the chart type to determine where the Y axis should cross the X axis, or you can enter a custom value. You must select the Numeric or time scale values check box on the Scale page for a custom value to take effect.
  • Side margins: Select this check box to add padding between the data and the edges of the chart.
  • Interlaced strips: Select this check box to display alternating light and dark strips between major intervals specified on the Major Grid Lines page. If none are specified, a default value of 1 is used.
  • Reversed: Select this check box to reverse the direction of the chart. This will have different effects depending on chart type.
See Also

Chart Y Axis Page | Report Item and Data Region Smart Panels | Chart


Chart Legend Page

The Legend page of the Chart smart panel gives you access to the General and Style pages.

  • General
  • Style
See Also

Chart Data Region Smart Panel | Report Item and Data Region Smart Panels | Chart


Chart Legend General Page

The General page of the Chart Legend smart panel allows you to control whether and where to display a legend for the chart.

  • Show chart legend: Clear this check box to disable the legend. This also disables all of the other properties on this page.
  • Layout: Choose the layout style for the legend.
    • Column: This option displays legend items in a single vertical column.
    • Row: This option displays legend items in a single horizontal row.
    • Table: This option displays legend items in a table of vertical columns, and is best when you have a large number of values.
  • Position: Select an enumerated value to determine the position of the legend relative to the chart area. The default value is RightCenter.
  • Display legend inside plot area: Select this check box to display the legend inside the plot area along with your data elements.
See Also

Chart Legend Page | Chart Data Region Smart Panel | Chart


Chart Legend Style Page

The Style page of the Chart Legend smart panel allows you to control the Font, Border, and Fill properties for the legend.

Font

  • Family: Choose the font family name.
  • Size: Choose the size in points for the font.
  • Style: Choose Normal or Italic.
  • Weight: Choose from Lighter, Thin, ExtraLight, Light, Normal, Medium, SemiBold, Bold, ExtraBold, Heavy, and Bolder.
  • Color: Select a Web or custom color for the font.
  • Decoration: Choose from None, Underline, Overline, and LineThrough.

Border

  • Style: Choose from one of the following enumerated styles for the border.
    • None
    • Solid
    • Dotted
    • Dashed
  • Width: Enter a width value between 0.25pt and 6pt.
  • Color: Select a Web or Custom color.

Fill

  • Fill Color: Select a Web or Custom color.
  • Gradient: Choose from one of the following gradient styles.
    • None: No gradient is used. The Fill Color is used to fill the area and the Gradient End Color property is ignored.
    • LeftRight: A gradient is used. The Fill Color property defines the color at the left, and the Gradient End Color property defines the color at the right. The two colors are gradually blended in between these areas.
    • TopBottom: A gradient is used. The Fill Color property defines the color at the top, and the Gradient End Color property defines the color at the bottom. The two colors are gradually blended in between these areas.
    • Center: A gradient is used. The Fill Color property defines the color at the center, and the Gradient End Color property defines the color at the edges. The two colors are gradually blended in between these areas.
    • DiagonalLeft: A gradient is used. The Fill Color property defines the color at the top left, and the Gradient End Color property defines the color at the bottom right. The two colors are gradually blended in between these areas.
    • DiagonalRight: A gradient is used. The Fill Color property defines the color at the top right, and the Gradient End Color property defines the color at the bottom left. The two colors are gradually blended in between these areas.
    • HorizontalCenter: A gradient is used. The Gradient End Color property defines the horizontal band of color across the center, and the Fill Color property defines the color at the top and bottom. The two colors are gradually blended in between these areas.
    • VerticalCenter: A gradient is used. The Gradient End Color property defines the vertical band of color across the center, and the Fill Color property defines the color at the left and right. The two colors are gradually blended in between these areas.
  • Gradient End Color: When you choose any gradient style other than None, this property becomes available. Choose a Web or Custom color.
Note: You can select <Expression...> within any of these properties to create an expression to determine the value, or you can select a theme to use.
See Also

Chart Legend General Page | Chart Legend Page | Expression Editor Dialog | Report Item and Data Region Smart Panels | Chart


Image Report Item Smart Panel

You can access the Image Report Item smart panel by right-clicking an image report item and choosing Properties. The Image smart panel has the following pages:

  • General
  • Visibility
  • Navigation
See Also

Report Item and Data Region Smart Panels | Images


Image General Page

The General page of the Image smart panel allows you to control the following items:

  • Name: Enter a name for the image that is unique within the report. This name can be called in code.
  • Tooltip: Enter a string or expression that you want to appear when a user hovers the cursor over the image in the viewer at run time.
  • Repeat report item with data region on every page: Select this check box to display the image on every page on which the selected data region continues.
    • Data Region: Select the data region with which to repeat the image.
Note: You must select Print Preview (paginated mode) in order to see the image repeat on each page.
See Also

Image Report Item Smart Panel | Report Item and Data Region Smart Panels | Images


Image Visibility Page

AThe Visibility page of the Image smart panel allows you to control the following items:

  • Initial visibility
    • Visible: The image is visible when the report runs.
    • Hidden: The image is hidden when the report runs.
    • Expression: Use an expression with a Boolean result to decide whether the image is visible. True for hidden, false for visible.
  • Visibility can be toggled by another report item: Select this check box to display a toggle image next to another report item. The user can click the toggle item to show or hide this image.
    • Report item: Specify the report item which, if clicked, toggles the visibility of the image.
See Also

Image Report Item Smart Panel | Report Item and Data Region Smart Panels | Images | Drill-Down Reports

Tutorials: Toggling Visibility


Image Navigation Page

The Navigation page of the Image smart panel allows you to provide various types of navigation for your report.

  • Document map label: Enter an expression to use as a label to represent this item in the table of contents (document map).
  • Bookmark ID: Enter an expression to use as a locator for this image. You will then be able to provide a bookmark link to this item from another report item using a Jump to bookmark action.

Action

Select one of the following actions to perform when a user clicks on this image.

  • None: The default behavior is to do nothing when a user clicks the image at run time.
  • Jump to report: For drill-through reporting, select this option and provide the name of a local report, the relative path of a report in another folder, or the full path of a report on another server.
    • Parameters: Supply parameters to the targeted report by entering the Name of each parameter, the Value to send to the targeted report, or whether to Omit the parameter. Note that parameter names you supply must exactly match parameters in the target report.
      Tip: You can remove or change the order of parameters using the X and arrow buttons.
  • Jump to bookmark: Select this option and provide a valid Bookmark ID (see above) to allow the user to jump to the report item with that Bookmark ID.
  • Jump to URL: Select this option and provide a valid URL to create a hyperlink to a Web page.
Note: You can select <Expression...> within any of these properties to open the Expression Editor.
See Also

Image Report Item Smart Panel | Report Item and Data Region Smart Panels | Images | Hyperlinks | Bookmarks | Drill Through


Line Report Item Smart Panel

You can access the Line smart panel by right-clicking a line report item and choosing Properties. The Line smart panel has the following pages:

  • General
  • Visibility
  • Navigation
See Also

Report Item and Data Region Smart Panels | Lines


Line General Page

The General page of the Line smart panel allows you to control the following items:

  • Name: Enter a name for the line that is unique within the report. This name can be called in code.
  • Tooltip: Enter a string or expression that you want to appear when a user hovers the cursor over the line in the viewer at run time.
  • Repeat report item with data region on every page: Select this check box to display the line on every page on which the selected data region continues.
    • Data Region: Select the data region with which to repeat the line.
Note: You must select Print Preview (paginated mode) in order to see the line repeat on each page.
See Also

Line Report Item Smart Panel | Report Item and Data Region Smart Panels | Lines


Line Visibility Page

The Visibility page of the Line smart panel allows you to control the following items:

  • Initial visibility
    • Visible: The line is visible when the report runs.
    • Hidden: The line is hidden when the report runs.
    • Expression: Use an expression with a Boolean result to decide whether the line is visible. True for hidden, false for visible.
  • Visibility can be toggled by another report item: Select this check box to display a toggle image next to another report item. The user can click the toggle item to show or hide this line.
    • Report item: Specify the report item which, if clicked, toggles the visibility of the line.
See Also

Line Report Item Smart Panel | Lines | Drill-Down Reports

Tutorials: Toggling Visibility


Line Navigation Page

The Navigation page of the Line smart panel allows you to provide various types of navigation for your report.

  • Document map label: Enter an expression to use as a label to represent this item in the table of contents (document map).
  • Bookmark ID: Enter an expression to use as a locator for this line. You will then be able to provide a bookmark link to this item from another report item using a Jump to bookmark action.

Action

Select one of the following actions to perform when a user clicks on this line.

  • None: The default behavior is to do nothing when a user clicks the line at run time.
  • Jump to report: For drill-through reporting, select this option and provide the name of a local report, the relative path of a report in another folder, or the full path of a report on another server.
    • Parameters: Supply parameters to the targeted report by entering the Name of each parameter, the Value to send to the targeted report, or whether to Omit the parameter. Note that parameter names you supply must exactly match parameters in the target report.
      Tip: You can remove or change the order of parameters using the X and arrow buttons.
  • Jump to bookmark: Select this option and provide a valid Bookmark ID (see above) to allow the user to jump to the report item with that Bookmark ID.
  • Jump to URL: Select this option and provide a valid URL to create a hyperlink to a Web page.
Note: You can select <Expression...> within any of these properties to open the Expression Editor.
See Also

Line Report Item Smart Panel | Lines | Bookmarks | Document Maps

Getting Started: Document Map


List Data Region Smart Panel

You can access the List smart panel by selecting a list report item, right-clicking the edge, and choosing Properties. The List smart panel has the following pages:

  • General
  • Detail Grouping
  • Visibility
  • Navigation
  • Filters
  • Sorting
  • Data Output
See Also

Report Item and Data Region Smart Panels | List

Tutorials: Walkthrough: XML Data


List General Page

The General page of the List smart panel allows you to control the following items:

  • Name: Enter a name for the list that is unique within the report. This name can be called in code.
  • Tooltip: Enter the value or expression you want to appear when a user hovers the cursor over the list in the viewer at run time.
  • Dataset name: Select a dataset to associate with the list. The combo box is populated with all of the datasets in the report's dataset collection.
  • Page breaks: Select any of the following options to apply to each instance of the list.
    • Insert a page break before this list
    • Insert a page break after this list
    • Fit list on a single page if possible
See Also

List Data Region Smart Panel | List Detail Grouping Page | List

Tutorials: Grouping a List


List Detail Grouping Page

The List Detail Grouping smart panel gives you access to four sub-pages.

  • General
  • Filters
  • Visibility
  • Data Output

Detail grouping is useful when you do not want to repeat values within the details. When a detail grouping is set, the value repeats for each distinct result of the grouping expression instead of for each row of data. For example, if you use the Customers table of the NorthWind database to create a list of countries without setting the details grouping, each country is listed as many times as there are customers in that country. If you set the details grouping to =Fields!Country.Value each country is listed only once.

Note: If the detail grouping expression you use results in a value that is distinct for every row of data, a customer number for example, you will see no difference in the results.
See Also

List Data Region Smart Panel | List

Tutorials: Grouping


List Detail Grouping General Page

The General page of the List Detail Grouping smart panel allows you to control the following items:

  • Name: Enter a name for the detail group that is unique within the report. This name can be called in code. A name is created automatically if you do not enter one.
  • Group on: Enter an expression to use for grouping the data. If you have already assigned a dataset name on the List General page, you can select a field from the dataset.
  • Document map label: Enter text or an expression to use as a label to represent this item in the table of contents (document map). You can select <Expression...> to open the Expression Editor.
  • Parent group: For use in recursive hierarchies. Enter an expression to use as the parent group.
  • Page break at start: Select this check box to cause the report to break to a new page before each instance of this detail grouping.
  • Page break at end: Select this check box to cause the report to break to a new page after each instance of this detail grouping.
See Also

List Detail Grouping Page | List General Page | Grouping and Sorting Data | List


List Detail Grouping Filters Page

The Filters page of the List Detail Grouping smart panel allows you to control the Filter collection for the detail grouping. Use the arrow and X buttons to move or delete filters. You need to provide three values to add a new filter to the collection:

  • Expression: Enter the expression to use for evaluating whether data should be included in the details.
  • Operator: Select from the following operators to decide how to compare the expression to the left with the value to the right:
    • = Select this operator if you want to choose only data for which the value on the left is equal to the value on the right.
    • Like Select this operator if you want to choose data for which the value on the left is similar to the value on the right. For more information on using the Like operator, see the MSDN Web site.
    • != Select this operator if you want to choose only data for which the value on the left is not equal to the value on the right.
    • > Select this operator if you want to choose only data for which the value on the left is greater than the value on the right.
    • >= Select this operator if you want to choose only data for which the value on the left is greater than or equal to the value on the right.
    • < Select this operator if you want to choose only data for which the value on the left is less than the value on the right.
    • <= Select this operator if you want to choose only data for which the value on the left is less than or equal to the value on the right.
    • Top N Select this operator if you want to choose only items from the value on the left which are the top number specified in the value on the right.
    • Bottom N Select this operator if you want to choose only items from the value on the left which are the bottom number specified in the value on the right.
    • Top % Select this operator if you want to choose only items from the value on the left which are the top percent specified in the value on the right.
    • Bottom % Select this operator if you want to choose only items from the value on the left which are the bottom percent specified in the value on the right.
    • In Select this operator if you want to choose only items from the value on the left which are in the array of values specified on the right. Values on the right are separated by commas.
    • Between Select this operator if you want to choose only items from the value on the left which fall between the pair of values you specify on the right. Values on the right are separated by commas.
  • Value: Enter a value to compare with the expression on the left based on the selected operator. For multiple values (used with the In and Between operators) separate values using commas.
See Also

List Detail Grouping Page | List General Page | Filters | List


List Detail Grouping Visibility Page

The Visibility page of the List Detail Grouping smart panel allows you to control the following items:

  • Initial visibility
    • Visible: The details are visible when the report runs.
    • Hidden: The details are hidden when the report runs.
    • Expression: Use an expression with a Boolean result to decide whether the details are visible. True for hidden, false for visible.
  • Visibility can be toggled by another report item: Select this check box to display a toggle image next to another report item. The user can click the toggle item to show or hide the details.
    • Report item: Specify the report item which, if clicked, toggles the visibility of the detail grouping.
Note: Please use the property grid to access the Visibility properties.
See Also

List Detail Grouping Page | List General Page | List | Drill-Down Reports

Tutorials: Toggling Visibility


List Detail Grouping Data Output Page

The Data Output page of the List Detail Grouping smart panel allows you to control the following properties when you export to XML:

  • Element name: Type in a name to be used in the XML output for this detail grouping.
  • Collection: Enter a name to be used in the XML output for the collection of all instances of this detail grouping.
  • Output: Choose Yes or No to decide whether to include this detail grouping in the XML output.
See Also

List Detail Grouping Page | List General Page | List | Rendering to XML


List Visibility Page

The Visibility page of the List smart panel allows you to control the following items:

  • Initial visibility
    • Visible: The list is visible when the report runs.
    • Hidden: The list is hidden when the report runs.
    • Expression: Use an expression with a Boolean result to decide whether the list is visible. True for hidden, false for visible.
  • Visibility can be toggled by another report item: Select this check box to display a toggle image next to another report item. The user can click the toggle item to show or hide this list.
    • Report item: Specify the report item which, if clicked, toggles the visibility of the list.
See Also

List Data Region Smart Panel | Report Item and Data Region Smart Panels | Drill-Down Reports | List

Tutorials: Toggling Visibility


List Navigation Page

The Navigation page of the List smart panel allows you to control the following items:

  • Document map label: Enter an expression to use as a label to represent this item in the table of contents (document map).
  • Bookmark ID: Enter an expression to use as a locator for this list. You will then be able to provide a bookmark link to this item from another report item using a Jump to bookmark action.
Note: You can select <Expression...> within these properties to create an expression to determine the value.
See Also

List Data Region Smart Panel | Report Item and Data Region Smart Panels | Bookmarks | Document Maps | List

Getting Started: Document Map


List Filters Page

The Filters page of the List smart panel allows you to control the Filter collection for the list. You can also access the Filters collection by clicking the ellipsis (...) button next to the Filters property in the property grid. Use the arrow and X buttons to move or delete filters. You need to provide three values to add a new filter to the collection:

  • Expression: Enter the expression to use for evaluating whether data should be included in the list.
  • Operator: Select from the following operators to decide how to compare the expression to the left with the value to the right:
    • = Select this operator if you want to choose only data for which the value on the left is equal to the value on the right.
    • Like Select this operator if you want to choose data for which the value on the left is similar to the value on the right. For more information on using the Like operator, see the MSDN Web site.
    • != Select this operator if you want to choose only data for which the value on the left is not equal to the value on the right.
    • > Select this operator if you want to choose only data for which the value on the left is greater than the value on the right.
    • >= Select this operator if you want to choose only data for which the value on the left is greater than or equal to the value on the right.
    • < Select this operator if you want to choose only data for which the value on the left is less than the value on the right.
    • <= Select this operator if you want to choose only data for which the value on the left is less than or equal to the value on the right.
    • Top N Select this operator if you want to choose only items from the value on the left which are the top number specified in the value on the right.
    • Bottom N Select this operator if you want to choose only items from the value on the left which are the bottom number specified in the value on the right.
    • Top % Select this operator if you want to choose only items from the value on the left which are the top percent specified in the value on the right.
    • Bottom % Select this operator if you want to choose only items from the value on the left which are the bottom percent specified in the value on the right.
    • In Select this operator if you want to choose only items from the value on the left which are in the array of values specified on the right. Values on the right are separated by commas.
    • Between Select this operator if you want to choose only items from the value on the left which fall between the pair of values you specify on the right. Values on the right are separated by commas.
  • Value: Enter a value to compare with the expression on the left based on the selected operator. For multiple values (used with the In and Between operators) separate values using commas.
See Also

List Data Region Smart Panel | Report Item and Data Region Smart Panels | List | Filters


List Sorting Page

The Sorting page of the List smart panel allows you to enter new sort expressions and remove or change the order of them using the X or arrow buttons. For each sort expression in this list, you can also choose the direction.

In the Expression column, enter an expression by which to sort the data in the list.

In the Direction column, select whether you want to sort the data in an Ascending or Descending direction.

See Also

List Data Region Smart Panel | Report Item and Data Region Smart Panels | List

Tutorials: Sorting a List


List Data Output Page

The Data Output page of the List smart panel allows you to control the following properties when you export to XML:

  • Element name: Enter a name to be used in the XML output for this list.
  • Output: Choose Auto, Yes, or No to decide whether to include this List in the XML output. Choosing Auto exports the contents of the list.
  • Instance element name: Enter a name to be used in the XML output for the data element for instances of the list. This name is ignored if you have specified a detail grouping.
  • Instance element output: Choose Yes or No to decide whether to include the instances of the list in the XML output. This is ignored if you have specified a detail grouping.
See Also

List Data Region Smart Panel | Report Item and Data Region Smart Panels | List | Rendering to XML


Matrix Data Region Smart Panel

You can access the Matrix smart panel by selecting a matrix report item (click the top left square), right-clicking the edge, and choosing Properties. The Matrix smart panel has the following pages:

  • General
  • Visibility
  • Navigation
  • Filters
  • Row Groups
  • Column Groups
  • Data Output

You can select pages from the Home page of the smart panel, or by clicking the icons along the top of the smart panel.

See Also

Report Item and Data Region Smart Panels | Matrix

Tutorials: Walkthrough: Matrix Data Region


Matrix General Page

The General page of the Matrix smart panel allows you to control the following items:

  • Name: Enter a name for the matrix that is unique within the report. This name can be called in code.
  • Tooltip: Enter the value or expression you want to appear when a user hovers the cursor over the matrix in the viewer at run time.
  • Dataset name: Select a dataset to associate with the matrix. The combo box is populated with all of the datasets in the report's dataset collection.
  • Page breaks: Select any of the following options to apply to each instance of the matrix.
    • Insert a page break before this matrix
    • Insert a page break after this matrix
    • Fit matrix on a single page if possible
  • Matrix column expand: Select the direction in which columns expand.
    • Left to right
    • Right to left
  • Groups before row headers: Select the number of columns to show before the row header columns begin. The default value of 0 displays the row header column to the left.
See Also

Matrix Data Region Smart Panel | Report Item and Data Region Smart Panels | Matrix

Getting Started: Adding Static Rows and Columns to a Matrix | Adding Subtotals to a Matrix


Matrix Visibility Page

The Visibility page of the Matrix smart panel allows you to control the following items:

  • Initial visibility
    • Visible: The matrix is visible when the report runs.
    • Hidden: The matrix is hidden when the report runs.
    • Expression: Use an expression with a Boolean result to decide whether the matrix is visible. True for hidden, false for visible.
  • Visibility can be toggled by another report item: Select this check box to display a toggle image next to another report item. The user can click the toggle item to show or hide this matrix.
    • Report item: Specify the report item which, if clicked, toggles the visibility of the matrix.
See Also

Matrix Data Region Smart Panel | Report Item and Data Region Smart Panels | Matrix | Drill-Down Reports

Tutorials: Toggling Visibility


Matrix Navigation Page

The Navigation page of the Matrix smart panel allows you to control the following items:

  • Document map label: Enter an expression to use as a label to represent this item in the table of contents (document map).
  • Bookmark ID: Enter an expression to use as a locator for this matrix. You will then be able to provide a bookmark link to this item from another report item using a Jump to bookmark action.
Note: You can select <Expression...> within these properties to create an expression to determine the value.
See Also

Matrix Data Region Smart Panel | Report Item and Data Region Smart Panels | Matrix | Bookmarks | Document Maps


Matrix Filters Page

The Filters page of the Matrix smart panel allows you to control the Filter collection for the matrix. Use the arrow and X buttons to move or delete filters. You need to provide three values to add a new filter to the collection:

  • Expression: Enter the expression to use for evaluating whether data should be included in the matrix.
  • Operator: Select from the following operators to decide how to compare the expression to the left with the value to the right:
    • = Select this operator if you want to choose only data for which the value on the left is equal to the value on the right.
    • Like Select this operator if you want to choose data for which the value on the left is similar to the value on the right. For more information on using the Like operator, see the MSDN Web site.
    • != Select this operator if you want to choose only data for which the value on the left is not equal to the value on the right.
    • > Select this operator if you want to choose only data for which the value on the left is greater than the value on the right.
    • >= Select this operator if you want to choose only data for which the value on the left is greater than or equal to the value on the right.
    • < Select this operator if you want to choose only data for which the value on the left is less than the value on the right.
    • <= Select this operator if you want to choose only data for which the value on the left is less than or equal to the value on the right.
    • Top N Select this operator if you want to choose only items from the value on the left which are the top number specified in the value on the right.
    • Bottom N Select this operator if you want to choose only items from the value on the left which are the bottom number specified in the value on the right.
    • Top % Select this operator if you want to choose only items from the value on the left which are the top percent specified in the value on the right.
    • Bottom % Select this operator if you want to choose only items from the value on the left which are the bottom percent specified in the value on the right.
    • In Select this operator if you want to choose only items from the value on the left which are in the array of values specified on the right. Values on the right are separated by commas.
    • Between Select this operator if you want to choose only items from the value on the left which fall between the pair of values you specify on the right. Values on the right are separated by commas.
  • Value: Enter a value to compare with the expression on the left based on the selected operator. For multiple values (used with the In and Between operators) separate values using commas.
See Also

Matrix Data Region Smart Panel | Report Item and Data Region Smart Panels | Filters | Matrix


Matrix Row Groups Page

The Row Groups page of the Matrix smart panel allows you to add, remove, or change the order of row groups using the plus sign, X and arrow buttons.

Click the Add button to add a new row group to the list.

Once there are row groups in the list, you can select a row group and use the icons below the list to make changes on the following pages.

  • General
  • Filters
  • Sorting
  • Visibility
  • Data Output
See Also

Matrix Data Region Smart Panel | Report Item and Data Region Smart Panels | Matrix

Tutorials: Grouping in a Matrix Using Dynamic Columns and Rows


Row Groups General Page

The General page of the Row Groups smart panel allows you to control the following items:

  • Name: Enter a name for the group that is unique within the report. This name can be called in code.
  • Group on: Enter an expression to use for grouping the data.
  • Label: Enter an expression to use as a label to represent this item in the table of contents (document map).
  • Parent group: For use in recursive hierarchies. Enter an expression to use as the parent group.
Note: You can select <Expression...> within these properties to create an expression to determine the value.
See Also

Matrix Data Region Smart Panel | Matrix Row Groups Page | Matrix | Grouping and Sorting Data


Row Groups Filters Page

The Filters page of the Row Groups smart panel allows you to control the Filter grid collection for the group. Use the arrow and X buttons to move or delete filters. You need to provide three values to add a new filter to the collection:

  • Expression: Enter the expression to use for evaluating whether data should be included in the group.
  • Operator: Select from the following operators to decide how to compare the expression to the left with the value to the right:
    • = Select this operator if you want to choose only data for which the value on the left is equal to the value on the right.
    • Like Select this operator if you want to choose data for which the value on the left is similar to the value on the right. For more information on using the Like operator, see the MSDN Web site.
    • != Select this operator if you want to choose only data for which the value on the left is not equal to the value on the right.
    • > Select this operator if you want to choose only data for which the value on the left is greater than the value on the right.
    • >= Select this operator if you want to choose only data for which the value on the left is greater than or equal to the value on the right.
    • < Select this operator if you want to choose only data for which the value on the left is less than the value on the right.
    • <= Select this operator if you want to choose only data for which the value on the left is less than or equal to the value on the right.
    • Top N Select this operator if you want to choose only items from the value on the left which are the top number specified in the value on the right.
    • Bottom N Select this operator if you want to choose only items from the value on the left which are the bottom number specified in the value on the right.
    • Top % Select this operator if you want to choose only items from the value on the left which are the top percent specified in the value on the right.
    • Bottom % Select this operator if you want to choose only items from the value on the left which are the bottom percent specified in the value on the right.
    • In Select this operator if you want to choose only items from the value on the left which are in the array of values specified on the right. Values on the right are separated by commas.
    • Between Select this operator if you want to choose only items from the value on the left which fall between the pair of values you specify on the right. Values on the right are separated by commas.
  • Value: Enter a value to compare with the expression on the left based on the selected operator. For multiple values (used with the In and Between operators) separate values using commas.
See Also

Matrix Row Groups Page | Matrix Data Region Smart Panel | Filters | Matrix


Row Groups Sorting Page

The Sorting page of the Row Groups smart panel allows you to enter new sort expressions and remove or change the order of them using the X and arrow buttons. For each sort expression in this list, you can also choose the direction.

In the Expression column, enter an expression by which to sort the data in the group.

In the Direction column, select whether you want to sort the data in an Ascending or Descending direction.

See Also

Matrix Row Groups Page | Matrix Data Region Smart Panel | Matrix | Grouping and Sorting Data

Tutorials: Sorting a Matrix


Row Groups Visibility Page

The Visibility page of the Row Groups smart panel allows you to control the following items:

  • Initial visibility
    • Visible: The group is visible when the report runs.
    • Hidden: The group is hidden when the report runs.
    • Expression: Use an expression with a Boolean result to decide whether the group is visible. True for hidden, false for visible.
  • Visibility can be toggled by another report item: Select this check box to display a toggle image next to another report item. The user can click the toggle item to show or hide this row group.
    • Report item: Specify the report item which, if clicked, toggles the visibility of the group.
See Also

Matrix Row Groups Page | Matrix Data Region Smart Panel | Matrix | Drill-Down Reports

Tutorials: Toggling Visibility


Row Groups Data Output Page

The Data Output page of the Row Groups smart panel allows you to control the following properties when you export to XML:

  • Element name: Enter a name to be used in the XML output for this group.
  • Collection: Enter a name to be used in the XML output for the collection of all instances of this group.
  • Output: Choose Yes or No to decide whether to include this group in the XML output.
See Also

Matrix Row Groups Page | Matrix Data Region Smart Panel | Matrix | Rendering to XML


Matrix Column Groups Page

The Column Groups page of the Matrix smart panel allows you to add, remove, or change the order of row groups using the plus sign, X and arrow buttons.

Click the Add button to add a new column group to the list.

Once there are groups in the list, you can select a column group and use the icons below the list to make changes on the following pages.

  • General
  • Filters
  • Sorting
  • Visibility
  • Data Output


Column Groups General Page

The General page of the Column Groups smart panel allows you to control the following items:

  • Name: Enter a name for the group that is unique within the report. This name can be called in code.
  • Group on: Enter an expression to use for grouping the data.
  • Label: Enter an expression to use as a label to represent this item in the table of contents (document map).
  • Parent group: For use in recursive hierarchies. Enter an expression to use as the parent group.
Note: You can select <Expression...> within these properties to create an expression to determine the value.
See Also

Matrix Column Groups Page | Matrix Data Region Smart Panel | Matrix | Grouping and Sorting Data


Column Groups Filters Page

The Filters page of the Column Groups smart panel allows you to control the Filter grid collection for the group. Use the arrow and X buttons to move or delete filters. You need to provide three values to add a new filter to the collection:

  • Expression: Enter the expression to use for evaluating whether data should be included in the group.
  • Operator: Select from the following operators to decide how to compare the expression to the left with the value to the right:
    • = Select this operator if you want to choose only data for which the value on the left is equal to the value on the right.
    • Like Select this operator if you want to choose data for which the value on the left is similar to the value on the right. For more information on using the Like operator, see the MSDN Web site.
    • != Select this operator if you want to choose only data for which the value on the left is not equal to the value on the right.
    • > Select this operator if you want to choose only data for which the value on the left is greater than the value on the right.
    • >= Select this operator if you want to choose only data for which the value on the left is greater than or equal to the value on the right.
    • < Select this operator if you want to choose only data for which the value on the left is less than the value on the right.
    • <= Select this operator if you want to choose only data for which the value on the left is less than or equal to the value on the right.
    • Top N Select this operator if you want to choose only items from the value on the left which are the top number specified in the value on the right.
    • Bottom N Select this operator if you want to choose only items from the value on the left which are the bottom number specified in the value on the right.
    • Top % Select this operator if you want to choose only items from the value on the left which are the top percent specified in the value on the right.
    • Bottom % Select this operator if you want to choose only items from the value on the left which are the bottom percent specified in the value on the right.
    • In Select this operator if you want to choose only items from the value on the left which are in the array of values specified on the right. Values on the right are separated by commas.
    • Between Select this operator if you want to choose only items from the value on the left which fall between the pair of values you specify on the right. Values on the right are separated by commas.
  • Value: Enter a value to compare with the expression on the left based on the selected operator. For multiple values (used with the In and Between operators) separate values using commas.
See Also

Matrix Column Groups Page | Matrix Data Region Smart Panel | Matrix | Filters


Column Groups Sorting Page

The Sorting page of the Column Groups smart panel allows you to enter new sort expressions and remove or change the order of them using the X and arrow buttons. For each sort expression in this list, you can also choose the direction.

In the Expression column, enter an expression by which to sort the data in the group.

In the Direction column, select whether you want to sort the data in an Ascending or Descending direction.

See Also

Matrix Column Groups Page | Matrix Data Region Smart Panel | Matrix | Grouping and Sorting Data


Column Groups Visibility Page

The Visibility page of the Column Groups smart panel allows you to control the following items:

  • Initial visibility
    • Visible: The group is visible when the report runs.
    • Hidden: The group is hidden when the report runs.
    • Expression: Use an expression with a Boolean result to decide whether the group is visible. True for hidden, false for visible.
  • Visibility can be toggled by another report item: Select this check box to display a toggle image next to another report item. The user can click the toggle item to show or hide this column group.
    • Report item: Specify the report item which, if clicked, toggles the visibility of the group.
See Also

Matrix Column Groups Page | Matrix Data Region Smart Panel | Matrix | Drill-Down Reports

Tutorials: Toggling Visibility


Column Groups Data Output Page

The Data Output page of the Column Groups smart panel allows you to control the following properties when you export to XML:

  • Element name: Enter a name to be used in the XML output for this group.
  • Collection: Enter a name to be used in the XML output for the collection of all instances of this group.
  • Output: Choose Yes or No to decide whether to include this group in the XML output.
See Also

Matrix Column Groups Page | Matrix Data Region Smart Panel | Matrix | Rendering to XML


Matrix Data Output Page

The Data Output page of the Matrix smart panel allows you to control the following properties when you export to XML:

  • Element name: Enter a name to be used in the XML output for this matrix.
  • Output: Choose Auto, Yes, or No to decide whether to include this matrix in the XML output. Choosing Auto exports the contents of the matrix.
  • Cell element name: Enter a name to be used in the XML output for the data element for the cell.
  • Cell element output: Choose Yes or No to decide whether to include the cell contents in the XML output.
See Also

Matrix Data Region Smart Panel | Report Item and Data Region Smart Panels | Matrix | Rendering to XML


Rectangle Report Item Smart Panel

You can access the Rectangle smart panel by right-clicking a rectangle report item and choosing Properties. The Rectangle smart panel has the following pages:

  • General
  • Visibility
  • Navigation
  • Data Output
See Also

Report Item and Data Region Smart Panels | Rectangles


Rectangle General Page

The General page of the Rectangle smart panel allows you to control the following items:

  • Name: Enter a name for the rectangle that is unique within the report. This name can be called in code.
  • Repeat report item with data region on every page: Select this check box to display the rectangle on every page on which the selected data region continues.
    • Data region: Select the data region with which to repeat the rectangle.
    Note: You must select Print Preview (paginated mode) in order to see the rectangle repeat on each page.
  • Page breaks:
    • Insert before: Insert a page break before the rectangle.
    • Insert after: Insert a page break after the rectangle.
See Also

Rectangle Report Item Smart Panel | Report Item and Data Region Smart Panels | Rectangles


Rectangle Visibility Page

The Visibility page of the Rectangle smart panel allows you to control the following items:

  • Initial visibility
    • Visible: The rectangle is visible when the report runs.
    • Hidden: The rectangle is hidden when the report runs.
    • Expression: Use an expression with a Boolean result to decide whether the rectangle is visible. True for hidden, false for visible.
  • Visibility can be toggled by another report item: Select this check box to display a toggle image next to another report item. The user can click the toggle item to show or hide this rectangle.
    • Report item: Specify the report item which, if clicked, toggles the visibility of the rectangle.
See Also

Rectangle Report Item Smart Panel | Report Item and Data Region Smart Panels | Rectangles | Drill-Down Reports

Tutorials: Toggling Visibility


Rectangle Navigation Page

The Navigation page of the Rectangle smart panel allows you to control the following items:

  • Document map label: Enter an expression to use as a label to represent this item in the table of contents (document map).
  • Bookmark ID: Enter an expression to use as a locator for this rectangle. You will then be able to provide a bookmark link to this item from another report item using a Jump to bookmark action.
Note: You can select <Expression...> within any of these properties to open the Expression Editor.
See Also

Rectangle Report Item Smart Panel | Report Item and Data Region Smart Panels | Rectangles | Bookmarks | Document Maps


Rectangle Data Output Page

The Data Output page of the Rectangle smart panel allows you to control the following properties when you export to XML:

  • Element name: Enter a name to be used in the XML output for this rectangle.
  • Output: Choose Auto, Yes, No, or Contents only to decide whether to include the contents of this rectangle in the XML output. Choosing Auto exports the contents of the rectangle only when the value is not a constant.
See Also

Rectangle Report Item Smart Panel | Report Item and Data Region Smart Panels | Rectangles | Rendering to XML


Subreport Report Item Smart Panel

You can access the Subreport smart panel by right-clicking a subreport control and choosing Properties. The Subreport smart panel has the following pages:

  • General
  • Visibility
  • Navigation
  • Parameters
  • Data Output
See Also

Report Item and Data Region Smart Panels | Subreports

Tutorials: Walkthrough: Subreports


Subreport Properties General Page

The General page of the Subreport Properties allows you to control the following items:

  • Name: Enter a name for the subreport that is unique within the report. This name can be called in code.
  • Tooltip: Enter the value or expression you want to appear when a user hovers the cursor over the subreport in the viewer at run time.
  • Subreport: Select the report to display within the subreport control. The combo box is populated with all of the reports in the local folder.
See Also

Subreport Report Item Smart Panel | Report Item and Data Region Smart Panels | Subreports


Subreport Properties Visibility Page

The Visibility page of the Subreport smart panel allows you to control the following items:

  • Initial visibility
    • Visible: The subreport is visible when the report runs.
    • Hidden: The subreport is hidden when the report runs.
    • Expression: Use an expression with a Boolean result to decide whether the subreport is visible. True for hidden, false for visible.
  • Visibility can be toggled by another report item: Select this check box to display a toggle image next to another report item. The user can click the toggle item to show or hide this subreport.
    • Report item: Specify the report item which, if clicked, toggles the visibility of the subreport.
See Also

Subreport Report Item Smart Panel | Report Item and Data Region Smart Panels | Subreports | Drill-Down Reports

Tutorials: Toggling Visibility


Subreport Properties Navigation Page

The Navigation page of the Subreport smart panel allows you to control the following items:

  • Document map label: Enter an expression to use as a label to represent this item in the table of contents (document map).
  • Bookmark ID: Enter an expression to use as a locator for this subreport. You will then be able to provide a bookmark link to this item from another report item using a Jump to bookmark action.
Note: You can select <Expression...> within any of these properties to open the Expression Editor.
See Also

Subreport Report Item Smart Panel | Report Item and Data Region Smart Panels | Subreports | Bookmarks | Document Maps


Subreport Properties Parameters Page

The Parameters page of the Subreport smart panel allows you to enter new parameters and remove or change the order of parameters using the X and arrow buttons. For each parameter in this list, there is a Parameter Name and a Parameter Value.

Each Parameter Name must exactly match the name of a parameter in the target report.

For the Parameter Value, enter an expression to use to send information from the summary or main report to the subreport target.

See Also

Subreport Report Item Smart Panel | Report Item and Data Region Smart Panels | Subreports | Parameters

Tutorials: Passing Parameters


Subreport Properties Data Output Page

The Data Output page of the Subreport smart panel allows you to control the following properties when you export to XML:

  • Element name: Enter a name to be used in the XML output for this subreport.
  • Output: Choose Auto, Yes, or No to decide whether to include this subreport in the XML output. Choosing Auto exports the contents of the subreport.
See Also

Subreport Report Item Smart Panel | Report Item and Data Region Smart Panels | Subreports | Rendering to XML


Table Data Region Smart Panel

You can access the Table Properties by selecting a table data region (click the top left square), right-clicking the edge, and choosing Properties. The Table Properties has the following pages:

  • General
  • Visibility
  • Navigation
  • Sorting
  • Groups
  • Detail Grouping
  • Filters
  • Data Output
See Also

Report Item and Data Region Smart Panels | Table

Tutorials: Walkthrough: Basic Report


Table General Page

The General page of the Table smart panel allows you to control the following items:

  • Name: Enter a name for the table that is unique within the report. This name can be called in code.
  • Tooltip: Enter the value or expression you want to appear when a user hovers the cursor over the table in the viewer at run time.
  • Dataset name: Select a dataset to associate with the table. The combo box is populated with all of the datasets in the report's dataset collection.
  • Page breaks: Select any of the following options to apply to each instance of the table.
    • Insert a page break before this table
    • Insert a page break after this table
    • Fit table on a single page if possible
  • Header and Footer: Select any of the following options.
    • Repeat header row on each page
    • Repeat footer row on each page
See Also

Table Data Region Smart Panel | Report Item and Data Region Smart Panels | Table


Table Visibility Page

The Visibility page of the Table smart panel allows you to control the following items:

  • Initial visibility
    • Visible: The table is visible when the report runs.
    • Hidden: The table is hidden when the report runs.
    • Expression: Use an expression with a Boolean result to decide whether the table is visible. True for hidden, false for visible.
  • Visibility can be toggled by another report item: Select this check box to display a toggle image next to another report item. The user can click the toggle item to show or hide this table.
    • Report item: Specify the report item which, if clicked, toggles the visibility of the table.
See Also

Table Data Region Smart Panel | Report Item and Data Region Smart Panels | Table | Drill-Down Reports

Tutorials: Toggling Visibility


Table Navigation Page

The Navigation page of the Table smart panel allows you to control the following items:

  • Document map label: Enter an expression to use as a label to represent this item in the table of contents (document map).
  • Bookmark ID: Enter an expression to use as a locator for this table. You will then be able to provide a bookmark link to this item from another report item using a Jump to bookmark action.
Note: You can select <Expression...> within these properties to create an expression to determine the value.
See Also

Table Data Region Smart Panel | Report Item and Data Region Smart Panels | Table | Document Maps | Bookmarks


Table Sorting Page

The Sorting page of the Table smart panel allows you to enter new sort expressions and remove or change the order of them using the X and arrow buttons. For each sort expression in this list, you can also choose the direction.

In the Expression column, enter an expression by which to sort the data in the table.

In the Direction column, select whether you want to sort the data in an Ascending or Descending direction.

See Also

Table Data Region Smart Panel | Report Item and Data Region Smart Panels | Table | Grouping and Sorting Data

Tutorials: Sorting a Table


Table Groups Page

The Groups page of the Table smart panel allows you to remove or change the order of items in the Group list using the X and arrow buttons.

Click the Add button to add a new group to the table.

Once there are groups in the list, you can select a group and use the icons below the list to make changes on the following pages.

  • General
  • Filters
  • Sorting
  • Visibility
  • Data Output
See Also

Table Data Region Smart Panel | List Detail Grouping Page | Report Item and Data Region Smart Panels | Table

Tutorials: Walkthrough: Basic Report | Grouping a Table


Table Groups General Page

The General page of the Table Groups smart panel allows you to control the following items:

  • Name: Enter a name for the group that is unique within the report. This property cannot be set until after a Group on expression is supplied.
  • Group on: Enter an expression to use for grouping the data.
    Tip: To populate this combo box with values from a dataset, first select a dataset on the General page.
  • Document map label: Enter an expression to use as a label to represent this item in the table of contents (document map).
  • Parent group: For use in recursive hierarchies. Enter an expression to use as the parent group.
Note: You can select <Expression...> within these properties to create an expression to determine the value.
See Also

Table Groups Page | Table Data Region Smart Panel | Report Item and Data Region Smart Panels | Table | Grouping and Sorting Data

Tutorials: Grouping a Table


Table Groups Filters Page

The Filters page of the Table Groups smart panel allows you to control the Filter grid collection for the group. Use the arrow and X buttons to move or delete filters. You need to provide three values to add a new filter to the collection:

  • Expression: Enter the expression to use for evaluating whether data should be included in the group.
  • Operator: Select from the following operators to decide how to compare the expression to the left with the value to the right:
    • = Select this operator if you want to choose only data for which the value on the left is equal to the value on the right.
    • Like Select this operator if you want to choose data for which the value on the left is similar to the value on the right. For more information on using the Like operator, see the MSDN Web site.
    • != Select this operator if you want to choose only data for which the value on the left is not equal to the value on the right.
    • > Select this operator if you want to choose only data for which the value on the left is greater than the value on the right.
    • >= Select this operator if you want to choose only data for which the value on the left is greater than or equal to the value on the right.
    • < Select this operator if you want to choose only data for which the value on the left is less than the value on the right.
    • <= Select this operator if you want to choose only data for which the value on the left is less than or equal to the value on the right.
    • Top N Select this operator if you want to choose only items from the value on the left which are the top number specified in the value on the right.
    • Bottom N Select this operator if you want to choose only items from the value on the left which are the bottom number specified in the value on the right.
    • Top % Select this operator if you want to choose only items from the value on the left which are the top percent specified in the value on the right.
    • Bottom % Select this operator if you want to choose only items from the value on the left which are the bottom percent specified in the value on the right.
    • In Select this operator if you want to choose only items from the value on the left which are in the array of values specified on the right. Values on the right are separated by commas.
    • Between Select this operator if you want to choose only items from the value on the left which fall between the pair of values you specify on the right. Values on the right are separated by commas.
  • Value: Enter a value to compare with the expression on the left based on the selected operator. For multiple values (used with the In and Between operators) separate values using commas.
See Also

Table Groups Page | Table Data Region Smart Panel | Report Item and Data Region Smart Panels | Table | Filters

Tutorials: Filtering a Table or Matrix Group


Table Groups Sorting Page

The Sorting page of the Table Groups smart panel allows you to enter new sort expressions and remove or change the order of them using the X and arrow buttons. For each sort expression in this list, you can also choose the direction.

In the Expression column, enter an expression by which to sort the data in the group.

In the Direction column, select whether you want to sort the data in an Ascending or Descending direction.

See Also

Table Groups Page | Table Data Region Smart Panel | Report Item and Data Region Smart Panels | Table | Grouping and Sorting Data

Tutorials: Sorting a Table


Table Groups Visibility Page

The Visibility page of the Table Groups smart panel allows you to control the following items:

  • Initial visibility
    • Visible: The group is visible when the report runs.
    • Hidden: The group is hidden when the report runs.
    • Expression: Use an expression with a Boolean result to decide whether the group is visible. True for hidden, false for visible.
  • Visibility can be toggled by another report item: Select this check box to display a toggle image next to another report item. The user can click the toggle item to show or hide this row group.
    • Report item: Specify the report item which, if clicked, toggles the visibility of the group.
See Also

Table Groups Page | Table Data Region Smart Panel | Report Item and Data Region Smart Panels | Table | Drill-Down Reports

Tutorials: Toggling Visibility


Table Groups Data Output Page

The Data Output page of the Table Groups smart panel allows you to control the following properties when you export to XML:

  • Element name: Enter a name to be used in the XML output for this group.
  • Collection: Enter a name to be used in the XML output for the collection of all instances of this group.
  • Output: Choose Yes or No to decide whether to include this group in the XML output.
See Also

Table Groups Page | Table Data Region Smart Panel | Report Item and Data Region Smart Panels | Table | Rendering to XML


Table Detail Grouping Page

The Table Detail Grouping smart panel gives you access to four pages.

  • General
  • Filters
  • Visibility
  • Data Output

Detail grouping is useful when you do not want to repeat values within the details. When a detail grouping is set, the value repeats for each distinct result of the grouping expression instead of for each row of data. For example, if you use the Customers table of the NorthWind database to create a list of countries without setting the details grouping, each country is listed as many times as there are customers in that country. If you set the details grouping to =Fields!Country.Value each country is listed only once.

Note: If the detail grouping expression you use results in a value that is distinct for every row of data, a customer number for example, you will see no difference in the results.
See Also

Table Data Region Smart Panel | Table | Grouping and Sorting Data

Tutorials: Grouping


Table Detail Grouping General Page

The General page of the Table Detail Grouping smart panel allows you to control the following items:

  • Name: Enter a name for the detail group that is unique within the report. This name can be called in code. A name is created automatically if you do not enter one.
  • Group on: Enter an expression to use for grouping the data. If you have already assigned a dataset name on the List General page, you can select a field from the dataset.
  • Document map label: Enter text or an expression to use as a label to represent this item in the table of contents (document map). You can select <Expression...> to open the Expression Editor.
  • Parent group: For use in recursive hierarchies. Enter an expression to use as the parent group.
  • Page break at start: Select this check box to cause the report to break to a new page before each instance of this detail grouping.
  • Page break at end: Select this check box to cause the report to break to a new page after each instance of this detail grouping.
See Also

Table Detail Grouping Page | Table Groups Page | Table | Grouping and Sorting Data


Table Detail Grouping Filters Page

The Filters page of the Table Detail Grouping smart panel allows you to control the Filter collection for the detail grouping. Use the arrow and X buttons to move or delete filters. You need to provide three values to add a new filter to the collection:

  • Expression: Enter the expression to use for evaluating whether data should be included in the details.
  • Operator: Select from the following operators to decide how to compare the expression to the left with the value to the right:
    • = Select this operator if you want to choose only data for which the value on the left is equal to the value on the right.
    • Like Select this operator if you want to choose data for which the value on the left is similar to the value on the right. For more information on using the Like operator, see the MSDN Web site.
    • != Select this operator if you want to choose only data for which the value on the left is not equal to the value on the right.
    • > Select this operator if you want to choose only data for which the value on the left is greater than the value on the right.
    • >= Select this operator if you want to choose only data for which the value on the left is greater than or equal to the value on the right.
    • < Select this operator if you want to choose only data for which the value on the left is less than the value on the right.
    • <= Select this operator if you want to choose only data for which the value on the left is less than or equal to the value on the right.
    • Top N Select this operator if you want to choose only items from the value on the left which are the top number specified in the value on the right.
    • Bottom N Select this operator if you want to choose only items from the value on the left which are the bottom number specified in the value on the right.
    • Top % Select this operator if you want to choose only items from the value on the left which are the top percent specified in the value on the right.
    • Bottom % Select this operator if you want to choose only items from the value on the left which are the bottom percent specified in the value on the right.
    • In Select this operator if you want to choose only items from the value on the left which are in the array of values specified on the right. Values on the right are separated by commas.
    • Between Select this operator if you want to choose only items from the value on the left which fall between the pair of values you specify on the right. Values on the right are separated by commas.
  • Value: Enter a value to compare with the expression on the left based on the selected operator. For multiple values (used with the In and Between operators) separate values using commas.
See Also

Table Detail Grouping Page | Table Groups Page | Table | Filters


Table Detail Grouping Visibility Page

The Visibility page of the Table Detail Grouping smart panel allows you to control the following items:

  • Initial visibility
    • Visible: The details are visible when the report runs.
    • Hidden: The details are hidden when the report runs.
    • Expression: Use an expression with a Boolean result to decide whether the details are visible. True for hidden, false for visible.
  • Visibility can be toggled by another report item: Select this check box to display a toggle image next to another report item. The user can click the toggle item to show or hide the details.
    • Report item: Specify the report item which, if clicked, toggles the visibility of the detail grouping.
See Also

Table Detail Grouping Page | Table Groups Page | Table | Drill-Down Reports

Tutorials: Toggling Visibility


Table Detail Grouping Data Output Page

The Data Output page of the Table Detail Grouping smart panel allows you to control the following properties when you export to XML:

  • Element name: Type in a name to be used in the XML output for this detail grouping.
  • Collection: Enter a name to be used in the XML output for the collection of all instances of this detail grouping.
  • Output: Choose Yes or No to decide whether to include this detail grouping in the XML output.
See Also

Table Detail Grouping Page | Table Groups Page | Table | Rendering to XML


Table Filters Page

The Filters page of the Table smart panel allows you to control the Filter grid collection for the table. Use the arrow and X buttons to move or delete filters. You need to provide three values to add a new filter to the collection:

  • Expression: Enter the expression to use for evaluating whether data should be included in the table.
  • Operator: Select from the following operators to decide how to compare the expression to the left with the value to the right:
    • = Select this operator if you want to choose only data for which the value on the left is equal to the value on the right.
    • Like Select this operator if you want to choose data for which the value on the left is similar to the value on the right. For more information on using the Like operator, see the MSDN Web site.
    • != Select this operator if you want to choose only data for which the value on the left is not equal to the value on the right.
    • > Select this operator if you want to choose only data for which the value on the left is greater than the value on the right.
    • >= Select this operator if you want to choose only data for which the value on the left is greater than or equal to the value on the right.
    • < Select this operator if you want to choose only data for which the value on the left is less than the value on the right.
    • <= Select this operator if you want to choose only data for which the value on the left is less than or equal to the value on the right.
    • Top N Select this operator if you want to choose only items from the value on the left which are the top number specified in the value on the right.
    • Bottom N Select this operator if you want to choose only items from the value on the left which are the bottom number specified in the value on the right.
    • Top % Select this operator if you want to choose only items from the value on the left which are the top percent specified in the value on the right.
    • Bottom % Select this operator if you want to choose only items from the value on the left which are the bottom percent specified in the value on the right.
    • In Select this operator if you want to choose only items from the value on the left which are in the array of values specified on the right. Values on the right are separated by commas.
    • Between Select this operator if you want to choose only items from the value on the left which fall between the pair of values you specify on the right. Values on the right are separated by commas.
  • Value: Enter a value to compare with the expression on the left based on the selected operator. For multiple values (used with the In and Between operators) separate values using commas.
See Also

Table Data Region Smart Panel | Report Item and Data Region Smart Panels | Table | Filters


Table Data Output Page

The Data Output page of the Table smart panel allows you to control the following properties when you export to XML:

  • Element name: Enter a name to be used in the XML output for this table.
  • Output: Choose Auto, Yes, or No to decide whether to include this table in the XML output. Choosing Auto exports the contents of the table.
  • Detail element name: Enter a name to be used in the XML output for the data element for instances of the table. This name is ignored if you have specified a details grouping.
  • Detail collection name: Enter a name to be used in the XML output for the data element for the collection of all instances of the detail grouping.
  • Data element output: Choose Yes or No to decide whether to include the details in the XML output.
See Also

Table Data Region Smart Panel | Report Item and Data Region Smart Panels | Table | Rendering to XML


TextBox Report Item Smart Panels

You can access the TextBox Report Item smart panel by right-clicking a TextBox report item and choosing Properties. The TextBox smart panel has the following pages:

  • General
  • Visibility
  • Navigation
  • Appearance
  • Font
  • Format
  • Interactive Sort
  • Data Output
See Also

Report Item and Data Region Smart Panels | TextBox Report Item


TextBox General Page

The General page of the TextBox smart panel allows you to control the following items:

  • Name: Enter a name for the textbox that is unique within the report. This name is displayed in the Document Outline and in XML exports.
  • Tooltip: Enter the value or expression you want to appear when a user hovers the cursor over the textbox in the viewer at run time.
  • Repeat report item with data region on every page: You can select this check box and select a data region to print the textbox on every page to which the data region continues.
    Note: You must select Print Preview mode in order to see this property working in the viewer.
    • Data Region: Select the data region with which to repeat the textbox.
  • Value: Enter an expression or a static label, or choose a field expression from the drop-down list. You can access the expression editor by selecting <Expression...> in the list. The value of this expression or text is displayed in the report.
  • Hide duplicates: This option is disabled unless the textbox is within a data region.
    • Containing group or dataset: Enter or select a group or dataset in which to hide repeated values.
      Note: When the group or dataset breaks to a new page, the first instance of the repeated value is printed.
See Also

TextBox Report Item | Report Item and Data Region Smart Panels


TextBox Visibility Page

The Visibility page of the TextBox smart panel allows you to control the following items:

  • Initial visibility allows you to select from the following options:
    • Visible - The textbox is visible when the report runs.
    • Hidden - The textbox is hidden when the report runs.
    • Expression - Use an expression with a Boolean result to decide whether the textbox is visible. For example, on a "Free Shipping" textbox, you could use the expression to see whether the ShippingCountry is international. A value of true hides the textbox, false shows it.
  • Visibility can be toggled by another report item
    • Report item: If you select the Visibility can be toggled check box, you can specify the report item next to which appears a grey toggle image button. If clicked, the Report Item toggles the visibility of the textbox.
  • Initial appearance of the toggle image: allows you to select from the following options:
    • Expanded (-) The toggle image shows as a minus sign, and all instances of this textbox are visible.
    • Collapsed (+) The toggle image shows as a plus sign, and all instances of this textbox are hidden.
    • Expression: Use an expression with a Boolean result to decide whether the toggle image is expanded. A value of true expands the toggle image, false collapses it.
See Also

TextBox Report Item Smart Panels | Report Item and Data Region Smart Panels | Drill-Down Reports | TextBox Report Item

Tutorials: Toggling Visibility | Walkthrough: Drilldown


TextBox Navigation Page

The Navigation page of the TextBox smart panel allows you to control the following items:

  • Document map label: Enter an expression to use as a label to represent this item in the table of contents (document map).
  • Bookmark ID: Enter an expression to use as a locator for this textbox. You will then be able to provide a bookmark link to this item from another report item using a Jump to bookmark action.

Action

Select one of the following actions to perform when a user clicks on this textbox.

  • None: The default behavior is to do nothing when a user clicks the textbox at run time.
  • Jump to report: For drill-through reporting, select this option and provide the name of a local report, the relative path of a report in another folder, or the full path of a report on another server.
    • Parameters: Supply parameters to the targeted report by entering the Name of each parameter, the Value to send to the targeted report, or whether to Omit the parameter. Note that parameter names you supply must exactly match parameters in the target report.
      Tip: You can remove or change the order of parameters using the X and arrow buttons.
  • Jump to bookmark: Select this option and provide a valid Bookmark ID (see above) to allow the user to jump to the report item with that Bookmark ID.
  • Jump to URL: Select this option and provide a valid URL to create a hyperlink to a Web page.
Note: You can select <Expression...> within any of these properties to open the Expression Editor.
See Also

Report Item and Data Region Smart Panels | TextBox Report Item Smart Panels | Hyperlinks | Bookmarks | Drill Through | TextBox Report Item

Getting Started: Document Map


TextBox Appearance Page

The Appearance page of the TextBox smart panel allows you to control the Border and Background for the textbox.

Border

  • Style: Select a style for the border.
  • Width: Enter a value in points to set the width of the border.
  • Color: Select a color to use for the border, or select the <Expression...> option to open the Expression Editor and create an expression that evaluates to a .NET color.

Background

  • Color: Select a color to use for the background of the textbox.
  • Image: Enter an image to use for the background of the textbox.
Note: You can select the <Expression...> option in many of these properties to create an expression to determine the value. For properties with enumerated values, the values are listed under Constants in the Fields tree view on the left side of the Expression Editor.
See Also

TextBox Report Item Smart Panels | Report Item and Data Region Smart Panels | TextBox Report Item


TextBox Font Page

The Font page of the TextBox smart panel allows you to control the following aspects of the font used to render text in the textbox:

  • Family: Select a font family name or a theme font.
  • Size: Choose the size in points for the font or use a theme.
  • Style: Choose Normal or Italic or select a theme.
  • Weight: Choose from Lighter, Thin, ExtraLight, Light, Normal, Medium, SemiBold, Bold, ExtraBold, Heavy, or Bolder.
  • Color: Choose a color to use for the text.
  • Decoration: Choose from None, Underline, Overline, or LineThrough.
Note: You can select the <Expression...> option in many of these properties to create an expression to determine the value. For properties with enumerated values, the values are listed under Constants in the Fields tree view on the left side of the Expression Editor.
See Also

TextBox Report Item Smart Panels | Report Item and Data Region Smart Panels | TextBox Report Item | Expressions


TextBox Format Page

The Format page of the TextBox smart panel gives you control over the following items:

  • Format code: Select one of the common numeric formats provided or use a custom .NET formatting code to format dates or numbers. For more information, see MSDN's Formatting Types topic.
  • Line height: This property sets the space between lines of text.
    Note: This property only affects HTML output.
  • Textbox height: Select the following options to control the height of the textbox.
    • Can increase to accommodate contents (True by default.) This property allows the textbox to grow vertically if the contents require it so that text is not cut off.
    • Can decrease to accommodate contents (False by default.) This property allows the textbox to shrink vertically if the contents do not fill the control.
  • Amount of space to leave around report item
    • Top margin: Set the top padding in points.
    • Left margin: Set the left padding in points.
    • Right margin: Set the right padding in points.
    • Bottom margin: Set the bottom padding in points.
  • Text direction and writing mode
    • Direction: Choose LTR for left to right, or RTL for right to left.
    • Mode: Choose lr-tb for left right top bottom (normal horizontal text) or tb-rl for top bottom right left (vertical text on its side).
Note: You can select the <Expression...> option in many of these properties to create an expression to determine the value. For properties with enumerated values, the values are listed under Constants in the Fields tree view on the left side of the Expression Editor.
See Also

TextBox Report Item Smart Panels | Report Item and Data Region Smart Panels | TextBox Report Item | Text Formatting | Conditional Formatting | Expressions


Textbox Interactive Sort Page

The Interactive Sort page of the TextBox smart panel allows you to control whether to allow end users to sort the report data in the viewer. If you select the checkbox next to Add an interactive sort action to this textbox, you gain access to the following items:

  • Sort expression: Enter an expression to use for determining the data to sort.
  • Data region or group to sort: Select the grouping level or data region within the report to sort. The default value is Current scope, but you may also elect to choose an alternate data region or grouping.
  • Evaluate sort expression in this scope: Select the grouping level within the report on which to evaluate an aggregate sorting expression. The default value is Current scope, but you may also elect to choose an alternate data region or grouping.
Note: You can select <Expression...> within any of these properties to open the Expression Editor.
See Also

TextBox Report Item Smart Panels

Tutorials: Allowing Users to Sort Data in the Viewer


TextBox Data Output Page

The Data Output page of the TextBox smart panel allows you to control the following properties when you export to XML:

  • Element Name: Enter a name to be used in the XML output for this textbox.
  • Output: Choose Auto, Yes, or No to decide whether to include this textbox in the XML output. Auto exports the contents of the textbox only when the value is not a constant.
  • Render as: Choose Auto, Element, or Attribute to decide whether to render textboxes as Attributes or Elements in the exported XML file. Auto uses the report's setting for this property.
    • Attributes example:
      <table1 textbox3="Report created on: 7/26/2005 1:13:00 PM">
    • Elements example:
      <table1> <textbox3>Report created on: 7/26/2005 1:13:28 PM</textbox3>
See Also

TextBox Report Item Smart Panels | Report Item and Data Region Smart Panels | TextBox Report Item | Rendering to XML


BandedList Data Region Smart Panel

You can access the BandedList smart panel by selecting a banded list report item, right-clicking the edge, and choosing Properties. The BandedList smart panel has the following pages:

  • General
  • Visibility
  • Navigation
  • Groups
  • Filters
  • Data Output
See Also

Report Item and Data Region Smart Panels | Banded List

Tutorials: Walkthrough: BandedList Data Region


BandedList General Page

The General page of the BandedList smart panel allows you to control the following items:

  • Name: Enter a name for the banded list that is unique within the report. This name can be called in code.
  • Tooltip: Enter the value or expression you want to appear when a user hovers the cursor over the banded list in the viewer at run time.
  • Dataset name: Select a dataset to associate with the banded list. The combo box is populated with all of the datasets in the report's dataset collection.
  • Page breaks: Select any of the following options to apply to each instance of the banded list.
    • Insert a page break before this banded list
    • Insert a page break after this banded list
    • Fit banded list on a single page if possible
  • Header and Footer: Select any of the following options.
    • Repeat header band on each page
    • Repeat footer band on each page
See Also

BandedList Data Region Smart Panel | Report Item and Data Region Smart Panels | Banded List

Tutorials: Walkthrough: BandedList Data Region


BandedList Visibility Page

The Visibility page of the BandedList smart panel allows you to control the following items:

  • Initial visibility
    • Visible: The banded list is visible when the report runs.
    • Hidden: The banded list is hidden when the report runs.
    • Expression: Use an expression with a Boolean result to decide whether the banded list is visible. True for hidden, false for visible.
  • Visibility can be toggled by another report item: Select this check box to display a toggle image next to another report item. The user can click the toggle item to show or hide this banded list.
    • Report item: Specify the report item which, if clicked, toggles the visibility of the banded list.
See Also

BandedList Data Region Smart Panel | Report Item and Data Region Smart Panels | Banded List | Drill-Down Reports

Tutorials: Toggling Visibility


BandedList Navigation Page

The Navigation page of the BandedList smart panel allows you to control the following items:

  • Document map label: Enter an expression to use as a label to represent this item in the table of contents (document map).
  • Bookmark ID: Enter an expression to use as a locator for this banded list. You will then be able to provide a bookmark link to this item from another report item using a Jump to bookmark action.
Note: You can select <Expression...> within these properties to create an expression to determine the value.
See Also

BandedList Data Region Smart Panel | Report Item and Data Region Smart Panels | Banded List | Document Maps | Bookmarks


BandedList Groups Page

The Groups page of the BandedList smart panel allows you to remove or change the order of items in the Group list using the X and arrow buttons.

Click the Add button to add a new group to the banded list.

Once there are groups in the list, you can select a group and use the icons below the list to make changes on the following pages.

  • General
  • Filters
  • Sorting
  • Visibility
  • Data Output


BandedList Groups General Page

The General page of the BandedList Groups smart panel allows you to control the following items:

  • Name: Enter a name for the group that is unique within the report. This property cannot be set until after a Group on expression is supplied.
  • Group on: Enter an expression to use for grouping the data.
    Tip: To populate this combo box with values from a dataset, first select a dataset on the General page.
  • Document map label: Enter an expression to use as a label to represent this item in the table of contents (document map).
  • Parent group: For use in recursive hierarchies. Enter an expression to use as the parent group.
Note: You can select <Expression...> within these properties to create an expression to determine the value.
See Also

BandedList Groups Page | BandedList Data Region Smart Panel | Report Item and Data Region Smart Panels | Banded List | Grouping and Sorting Data

Tutorials: Grouping a Banded List


BandedList Groups Filters Page

The Filters page of the BandedList Groups smart panel allows you to control the Filter grid collection for the group. Use the arrow and X buttons to move or delete filters. You need to provide three values to add a new filter to the collection:

  • Expression: Enter the expression to use for evaluating whether data should be included in the group.
  • Operator: Select from the following operators to decide how to compare the expression to the left with the value to the right:
    • = Select this operator if you want to choose only data for which the value on the left is equal to the value on the right.
    • Like Select this operator if you want to choose data for which the value on the left is similar to the value on the right. For more information on using the Like operator, see the MSDN Web site.
    • != Select this operator if you want to choose only data for which the value on the left is not equal to the value on the right.
    • > Select this operator if you want to choose only data for which the value on the left is greater than the value on the right.
    • >= Select this operator if you want to choose only data for which the value on the left is greater than or equal to the value on the right.
    • < Select this operator if you want to choose only data for which the value on the left is less than the value on the right.
    • <= Select this operator if you want to choose only data for which the value on the left is less than or equal to the value on the right.
    • Top N Select this operator if you want to choose only items from the value on the left which are the top number specified in the value on the right.
    • Bottom N Select this operator if you want to choose only items from the value on the left which are the bottom number specified in the value on the right.
    • Top % Select this operator if you want to choose only items from the value on the left which are the top percent specified in the value on the right.
    • Bottom % Select this operator if you want to choose only items from the value on the left which are the bottom percent specified in the value on the right.
    • In Select this operator if you want to choose only items from the value on the left which are in the array of values specified on the right. Values on the right are separated by commas.
    • Between Select this operator if you want to choose only items from the value on the left which fall between the pair of values you specify on the right. Values on the right are separated by commas.
  • Value: Enter a value to compare with the expression on the left based on the selected operator. For multiple values (used with the In and Between operators) separate values using commas.
See Also

BandedList Groups Page | BandedList Data Region Smart Panel | Report Item and Data Region Smart Panels | Banded List | Filters


BandedList Groups Sorting Page

The Sorting page of the BandedList Groups smart panel allows you to enter new sort expressions and remove or change the order of them using the X and arrow buttons. For each sort expression in this list, you can also choose the direction.

In the Expression column, enter an expression by which to sort the data in the group.

In the Direction column, select whether you want to sort the data in an Ascending or Descending direction.

See Also

BandedList Groups Page | BandedList Data Region Smart Panel | Report Item and Data Region Smart Panels | Banded List | Grouping and Sorting Data

Tutorials: Sorting a Banded List


BandedList Groups Visibility Page

The Visibility page of the BandedList Groups smart panel allows you to control the following items:

  • Initial visibility
    • Visible: The group is visible when the report runs.
    • Hidden: The group is hidden when the report runs.
    • Expression: Use an expression with a Boolean result to decide whether the group is visible. True for hidden, false for visible.
  • Visibility can be toggled by another report item: Select this check box to display a toggle image next to another report item. The user can click the toggle item to show or hide this band group.
    • Report item: Specify the report item which, if clicked, toggles the visibility of the group.
See Also

BandedList Groups Page | BandedList Data Region Smart Panel | Report Item and Data Region Smart Panels | Banded List | Drill-Down Reports

Tutorials: Toggling Visibility


BandedList Groups Data Output Page

The Data Output page of the BandedList Groups smart panel allows you to control the following properties when you export to XML:

  • Element name: Enter a name to be used in the XML output for this group.
  • Collection: Enter a name to be used in the XML output for the collection of all instances of this group.
  • Output: Choose Yes or No to decide whether to include this group in the XML output.
See Also

BandedList Groups Page | BandedList Data Region Smart Panel | Report Item and Data Region Smart Panels | Banded List | Rendering to XML


BandedList Filters Page

The Filters page of the BandedList smart panel allows you to control the Filter collection for the banded list. Use the arrow and X buttons to move or delete filters. You need to provide three values to add a new filter to the collection:

  • Expression: Enter the expression to use for evaluating whether data should be included in the banded list.
  • Operator: Select from the following operators to decide how to compare the expression to the left with the value to the right:
    • = Select this operator if you want to choose only data for which the value on the left is equal to the value on the right.
    • Like Select this operator if you want to choose data for which the value on the left is similar to the value on the right. For more information on using the Like operator, see the MSDN Web site.
    • != Select this operator if you want to choose only data for which the value on the left is not equal to the value on the right.
    • > Select this operator if you want to choose only data for which the value on the left is greater than the value on the right.
    • >= Select this operator if you want to choose only data for which the value on the left is greater than or equal to the value on the right.
    • < Select this operator if you want to choose only data for which the value on the left is less than the value on the right.
    • <= Select this operator if you want to choose only data for which the value on the left is less than or equal to the value on the right.
    • Top N Select this operator if you want to choose only items from the value on the left which are the top number specified in the value on the right.
    • Bottom N Select this operator if you want to choose only items from the value on the left which are the bottom number specified in the value on the right.
    • Top % Select this operator if you want to choose only items from the value on the left which are the top percent specified in the value on the right.
    • Bottom % Select this operator if you want to choose only items from the value on the left which are the bottom percent specified in the value on the right.
    • In Select this operator if you want to choose only items from the value on the left which are in the array of values specified on the right. Values on the right are separated by commas.
    • Between Select this operator if you want to choose only items from the value on the left which fall between the pair of values you specify on the right. Values on the right are separated by commas.
  • Value: Enter a value to compare with the expression on the left based on the selected operator. For multiple values (used with the In and Between operators) separate values using commas.
See Also

BandedList Data Region Smart Panel | Report Item and Data Region Smart Panels | Banded List | Filters


BandedList Data Output Page

The Data Output page of the BandedList smart panel allows you to control the following properties when you export to XML:

  • Element name: Enter a name to be used in the XML output for this banded list.
  • Output: Choose Auto, Yes, or No to decide whether to include this banded list in the XML output. Choosing Auto exports the contents of the banded list.
See Also

BandedList Data Region Smart Panel | Report Item and Data Region Smart Panels | Banded List | Rendering to XML


Barcode Report Item Smart Panel

You can access the Barcode Properties by right-clicking a barcode report item and choosing Properties. The Barcode Properties has the following pages:

  • General
  • Symbology
    • Also see: Code128C Additional Information
    • Also see: Ean13 Additional Information
  • Barcode Settings
  • Appearance
  • Format
  • Visibility
  • Navigation
  • Data Output
See Also

Report Item and Data Region Smart Panels | Barcodes

Getting Started: Report Items


Barcode Properties General Page

The General page of the Barcode Properties smart panel allows you to control the following items:

  • Name: Enter a name for the barcode that is unique within the report. This name is displayed in the Document Outline and in XML exports.
  • Tooltip: Enter the value or expression you want to appear when a user hovers the cursor over the barcode in the viewer at run time.
  • Value: Enter an expression or a static label, or choose a field expression from the drop-down list. You can access the expression editor by selecting <Expression...> in the list. The value of this expression or text is used to render the barcode in the report.
  • Caption
    • Location: Select whether to display the caption above or below the barcode, or select None to display the barcode without a caption.
    • Text Alignment: Select the horizontal alignment of the caption. The default value of General centers the caption.
See Also

Barcode Report Item Smart Panel


Barcode Properties Symbology Page

The Symbology page of the Barcode Properties smart panel allows you to control the type of barcode used. Data Dynamics Reports supports all of the most popular symbologies.

Symbology | Description | Also Known As | Allowed Characters
Codabar | Codabar is self checking and does not require a checksum character. Start and stop characters which mark the beginning and end of the code are not returned by scanners. | USD-4, NW-7, and Code 2 of 7 | 0 1 2 3 4 5 6 7 8 9 - $ : / . +
Code128A | Code 128 A is a high-density symbology and uses code set A of Code 128. It is self checking and requires a check digit for greater security. The ComputeCheckSum property is set to True by default and the check character is calculated automatically. | NUL (0x00) SOH (0x01) STX (0x02) ETX (0x03) EOT (0x04) ENQ (0x05) ACK (0x06) BEL (0x07) BS (0x08) HT (0x09) LF (0x0A) VT (0x0B) FF (0x0C) CR (0x0D) SO (0x0E) SI (0x0F) DLE (0x10) DC1 (0x11) DC2 (0x12) DC3 (0x13) DC4 (0x14) NAK (0x15) SYN (0x16) ETB (0x17) CAN (0x18) EM (0x19) SUB (0x1A) ESC (0x1B) FS (0x1C) GS (0x1D) RS (0x1E) US (0x1F) SPACE (0x20) ! " # $ % & ' ( ) * + , - . / 0 1 2 3 4 5 6 7 8 9 : ; < = > ? @ A B C D E F G H I J K L M N O P Q R S T U V W X Y Z [ \ ]^ _
Code128Auto | Uses the complete ASCII character set. It automatically selects between Code 128 A, B and C to give the smallest barcode. | NUL (0x00) SOH (0x01) STX (0x02) ETX (0x03) EOT (0x04) ENQ (0x05) ACK (0x06) BEL (0x07) BS (0x08) HT (0x09) LF (0x0A) VT (0x0B) FF (0x0C) CR (0x0D) SO (0x0E) SI (0x0F) DLE (0x10) DC1 (0x11) DC2 (0x12) DC3 (0x13) DC4 (0x14) NAK (0x15) SYN (0x16) ETB (0x17) CAN (0x18) EM (0x19) SUB (0x1A) ESC (0x1B) FS (0x1C) GS (0x1D) RS (0x1E) US (0x1F) SPACE (0x20) ! " # $ % & ' ( ) * + , - . / 0 1 2 3 4 5 6 7 8 9 : ; < = > ? @ A B C D E F G H I J K L M N O P Q R S T U V W X Y Z [ \ ]^ _
Code128B | Code 128 B is a high-density symbology and uses code set B of Code 128. It is self checking and requires a check digit for greater security. The ComputeCheckSum property is set to True by default and the check character is calculated automatically. | SPACE (0x20) ! " # $ % & ' ( ) * + , - . / 0 1 2 3 4 5 6 7 8 9 : ; < = > ? @ A B C D E F G H I J K L M N O P Q R S T U V W X Y Z [ \ ]^ _ ` a b c d e f g h i j k l m n o p q r s t u v w x y z { | } ~ DEL (\x7F)

Code128C

 Code 128 C is a high-density symbology and uses code set C of Code 128. It is self checking and requires a check digit for greater security. The ComputeCheckSum property is set to True by default and the check character is calculated automatically.

SCC14 (Shipping Container Code 14)and SSCC18 (Serial Shipping Container Code 18)

 0 1 2 3 4 5 6 7 8 9
Code2of5 | Code 2 of 5 is a low-density numeric symbology. Use of a check digit is optional. If the ComputeCheckSum property is set to True, the check character is calculated automatically. | Standard 2 of 5 and Industrial 2 of 5 | 0 1 2 3 4 5 6 7 8 9
Code2of5Interleaved | Interleaved 2 of 5 is a high-density numeric symbology. It is an updated version of Code 2 of 5 in which every second digit is encoded in the spaces instead of the bars. Use of a check digit is optional. If the ComputeCheckSum property is set to True, the check character is calculated automatically. | Interleaved 2 of 5 | 0 1 2 3 4 5 6 7 8 9
Code39 (default) | The original barcode. It is self checking and use of a check digit is optional. If the ComputeCheckSum property is set to True, the check character is calculated automatically. | USD-3, Code 3 of 9, LOGMARS and Ansi39 | 1 2 3 4 5 6 7 8 9 0 A B C D E F G H I J K L M N O P Q R S T U V W X Y Z - . $ / + % SPACE
Code39Extended | Code39 extended to use the entire ASCII character set. | USD-3, Code 3 of 9, LOGMARS and Ansi39x | All 128 ASCII characters.
Code49 | Code 49 is a high-density stacked symbology containing two to eight rows of eight characters each. Each row has a start code and a stop code. | All 128 ASCII characters.
Code93 | The same as Code39 except that two check digits are required. The ComputeCheckSum property is set to True by default and the check characters are calculated automatically. | USS-93 | 1 2 3 4 5 6 7 8 9 0 A B C D E F G H I J K L M N O P Q R S T U V W X Y Z - . $ / + % SPACE
Code93Extended | Code93 extended to use the entire ASCII character set. | USS-93 | All 128 ASCII characters.
Ean128Fnc1 EAN-128 is an alphanumeric one-dimensional representation of Application Identifier data that contains the following sections:
  • Leading quiet zone (blank area)
  • Code 128 start character
    • A allows standard alphanumeric plus control and special characters
    • B allows standard alphanumeric plus lower case alpha and special characters
    • C allows a set of 100 digit pairs from 00 to 99
  • FNC (function) 1 character which allows scanners to identify this as an EAN-128 barcode
  • Data (AI or Application Identifier plus data field) The AI sets the type of the data to follow. This AI is what distinguishes the EAN-128 code from Code 128. Multiple AIs can be combined into a single bar code.
  • Symbol check character (Start code value plus product of each character position plus value of each character divided by 103. The checksum is the remainder value.)
  • Stop character
  • Trailing quiet zone (blank area)

EAN128FNC1 is a UCC/EAN-128 (EAN128) type barcode that allows you to insert an FNC1 character at any place and adjust the bar size etc., which is not possible in UCC/EAN-128.

To insert an FNC1 character, add "\n" for C#, or "vbLf" for VB to the Text property at runtime.
Ean13 | EAN-13 is a numeric symbology and is a superset of UPC-A. It is self checking and requires a check digit for greater security. The ComputeCheckSum property is set to True by default and the check character is calculated automatically. EAN-13 requires 12 digits for the main barcode. It also supports a secondary barcode of 2 or 5 digits. | ISBN, ISMN, ISSN, and JAN-13 | 0 1 2 3 4 5 6 7 8 9
Ean8 | EAN-8 is a shorter version of EAN-13. It is self checking and requires a check digit for greater security. The ComputeCheckSum property is set to True by default and the check character is calculated automatically. EAN-8 requires 7 digits for the main barcode. It also supports a secondary barcode of 2 or 5 digits. | 0 1 2 3 4 5 6 7 8 9
JapanesePostal | This is the barcode used by the Japanese Postal system. Encodes alpha and numeric characters consisting of 18 digits including a 7-digit postal code number, optionally followed by block and house number information. The data to be encoded can include hyphens. | Japanese Postal | 1 2 3 4 5 6 7 8 9 0 A B C D E F G H I J K L M N O P Q R S T U V W X Y Z -
Matrix2of5 | Matrix 2 of 5 is a numeric symbology. It is self checking and use of a check digit is optional. If the ComputeCheckSum property is set to True, the check character is calculated automatically. | 0 1 2 3 4 5 6 7 8 9
MsiPlessey | MSI Plessey is a numeric symbology. It is not self checking, but use of a check digit is optional. If the ComputeCheckSum property is set to True, the check character is calculated automatically. | Modified Plessey | 0 1 2 3 4 5 6 7 8 9
PDF417 | PDF417 is a multi-row variable-length symbology that has ten error correction levels and three data compaction modes: Text, Byte, and Numeric. This symbology can encode up to 1,850 alphanumeric characters or 2,710 numeric characters. | Portable Data File 417, PDF 417 Truncated | All 256 ISO 8859-1 characters.
Postnet | Postnet is a height-modulated numeric symbology that requires a check digit for greater security. The ComputeCheckSum property is set to True by default and the check character is calculated automatically. Postnet requires 5 digits (ZIP code), 9 digits (ZIP+4), or 11 digits (full delivery point) for the main barcode. | 0 1 2 3 4 5 6 7 8 9
QRCode | QRCode is a two-dimensional symbology that is capable of handling numeric, alphanumeric and byte data as well as Japanese kanji and kana characters. This symbology can encode up to 7,366 characters. | Quick Response Code | All alphanumeric, binary, kanji, and kana characters.
RoyalMail4Scc | RM4SCC is a height-modulated alphanumeric symbology that requires a check digit for greater security. The ComputeCheckSum property is set to True by default and the check character is calculated automatically. | RM4SCC and Royal Mail 4-state Customer Code | 0 1 2 3 4 5 6 7 8 9 A B C D E F G H I J K L M N O P Q R S T U V W X Y Z
UccEan128 This is a special version of Code 128 which is composed of the following seven sections:
  • Code128 start character
  • Code128 FNC1 character
  • Application Identifier (AI)
  • Encoded data
  • Check character
  • Stop character
  • Termination bar
 UCC/EAN 128 All 128 ASCII characters.
UpcA | UPC-A is a numeric symbology that is self checking and requires a check digit for greater security. The ComputeCheckSum property is set to True by default and the check character is calculated automatically. UPC-A requires 11 digits for the main barcode. It also supports a secondary barcode of 2 or 5 digits. | 0 1 2 3 4 5 6 7 8 9
UpcE | UPC-E is a shorter version of UPC-A symbology that is self checking and requires a check digit for greater security. The ComputeCheckSum property is set to True by default and the check character is calculated automatically. UPC-E requires 7 digits for the main barcode. It also supports a secondary barcode of 2 or 5 digits. | 0 1 2 3 4 5 6 7 8 9

When you choose a symbology which offers supplemental options, the additional options appear below the Symbology drop-down box. For more information, see Additional Options for Selected Symbologies.

See Also

Barcode Report Item Smart Panel | Code128C Additional Information | Ean13 Additional Information


Code128C Additional Information

The Code128C symbology supports SCC-14 and SSCC-18 symbologies with special rules.

SCC-14 (Shipping Container Code 14)

SCC-14 is a numeric symbology based on Code 128C. To use Code128C as SCC-14, apply the following rules:

  • The first two digits must be the application identifier 01.
  • The data length must be 13 digits.

    SSCC-18 (Serial Shipping Container Code 18)

    SCC-18 is a numeric symbology based on Code 128C. To use Code128C as SSCC-18, apply the following rules:

  • The first two digits must be the application identifier 00.
  • The data length must be 17 digits.
      • See Also

      Reference: Barcode Properties Symbology Page


Ean13 Additional Information

The EAN-13 symbology supports ISBN, ISMN, ISSN, and JAN-13 symbologies with special rules.

Isbn (International Standard Book Numbering)

ISBN is a numeric symbology based on EAN-13. To use EAN-13 as ISBN, apply the following rules:

  • The first three digits must be 978.
  • The data length of the main barcode must be 9 digits.
  • The data length of the supplemental barcode must be 2 or 5 digits.

Ismn (International Standard Music Numbering)

ISMN is a numeric symbology based on EAN-13. To use EAN-13 as ISMN, apply the following rules:

  • The first three digits must be 979.
  • The data length of the main barcode must be 9 digits.
  • The data length of the supplemental barcode must be 2 or 5 digits.

Issn (International Standard Serial Number)

ISSN is a numeric symbology based on EAN-13. To use EAN-13 as ISSN, apply the following rules:

  • The first three digits must be 977.
  • The data length of the main barcode must be 9 digits.
  • The data length of the supplemental barcode must be 2 or 5 digits.

Jan13 (Japanese Article Numbering)

JAN-13 is a numeric symbology based on EAN-13. To use EAN-13 as JAN-13, apply the following rules:

  • The first two digits must be 45 or 49.
  • The data length of the main barcode must be 10 digits. (5 for company code, 5 for product code)
  • The data length of the supplemental barcode must be 2 or 5 digits.
See Also

Barcode Properties Symbology Page


Additional Options for Selected Symbologies

Each of the following symbologies have supplemental options which appear on the Symbology page of the Barcode smart panel when you select them. Click the symbology name to drop down the supplemental options associated with it.

Show Code49

Use Grouping: Select this check box to allow the Code 49 barcode to use grouping. Selecting this check box enables the Group Number property below.

Group Number: Enter the number of groups to use in the Code 49 barcode. Valid numbers range from 0 to 8.

Show Ean128Fnc1

Module Size: Enter the horizontal size to use for the barcode module.

Bar Adjust: Enter the number of dot units by which to adjust the barcode module (this affects the size of the module and not the entire barcode).

Show Ean13

Supplement Value: Enter a two- or five-digit value or an expression that resolves to a two- or five-digit value for the Add-On symbol to print to the right of the main barcode.

Supplement Bar Height: Enter a size for the height of the supplement barcode. By default, this value is set to the height of the report item minus the amount set in the Padding property.

Supplement Caption Location: Select an enumerated value to control whether a caption for the supplement barcode is printed and where. You can select from None, which prints no caption, Above, or Below.

Show Ean8

Supplement Value: Enter a two- or five-digit value or an expression that resolves to a two- or five-digit value for the Add-On symbol to print to the right of the main barcode.

Supplement Bar Height: Enter a size for the height of the supplement barcode. By default, this value is set to the height of the report item minus the amount set in the Padding property.

Supplement Caption Location: Select an enumerated value to control whether a caption for the supplement barcode is printed and where. You can select from None, which prints no caption, Above, or Below.

Show PDF417

Columns: Enter the fixed number of columns of codewords to use in the barcode. The default value of -1 allows it to automatically determine the number of columns to use. If you set this to a fixed number, you should leave the Rows property set to -1 so that it can add rows as needed to handle the data. The range of valid values is from 1 to 30.

Rows: Enter the fixed number of rows of codewords to use in the barcode. The default value of -1 allows it to automatically determine the number of rows to use. If you set this to a fixed number, you should leave the Columns property set to -1 so that it can add columns as needed to handle the data. The range of valid values is from 3 to 90.

Compaction Mode: Select an enumerated value to determine how data is compacted into codewords to save space. Text encodes most characters on the US keyboard (ASCII 9, 10, 13 and 32-127) with a maximum compaction of 2 characters per codeword. Numeric encodes only numbers (0-9) with a maximum compaction of 2.9 digits per codeword. Byte encodes actual bytes of data with a maximum compaction of 1.2 bytes per codeword.

Error Correction Level: Select an enumerated value from Level0 to Level8 to set the Reed Solomon error correction level which is used instead of check digits for this symbology. A minimum of Level2 is recommended.

Show QRCode

Use Connection: Select this check box to divide a value that is too large to be expressed in a single barcode into multiple barcodes. Selecting this check box enables the Connection Number property below.

Connection Number: Enter the number of connections to use for the barcode. For example, if the value you are using is large enough for two QRCodes, entering the number 2 created the connected barcode's second symbol. Valid numbers range from 0 to 15.

Version: Specify any value between 1 and 14 when the Model property is set to Model1 and 1 to 40 for Model2. When -1 is specified, the version most suited to the value is automatically determined. Version indicates the size of the barcode. As the value increases, the barcode's size increases, enabling more information to be stored.

Error Level: Select an enumerated value to set the error correction capacity. Level L enables 7% of codewords to be restored, M enables 15%, Q enables 25%, and H enables 30% of codewords to be restored.

Mask: Select an enumerated mask pattern reference. Masking is the process used to balance brightness to confirm QRCode's read, which is selected from 8 different patterns. The default value is Auto, which indicates that the masking pattern is set automatically. The default value is recommended for most uses.

Model: Select from Model1 or Model2. The model you choose affects the value you can enter in the Version property above.

Show UpcA

Supplement Value: Enter a two- or five-digit value or an expression that resolves to a two- or five-digit value for the Add-On symbol to print to the right of the main barcode.

Supplement Bar Height: Enter a size for the height of the supplement barcode. By default, this value is set to the height of the report item minus the amount set in the Padding property.

Supplement Caption Location: Select an enumerated value to control whether a caption for the supplement barcode is printed and where. You can select from None, which prints no caption, Above, or Below.

See Also

Barcode Properties Symbology Page | Ean13 Additional Information | Barcode Report Item Smart Panel


Barcode Properties Barcode Settings Page

The Barcode Settings page of the Barcode Properties smart panel allows you to control the following items:

  • Bar Height: Enter a value in inches (i.e. .25in) for the height of the barcode.
  • Narrow Bar Width (also known as X dimension): Enter a value in points (i.e. 0.8pt) for the width of the narrowest part of the barcode. Before using an extremely small value for this width, ensure that the scanner can read it.
    Tip: For accurate scanning, the quiet zone should be ten times the Narrow Bar Width value.

Quiet Zone

A quiet zone is an area of blank space on either side of a barcode that tells the scanner where the symbology starts and stops.

  • Left: Enter a size in inches of blank space to leave to the left of the barcode.
  • Right: Enter a size in inches of blank space to leave to the right of the barcode.
    Note: The units of measure listed for all of these properties are the default units of measure used if you do not specify. You may also specify cm, mm, in, pt, or pc.

Checksum

A checksum provides greater accuracy for many barcode symbologies.

  • Compute Checksum: Select whether to automatically calculate a checksum for the barcode.
    Note: If the symbology you choose requires a checksum, setting this value to False has no effect.
  • Display Checksum in Caption: Select whether to display the checksum along with the barcode value in the caption.
See Also

Barcode Report Item Smart Panel


Barcode Properties Appearance Page

The Appearance page of the Barcode Properties smart panel allows you to control the following aspects of the barcode caption and border:

Font

  • Family: Select a font family name or a theme font.
  • Size: Choose the size in points for the font or use a theme.
  • Style: Choose Normal or Italic or select a theme.
  • Weight: Choose from Lighter, Thin, ExtraLight, Light, Normal, Medium, SemiBold, Bold, ExtraBold, Heavy, or Bolder.
  • Color: Choose a color to use for the text.
  • Decoration: Choose from None, Underline, Overline, or LineThrough.
Note: You can select the <Expression...> option in many of these properties to create an expression to determine the value. For properties with enumerated values, the values are listed under Constants in the Fields tree view on the left side of the Expression Editor.

Border

  • Style: Select a style for the border.
  • Width: Enter a value in points to set the width of the border.
  • Color: Select a color to use for the border, or select the <Expression...> option to open the Expression Editor and create an expression that evaluates to a .NET color.
See Also

Barcode Report Item Smart Panel | Expressions


Barcode Properties Format Page

The Format page of the Barcode Properties smart panel gives you control over the following items:

  • Format code: Select one of the common numeric formats provided or use a custom .NET formatting code to format dates or numbers. For more information, see MSDN's Formatting Types topic.
  • Amount of space to leave around report item
    • Top margin: Set the top padding in points.
    • Left margin: Set the left padding in points.
    • Right margin: Set the right padding in points.
    • Bottom margin: Set the bottom padding in points.
    • Rotation: Choose None, Rotate90Degrees, Rotate180Degrees, or Rotate270Degrees.
    • Resolution (DPI): Adjust the resolution of the rendered barcode. The default value is 96.
      Tip: A dot matrix printer typically prints in the 60 to 90 DPI range, a laser printer may be in the range of 600 to 1200 DPI, an inkjet printer may be in the range of 1200 to 9600 DPI, and 72 to 150 DPI is sufficient for web use. The higher DPI ranges take longer to print, so consider whether a high value is necessary.
Note: You can select the <Expression...> option in many of these properties to create an expression to determine the value. For properties with enumerated values, the values are listed under Constants in the Fields tree view on the left side of the Expression Editor.
See Also

Barcode Report Item Smart Panel


Barcode Properties Visibility Page

The Visibility page of the Barcode Properties smart panel allows you to control the following items:

  • Initial visibility allows you to select from the following options:
    • Visible - The barcode is visible when the report runs.
    • Hidden - The barcode is hidden when the report runs.
    • Expression - Use an expression with a Boolean result to decide whether the barcode is visible.
  • Visibility can be toggled by another report item
    • Report item: If you select the Visibility can be toggled check box, you can specify the report item next to which appears a grey toggle image button. If clicked, the Report Item toggles the visibility of the barcode.
  • Initial appearance of the toggle image: allows you to select from the following options:
    • Expanded (-) The toggle image shows as a minus sign, and all instances of this barcode are visible.
    • Collapsed (+) The toggle image shows as a plus sign, and all instances of this barcode are hidden.
    • Expression: Use an expression with a Boolean result to decide whether the toggle image is expanded. A value of true expands the toggle image, false collapses it.
See Also

Barcode Report Item Smart Panel | Drill-Down Reports

Tutorials: Toggling Visibility | Walkthrough: Drill-Through


Barcode Properties Navigation Page

The Navigation page of the Barcode Properties smart panel allows you to control the following items:

  • Document map label: Enter an expression to use as a label to represent this item in the table of contents (document map).
  • Bookmark ID: Enter an expression to use as a locator for this barcode. You will then be able to provide a bookmark link to this item from another report item using a Jump to bookmark action.
See Also

Barcode Report Item Smart Panel | Document Maps | Bookmarks


Barcode Properties Data Output Page

The Data Output page of the Barcode Properties smart panel allows you to control the following properties when you export to XML:

  • Element Name: Enter a name to be used in the XML output for this barcode.
  • Output: Choose Auto, Yes, or No to decide whether to include this barcode in the XML output. Auto exports the contents of the barcode only when the value is not a constant.
  • Render as: Choose Auto, Element, or Attribute to decide whether to render barcodes as Attributes or Elements in the exported XML file. Auto uses the report's setting for this property.
See Also

Barcode Report Item Smart Panel | Rendering to XML


%%ItemTitle%%

Glossary Item Box

Data Dynamics Reports Documentation Support Forum

Transforming

Transform your data into these formats for use in other applications or servers.

XML
Transform data to XML for data exchange.


%%ItemTitle%%

Glossary Item Box

Data Dynamics Reports Documentation Support Forum

Requirements

This topic details hardware and software requirements for installing and using Data Dynamics Reports.

Hardware requirements

  • Minimum processor: Pentium® II-class processor 450 MHz
    • Recommended processor: Pentium® III-class processor 600 MHz
  • Minimum RAM: 160 MB (192 MB for Windows® 2000 Server operating system)
    • Recommended RAM: 200 MB
  • Minimum hard drive space: 46 MB available
    • Recommended hard drive space: 50 MB available

Software requirements

  • Operating System: Windows® 2000, Windows® XP or Windows® NT 4.0
  • Microsoft® .NET framework version 2.0
  • Microsoft Visual Studio® 2005


%%ItemTitle%%

Glossary Item Box

Getting Started: Components

See Also Data Dynamics Reports Documentation Support Forum

Adding Components to the Visual Studio Toolbox

Although Data Dynamics Reports provides compiled Viewer and Designer applications that you can use independently, you may want to add components to projects in Visual Studio. To use the Data Dynamics Reports components in your Visual Studio projects, you must add them to the toolbox. The components and their functions are listed below.

Note: All of the components in the Web namespace are available only in Web projects and appear disabled in the Visual Studio toolbox in Windows Application projects. Conversely, the other three components are available only in Windows Application projects and appear disabled in the Visual Studio toolbox in Web projects.

To add components to the Visual Studio toolbox

  1. Open the tab of the toolbox to which you want to add the components.
  2. Right-click the toolbox and select Choose Items.
  3. On the .NET Framework Components tab, click the Namespace column header to sort by namespace.
  4. Scroll to the DataDynamics.Reports namespaces and select the check boxes next to the components you wish to add.
  5. Click the OK button to accept the changes and see the components added to the toolbox.
Component Name | Namespace | Description
UserDesignerControl | DataDynamics.Reports.Design.User | The complete report designer for use on Windows Forms to create your own report designer application.
WebReportViewer | DataDynamics.Reports.Web | The complete report viewer for use on Web Forms.
ReportPreview | DataDynamics.Reports.Windows.Forms | The complete report viewer for use on Windows Forms.
See Also

Getting Started: Components


Glossary

A | B | C | D | E | F | G | H | I | J | K | L | M | N | O | P | Q | R | S | T | U | V | W | X | Y | Z